"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TxResult = exports.TransactionLogs = exports.TraceConfig = exports.State = exports.Params = exports.Log = exports.EIP712NestedMsgType = exports.EIP712MsgAttrType = exports.EIP712AllowedMsg = exports.ChainConfig = exports.AccessTuple = void 0;
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseParams() {
  return {
    evmDenom: "",
    enableCreate: false,
    enableCall: false,
    extraEips: [],
    chainConfig: undefined,
    eip712AllowedMsgs: []
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.evmDenom !== "") {
      writer.uint32(10).string(message.evmDenom);
    }
    if (message.enableCreate === true) {
      writer.uint32(16).bool(message.enableCreate);
    }
    if (message.enableCall === true) {
      writer.uint32(24).bool(message.enableCall);
    }
    writer.uint32(34).fork();
    var _iterator = _createForOfIteratorHelper(message.extraEips),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        writer.int64(v);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    writer.ldelim();
    if (message.chainConfig !== undefined) {
      ChainConfig.encode(message.chainConfig, writer.uint32(42).fork()).ldelim();
    }
    var _iterator2 = _createForOfIteratorHelper(message.eip712AllowedMsgs),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        EIP712AllowedMsg.encode(_v, writer.uint32(50).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.evmDenom = reader.string();
          break;
        case 2:
          message.enableCreate = reader.bool();
          break;
        case 3:
          message.enableCall = reader.bool();
          break;
        case 4:
          if ((tag & 7) === 2) {
            var end2 = reader.uint32() + reader.pos;
            while (reader.pos < end2) {
              message.extraEips.push(reader.int64());
            }
          } else {
            message.extraEips.push(reader.int64());
          }
          break;
        case 5:
          message.chainConfig = ChainConfig.decode(reader, reader.uint32());
          break;
        case 6:
          message.eip712AllowedMsgs.push(EIP712AllowedMsg.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      evmDenom: (0, _helpers.isSet)(object.evmDenom) ? String(object.evmDenom) : "",
      enableCreate: (0, _helpers.isSet)(object.enableCreate) ? Boolean(object.enableCreate) : false,
      enableCall: (0, _helpers.isSet)(object.enableCall) ? Boolean(object.enableCall) : false,
      extraEips: Array.isArray(object === null || object === void 0 ? void 0 : object.extraEips) ? object.extraEips.map(function (e) {
        return _helpers.Long.fromValue(e);
      }) : [],
      chainConfig: (0, _helpers.isSet)(object.chainConfig) ? ChainConfig.fromJSON(object.chainConfig) : undefined,
      eip712AllowedMsgs: Array.isArray(object === null || object === void 0 ? void 0 : object.eip712AllowedMsgs) ? object.eip712AllowedMsgs.map(function (e) {
        return EIP712AllowedMsg.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.evmDenom !== undefined && (obj.evmDenom = message.evmDenom);
    message.enableCreate !== undefined && (obj.enableCreate = message.enableCreate);
    message.enableCall !== undefined && (obj.enableCall = message.enableCall);
    if (message.extraEips) {
      obj.extraEips = message.extraEips.map(function (e) {
        return (e || _helpers.Long.ZERO).toString();
      });
    } else {
      obj.extraEips = [];
    }
    message.chainConfig !== undefined && (obj.chainConfig = message.chainConfig ? ChainConfig.toJSON(message.chainConfig) : undefined);
    if (message.eip712AllowedMsgs) {
      obj.eip712AllowedMsgs = message.eip712AllowedMsgs.map(function (e) {
        return e ? EIP712AllowedMsg.toJSON(e) : undefined;
      });
    } else {
      obj.eip712AllowedMsgs = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$evmDenom, _object$enableCreate, _object$enableCall, _object$extraEips, _object$eip712Allowed;
    var message = createBaseParams();
    message.evmDenom = (_object$evmDenom = object.evmDenom) !== null && _object$evmDenom !== void 0 ? _object$evmDenom : "";
    message.enableCreate = (_object$enableCreate = object.enableCreate) !== null && _object$enableCreate !== void 0 ? _object$enableCreate : false;
    message.enableCall = (_object$enableCall = object.enableCall) !== null && _object$enableCall !== void 0 ? _object$enableCall : false;
    message.extraEips = ((_object$extraEips = object.extraEips) === null || _object$extraEips === void 0 ? void 0 : _object$extraEips.map(function (e) {
      return _helpers.Long.fromValue(e);
    })) || [];
    message.chainConfig = object.chainConfig !== undefined && object.chainConfig !== null ? ChainConfig.fromPartial(object.chainConfig) : undefined;
    message.eip712AllowedMsgs = ((_object$eip712Allowed = object.eip712AllowedMsgs) === null || _object$eip712Allowed === void 0 ? void 0 : _object$eip712Allowed.map(function (e) {
      return EIP712AllowedMsg.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.Params = Params;
function createBaseChainConfig() {
  return {
    homesteadBlock: "",
    daoForkBlock: "",
    daoForkSupport: false,
    eip150Block: "",
    eip150Hash: "",
    eip155Block: "",
    eip158Block: "",
    byzantiumBlock: "",
    constantinopleBlock: "",
    petersburgBlock: "",
    istanbulBlock: "",
    muirGlacierBlock: "",
    berlinBlock: "",
    londonBlock: "",
    arrowGlacierBlock: "",
    mergeForkBlock: ""
  };
}
var ChainConfig = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.homesteadBlock !== "") {
      writer.uint32(10).string(message.homesteadBlock);
    }
    if (message.daoForkBlock !== "") {
      writer.uint32(18).string(message.daoForkBlock);
    }
    if (message.daoForkSupport === true) {
      writer.uint32(24).bool(message.daoForkSupport);
    }
    if (message.eip150Block !== "") {
      writer.uint32(34).string(message.eip150Block);
    }
    if (message.eip150Hash !== "") {
      writer.uint32(42).string(message.eip150Hash);
    }
    if (message.eip155Block !== "") {
      writer.uint32(50).string(message.eip155Block);
    }
    if (message.eip158Block !== "") {
      writer.uint32(58).string(message.eip158Block);
    }
    if (message.byzantiumBlock !== "") {
      writer.uint32(66).string(message.byzantiumBlock);
    }
    if (message.constantinopleBlock !== "") {
      writer.uint32(74).string(message.constantinopleBlock);
    }
    if (message.petersburgBlock !== "") {
      writer.uint32(82).string(message.petersburgBlock);
    }
    if (message.istanbulBlock !== "") {
      writer.uint32(90).string(message.istanbulBlock);
    }
    if (message.muirGlacierBlock !== "") {
      writer.uint32(98).string(message.muirGlacierBlock);
    }
    if (message.berlinBlock !== "") {
      writer.uint32(106).string(message.berlinBlock);
    }
    if (message.londonBlock !== "") {
      writer.uint32(138).string(message.londonBlock);
    }
    if (message.arrowGlacierBlock !== "") {
      writer.uint32(146).string(message.arrowGlacierBlock);
    }
    if (message.mergeForkBlock !== "") {
      writer.uint32(154).string(message.mergeForkBlock);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseChainConfig();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.homesteadBlock = reader.string();
          break;
        case 2:
          message.daoForkBlock = reader.string();
          break;
        case 3:
          message.daoForkSupport = reader.bool();
          break;
        case 4:
          message.eip150Block = reader.string();
          break;
        case 5:
          message.eip150Hash = reader.string();
          break;
        case 6:
          message.eip155Block = reader.string();
          break;
        case 7:
          message.eip158Block = reader.string();
          break;
        case 8:
          message.byzantiumBlock = reader.string();
          break;
        case 9:
          message.constantinopleBlock = reader.string();
          break;
        case 10:
          message.petersburgBlock = reader.string();
          break;
        case 11:
          message.istanbulBlock = reader.string();
          break;
        case 12:
          message.muirGlacierBlock = reader.string();
          break;
        case 13:
          message.berlinBlock = reader.string();
          break;
        case 17:
          message.londonBlock = reader.string();
          break;
        case 18:
          message.arrowGlacierBlock = reader.string();
          break;
        case 19:
          message.mergeForkBlock = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      homesteadBlock: (0, _helpers.isSet)(object.homesteadBlock) ? String(object.homesteadBlock) : "",
      daoForkBlock: (0, _helpers.isSet)(object.daoForkBlock) ? String(object.daoForkBlock) : "",
      daoForkSupport: (0, _helpers.isSet)(object.daoForkSupport) ? Boolean(object.daoForkSupport) : false,
      eip150Block: (0, _helpers.isSet)(object.eip150Block) ? String(object.eip150Block) : "",
      eip150Hash: (0, _helpers.isSet)(object.eip150Hash) ? String(object.eip150Hash) : "",
      eip155Block: (0, _helpers.isSet)(object.eip155Block) ? String(object.eip155Block) : "",
      eip158Block: (0, _helpers.isSet)(object.eip158Block) ? String(object.eip158Block) : "",
      byzantiumBlock: (0, _helpers.isSet)(object.byzantiumBlock) ? String(object.byzantiumBlock) : "",
      constantinopleBlock: (0, _helpers.isSet)(object.constantinopleBlock) ? String(object.constantinopleBlock) : "",
      petersburgBlock: (0, _helpers.isSet)(object.petersburgBlock) ? String(object.petersburgBlock) : "",
      istanbulBlock: (0, _helpers.isSet)(object.istanbulBlock) ? String(object.istanbulBlock) : "",
      muirGlacierBlock: (0, _helpers.isSet)(object.muirGlacierBlock) ? String(object.muirGlacierBlock) : "",
      berlinBlock: (0, _helpers.isSet)(object.berlinBlock) ? String(object.berlinBlock) : "",
      londonBlock: (0, _helpers.isSet)(object.londonBlock) ? String(object.londonBlock) : "",
      arrowGlacierBlock: (0, _helpers.isSet)(object.arrowGlacierBlock) ? String(object.arrowGlacierBlock) : "",
      mergeForkBlock: (0, _helpers.isSet)(object.mergeForkBlock) ? String(object.mergeForkBlock) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.homesteadBlock !== undefined && (obj.homesteadBlock = message.homesteadBlock);
    message.daoForkBlock !== undefined && (obj.daoForkBlock = message.daoForkBlock);
    message.daoForkSupport !== undefined && (obj.daoForkSupport = message.daoForkSupport);
    message.eip150Block !== undefined && (obj.eip150Block = message.eip150Block);
    message.eip150Hash !== undefined && (obj.eip150Hash = message.eip150Hash);
    message.eip155Block !== undefined && (obj.eip155Block = message.eip155Block);
    message.eip158Block !== undefined && (obj.eip158Block = message.eip158Block);
    message.byzantiumBlock !== undefined && (obj.byzantiumBlock = message.byzantiumBlock);
    message.constantinopleBlock !== undefined && (obj.constantinopleBlock = message.constantinopleBlock);
    message.petersburgBlock !== undefined && (obj.petersburgBlock = message.petersburgBlock);
    message.istanbulBlock !== undefined && (obj.istanbulBlock = message.istanbulBlock);
    message.muirGlacierBlock !== undefined && (obj.muirGlacierBlock = message.muirGlacierBlock);
    message.berlinBlock !== undefined && (obj.berlinBlock = message.berlinBlock);
    message.londonBlock !== undefined && (obj.londonBlock = message.londonBlock);
    message.arrowGlacierBlock !== undefined && (obj.arrowGlacierBlock = message.arrowGlacierBlock);
    message.mergeForkBlock !== undefined && (obj.mergeForkBlock = message.mergeForkBlock);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$homesteadBloc, _object$daoForkBlock, _object$daoForkSuppor, _object$eip150Block, _object$eip150Hash, _object$eip155Block, _object$eip158Block, _object$byzantiumBloc, _object$constantinopl, _object$petersburgBlo, _object$istanbulBlock, _object$muirGlacierBl, _object$berlinBlock, _object$londonBlock, _object$arrowGlacierB, _object$mergeForkBloc;
    var message = createBaseChainConfig();
    message.homesteadBlock = (_object$homesteadBloc = object.homesteadBlock) !== null && _object$homesteadBloc !== void 0 ? _object$homesteadBloc : "";
    message.daoForkBlock = (_object$daoForkBlock = object.daoForkBlock) !== null && _object$daoForkBlock !== void 0 ? _object$daoForkBlock : "";
    message.daoForkSupport = (_object$daoForkSuppor = object.daoForkSupport) !== null && _object$daoForkSuppor !== void 0 ? _object$daoForkSuppor : false;
    message.eip150Block = (_object$eip150Block = object.eip150Block) !== null && _object$eip150Block !== void 0 ? _object$eip150Block : "";
    message.eip150Hash = (_object$eip150Hash = object.eip150Hash) !== null && _object$eip150Hash !== void 0 ? _object$eip150Hash : "";
    message.eip155Block = (_object$eip155Block = object.eip155Block) !== null && _object$eip155Block !== void 0 ? _object$eip155Block : "";
    message.eip158Block = (_object$eip158Block = object.eip158Block) !== null && _object$eip158Block !== void 0 ? _object$eip158Block : "";
    message.byzantiumBlock = (_object$byzantiumBloc = object.byzantiumBlock) !== null && _object$byzantiumBloc !== void 0 ? _object$byzantiumBloc : "";
    message.constantinopleBlock = (_object$constantinopl = object.constantinopleBlock) !== null && _object$constantinopl !== void 0 ? _object$constantinopl : "";
    message.petersburgBlock = (_object$petersburgBlo = object.petersburgBlock) !== null && _object$petersburgBlo !== void 0 ? _object$petersburgBlo : "";
    message.istanbulBlock = (_object$istanbulBlock = object.istanbulBlock) !== null && _object$istanbulBlock !== void 0 ? _object$istanbulBlock : "";
    message.muirGlacierBlock = (_object$muirGlacierBl = object.muirGlacierBlock) !== null && _object$muirGlacierBl !== void 0 ? _object$muirGlacierBl : "";
    message.berlinBlock = (_object$berlinBlock = object.berlinBlock) !== null && _object$berlinBlock !== void 0 ? _object$berlinBlock : "";
    message.londonBlock = (_object$londonBlock = object.londonBlock) !== null && _object$londonBlock !== void 0 ? _object$londonBlock : "";
    message.arrowGlacierBlock = (_object$arrowGlacierB = object.arrowGlacierBlock) !== null && _object$arrowGlacierB !== void 0 ? _object$arrowGlacierB : "";
    message.mergeForkBlock = (_object$mergeForkBloc = object.mergeForkBlock) !== null && _object$mergeForkBloc !== void 0 ? _object$mergeForkBloc : "";
    return message;
  }
};
exports.ChainConfig = ChainConfig;
function createBaseState() {
  return {
    key: "",
    value: ""
  };
}
var State = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.key !== "") {
      writer.uint32(10).string(message.key);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.key = reader.string();
          break;
        case 2:
          message.value = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      key: (0, _helpers.isSet)(object.key) ? String(object.key) : "",
      value: (0, _helpers.isSet)(object.value) ? String(object.value) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.key !== undefined && (obj.key = message.key);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$key, _object$value;
    var message = createBaseState();
    message.key = (_object$key = object.key) !== null && _object$key !== void 0 ? _object$key : "";
    message.value = (_object$value = object.value) !== null && _object$value !== void 0 ? _object$value : "";
    return message;
  }
};
exports.State = State;
function createBaseTransactionLogs() {
  return {
    hash: "",
    logs: []
  };
}
var TransactionLogs = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.hash !== "") {
      writer.uint32(10).string(message.hash);
    }
    var _iterator3 = _createForOfIteratorHelper(message.logs),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var v = _step3.value;
        Log.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseTransactionLogs();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.hash = reader.string();
          break;
        case 2:
          message.logs.push(Log.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      hash: (0, _helpers.isSet)(object.hash) ? String(object.hash) : "",
      logs: Array.isArray(object === null || object === void 0 ? void 0 : object.logs) ? object.logs.map(function (e) {
        return Log.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.hash !== undefined && (obj.hash = message.hash);
    if (message.logs) {
      obj.logs = message.logs.map(function (e) {
        return e ? Log.toJSON(e) : undefined;
      });
    } else {
      obj.logs = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$hash, _object$logs;
    var message = createBaseTransactionLogs();
    message.hash = (_object$hash = object.hash) !== null && _object$hash !== void 0 ? _object$hash : "";
    message.logs = ((_object$logs = object.logs) === null || _object$logs === void 0 ? void 0 : _object$logs.map(function (e) {
      return Log.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.TransactionLogs = TransactionLogs;
function createBaseLog() {
  return {
    address: "",
    topics: [],
    data: new Uint8Array(),
    blockNumber: _helpers.Long.UZERO,
    txHash: "",
    txIndex: _helpers.Long.UZERO,
    blockHash: "",
    index: _helpers.Long.UZERO,
    removed: false
  };
}
var Log = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.address !== "") {
      writer.uint32(10).string(message.address);
    }
    var _iterator4 = _createForOfIteratorHelper(message.topics),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var v = _step4.value;
        writer.uint32(18).string(v);
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    if (message.data.length !== 0) {
      writer.uint32(26).bytes(message.data);
    }
    if (!message.blockNumber.isZero()) {
      writer.uint32(32).uint64(message.blockNumber);
    }
    if (message.txHash !== "") {
      writer.uint32(42).string(message.txHash);
    }
    if (!message.txIndex.isZero()) {
      writer.uint32(48).uint64(message.txIndex);
    }
    if (message.blockHash !== "") {
      writer.uint32(58).string(message.blockHash);
    }
    if (!message.index.isZero()) {
      writer.uint32(64).uint64(message.index);
    }
    if (message.removed === true) {
      writer.uint32(72).bool(message.removed);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseLog();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.string();
          break;
        case 2:
          message.topics.push(reader.string());
          break;
        case 3:
          message.data = reader.bytes();
          break;
        case 4:
          message.blockNumber = reader.uint64();
          break;
        case 5:
          message.txHash = reader.string();
          break;
        case 6:
          message.txIndex = reader.uint64();
          break;
        case 7:
          message.blockHash = reader.string();
          break;
        case 8:
          message.index = reader.uint64();
          break;
        case 9:
          message.removed = reader.bool();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      address: (0, _helpers.isSet)(object.address) ? String(object.address) : "",
      topics: Array.isArray(object === null || object === void 0 ? void 0 : object.topics) ? object.topics.map(function (e) {
        return String(e);
      }) : [],
      data: (0, _helpers.isSet)(object.data) ? (0, _helpers.bytesFromBase64)(object.data) : new Uint8Array(),
      blockNumber: (0, _helpers.isSet)(object.blockNumber) ? _helpers.Long.fromValue(object.blockNumber) : _helpers.Long.UZERO,
      txHash: (0, _helpers.isSet)(object.txHash) ? String(object.txHash) : "",
      txIndex: (0, _helpers.isSet)(object.txIndex) ? _helpers.Long.fromValue(object.txIndex) : _helpers.Long.UZERO,
      blockHash: (0, _helpers.isSet)(object.blockHash) ? String(object.blockHash) : "",
      index: (0, _helpers.isSet)(object.index) ? _helpers.Long.fromValue(object.index) : _helpers.Long.UZERO,
      removed: (0, _helpers.isSet)(object.removed) ? Boolean(object.removed) : false
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.address !== undefined && (obj.address = message.address);
    if (message.topics) {
      obj.topics = message.topics.map(function (e) {
        return e;
      });
    } else {
      obj.topics = [];
    }
    message.data !== undefined && (obj.data = (0, _helpers.base64FromBytes)(message.data !== undefined ? message.data : new Uint8Array()));
    message.blockNumber !== undefined && (obj.blockNumber = (message.blockNumber || _helpers.Long.UZERO).toString());
    message.txHash !== undefined && (obj.txHash = message.txHash);
    message.txIndex !== undefined && (obj.txIndex = (message.txIndex || _helpers.Long.UZERO).toString());
    message.blockHash !== undefined && (obj.blockHash = message.blockHash);
    message.index !== undefined && (obj.index = (message.index || _helpers.Long.UZERO).toString());
    message.removed !== undefined && (obj.removed = message.removed);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$address, _object$topics, _object$data, _object$txHash, _object$blockHash, _object$removed;
    var message = createBaseLog();
    message.address = (_object$address = object.address) !== null && _object$address !== void 0 ? _object$address : "";
    message.topics = ((_object$topics = object.topics) === null || _object$topics === void 0 ? void 0 : _object$topics.map(function (e) {
      return e;
    })) || [];
    message.data = (_object$data = object.data) !== null && _object$data !== void 0 ? _object$data : new Uint8Array();
    message.blockNumber = object.blockNumber !== undefined && object.blockNumber !== null ? _helpers.Long.fromValue(object.blockNumber) : _helpers.Long.UZERO;
    message.txHash = (_object$txHash = object.txHash) !== null && _object$txHash !== void 0 ? _object$txHash : "";
    message.txIndex = object.txIndex !== undefined && object.txIndex !== null ? _helpers.Long.fromValue(object.txIndex) : _helpers.Long.UZERO;
    message.blockHash = (_object$blockHash = object.blockHash) !== null && _object$blockHash !== void 0 ? _object$blockHash : "";
    message.index = object.index !== undefined && object.index !== null ? _helpers.Long.fromValue(object.index) : _helpers.Long.UZERO;
    message.removed = (_object$removed = object.removed) !== null && _object$removed !== void 0 ? _object$removed : false;
    return message;
  }
};
exports.Log = Log;
function createBaseTxResult() {
  return {
    contractAddress: "",
    bloom: new Uint8Array(),
    txLogs: undefined,
    ret: new Uint8Array(),
    reverted: false,
    gasUsed: _helpers.Long.UZERO
  };
}
var TxResult = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.contractAddress !== "") {
      writer.uint32(10).string(message.contractAddress);
    }
    if (message.bloom.length !== 0) {
      writer.uint32(18).bytes(message.bloom);
    }
    if (message.txLogs !== undefined) {
      TransactionLogs.encode(message.txLogs, writer.uint32(26).fork()).ldelim();
    }
    if (message.ret.length !== 0) {
      writer.uint32(34).bytes(message.ret);
    }
    if (message.reverted === true) {
      writer.uint32(40).bool(message.reverted);
    }
    if (!message.gasUsed.isZero()) {
      writer.uint32(48).uint64(message.gasUsed);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseTxResult();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.contractAddress = reader.string();
          break;
        case 2:
          message.bloom = reader.bytes();
          break;
        case 3:
          message.txLogs = TransactionLogs.decode(reader, reader.uint32());
          break;
        case 4:
          message.ret = reader.bytes();
          break;
        case 5:
          message.reverted = reader.bool();
          break;
        case 6:
          message.gasUsed = reader.uint64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      contractAddress: (0, _helpers.isSet)(object.contractAddress) ? String(object.contractAddress) : "",
      bloom: (0, _helpers.isSet)(object.bloom) ? (0, _helpers.bytesFromBase64)(object.bloom) : new Uint8Array(),
      txLogs: (0, _helpers.isSet)(object.txLogs) ? TransactionLogs.fromJSON(object.txLogs) : undefined,
      ret: (0, _helpers.isSet)(object.ret) ? (0, _helpers.bytesFromBase64)(object.ret) : new Uint8Array(),
      reverted: (0, _helpers.isSet)(object.reverted) ? Boolean(object.reverted) : false,
      gasUsed: (0, _helpers.isSet)(object.gasUsed) ? _helpers.Long.fromValue(object.gasUsed) : _helpers.Long.UZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
    message.bloom !== undefined && (obj.bloom = (0, _helpers.base64FromBytes)(message.bloom !== undefined ? message.bloom : new Uint8Array()));
    message.txLogs !== undefined && (obj.txLogs = message.txLogs ? TransactionLogs.toJSON(message.txLogs) : undefined);
    message.ret !== undefined && (obj.ret = (0, _helpers.base64FromBytes)(message.ret !== undefined ? message.ret : new Uint8Array()));
    message.reverted !== undefined && (obj.reverted = message.reverted);
    message.gasUsed !== undefined && (obj.gasUsed = (message.gasUsed || _helpers.Long.UZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$contractAddre, _object$bloom, _object$ret, _object$reverted;
    var message = createBaseTxResult();
    message.contractAddress = (_object$contractAddre = object.contractAddress) !== null && _object$contractAddre !== void 0 ? _object$contractAddre : "";
    message.bloom = (_object$bloom = object.bloom) !== null && _object$bloom !== void 0 ? _object$bloom : new Uint8Array();
    message.txLogs = object.txLogs !== undefined && object.txLogs !== null ? TransactionLogs.fromPartial(object.txLogs) : undefined;
    message.ret = (_object$ret = object.ret) !== null && _object$ret !== void 0 ? _object$ret : new Uint8Array();
    message.reverted = (_object$reverted = object.reverted) !== null && _object$reverted !== void 0 ? _object$reverted : false;
    message.gasUsed = object.gasUsed !== undefined && object.gasUsed !== null ? _helpers.Long.fromValue(object.gasUsed) : _helpers.Long.UZERO;
    return message;
  }
};
exports.TxResult = TxResult;
function createBaseAccessTuple() {
  return {
    address: "",
    storageKeys: []
  };
}
var AccessTuple = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.address !== "") {
      writer.uint32(10).string(message.address);
    }
    var _iterator5 = _createForOfIteratorHelper(message.storageKeys),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var v = _step5.value;
        writer.uint32(18).string(v);
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseAccessTuple();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.string();
          break;
        case 2:
          message.storageKeys.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      address: (0, _helpers.isSet)(object.address) ? String(object.address) : "",
      storageKeys: Array.isArray(object === null || object === void 0 ? void 0 : object.storageKeys) ? object.storageKeys.map(function (e) {
        return String(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.address !== undefined && (obj.address = message.address);
    if (message.storageKeys) {
      obj.storageKeys = message.storageKeys.map(function (e) {
        return e;
      });
    } else {
      obj.storageKeys = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$address2, _object$storageKeys;
    var message = createBaseAccessTuple();
    message.address = (_object$address2 = object.address) !== null && _object$address2 !== void 0 ? _object$address2 : "";
    message.storageKeys = ((_object$storageKeys = object.storageKeys) === null || _object$storageKeys === void 0 ? void 0 : _object$storageKeys.map(function (e) {
      return e;
    })) || [];
    return message;
  }
};
exports.AccessTuple = AccessTuple;
function createBaseTraceConfig() {
  return {
    tracer: "",
    timeout: "",
    reexec: _helpers.Long.UZERO,
    disableStack: false,
    disableStorage: false,
    debug: false,
    limit: 0,
    overrides: undefined,
    enableMemory: false,
    enableReturnData: false
  };
}
var TraceConfig = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.tracer !== "") {
      writer.uint32(10).string(message.tracer);
    }
    if (message.timeout !== "") {
      writer.uint32(18).string(message.timeout);
    }
    if (!message.reexec.isZero()) {
      writer.uint32(24).uint64(message.reexec);
    }
    if (message.disableStack === true) {
      writer.uint32(40).bool(message.disableStack);
    }
    if (message.disableStorage === true) {
      writer.uint32(48).bool(message.disableStorage);
    }
    if (message.debug === true) {
      writer.uint32(64).bool(message.debug);
    }
    if (message.limit !== 0) {
      writer.uint32(72).int32(message.limit);
    }
    if (message.overrides !== undefined) {
      ChainConfig.encode(message.overrides, writer.uint32(82).fork()).ldelim();
    }
    if (message.enableMemory === true) {
      writer.uint32(88).bool(message.enableMemory);
    }
    if (message.enableReturnData === true) {
      writer.uint32(96).bool(message.enableReturnData);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseTraceConfig();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.tracer = reader.string();
          break;
        case 2:
          message.timeout = reader.string();
          break;
        case 3:
          message.reexec = reader.uint64();
          break;
        case 5:
          message.disableStack = reader.bool();
          break;
        case 6:
          message.disableStorage = reader.bool();
          break;
        case 8:
          message.debug = reader.bool();
          break;
        case 9:
          message.limit = reader.int32();
          break;
        case 10:
          message.overrides = ChainConfig.decode(reader, reader.uint32());
          break;
        case 11:
          message.enableMemory = reader.bool();
          break;
        case 12:
          message.enableReturnData = reader.bool();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      tracer: (0, _helpers.isSet)(object.tracer) ? String(object.tracer) : "",
      timeout: (0, _helpers.isSet)(object.timeout) ? String(object.timeout) : "",
      reexec: (0, _helpers.isSet)(object.reexec) ? _helpers.Long.fromValue(object.reexec) : _helpers.Long.UZERO,
      disableStack: (0, _helpers.isSet)(object.disableStack) ? Boolean(object.disableStack) : false,
      disableStorage: (0, _helpers.isSet)(object.disableStorage) ? Boolean(object.disableStorage) : false,
      debug: (0, _helpers.isSet)(object.debug) ? Boolean(object.debug) : false,
      limit: (0, _helpers.isSet)(object.limit) ? Number(object.limit) : 0,
      overrides: (0, _helpers.isSet)(object.overrides) ? ChainConfig.fromJSON(object.overrides) : undefined,
      enableMemory: (0, _helpers.isSet)(object.enableMemory) ? Boolean(object.enableMemory) : false,
      enableReturnData: (0, _helpers.isSet)(object.enableReturnData) ? Boolean(object.enableReturnData) : false
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.tracer !== undefined && (obj.tracer = message.tracer);
    message.timeout !== undefined && (obj.timeout = message.timeout);
    message.reexec !== undefined && (obj.reexec = (message.reexec || _helpers.Long.UZERO).toString());
    message.disableStack !== undefined && (obj.disableStack = message.disableStack);
    message.disableStorage !== undefined && (obj.disableStorage = message.disableStorage);
    message.debug !== undefined && (obj.debug = message.debug);
    message.limit !== undefined && (obj.limit = Math.round(message.limit));
    message.overrides !== undefined && (obj.overrides = message.overrides ? ChainConfig.toJSON(message.overrides) : undefined);
    message.enableMemory !== undefined && (obj.enableMemory = message.enableMemory);
    message.enableReturnData !== undefined && (obj.enableReturnData = message.enableReturnData);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$tracer, _object$timeout, _object$disableStack, _object$disableStorag, _object$debug, _object$limit, _object$enableMemory, _object$enableReturnD;
    var message = createBaseTraceConfig();
    message.tracer = (_object$tracer = object.tracer) !== null && _object$tracer !== void 0 ? _object$tracer : "";
    message.timeout = (_object$timeout = object.timeout) !== null && _object$timeout !== void 0 ? _object$timeout : "";
    message.reexec = object.reexec !== undefined && object.reexec !== null ? _helpers.Long.fromValue(object.reexec) : _helpers.Long.UZERO;
    message.disableStack = (_object$disableStack = object.disableStack) !== null && _object$disableStack !== void 0 ? _object$disableStack : false;
    message.disableStorage = (_object$disableStorag = object.disableStorage) !== null && _object$disableStorag !== void 0 ? _object$disableStorag : false;
    message.debug = (_object$debug = object.debug) !== null && _object$debug !== void 0 ? _object$debug : false;
    message.limit = (_object$limit = object.limit) !== null && _object$limit !== void 0 ? _object$limit : 0;
    message.overrides = object.overrides !== undefined && object.overrides !== null ? ChainConfig.fromPartial(object.overrides) : undefined;
    message.enableMemory = (_object$enableMemory = object.enableMemory) !== null && _object$enableMemory !== void 0 ? _object$enableMemory : false;
    message.enableReturnData = (_object$enableReturnD = object.enableReturnData) !== null && _object$enableReturnD !== void 0 ? _object$enableReturnD : false;
    return message;
  }
};
exports.TraceConfig = TraceConfig;
function createBaseEIP712AllowedMsg() {
  return {
    msgTypeUrl: "",
    msgValueTypeName: "",
    valueTypes: [],
    nestedTypes: []
  };
}
var EIP712AllowedMsg = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.msgTypeUrl !== "") {
      writer.uint32(10).string(message.msgTypeUrl);
    }
    if (message.msgValueTypeName !== "") {
      writer.uint32(18).string(message.msgValueTypeName);
    }
    var _iterator6 = _createForOfIteratorHelper(message.valueTypes),
      _step6;
    try {
      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
        var v = _step6.value;
        EIP712MsgAttrType.encode(v, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator6.e(err);
    } finally {
      _iterator6.f();
    }
    var _iterator7 = _createForOfIteratorHelper(message.nestedTypes),
      _step7;
    try {
      for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
        var _v2 = _step7.value;
        EIP712NestedMsgType.encode(_v2, writer.uint32(34).fork()).ldelim();
      }
    } catch (err) {
      _iterator7.e(err);
    } finally {
      _iterator7.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseEIP712AllowedMsg();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.msgTypeUrl = reader.string();
          break;
        case 2:
          message.msgValueTypeName = reader.string();
          break;
        case 3:
          message.valueTypes.push(EIP712MsgAttrType.decode(reader, reader.uint32()));
          break;
        case 4:
          message.nestedTypes.push(EIP712NestedMsgType.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      msgTypeUrl: (0, _helpers.isSet)(object.msgTypeUrl) ? String(object.msgTypeUrl) : "",
      msgValueTypeName: (0, _helpers.isSet)(object.msgValueTypeName) ? String(object.msgValueTypeName) : "",
      valueTypes: Array.isArray(object === null || object === void 0 ? void 0 : object.valueTypes) ? object.valueTypes.map(function (e) {
        return EIP712MsgAttrType.fromJSON(e);
      }) : [],
      nestedTypes: Array.isArray(object === null || object === void 0 ? void 0 : object.nestedTypes) ? object.nestedTypes.map(function (e) {
        return EIP712NestedMsgType.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.msgTypeUrl !== undefined && (obj.msgTypeUrl = message.msgTypeUrl);
    message.msgValueTypeName !== undefined && (obj.msgValueTypeName = message.msgValueTypeName);
    if (message.valueTypes) {
      obj.valueTypes = message.valueTypes.map(function (e) {
        return e ? EIP712MsgAttrType.toJSON(e) : undefined;
      });
    } else {
      obj.valueTypes = [];
    }
    if (message.nestedTypes) {
      obj.nestedTypes = message.nestedTypes.map(function (e) {
        return e ? EIP712NestedMsgType.toJSON(e) : undefined;
      });
    } else {
      obj.nestedTypes = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$msgTypeUrl, _object$msgValueTypeN, _object$valueTypes, _object$nestedTypes;
    var message = createBaseEIP712AllowedMsg();
    message.msgTypeUrl = (_object$msgTypeUrl = object.msgTypeUrl) !== null && _object$msgTypeUrl !== void 0 ? _object$msgTypeUrl : "";
    message.msgValueTypeName = (_object$msgValueTypeN = object.msgValueTypeName) !== null && _object$msgValueTypeN !== void 0 ? _object$msgValueTypeN : "";
    message.valueTypes = ((_object$valueTypes = object.valueTypes) === null || _object$valueTypes === void 0 ? void 0 : _object$valueTypes.map(function (e) {
      return EIP712MsgAttrType.fromPartial(e);
    })) || [];
    message.nestedTypes = ((_object$nestedTypes = object.nestedTypes) === null || _object$nestedTypes === void 0 ? void 0 : _object$nestedTypes.map(function (e) {
      return EIP712NestedMsgType.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.EIP712AllowedMsg = EIP712AllowedMsg;
function createBaseEIP712NestedMsgType() {
  return {
    name: "",
    attrs: []
  };
}
var EIP712NestedMsgType = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    var _iterator8 = _createForOfIteratorHelper(message.attrs),
      _step8;
    try {
      for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
        var v = _step8.value;
        EIP712MsgAttrType.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator8.e(err);
    } finally {
      _iterator8.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseEIP712NestedMsgType();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.name = reader.string();
          break;
        case 2:
          message.attrs.push(EIP712MsgAttrType.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      name: (0, _helpers.isSet)(object.name) ? String(object.name) : "",
      attrs: Array.isArray(object === null || object === void 0 ? void 0 : object.attrs) ? object.attrs.map(function (e) {
        return EIP712MsgAttrType.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.name !== undefined && (obj.name = message.name);
    if (message.attrs) {
      obj.attrs = message.attrs.map(function (e) {
        return e ? EIP712MsgAttrType.toJSON(e) : undefined;
      });
    } else {
      obj.attrs = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$name, _object$attrs;
    var message = createBaseEIP712NestedMsgType();
    message.name = (_object$name = object.name) !== null && _object$name !== void 0 ? _object$name : "";
    message.attrs = ((_object$attrs = object.attrs) === null || _object$attrs === void 0 ? void 0 : _object$attrs.map(function (e) {
      return EIP712MsgAttrType.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.EIP712NestedMsgType = EIP712NestedMsgType;
function createBaseEIP712MsgAttrType() {
  return {
    name: "",
    type: ""
  };
}
var EIP712MsgAttrType = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    if (message.type !== "") {
      writer.uint32(18).string(message.type);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseEIP712MsgAttrType();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.name = reader.string();
          break;
        case 2:
          message.type = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      name: (0, _helpers.isSet)(object.name) ? String(object.name) : "",
      type: (0, _helpers.isSet)(object.type) ? String(object.type) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.name !== undefined && (obj.name = message.name);
    message.type !== undefined && (obj.type = message.type);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$name2, _object$type;
    var message = createBaseEIP712MsgAttrType();
    message.name = (_object$name2 = object.name) !== null && _object$name2 !== void 0 ? _object$name2 : "";
    message.type = (_object$type = object.type) !== null && _object$type !== void 0 ? _object$type : "";
    return message;
  }
};
exports.EIP712MsgAttrType = EIP712MsgAttrType;