"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRpcQueryExtension = exports.QueryClientImpl = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _tx = require("./tx");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _stargate = require("@cosmjs/stargate");
var _query = require("./query");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var QueryClientImpl = /*#__PURE__*/function () {
  function QueryClientImpl(rpc) {
    (0, _classCallCheck2["default"])(this, QueryClientImpl);
    (0, _defineProperty2["default"])(this, "rpc", void 0);
    this.rpc = rpc;
    this.account = this.account.bind(this);
    this.cosmosAccount = this.cosmosAccount.bind(this);
    this.validatorAccount = this.validatorAccount.bind(this);
    this.balance = this.balance.bind(this);
    this.storage = this.storage.bind(this);
    this.code = this.code.bind(this);
    this.params = this.params.bind(this);
    this.ethCall = this.ethCall.bind(this);
    this.estimateGas = this.estimateGas.bind(this);
    this.traceTx = this.traceTx.bind(this);
    this.traceBlock = this.traceBlock.bind(this);
  }
  (0, _createClass2["default"])(QueryClientImpl, [{
    key: "account",
    value: function account(request) {
      var data = _query.QueryAccountRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "Account", data);
      return promise.then(function (data) {
        return _query.QueryAccountResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "cosmosAccount",
    value: function cosmosAccount(request) {
      var data = _query.QueryCosmosAccountRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "CosmosAccount", data);
      return promise.then(function (data) {
        return _query.QueryCosmosAccountResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "validatorAccount",
    value: function validatorAccount(request) {
      var data = _query.QueryValidatorAccountRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "ValidatorAccount", data);
      return promise.then(function (data) {
        return _query.QueryValidatorAccountResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "balance",
    value: function balance(request) {
      var data = _query.QueryBalanceRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "Balance", data);
      return promise.then(function (data) {
        return _query.QueryBalanceResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "storage",
    value: function storage(request) {
      var data = _query.QueryStorageRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "Storage", data);
      return promise.then(function (data) {
        return _query.QueryStorageResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "code",
    value: function code(request) {
      var data = _query.QueryCodeRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "Code", data);
      return promise.then(function (data) {
        return _query.QueryCodeResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "params",
    value: function params() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryParamsRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "Params", data);
      return promise.then(function (data) {
        return _query.QueryParamsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "ethCall",
    value: function ethCall(request) {
      var data = _query.EthCallRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "EthCall", data);
      return promise.then(function (data) {
        return _tx.MsgEthereumTxResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "estimateGas",
    value: function estimateGas(request) {
      var data = _query.EthCallRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "EstimateGas", data);
      return promise.then(function (data) {
        return _query.EstimateGasResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "traceTx",
    value: function traceTx(request) {
      var data = _query.QueryTraceTxRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "TraceTx", data);
      return promise.then(function (data) {
        return _query.QueryTraceTxResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "traceBlock",
    value: function traceBlock(request) {
      var data = _query.QueryTraceBlockRequest.encode(request).finish();
      var promise = this.rpc.request("ethermint.evm.v1.Query", "TraceBlock", data);
      return promise.then(function (data) {
        return _query.QueryTraceBlockResponse.decode(new _m0.Reader(data));
      });
    }
  }]);
  return QueryClientImpl;
}();
exports.QueryClientImpl = QueryClientImpl;
var createRpcQueryExtension = function createRpcQueryExtension(base) {
  var rpc = (0, _stargate.createProtobufRpcClient)(base);
  var queryService = new QueryClientImpl(rpc);
  return {
    account: function account(request) {
      return queryService.account(request);
    },
    cosmosAccount: function cosmosAccount(request) {
      return queryService.cosmosAccount(request);
    },
    validatorAccount: function validatorAccount(request) {
      return queryService.validatorAccount(request);
    },
    balance: function balance(request) {
      return queryService.balance(request);
    },
    storage: function storage(request) {
      return queryService.storage(request);
    },
    code: function code(request) {
      return queryService.code(request);
    },
    params: function params(request) {
      return queryService.params(request);
    },
    ethCall: function ethCall(request) {
      return queryService.ethCall(request);
    },
    estimateGas: function estimateGas(request) {
      return queryService.estimateGas(request);
    },
    traceTx: function traceTx(request) {
      return queryService.traceTx(request);
    },
    traceBlock: function traceBlock(request) {
      return queryService.traceBlock(request);
    }
  };
};
exports.createRpcQueryExtension = createRpcQueryExtension;