"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Params = void 0;
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function createBaseParams() {
  return {
    noBaseFee: false,
    baseFeeChangeDenominator: 0,
    elasticityMultiplier: 0,
    enableHeight: _helpers.Long.ZERO,
    baseFee: ""
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.noBaseFee === true) {
      writer.uint32(8).bool(message.noBaseFee);
    }
    if (message.baseFeeChangeDenominator !== 0) {
      writer.uint32(16).uint32(message.baseFeeChangeDenominator);
    }
    if (message.elasticityMultiplier !== 0) {
      writer.uint32(24).uint32(message.elasticityMultiplier);
    }
    if (!message.enableHeight.isZero()) {
      writer.uint32(40).int64(message.enableHeight);
    }
    if (message.baseFee !== "") {
      writer.uint32(50).string(message.baseFee);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.noBaseFee = reader.bool();
          break;
        case 2:
          message.baseFeeChangeDenominator = reader.uint32();
          break;
        case 3:
          message.elasticityMultiplier = reader.uint32();
          break;
        case 5:
          message.enableHeight = reader.int64();
          break;
        case 6:
          message.baseFee = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      noBaseFee: (0, _helpers.isSet)(object.noBaseFee) ? Boolean(object.noBaseFee) : false,
      baseFeeChangeDenominator: (0, _helpers.isSet)(object.baseFeeChangeDenominator) ? Number(object.baseFeeChangeDenominator) : 0,
      elasticityMultiplier: (0, _helpers.isSet)(object.elasticityMultiplier) ? Number(object.elasticityMultiplier) : 0,
      enableHeight: (0, _helpers.isSet)(object.enableHeight) ? _helpers.Long.fromValue(object.enableHeight) : _helpers.Long.ZERO,
      baseFee: (0, _helpers.isSet)(object.baseFee) ? String(object.baseFee) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.noBaseFee !== undefined && (obj.noBaseFee = message.noBaseFee);
    message.baseFeeChangeDenominator !== undefined && (obj.baseFeeChangeDenominator = Math.round(message.baseFeeChangeDenominator));
    message.elasticityMultiplier !== undefined && (obj.elasticityMultiplier = Math.round(message.elasticityMultiplier));
    message.enableHeight !== undefined && (obj.enableHeight = (message.enableHeight || _helpers.Long.ZERO).toString());
    message.baseFee !== undefined && (obj.baseFee = message.baseFee);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$noBaseFee, _object$baseFeeChange, _object$elasticityMul, _object$baseFee;
    var message = createBaseParams();
    message.noBaseFee = (_object$noBaseFee = object.noBaseFee) !== null && _object$noBaseFee !== void 0 ? _object$noBaseFee : false;
    message.baseFeeChangeDenominator = (_object$baseFeeChange = object.baseFeeChangeDenominator) !== null && _object$baseFeeChange !== void 0 ? _object$baseFeeChange : 0;
    message.elasticityMultiplier = (_object$elasticityMul = object.elasticityMultiplier) !== null && _object$elasticityMul !== void 0 ? _object$elasticityMul : 0;
    message.enableHeight = object.enableHeight !== undefined && object.enableHeight !== null ? _helpers.Long.fromValue(object.enableHeight) : _helpers.Long.ZERO;
    message.baseFee = (_object$baseFee = object.baseFee) !== null && _object$baseFee !== void 0 ? _object$baseFee : "";
    return message;
  }
};
exports.Params = Params;