"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WeightedAddresses = exports.SurplusAuction = exports.DebtAuction = exports.CollateralAuction = exports.BaseAuction = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseBaseAuction() {
  return {
    id: _helpers.Long.UZERO,
    initiator: "",
    lot: undefined,
    bidder: new Uint8Array(),
    bid: undefined,
    hasReceivedBids: false,
    endTime: undefined,
    maxEndTime: undefined
  };
}
var BaseAuction = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.id.isZero()) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.initiator !== "") {
      writer.uint32(18).string(message.initiator);
    }
    if (message.lot !== undefined) {
      _coin.Coin.encode(message.lot, writer.uint32(26).fork()).ldelim();
    }
    if (message.bidder.length !== 0) {
      writer.uint32(34).bytes(message.bidder);
    }
    if (message.bid !== undefined) {
      _coin.Coin.encode(message.bid, writer.uint32(42).fork()).ldelim();
    }
    if (message.hasReceivedBids === true) {
      writer.uint32(48).bool(message.hasReceivedBids);
    }
    if (message.endTime !== undefined) {
      _timestamp.Timestamp.encode(message.endTime, writer.uint32(58).fork()).ldelim();
    }
    if (message.maxEndTime !== undefined) {
      _timestamp.Timestamp.encode(message.maxEndTime, writer.uint32(66).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseBaseAuction();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = reader.uint64();
          break;
        case 2:
          message.initiator = reader.string();
          break;
        case 3:
          message.lot = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.bidder = reader.bytes();
          break;
        case 5:
          message.bid = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 6:
          message.hasReceivedBids = reader.bool();
          break;
        case 7:
          message.endTime = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 8:
          message.maxEndTime = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      id: (0, _helpers.isSet)(object.id) ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO,
      initiator: (0, _helpers.isSet)(object.initiator) ? String(object.initiator) : "",
      lot: (0, _helpers.isSet)(object.lot) ? _coin.Coin.fromJSON(object.lot) : undefined,
      bidder: (0, _helpers.isSet)(object.bidder) ? (0, _helpers.bytesFromBase64)(object.bidder) : new Uint8Array(),
      bid: (0, _helpers.isSet)(object.bid) ? _coin.Coin.fromJSON(object.bid) : undefined,
      hasReceivedBids: (0, _helpers.isSet)(object.hasReceivedBids) ? Boolean(object.hasReceivedBids) : false,
      endTime: (0, _helpers.isSet)(object.endTime) ? (0, _helpers.fromJsonTimestamp)(object.endTime) : undefined,
      maxEndTime: (0, _helpers.isSet)(object.maxEndTime) ? (0, _helpers.fromJsonTimestamp)(object.maxEndTime) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.id !== undefined && (obj.id = (message.id || _helpers.Long.UZERO).toString());
    message.initiator !== undefined && (obj.initiator = message.initiator);
    message.lot !== undefined && (obj.lot = message.lot ? _coin.Coin.toJSON(message.lot) : undefined);
    message.bidder !== undefined && (obj.bidder = (0, _helpers.base64FromBytes)(message.bidder !== undefined ? message.bidder : new Uint8Array()));
    message.bid !== undefined && (obj.bid = message.bid ? _coin.Coin.toJSON(message.bid) : undefined);
    message.hasReceivedBids !== undefined && (obj.hasReceivedBids = message.hasReceivedBids);
    message.endTime !== undefined && (obj.endTime = (0, _helpers.fromTimestamp)(message.endTime).toISOString());
    message.maxEndTime !== undefined && (obj.maxEndTime = (0, _helpers.fromTimestamp)(message.maxEndTime).toISOString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$initiator, _object$bidder, _object$hasReceivedBi;
    var message = createBaseBaseAuction();
    message.id = object.id !== undefined && object.id !== null ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO;
    message.initiator = (_object$initiator = object.initiator) !== null && _object$initiator !== void 0 ? _object$initiator : "";
    message.lot = object.lot !== undefined && object.lot !== null ? _coin.Coin.fromPartial(object.lot) : undefined;
    message.bidder = (_object$bidder = object.bidder) !== null && _object$bidder !== void 0 ? _object$bidder : new Uint8Array();
    message.bid = object.bid !== undefined && object.bid !== null ? _coin.Coin.fromPartial(object.bid) : undefined;
    message.hasReceivedBids = (_object$hasReceivedBi = object.hasReceivedBids) !== null && _object$hasReceivedBi !== void 0 ? _object$hasReceivedBi : false;
    message.endTime = object.endTime !== undefined && object.endTime !== null ? _timestamp.Timestamp.fromPartial(object.endTime) : undefined;
    message.maxEndTime = object.maxEndTime !== undefined && object.maxEndTime !== null ? _timestamp.Timestamp.fromPartial(object.maxEndTime) : undefined;
    return message;
  }
};
exports.BaseAuction = BaseAuction;
function createBaseSurplusAuction() {
  return {
    baseAuction: undefined
  };
}
var SurplusAuction = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.baseAuction !== undefined) {
      BaseAuction.encode(message.baseAuction, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseSurplusAuction();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseAuction = BaseAuction.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      baseAuction: (0, _helpers.isSet)(object.baseAuction) ? BaseAuction.fromJSON(object.baseAuction) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.baseAuction !== undefined && (obj.baseAuction = message.baseAuction ? BaseAuction.toJSON(message.baseAuction) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseSurplusAuction();
    message.baseAuction = object.baseAuction !== undefined && object.baseAuction !== null ? BaseAuction.fromPartial(object.baseAuction) : undefined;
    return message;
  }
};
exports.SurplusAuction = SurplusAuction;
function createBaseDebtAuction() {
  return {
    baseAuction: undefined,
    correspondingDebt: undefined
  };
}
var DebtAuction = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.baseAuction !== undefined) {
      BaseAuction.encode(message.baseAuction, writer.uint32(10).fork()).ldelim();
    }
    if (message.correspondingDebt !== undefined) {
      _coin.Coin.encode(message.correspondingDebt, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseDebtAuction();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseAuction = BaseAuction.decode(reader, reader.uint32());
          break;
        case 2:
          message.correspondingDebt = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      baseAuction: (0, _helpers.isSet)(object.baseAuction) ? BaseAuction.fromJSON(object.baseAuction) : undefined,
      correspondingDebt: (0, _helpers.isSet)(object.correspondingDebt) ? _coin.Coin.fromJSON(object.correspondingDebt) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.baseAuction !== undefined && (obj.baseAuction = message.baseAuction ? BaseAuction.toJSON(message.baseAuction) : undefined);
    message.correspondingDebt !== undefined && (obj.correspondingDebt = message.correspondingDebt ? _coin.Coin.toJSON(message.correspondingDebt) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseDebtAuction();
    message.baseAuction = object.baseAuction !== undefined && object.baseAuction !== null ? BaseAuction.fromPartial(object.baseAuction) : undefined;
    message.correspondingDebt = object.correspondingDebt !== undefined && object.correspondingDebt !== null ? _coin.Coin.fromPartial(object.correspondingDebt) : undefined;
    return message;
  }
};
exports.DebtAuction = DebtAuction;
function createBaseCollateralAuction() {
  return {
    baseAuction: undefined,
    correspondingDebt: undefined,
    maxBid: undefined,
    lotReturns: undefined
  };
}
var CollateralAuction = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.baseAuction !== undefined) {
      BaseAuction.encode(message.baseAuction, writer.uint32(10).fork()).ldelim();
    }
    if (message.correspondingDebt !== undefined) {
      _coin.Coin.encode(message.correspondingDebt, writer.uint32(18).fork()).ldelim();
    }
    if (message.maxBid !== undefined) {
      _coin.Coin.encode(message.maxBid, writer.uint32(26).fork()).ldelim();
    }
    if (message.lotReturns !== undefined) {
      WeightedAddresses.encode(message.lotReturns, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCollateralAuction();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseAuction = BaseAuction.decode(reader, reader.uint32());
          break;
        case 2:
          message.correspondingDebt = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.maxBid = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.lotReturns = WeightedAddresses.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      baseAuction: (0, _helpers.isSet)(object.baseAuction) ? BaseAuction.fromJSON(object.baseAuction) : undefined,
      correspondingDebt: (0, _helpers.isSet)(object.correspondingDebt) ? _coin.Coin.fromJSON(object.correspondingDebt) : undefined,
      maxBid: (0, _helpers.isSet)(object.maxBid) ? _coin.Coin.fromJSON(object.maxBid) : undefined,
      lotReturns: (0, _helpers.isSet)(object.lotReturns) ? WeightedAddresses.fromJSON(object.lotReturns) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.baseAuction !== undefined && (obj.baseAuction = message.baseAuction ? BaseAuction.toJSON(message.baseAuction) : undefined);
    message.correspondingDebt !== undefined && (obj.correspondingDebt = message.correspondingDebt ? _coin.Coin.toJSON(message.correspondingDebt) : undefined);
    message.maxBid !== undefined && (obj.maxBid = message.maxBid ? _coin.Coin.toJSON(message.maxBid) : undefined);
    message.lotReturns !== undefined && (obj.lotReturns = message.lotReturns ? WeightedAddresses.toJSON(message.lotReturns) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseCollateralAuction();
    message.baseAuction = object.baseAuction !== undefined && object.baseAuction !== null ? BaseAuction.fromPartial(object.baseAuction) : undefined;
    message.correspondingDebt = object.correspondingDebt !== undefined && object.correspondingDebt !== null ? _coin.Coin.fromPartial(object.correspondingDebt) : undefined;
    message.maxBid = object.maxBid !== undefined && object.maxBid !== null ? _coin.Coin.fromPartial(object.maxBid) : undefined;
    message.lotReturns = object.lotReturns !== undefined && object.lotReturns !== null ? WeightedAddresses.fromPartial(object.lotReturns) : undefined;
    return message;
  }
};
exports.CollateralAuction = CollateralAuction;
function createBaseWeightedAddresses() {
  return {
    addresses: [],
    weights: []
  };
}
var WeightedAddresses = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator = _createForOfIteratorHelper(message.addresses),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        writer.uint32(10).bytes(v);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var _iterator2 = _createForOfIteratorHelper(message.weights),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        writer.uint32(18).bytes(_v);
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseWeightedAddresses();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.addresses.push(reader.bytes());
          break;
        case 2:
          message.weights.push(reader.bytes());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      addresses: Array.isArray(object === null || object === void 0 ? void 0 : object.addresses) ? object.addresses.map(function (e) {
        return (0, _helpers.bytesFromBase64)(e);
      }) : [],
      weights: Array.isArray(object === null || object === void 0 ? void 0 : object.weights) ? object.weights.map(function (e) {
        return (0, _helpers.bytesFromBase64)(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.addresses) {
      obj.addresses = message.addresses.map(function (e) {
        return (0, _helpers.base64FromBytes)(e !== undefined ? e : new Uint8Array());
      });
    } else {
      obj.addresses = [];
    }
    if (message.weights) {
      obj.weights = message.weights.map(function (e) {
        return (0, _helpers.base64FromBytes)(e !== undefined ? e : new Uint8Array());
      });
    } else {
      obj.weights = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$addresses, _object$weights;
    var message = createBaseWeightedAddresses();
    message.addresses = ((_object$addresses = object.addresses) === null || _object$addresses === void 0 ? void 0 : _object$addresses.map(function (e) {
      return e;
    })) || [];
    message.weights = ((_object$weights = object.weights) === null || _object$weights === void 0 ? void 0 : _object$weights.map(function (e) {
      return e;
    })) || [];
    return message;
  }
};
exports.WeightedAddresses = WeightedAddresses;