"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.auction.v1beta1.MsgPlaceBid", _tx.MsgPlaceBid]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    placeBid: function placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: _tx.MsgPlaceBid.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    placeBid: function placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: value
      };
    }
  },
  toJSON: {
    placeBid: function placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: _tx.MsgPlaceBid.toJSON(value)
      };
    }
  },
  fromJSON: {
    placeBid: function placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: _tx.MsgPlaceBid.fromJSON(value)
      };
    }
  },
  fromPartial: {
    placeBid: function placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: _tx.MsgPlaceBid.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;