"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.bep3.v1beta1.MsgCreateAtomicSwap": {
    aminoType: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
    toAmino: function toAmino(_ref) {
      var from = _ref.from,
        to = _ref.to,
        recipientOtherChain = _ref.recipientOtherChain,
        senderOtherChain = _ref.senderOtherChain,
        randomNumberHash = _ref.randomNumberHash,
        timestamp = _ref.timestamp,
        amount = _ref.amount,
        heightSpan = _ref.heightSpan;
      return {
        from: from,
        to: to,
        recipient_other_chain: recipientOtherChain,
        sender_other_chain: senderOtherChain,
        random_number_hash: randomNumberHash,
        timestamp: timestamp.toString(),
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        }),
        height_span: heightSpan.toString()
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var from = _ref2.from,
        to = _ref2.to,
        recipient_other_chain = _ref2.recipient_other_chain,
        sender_other_chain = _ref2.sender_other_chain,
        random_number_hash = _ref2.random_number_hash,
        timestamp = _ref2.timestamp,
        amount = _ref2.amount,
        height_span = _ref2.height_span;
      return {
        from: from,
        to: to,
        recipientOtherChain: recipient_other_chain,
        senderOtherChain: sender_other_chain,
        randomNumberHash: random_number_hash,
        timestamp: _helpers.Long.fromString(timestamp),
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        }),
        heightSpan: _helpers.Long.fromString(height_span)
      };
    }
  },
  "/kava.bep3.v1beta1.MsgClaimAtomicSwap": {
    aminoType: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
    toAmino: function toAmino(_ref3) {
      var from = _ref3.from,
        swapId = _ref3.swapId,
        randomNumber = _ref3.randomNumber;
      return {
        from: from,
        swap_id: swapId,
        random_number: randomNumber
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var from = _ref4.from,
        swap_id = _ref4.swap_id,
        random_number = _ref4.random_number;
      return {
        from: from,
        swapId: swap_id,
        randomNumber: random_number
      };
    }
  },
  "/kava.bep3.v1beta1.MsgRefundAtomicSwap": {
    aminoType: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
    toAmino: function toAmino(_ref5) {
      var from = _ref5.from,
        swapId = _ref5.swapId;
      return {
        from: from,
        swap_id: swapId
      };
    },
    fromAmino: function fromAmino(_ref6) {
      var from = _ref6.from,
        swap_id = _ref6.swap_id;
      return {
        from: from,
        swapId: swap_id
      };
    }
  }
};
exports.AminoConverter = AminoConverter;