"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MsgRefundAtomicSwapResponse = exports.MsgRefundAtomicSwap = exports.MsgCreateAtomicSwapResponse = exports.MsgCreateAtomicSwap = exports.MsgClaimAtomicSwapResponse = exports.MsgClaimAtomicSwap = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseMsgCreateAtomicSwap() {
  return {
    from: "",
    to: "",
    recipientOtherChain: "",
    senderOtherChain: "",
    randomNumberHash: "",
    timestamp: _helpers.Long.ZERO,
    amount: [],
    heightSpan: _helpers.Long.UZERO
  };
}
var MsgCreateAtomicSwap = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.to !== "") {
      writer.uint32(18).string(message.to);
    }
    if (message.recipientOtherChain !== "") {
      writer.uint32(26).string(message.recipientOtherChain);
    }
    if (message.senderOtherChain !== "") {
      writer.uint32(34).string(message.senderOtherChain);
    }
    if (message.randomNumberHash !== "") {
      writer.uint32(42).string(message.randomNumberHash);
    }
    if (!message.timestamp.isZero()) {
      writer.uint32(48).int64(message.timestamp);
    }
    var _iterator = _createForOfIteratorHelper(message.amount),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        _coin.Coin.encode(v, writer.uint32(58).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    if (!message.heightSpan.isZero()) {
      writer.uint32(64).uint64(message.heightSpan);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgCreateAtomicSwap();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.to = reader.string();
          break;
        case 3:
          message.recipientOtherChain = reader.string();
          break;
        case 4:
          message.senderOtherChain = reader.string();
          break;
        case 5:
          message.randomNumberHash = reader.string();
          break;
        case 6:
          message.timestamp = reader.int64();
          break;
        case 7:
          message.amount.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        case 8:
          message.heightSpan = reader.uint64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      from: (0, _helpers.isSet)(object.from) ? String(object.from) : "",
      to: (0, _helpers.isSet)(object.to) ? String(object.to) : "",
      recipientOtherChain: (0, _helpers.isSet)(object.recipientOtherChain) ? String(object.recipientOtherChain) : "",
      senderOtherChain: (0, _helpers.isSet)(object.senderOtherChain) ? String(object.senderOtherChain) : "",
      randomNumberHash: (0, _helpers.isSet)(object.randomNumberHash) ? String(object.randomNumberHash) : "",
      timestamp: (0, _helpers.isSet)(object.timestamp) ? _helpers.Long.fromValue(object.timestamp) : _helpers.Long.ZERO,
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : [],
      heightSpan: (0, _helpers.isSet)(object.heightSpan) ? _helpers.Long.fromValue(object.heightSpan) : _helpers.Long.UZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.to !== undefined && (obj.to = message.to);
    message.recipientOtherChain !== undefined && (obj.recipientOtherChain = message.recipientOtherChain);
    message.senderOtherChain !== undefined && (obj.senderOtherChain = message.senderOtherChain);
    message.randomNumberHash !== undefined && (obj.randomNumberHash = message.randomNumberHash);
    message.timestamp !== undefined && (obj.timestamp = (message.timestamp || _helpers.Long.ZERO).toString());
    if (message.amount) {
      obj.amount = message.amount.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.amount = [];
    }
    message.heightSpan !== undefined && (obj.heightSpan = (message.heightSpan || _helpers.Long.UZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$from, _object$to, _object$recipientOthe, _object$senderOtherCh, _object$randomNumberH, _object$amount;
    var message = createBaseMsgCreateAtomicSwap();
    message.from = (_object$from = object.from) !== null && _object$from !== void 0 ? _object$from : "";
    message.to = (_object$to = object.to) !== null && _object$to !== void 0 ? _object$to : "";
    message.recipientOtherChain = (_object$recipientOthe = object.recipientOtherChain) !== null && _object$recipientOthe !== void 0 ? _object$recipientOthe : "";
    message.senderOtherChain = (_object$senderOtherCh = object.senderOtherChain) !== null && _object$senderOtherCh !== void 0 ? _object$senderOtherCh : "";
    message.randomNumberHash = (_object$randomNumberH = object.randomNumberHash) !== null && _object$randomNumberH !== void 0 ? _object$randomNumberH : "";
    message.timestamp = object.timestamp !== undefined && object.timestamp !== null ? _helpers.Long.fromValue(object.timestamp) : _helpers.Long.ZERO;
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    message.heightSpan = object.heightSpan !== undefined && object.heightSpan !== null ? _helpers.Long.fromValue(object.heightSpan) : _helpers.Long.UZERO;
    return message;
  }
};
exports.MsgCreateAtomicSwap = MsgCreateAtomicSwap;
function createBaseMsgCreateAtomicSwapResponse() {
  return {};
}
var MsgCreateAtomicSwapResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgCreateAtomicSwapResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgCreateAtomicSwapResponse();
    return message;
  }
};
exports.MsgCreateAtomicSwapResponse = MsgCreateAtomicSwapResponse;
function createBaseMsgClaimAtomicSwap() {
  return {
    from: "",
    swapId: "",
    randomNumber: ""
  };
}
var MsgClaimAtomicSwap = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.swapId !== "") {
      writer.uint32(18).string(message.swapId);
    }
    if (message.randomNumber !== "") {
      writer.uint32(26).string(message.randomNumber);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgClaimAtomicSwap();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.swapId = reader.string();
          break;
        case 3:
          message.randomNumber = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      from: (0, _helpers.isSet)(object.from) ? String(object.from) : "",
      swapId: (0, _helpers.isSet)(object.swapId) ? String(object.swapId) : "",
      randomNumber: (0, _helpers.isSet)(object.randomNumber) ? String(object.randomNumber) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.swapId !== undefined && (obj.swapId = message.swapId);
    message.randomNumber !== undefined && (obj.randomNumber = message.randomNumber);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$from2, _object$swapId, _object$randomNumber;
    var message = createBaseMsgClaimAtomicSwap();
    message.from = (_object$from2 = object.from) !== null && _object$from2 !== void 0 ? _object$from2 : "";
    message.swapId = (_object$swapId = object.swapId) !== null && _object$swapId !== void 0 ? _object$swapId : "";
    message.randomNumber = (_object$randomNumber = object.randomNumber) !== null && _object$randomNumber !== void 0 ? _object$randomNumber : "";
    return message;
  }
};
exports.MsgClaimAtomicSwap = MsgClaimAtomicSwap;
function createBaseMsgClaimAtomicSwapResponse() {
  return {};
}
var MsgClaimAtomicSwapResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgClaimAtomicSwapResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgClaimAtomicSwapResponse();
    return message;
  }
};
exports.MsgClaimAtomicSwapResponse = MsgClaimAtomicSwapResponse;
function createBaseMsgRefundAtomicSwap() {
  return {
    from: "",
    swapId: ""
  };
}
var MsgRefundAtomicSwap = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.swapId !== "") {
      writer.uint32(18).string(message.swapId);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgRefundAtomicSwap();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.swapId = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      from: (0, _helpers.isSet)(object.from) ? String(object.from) : "",
      swapId: (0, _helpers.isSet)(object.swapId) ? String(object.swapId) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.swapId !== undefined && (obj.swapId = message.swapId);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$from3, _object$swapId2;
    var message = createBaseMsgRefundAtomicSwap();
    message.from = (_object$from3 = object.from) !== null && _object$from3 !== void 0 ? _object$from3 : "";
    message.swapId = (_object$swapId2 = object.swapId) !== null && _object$swapId2 !== void 0 ? _object$swapId2 : "";
    return message;
  }
};
exports.MsgRefundAtomicSwap = MsgRefundAtomicSwap;
function createBaseMsgRefundAtomicSwapResponse() {
  return {};
}
var MsgRefundAtomicSwapResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgRefundAtomicSwapResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgRefundAtomicSwapResponse();
    return message;
  }
};
exports.MsgRefundAtomicSwapResponse = MsgRefundAtomicSwapResponse;