"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.bep3.v1beta1.MsgCreateAtomicSwap", _tx.MsgCreateAtomicSwap], ["/kava.bep3.v1beta1.MsgClaimAtomicSwap", _tx.MsgClaimAtomicSwap], ["/kava.bep3.v1beta1.MsgRefundAtomicSwap", _tx.MsgRefundAtomicSwap]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    createAtomicSwap: function createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: _tx.MsgCreateAtomicSwap.encode(value).finish()
      };
    },
    claimAtomicSwap: function claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: _tx.MsgClaimAtomicSwap.encode(value).finish()
      };
    },
    refundAtomicSwap: function refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: _tx.MsgRefundAtomicSwap.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    createAtomicSwap: function createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: value
      };
    },
    claimAtomicSwap: function claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: value
      };
    },
    refundAtomicSwap: function refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: value
      };
    }
  },
  toJSON: {
    createAtomicSwap: function createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: _tx.MsgCreateAtomicSwap.toJSON(value)
      };
    },
    claimAtomicSwap: function claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: _tx.MsgClaimAtomicSwap.toJSON(value)
      };
    },
    refundAtomicSwap: function refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: _tx.MsgRefundAtomicSwap.toJSON(value)
      };
    }
  },
  fromJSON: {
    createAtomicSwap: function createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: _tx.MsgCreateAtomicSwap.fromJSON(value)
      };
    },
    claimAtomicSwap: function claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: _tx.MsgClaimAtomicSwap.fromJSON(value)
      };
    },
    refundAtomicSwap: function refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: _tx.MsgRefundAtomicSwap.fromJSON(value)
      };
    }
  },
  fromPartial: {
    createAtomicSwap: function createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: _tx.MsgCreateAtomicSwap.fromPartial(value)
      };
    },
    claimAtomicSwap: function claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: _tx.MsgClaimAtomicSwap.fromPartial(value)
      };
    },
    refundAtomicSwap: function refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: _tx.MsgRefundAtomicSwap.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;