"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TotalPrincipal = exports.TotalCollateral = exports.OwnerCDPIndex = exports.Deposit = exports.CDP = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseCDP() {
  return {
    id: _helpers.Long.UZERO,
    owner: new Uint8Array(),
    type: "",
    collateral: undefined,
    principal: undefined,
    accumulatedFees: undefined,
    feesUpdated: undefined,
    interestFactor: ""
  };
}
var CDP = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.id.isZero()) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.owner.length !== 0) {
      writer.uint32(18).bytes(message.owner);
    }
    if (message.type !== "") {
      writer.uint32(26).string(message.type);
    }
    if (message.collateral !== undefined) {
      _coin.Coin.encode(message.collateral, writer.uint32(34).fork()).ldelim();
    }
    if (message.principal !== undefined) {
      _coin.Coin.encode(message.principal, writer.uint32(42).fork()).ldelim();
    }
    if (message.accumulatedFees !== undefined) {
      _coin.Coin.encode(message.accumulatedFees, writer.uint32(50).fork()).ldelim();
    }
    if (message.feesUpdated !== undefined) {
      _timestamp.Timestamp.encode(message.feesUpdated, writer.uint32(58).fork()).ldelim();
    }
    if (message.interestFactor !== "") {
      writer.uint32(66).string(message.interestFactor);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCDP();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = reader.uint64();
          break;
        case 2:
          message.owner = reader.bytes();
          break;
        case 3:
          message.type = reader.string();
          break;
        case 4:
          message.collateral = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.principal = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 6:
          message.accumulatedFees = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 7:
          message.feesUpdated = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 8:
          message.interestFactor = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      id: (0, _helpers.isSet)(object.id) ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO,
      owner: (0, _helpers.isSet)(object.owner) ? (0, _helpers.bytesFromBase64)(object.owner) : new Uint8Array(),
      type: (0, _helpers.isSet)(object.type) ? String(object.type) : "",
      collateral: (0, _helpers.isSet)(object.collateral) ? _coin.Coin.fromJSON(object.collateral) : undefined,
      principal: (0, _helpers.isSet)(object.principal) ? _coin.Coin.fromJSON(object.principal) : undefined,
      accumulatedFees: (0, _helpers.isSet)(object.accumulatedFees) ? _coin.Coin.fromJSON(object.accumulatedFees) : undefined,
      feesUpdated: (0, _helpers.isSet)(object.feesUpdated) ? (0, _helpers.fromJsonTimestamp)(object.feesUpdated) : undefined,
      interestFactor: (0, _helpers.isSet)(object.interestFactor) ? String(object.interestFactor) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.id !== undefined && (obj.id = (message.id || _helpers.Long.UZERO).toString());
    message.owner !== undefined && (obj.owner = (0, _helpers.base64FromBytes)(message.owner !== undefined ? message.owner : new Uint8Array()));
    message.type !== undefined && (obj.type = message.type);
    message.collateral !== undefined && (obj.collateral = message.collateral ? _coin.Coin.toJSON(message.collateral) : undefined);
    message.principal !== undefined && (obj.principal = message.principal ? _coin.Coin.toJSON(message.principal) : undefined);
    message.accumulatedFees !== undefined && (obj.accumulatedFees = message.accumulatedFees ? _coin.Coin.toJSON(message.accumulatedFees) : undefined);
    message.feesUpdated !== undefined && (obj.feesUpdated = (0, _helpers.fromTimestamp)(message.feesUpdated).toISOString());
    message.interestFactor !== undefined && (obj.interestFactor = message.interestFactor);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$owner, _object$type, _object$interestFacto;
    var message = createBaseCDP();
    message.id = object.id !== undefined && object.id !== null ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO;
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : new Uint8Array();
    message.type = (_object$type = object.type) !== null && _object$type !== void 0 ? _object$type : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? _coin.Coin.fromPartial(object.collateral) : undefined;
    message.principal = object.principal !== undefined && object.principal !== null ? _coin.Coin.fromPartial(object.principal) : undefined;
    message.accumulatedFees = object.accumulatedFees !== undefined && object.accumulatedFees !== null ? _coin.Coin.fromPartial(object.accumulatedFees) : undefined;
    message.feesUpdated = object.feesUpdated !== undefined && object.feesUpdated !== null ? _timestamp.Timestamp.fromPartial(object.feesUpdated) : undefined;
    message.interestFactor = (_object$interestFacto = object.interestFactor) !== null && _object$interestFacto !== void 0 ? _object$interestFacto : "";
    return message;
  }
};
exports.CDP = CDP;
function createBaseDeposit() {
  return {
    cdpId: _helpers.Long.UZERO,
    depositor: "",
    amount: undefined
  };
}
var Deposit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.cdpId.isZero()) {
      writer.uint32(8).uint64(message.cdpId);
    }
    if (message.depositor !== "") {
      writer.uint32(18).string(message.depositor);
    }
    if (message.amount !== undefined) {
      _coin.Coin.encode(message.amount, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseDeposit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.cdpId = reader.uint64();
          break;
        case 2:
          message.depositor = reader.string();
          break;
        case 3:
          message.amount = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      cdpId: (0, _helpers.isSet)(object.cdpId) ? _helpers.Long.fromValue(object.cdpId) : _helpers.Long.UZERO,
      depositor: (0, _helpers.isSet)(object.depositor) ? String(object.depositor) : "",
      amount: (0, _helpers.isSet)(object.amount) ? _coin.Coin.fromJSON(object.amount) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.cdpId !== undefined && (obj.cdpId = (message.cdpId || _helpers.Long.UZERO).toString());
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.amount !== undefined && (obj.amount = message.amount ? _coin.Coin.toJSON(message.amount) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor;
    var message = createBaseDeposit();
    message.cdpId = object.cdpId !== undefined && object.cdpId !== null ? _helpers.Long.fromValue(object.cdpId) : _helpers.Long.UZERO;
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.amount = object.amount !== undefined && object.amount !== null ? _coin.Coin.fromPartial(object.amount) : undefined;
    return message;
  }
};
exports.Deposit = Deposit;
function createBaseTotalPrincipal() {
  return {
    collateralType: "",
    amount: undefined
  };
}
var TotalPrincipal = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.amount !== undefined) {
      _coin.Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseTotalPrincipal();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.amount = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      amount: (0, _helpers.isSet)(object.amount) ? _coin.Coin.fromJSON(object.amount) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.amount !== undefined && (obj.amount = message.amount ? _coin.Coin.toJSON(message.amount) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralTyp;
    var message = createBaseTotalPrincipal();
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.amount = object.amount !== undefined && object.amount !== null ? _coin.Coin.fromPartial(object.amount) : undefined;
    return message;
  }
};
exports.TotalPrincipal = TotalPrincipal;
function createBaseTotalCollateral() {
  return {
    collateralType: "",
    amount: undefined
  };
}
var TotalCollateral = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.amount !== undefined) {
      _coin.Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseTotalCollateral();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.amount = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      amount: (0, _helpers.isSet)(object.amount) ? _coin.Coin.fromJSON(object.amount) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.amount !== undefined && (obj.amount = message.amount ? _coin.Coin.toJSON(message.amount) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralTyp2;
    var message = createBaseTotalCollateral();
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    message.amount = object.amount !== undefined && object.amount !== null ? _coin.Coin.fromPartial(object.amount) : undefined;
    return message;
  }
};
exports.TotalCollateral = TotalCollateral;
function createBaseOwnerCDPIndex() {
  return {
    cdpIds: []
  };
}
var OwnerCDPIndex = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    writer.uint32(10).fork();
    var _iterator = _createForOfIteratorHelper(message.cdpIds),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        writer.uint64(v);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    writer.ldelim();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseOwnerCDPIndex();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if ((tag & 7) === 2) {
            var end2 = reader.uint32() + reader.pos;
            while (reader.pos < end2) {
              message.cdpIds.push(reader.uint64());
            }
          } else {
            message.cdpIds.push(reader.uint64());
          }
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      cdpIds: Array.isArray(object === null || object === void 0 ? void 0 : object.cdpIds) ? object.cdpIds.map(function (e) {
        return _helpers.Long.fromValue(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.cdpIds) {
      obj.cdpIds = message.cdpIds.map(function (e) {
        return (e || _helpers.Long.UZERO).toString();
      });
    } else {
      obj.cdpIds = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$cdpIds;
    var message = createBaseOwnerCDPIndex();
    message.cdpIds = ((_object$cdpIds = object.cdpIds) === null || _object$cdpIds === void 0 ? void 0 : _object$cdpIds.map(function (e) {
      return _helpers.Long.fromValue(e);
    })) || [];
    return message;
  }
};
exports.OwnerCDPIndex = OwnerCDPIndex;