"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Params = exports.GenesisTotalPrincipal = exports.GenesisState = exports.GenesisAccumulationTime = exports.DebtParam = exports.CollateralParam = void 0;
var _cdp = require("./cdp");
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseGenesisState() {
  return {
    params: undefined,
    cdps: [],
    deposits: [],
    startingCdpId: _helpers.Long.UZERO,
    debtDenom: "",
    govDenom: "",
    previousAccumulationTimes: [],
    totalPrincipals: []
  };
}
var GenesisState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    var _iterator = _createForOfIteratorHelper(message.cdps),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        _cdp.CDP.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var _iterator2 = _createForOfIteratorHelper(message.deposits),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        _cdp.Deposit.encode(_v, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    if (!message.startingCdpId.isZero()) {
      writer.uint32(32).uint64(message.startingCdpId);
    }
    if (message.debtDenom !== "") {
      writer.uint32(42).string(message.debtDenom);
    }
    if (message.govDenom !== "") {
      writer.uint32(50).string(message.govDenom);
    }
    var _iterator3 = _createForOfIteratorHelper(message.previousAccumulationTimes),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var _v2 = _step3.value;
        GenesisAccumulationTime.encode(_v2, writer.uint32(58).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    var _iterator4 = _createForOfIteratorHelper(message.totalPrincipals),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var _v3 = _step4.value;
        GenesisTotalPrincipal.encode(_v3, writer.uint32(66).fork()).ldelim();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.cdps.push(_cdp.CDP.decode(reader, reader.uint32()));
          break;
        case 3:
          message.deposits.push(_cdp.Deposit.decode(reader, reader.uint32()));
          break;
        case 4:
          message.startingCdpId = reader.uint64();
          break;
        case 5:
          message.debtDenom = reader.string();
          break;
        case 6:
          message.govDenom = reader.string();
          break;
        case 7:
          message.previousAccumulationTimes.push(GenesisAccumulationTime.decode(reader, reader.uint32()));
          break;
        case 8:
          message.totalPrincipals.push(GenesisTotalPrincipal.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      params: (0, _helpers.isSet)(object.params) ? Params.fromJSON(object.params) : undefined,
      cdps: Array.isArray(object === null || object === void 0 ? void 0 : object.cdps) ? object.cdps.map(function (e) {
        return _cdp.CDP.fromJSON(e);
      }) : [],
      deposits: Array.isArray(object === null || object === void 0 ? void 0 : object.deposits) ? object.deposits.map(function (e) {
        return _cdp.Deposit.fromJSON(e);
      }) : [],
      startingCdpId: (0, _helpers.isSet)(object.startingCdpId) ? _helpers.Long.fromValue(object.startingCdpId) : _helpers.Long.UZERO,
      debtDenom: (0, _helpers.isSet)(object.debtDenom) ? String(object.debtDenom) : "",
      govDenom: (0, _helpers.isSet)(object.govDenom) ? String(object.govDenom) : "",
      previousAccumulationTimes: Array.isArray(object === null || object === void 0 ? void 0 : object.previousAccumulationTimes) ? object.previousAccumulationTimes.map(function (e) {
        return GenesisAccumulationTime.fromJSON(e);
      }) : [],
      totalPrincipals: Array.isArray(object === null || object === void 0 ? void 0 : object.totalPrincipals) ? object.totalPrincipals.map(function (e) {
        return GenesisTotalPrincipal.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    if (message.cdps) {
      obj.cdps = message.cdps.map(function (e) {
        return e ? _cdp.CDP.toJSON(e) : undefined;
      });
    } else {
      obj.cdps = [];
    }
    if (message.deposits) {
      obj.deposits = message.deposits.map(function (e) {
        return e ? _cdp.Deposit.toJSON(e) : undefined;
      });
    } else {
      obj.deposits = [];
    }
    message.startingCdpId !== undefined && (obj.startingCdpId = (message.startingCdpId || _helpers.Long.UZERO).toString());
    message.debtDenom !== undefined && (obj.debtDenom = message.debtDenom);
    message.govDenom !== undefined && (obj.govDenom = message.govDenom);
    if (message.previousAccumulationTimes) {
      obj.previousAccumulationTimes = message.previousAccumulationTimes.map(function (e) {
        return e ? GenesisAccumulationTime.toJSON(e) : undefined;
      });
    } else {
      obj.previousAccumulationTimes = [];
    }
    if (message.totalPrincipals) {
      obj.totalPrincipals = message.totalPrincipals.map(function (e) {
        return e ? GenesisTotalPrincipal.toJSON(e) : undefined;
      });
    } else {
      obj.totalPrincipals = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$cdps, _object$deposits, _object$debtDenom, _object$govDenom, _object$previousAccum, _object$totalPrincipa;
    var message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    message.cdps = ((_object$cdps = object.cdps) === null || _object$cdps === void 0 ? void 0 : _object$cdps.map(function (e) {
      return _cdp.CDP.fromPartial(e);
    })) || [];
    message.deposits = ((_object$deposits = object.deposits) === null || _object$deposits === void 0 ? void 0 : _object$deposits.map(function (e) {
      return _cdp.Deposit.fromPartial(e);
    })) || [];
    message.startingCdpId = object.startingCdpId !== undefined && object.startingCdpId !== null ? _helpers.Long.fromValue(object.startingCdpId) : _helpers.Long.UZERO;
    message.debtDenom = (_object$debtDenom = object.debtDenom) !== null && _object$debtDenom !== void 0 ? _object$debtDenom : "";
    message.govDenom = (_object$govDenom = object.govDenom) !== null && _object$govDenom !== void 0 ? _object$govDenom : "";
    message.previousAccumulationTimes = ((_object$previousAccum = object.previousAccumulationTimes) === null || _object$previousAccum === void 0 ? void 0 : _object$previousAccum.map(function (e) {
      return GenesisAccumulationTime.fromPartial(e);
    })) || [];
    message.totalPrincipals = ((_object$totalPrincipa = object.totalPrincipals) === null || _object$totalPrincipa === void 0 ? void 0 : _object$totalPrincipa.map(function (e) {
      return GenesisTotalPrincipal.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.GenesisState = GenesisState;
function createBaseParams() {
  return {
    collateralParams: [],
    debtParam: undefined,
    globalDebtLimit: undefined,
    surplusAuctionThreshold: "",
    surplusAuctionLot: "",
    debtAuctionThreshold: "",
    debtAuctionLot: "",
    circuitBreaker: false
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator5 = _createForOfIteratorHelper(message.collateralParams),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var v = _step5.value;
        CollateralParam.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    if (message.debtParam !== undefined) {
      DebtParam.encode(message.debtParam, writer.uint32(18).fork()).ldelim();
    }
    if (message.globalDebtLimit !== undefined) {
      _coin.Coin.encode(message.globalDebtLimit, writer.uint32(26).fork()).ldelim();
    }
    if (message.surplusAuctionThreshold !== "") {
      writer.uint32(34).string(message.surplusAuctionThreshold);
    }
    if (message.surplusAuctionLot !== "") {
      writer.uint32(42).string(message.surplusAuctionLot);
    }
    if (message.debtAuctionThreshold !== "") {
      writer.uint32(50).string(message.debtAuctionThreshold);
    }
    if (message.debtAuctionLot !== "") {
      writer.uint32(58).string(message.debtAuctionLot);
    }
    if (message.circuitBreaker === true) {
      writer.uint32(64).bool(message.circuitBreaker);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralParams.push(CollateralParam.decode(reader, reader.uint32()));
          break;
        case 2:
          message.debtParam = DebtParam.decode(reader, reader.uint32());
          break;
        case 3:
          message.globalDebtLimit = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.surplusAuctionThreshold = reader.string();
          break;
        case 5:
          message.surplusAuctionLot = reader.string();
          break;
        case 6:
          message.debtAuctionThreshold = reader.string();
          break;
        case 7:
          message.debtAuctionLot = reader.string();
          break;
        case 8:
          message.circuitBreaker = reader.bool();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralParams: Array.isArray(object === null || object === void 0 ? void 0 : object.collateralParams) ? object.collateralParams.map(function (e) {
        return CollateralParam.fromJSON(e);
      }) : [],
      debtParam: (0, _helpers.isSet)(object.debtParam) ? DebtParam.fromJSON(object.debtParam) : undefined,
      globalDebtLimit: (0, _helpers.isSet)(object.globalDebtLimit) ? _coin.Coin.fromJSON(object.globalDebtLimit) : undefined,
      surplusAuctionThreshold: (0, _helpers.isSet)(object.surplusAuctionThreshold) ? String(object.surplusAuctionThreshold) : "",
      surplusAuctionLot: (0, _helpers.isSet)(object.surplusAuctionLot) ? String(object.surplusAuctionLot) : "",
      debtAuctionThreshold: (0, _helpers.isSet)(object.debtAuctionThreshold) ? String(object.debtAuctionThreshold) : "",
      debtAuctionLot: (0, _helpers.isSet)(object.debtAuctionLot) ? String(object.debtAuctionLot) : "",
      circuitBreaker: (0, _helpers.isSet)(object.circuitBreaker) ? Boolean(object.circuitBreaker) : false
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.collateralParams) {
      obj.collateralParams = message.collateralParams.map(function (e) {
        return e ? CollateralParam.toJSON(e) : undefined;
      });
    } else {
      obj.collateralParams = [];
    }
    message.debtParam !== undefined && (obj.debtParam = message.debtParam ? DebtParam.toJSON(message.debtParam) : undefined);
    message.globalDebtLimit !== undefined && (obj.globalDebtLimit = message.globalDebtLimit ? _coin.Coin.toJSON(message.globalDebtLimit) : undefined);
    message.surplusAuctionThreshold !== undefined && (obj.surplusAuctionThreshold = message.surplusAuctionThreshold);
    message.surplusAuctionLot !== undefined && (obj.surplusAuctionLot = message.surplusAuctionLot);
    message.debtAuctionThreshold !== undefined && (obj.debtAuctionThreshold = message.debtAuctionThreshold);
    message.debtAuctionLot !== undefined && (obj.debtAuctionLot = message.debtAuctionLot);
    message.circuitBreaker !== undefined && (obj.circuitBreaker = message.circuitBreaker);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralPar, _object$surplusAuctio, _object$surplusAuctio2, _object$debtAuctionTh, _object$debtAuctionLo, _object$circuitBreake;
    var message = createBaseParams();
    message.collateralParams = ((_object$collateralPar = object.collateralParams) === null || _object$collateralPar === void 0 ? void 0 : _object$collateralPar.map(function (e) {
      return CollateralParam.fromPartial(e);
    })) || [];
    message.debtParam = object.debtParam !== undefined && object.debtParam !== null ? DebtParam.fromPartial(object.debtParam) : undefined;
    message.globalDebtLimit = object.globalDebtLimit !== undefined && object.globalDebtLimit !== null ? _coin.Coin.fromPartial(object.globalDebtLimit) : undefined;
    message.surplusAuctionThreshold = (_object$surplusAuctio = object.surplusAuctionThreshold) !== null && _object$surplusAuctio !== void 0 ? _object$surplusAuctio : "";
    message.surplusAuctionLot = (_object$surplusAuctio2 = object.surplusAuctionLot) !== null && _object$surplusAuctio2 !== void 0 ? _object$surplusAuctio2 : "";
    message.debtAuctionThreshold = (_object$debtAuctionTh = object.debtAuctionThreshold) !== null && _object$debtAuctionTh !== void 0 ? _object$debtAuctionTh : "";
    message.debtAuctionLot = (_object$debtAuctionLo = object.debtAuctionLot) !== null && _object$debtAuctionLo !== void 0 ? _object$debtAuctionLo : "";
    message.circuitBreaker = (_object$circuitBreake = object.circuitBreaker) !== null && _object$circuitBreake !== void 0 ? _object$circuitBreake : false;
    return message;
  }
};
exports.Params = Params;
function createBaseDebtParam() {
  return {
    denom: "",
    referenceAsset: "",
    conversionFactor: "",
    debtFloor: ""
  };
}
var DebtParam = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.referenceAsset !== "") {
      writer.uint32(18).string(message.referenceAsset);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(26).string(message.conversionFactor);
    }
    if (message.debtFloor !== "") {
      writer.uint32(34).string(message.debtFloor);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseDebtParam();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.referenceAsset = reader.string();
          break;
        case 3:
          message.conversionFactor = reader.string();
          break;
        case 4:
          message.debtFloor = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      referenceAsset: (0, _helpers.isSet)(object.referenceAsset) ? String(object.referenceAsset) : "",
      conversionFactor: (0, _helpers.isSet)(object.conversionFactor) ? String(object.conversionFactor) : "",
      debtFloor: (0, _helpers.isSet)(object.debtFloor) ? String(object.debtFloor) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.referenceAsset !== undefined && (obj.referenceAsset = message.referenceAsset);
    message.conversionFactor !== undefined && (obj.conversionFactor = message.conversionFactor);
    message.debtFloor !== undefined && (obj.debtFloor = message.debtFloor);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$denom, _object$referenceAsse, _object$conversionFac, _object$debtFloor;
    var message = createBaseDebtParam();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.referenceAsset = (_object$referenceAsse = object.referenceAsset) !== null && _object$referenceAsse !== void 0 ? _object$referenceAsse : "";
    message.conversionFactor = (_object$conversionFac = object.conversionFactor) !== null && _object$conversionFac !== void 0 ? _object$conversionFac : "";
    message.debtFloor = (_object$debtFloor = object.debtFloor) !== null && _object$debtFloor !== void 0 ? _object$debtFloor : "";
    return message;
  }
};
exports.DebtParam = DebtParam;
function createBaseCollateralParam() {
  return {
    denom: "",
    type: "",
    liquidationRatio: "",
    debtLimit: undefined,
    stabilityFee: "",
    auctionSize: "",
    liquidationPenalty: "",
    spotMarketId: "",
    liquidationMarketId: "",
    keeperRewardPercentage: "",
    checkCollateralizationIndexCount: "",
    conversionFactor: ""
  };
}
var CollateralParam = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.type !== "") {
      writer.uint32(18).string(message.type);
    }
    if (message.liquidationRatio !== "") {
      writer.uint32(26).string(message.liquidationRatio);
    }
    if (message.debtLimit !== undefined) {
      _coin.Coin.encode(message.debtLimit, writer.uint32(34).fork()).ldelim();
    }
    if (message.stabilityFee !== "") {
      writer.uint32(42).string(message.stabilityFee);
    }
    if (message.auctionSize !== "") {
      writer.uint32(50).string(message.auctionSize);
    }
    if (message.liquidationPenalty !== "") {
      writer.uint32(58).string(message.liquidationPenalty);
    }
    if (message.spotMarketId !== "") {
      writer.uint32(66).string(message.spotMarketId);
    }
    if (message.liquidationMarketId !== "") {
      writer.uint32(74).string(message.liquidationMarketId);
    }
    if (message.keeperRewardPercentage !== "") {
      writer.uint32(82).string(message.keeperRewardPercentage);
    }
    if (message.checkCollateralizationIndexCount !== "") {
      writer.uint32(90).string(message.checkCollateralizationIndexCount);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(98).string(message.conversionFactor);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCollateralParam();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.type = reader.string();
          break;
        case 3:
          message.liquidationRatio = reader.string();
          break;
        case 4:
          message.debtLimit = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.stabilityFee = reader.string();
          break;
        case 6:
          message.auctionSize = reader.string();
          break;
        case 7:
          message.liquidationPenalty = reader.string();
          break;
        case 8:
          message.spotMarketId = reader.string();
          break;
        case 9:
          message.liquidationMarketId = reader.string();
          break;
        case 10:
          message.keeperRewardPercentage = reader.string();
          break;
        case 11:
          message.checkCollateralizationIndexCount = reader.string();
          break;
        case 12:
          message.conversionFactor = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      type: (0, _helpers.isSet)(object.type) ? String(object.type) : "",
      liquidationRatio: (0, _helpers.isSet)(object.liquidationRatio) ? String(object.liquidationRatio) : "",
      debtLimit: (0, _helpers.isSet)(object.debtLimit) ? _coin.Coin.fromJSON(object.debtLimit) : undefined,
      stabilityFee: (0, _helpers.isSet)(object.stabilityFee) ? String(object.stabilityFee) : "",
      auctionSize: (0, _helpers.isSet)(object.auctionSize) ? String(object.auctionSize) : "",
      liquidationPenalty: (0, _helpers.isSet)(object.liquidationPenalty) ? String(object.liquidationPenalty) : "",
      spotMarketId: (0, _helpers.isSet)(object.spotMarketId) ? String(object.spotMarketId) : "",
      liquidationMarketId: (0, _helpers.isSet)(object.liquidationMarketId) ? String(object.liquidationMarketId) : "",
      keeperRewardPercentage: (0, _helpers.isSet)(object.keeperRewardPercentage) ? String(object.keeperRewardPercentage) : "",
      checkCollateralizationIndexCount: (0, _helpers.isSet)(object.checkCollateralizationIndexCount) ? String(object.checkCollateralizationIndexCount) : "",
      conversionFactor: (0, _helpers.isSet)(object.conversionFactor) ? String(object.conversionFactor) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.type !== undefined && (obj.type = message.type);
    message.liquidationRatio !== undefined && (obj.liquidationRatio = message.liquidationRatio);
    message.debtLimit !== undefined && (obj.debtLimit = message.debtLimit ? _coin.Coin.toJSON(message.debtLimit) : undefined);
    message.stabilityFee !== undefined && (obj.stabilityFee = message.stabilityFee);
    message.auctionSize !== undefined && (obj.auctionSize = message.auctionSize);
    message.liquidationPenalty !== undefined && (obj.liquidationPenalty = message.liquidationPenalty);
    message.spotMarketId !== undefined && (obj.spotMarketId = message.spotMarketId);
    message.liquidationMarketId !== undefined && (obj.liquidationMarketId = message.liquidationMarketId);
    message.keeperRewardPercentage !== undefined && (obj.keeperRewardPercentage = message.keeperRewardPercentage);
    message.checkCollateralizationIndexCount !== undefined && (obj.checkCollateralizationIndexCount = message.checkCollateralizationIndexCount);
    message.conversionFactor !== undefined && (obj.conversionFactor = message.conversionFactor);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$denom2, _object$type, _object$liquidationRa, _object$stabilityFee, _object$auctionSize, _object$liquidationPe, _object$spotMarketId, _object$liquidationMa, _object$keeperRewardP, _object$checkCollater, _object$conversionFac2;
    var message = createBaseCollateralParam();
    message.denom = (_object$denom2 = object.denom) !== null && _object$denom2 !== void 0 ? _object$denom2 : "";
    message.type = (_object$type = object.type) !== null && _object$type !== void 0 ? _object$type : "";
    message.liquidationRatio = (_object$liquidationRa = object.liquidationRatio) !== null && _object$liquidationRa !== void 0 ? _object$liquidationRa : "";
    message.debtLimit = object.debtLimit !== undefined && object.debtLimit !== null ? _coin.Coin.fromPartial(object.debtLimit) : undefined;
    message.stabilityFee = (_object$stabilityFee = object.stabilityFee) !== null && _object$stabilityFee !== void 0 ? _object$stabilityFee : "";
    message.auctionSize = (_object$auctionSize = object.auctionSize) !== null && _object$auctionSize !== void 0 ? _object$auctionSize : "";
    message.liquidationPenalty = (_object$liquidationPe = object.liquidationPenalty) !== null && _object$liquidationPe !== void 0 ? _object$liquidationPe : "";
    message.spotMarketId = (_object$spotMarketId = object.spotMarketId) !== null && _object$spotMarketId !== void 0 ? _object$spotMarketId : "";
    message.liquidationMarketId = (_object$liquidationMa = object.liquidationMarketId) !== null && _object$liquidationMa !== void 0 ? _object$liquidationMa : "";
    message.keeperRewardPercentage = (_object$keeperRewardP = object.keeperRewardPercentage) !== null && _object$keeperRewardP !== void 0 ? _object$keeperRewardP : "";
    message.checkCollateralizationIndexCount = (_object$checkCollater = object.checkCollateralizationIndexCount) !== null && _object$checkCollater !== void 0 ? _object$checkCollater : "";
    message.conversionFactor = (_object$conversionFac2 = object.conversionFactor) !== null && _object$conversionFac2 !== void 0 ? _object$conversionFac2 : "";
    return message;
  }
};
exports.CollateralParam = CollateralParam;
function createBaseGenesisAccumulationTime() {
  return {
    collateralType: "",
    previousAccumulationTime: undefined,
    interestFactor: ""
  };
}
var GenesisAccumulationTime = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.previousAccumulationTime !== undefined) {
      _timestamp.Timestamp.encode(message.previousAccumulationTime, writer.uint32(18).fork()).ldelim();
    }
    if (message.interestFactor !== "") {
      writer.uint32(26).string(message.interestFactor);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisAccumulationTime();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.previousAccumulationTime = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 3:
          message.interestFactor = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      previousAccumulationTime: (0, _helpers.isSet)(object.previousAccumulationTime) ? (0, _helpers.fromJsonTimestamp)(object.previousAccumulationTime) : undefined,
      interestFactor: (0, _helpers.isSet)(object.interestFactor) ? String(object.interestFactor) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.previousAccumulationTime !== undefined && (obj.previousAccumulationTime = (0, _helpers.fromTimestamp)(message.previousAccumulationTime).toISOString());
    message.interestFactor !== undefined && (obj.interestFactor = message.interestFactor);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralTyp, _object$interestFacto;
    var message = createBaseGenesisAccumulationTime();
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.previousAccumulationTime = object.previousAccumulationTime !== undefined && object.previousAccumulationTime !== null ? _timestamp.Timestamp.fromPartial(object.previousAccumulationTime) : undefined;
    message.interestFactor = (_object$interestFacto = object.interestFactor) !== null && _object$interestFacto !== void 0 ? _object$interestFacto : "";
    return message;
  }
};
exports.GenesisAccumulationTime = GenesisAccumulationTime;
function createBaseGenesisTotalPrincipal() {
  return {
    collateralType: "",
    totalPrincipal: ""
  };
}
var GenesisTotalPrincipal = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.totalPrincipal !== "") {
      writer.uint32(18).string(message.totalPrincipal);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisTotalPrincipal();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.totalPrincipal = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      totalPrincipal: (0, _helpers.isSet)(object.totalPrincipal) ? String(object.totalPrincipal) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.totalPrincipal !== undefined && (obj.totalPrincipal = message.totalPrincipal);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralTyp2, _object$totalPrincipa2;
    var message = createBaseGenesisTotalPrincipal();
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    message.totalPrincipal = (_object$totalPrincipa2 = object.totalPrincipal) !== null && _object$totalPrincipa2 !== void 0 ? _object$totalPrincipa2 : "";
    return message;
  }
};
exports.GenesisTotalPrincipal = GenesisTotalPrincipal;