"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MsgWithdrawResponse = exports.MsgWithdraw = exports.MsgRepayDebtResponse = exports.MsgRepayDebt = exports.MsgLiquidateResponse = exports.MsgLiquidate = exports.MsgDrawDebtResponse = exports.MsgDrawDebt = exports.MsgDepositResponse = exports.MsgDeposit = exports.MsgCreateCDPResponse = exports.MsgCreateCDP = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function createBaseMsgCreateCDP() {
  return {
    sender: "",
    collateral: undefined,
    principal: undefined,
    collateralType: ""
  };
}
var MsgCreateCDP = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.collateral !== undefined) {
      _coin.Coin.encode(message.collateral, writer.uint32(18).fork()).ldelim();
    }
    if (message.principal !== undefined) {
      _coin.Coin.encode(message.principal, writer.uint32(26).fork()).ldelim();
    }
    if (message.collateralType !== "") {
      writer.uint32(34).string(message.collateralType);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgCreateCDP();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.collateral = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.principal = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      sender: (0, _helpers.isSet)(object.sender) ? String(object.sender) : "",
      collateral: (0, _helpers.isSet)(object.collateral) ? _coin.Coin.fromJSON(object.collateral) : undefined,
      principal: (0, _helpers.isSet)(object.principal) ? _coin.Coin.fromJSON(object.principal) : undefined,
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.collateral !== undefined && (obj.collateral = message.collateral ? _coin.Coin.toJSON(message.collateral) : undefined);
    message.principal !== undefined && (obj.principal = message.principal ? _coin.Coin.toJSON(message.principal) : undefined);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$sender, _object$collateralTyp;
    var message = createBaseMsgCreateCDP();
    message.sender = (_object$sender = object.sender) !== null && _object$sender !== void 0 ? _object$sender : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? _coin.Coin.fromPartial(object.collateral) : undefined;
    message.principal = object.principal !== undefined && object.principal !== null ? _coin.Coin.fromPartial(object.principal) : undefined;
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    return message;
  }
};
exports.MsgCreateCDP = MsgCreateCDP;
function createBaseMsgCreateCDPResponse() {
  return {
    cdpId: _helpers.Long.UZERO
  };
}
var MsgCreateCDPResponse = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.cdpId.isZero()) {
      writer.uint32(8).uint64(message.cdpId);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgCreateCDPResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.cdpId = reader.uint64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      cdpId: (0, _helpers.isSet)(object.cdpId) ? _helpers.Long.fromValue(object.cdpId) : _helpers.Long.UZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.cdpId !== undefined && (obj.cdpId = (message.cdpId || _helpers.Long.UZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseMsgCreateCDPResponse();
    message.cdpId = object.cdpId !== undefined && object.cdpId !== null ? _helpers.Long.fromValue(object.cdpId) : _helpers.Long.UZERO;
    return message;
  }
};
exports.MsgCreateCDPResponse = MsgCreateCDPResponse;
function createBaseMsgDeposit() {
  return {
    depositor: "",
    owner: "",
    collateral: undefined,
    collateralType: ""
  };
}
var MsgDeposit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.collateral !== undefined) {
      _coin.Coin.encode(message.collateral, writer.uint32(26).fork()).ldelim();
    }
    if (message.collateralType !== "") {
      writer.uint32(34).string(message.collateralType);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDeposit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        case 3:
          message.collateral = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      depositor: (0, _helpers.isSet)(object.depositor) ? String(object.depositor) : "",
      owner: (0, _helpers.isSet)(object.owner) ? String(object.owner) : "",
      collateral: (0, _helpers.isSet)(object.collateral) ? _coin.Coin.fromJSON(object.collateral) : undefined,
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.owner !== undefined && (obj.owner = message.owner);
    message.collateral !== undefined && (obj.collateral = message.collateral ? _coin.Coin.toJSON(message.collateral) : undefined);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor, _object$owner, _object$collateralTyp2;
    var message = createBaseMsgDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? _coin.Coin.fromPartial(object.collateral) : undefined;
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    return message;
  }
};
exports.MsgDeposit = MsgDeposit;
function createBaseMsgDepositResponse() {
  return {};
}
var MsgDepositResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDepositResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgDepositResponse();
    return message;
  }
};
exports.MsgDepositResponse = MsgDepositResponse;
function createBaseMsgWithdraw() {
  return {
    depositor: "",
    owner: "",
    collateral: undefined,
    collateralType: ""
  };
}
var MsgWithdraw = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.collateral !== undefined) {
      _coin.Coin.encode(message.collateral, writer.uint32(26).fork()).ldelim();
    }
    if (message.collateralType !== "") {
      writer.uint32(34).string(message.collateralType);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgWithdraw();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        case 3:
          message.collateral = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      depositor: (0, _helpers.isSet)(object.depositor) ? String(object.depositor) : "",
      owner: (0, _helpers.isSet)(object.owner) ? String(object.owner) : "",
      collateral: (0, _helpers.isSet)(object.collateral) ? _coin.Coin.fromJSON(object.collateral) : undefined,
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.owner !== undefined && (obj.owner = message.owner);
    message.collateral !== undefined && (obj.collateral = message.collateral ? _coin.Coin.toJSON(message.collateral) : undefined);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor2, _object$owner2, _object$collateralTyp3;
    var message = createBaseMsgWithdraw();
    message.depositor = (_object$depositor2 = object.depositor) !== null && _object$depositor2 !== void 0 ? _object$depositor2 : "";
    message.owner = (_object$owner2 = object.owner) !== null && _object$owner2 !== void 0 ? _object$owner2 : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? _coin.Coin.fromPartial(object.collateral) : undefined;
    message.collateralType = (_object$collateralTyp3 = object.collateralType) !== null && _object$collateralTyp3 !== void 0 ? _object$collateralTyp3 : "";
    return message;
  }
};
exports.MsgWithdraw = MsgWithdraw;
function createBaseMsgWithdrawResponse() {
  return {};
}
var MsgWithdrawResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgWithdrawResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgWithdrawResponse();
    return message;
  }
};
exports.MsgWithdrawResponse = MsgWithdrawResponse;
function createBaseMsgDrawDebt() {
  return {
    sender: "",
    collateralType: "",
    principal: undefined
  };
}
var MsgDrawDebt = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.principal !== undefined) {
      _coin.Coin.encode(message.principal, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDrawDebt();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.principal = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      sender: (0, _helpers.isSet)(object.sender) ? String(object.sender) : "",
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      principal: (0, _helpers.isSet)(object.principal) ? _coin.Coin.fromJSON(object.principal) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.principal !== undefined && (obj.principal = message.principal ? _coin.Coin.toJSON(message.principal) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$sender2, _object$collateralTyp4;
    var message = createBaseMsgDrawDebt();
    message.sender = (_object$sender2 = object.sender) !== null && _object$sender2 !== void 0 ? _object$sender2 : "";
    message.collateralType = (_object$collateralTyp4 = object.collateralType) !== null && _object$collateralTyp4 !== void 0 ? _object$collateralTyp4 : "";
    message.principal = object.principal !== undefined && object.principal !== null ? _coin.Coin.fromPartial(object.principal) : undefined;
    return message;
  }
};
exports.MsgDrawDebt = MsgDrawDebt;
function createBaseMsgDrawDebtResponse() {
  return {};
}
var MsgDrawDebtResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDrawDebtResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgDrawDebtResponse();
    return message;
  }
};
exports.MsgDrawDebtResponse = MsgDrawDebtResponse;
function createBaseMsgRepayDebt() {
  return {
    sender: "",
    collateralType: "",
    payment: undefined
  };
}
var MsgRepayDebt = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.payment !== undefined) {
      _coin.Coin.encode(message.payment, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgRepayDebt();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.payment = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      sender: (0, _helpers.isSet)(object.sender) ? String(object.sender) : "",
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      payment: (0, _helpers.isSet)(object.payment) ? _coin.Coin.fromJSON(object.payment) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.payment !== undefined && (obj.payment = message.payment ? _coin.Coin.toJSON(message.payment) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$sender3, _object$collateralTyp5;
    var message = createBaseMsgRepayDebt();
    message.sender = (_object$sender3 = object.sender) !== null && _object$sender3 !== void 0 ? _object$sender3 : "";
    message.collateralType = (_object$collateralTyp5 = object.collateralType) !== null && _object$collateralTyp5 !== void 0 ? _object$collateralTyp5 : "";
    message.payment = object.payment !== undefined && object.payment !== null ? _coin.Coin.fromPartial(object.payment) : undefined;
    return message;
  }
};
exports.MsgRepayDebt = MsgRepayDebt;
function createBaseMsgRepayDebtResponse() {
  return {};
}
var MsgRepayDebtResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgRepayDebtResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgRepayDebtResponse();
    return message;
  }
};
exports.MsgRepayDebtResponse = MsgRepayDebtResponse;
function createBaseMsgLiquidate() {
  return {
    keeper: "",
    borrower: "",
    collateralType: ""
  };
}
var MsgLiquidate = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.keeper !== "") {
      writer.uint32(10).string(message.keeper);
    }
    if (message.borrower !== "") {
      writer.uint32(18).string(message.borrower);
    }
    if (message.collateralType !== "") {
      writer.uint32(26).string(message.collateralType);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgLiquidate();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.keeper = reader.string();
          break;
        case 2:
          message.borrower = reader.string();
          break;
        case 3:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      keeper: (0, _helpers.isSet)(object.keeper) ? String(object.keeper) : "",
      borrower: (0, _helpers.isSet)(object.borrower) ? String(object.borrower) : "",
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.keeper !== undefined && (obj.keeper = message.keeper);
    message.borrower !== undefined && (obj.borrower = message.borrower);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$keeper, _object$borrower, _object$collateralTyp6;
    var message = createBaseMsgLiquidate();
    message.keeper = (_object$keeper = object.keeper) !== null && _object$keeper !== void 0 ? _object$keeper : "";
    message.borrower = (_object$borrower = object.borrower) !== null && _object$borrower !== void 0 ? _object$borrower : "";
    message.collateralType = (_object$collateralTyp6 = object.collateralType) !== null && _object$collateralTyp6 !== void 0 ? _object$collateralTyp6 : "";
    return message;
  }
};
exports.MsgLiquidate = MsgLiquidate;
function createBaseMsgLiquidateResponse() {
  return {};
}
var MsgLiquidateResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgLiquidateResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgLiquidateResponse();
    return message;
  }
};
exports.MsgLiquidateResponse = MsgLiquidateResponse;