"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.cdp.v1beta1.MsgCreateCDP", _tx.MsgCreateCDP], ["/kava.cdp.v1beta1.MsgDeposit", _tx.MsgDeposit], ["/kava.cdp.v1beta1.MsgWithdraw", _tx.MsgWithdraw], ["/kava.cdp.v1beta1.MsgDrawDebt", _tx.MsgDrawDebt], ["/kava.cdp.v1beta1.MsgRepayDebt", _tx.MsgRepayDebt], ["/kava.cdp.v1beta1.MsgLiquidate", _tx.MsgLiquidate]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    createCDP: function createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: _tx.MsgCreateCDP.encode(value).finish()
      };
    },
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.encode(value).finish()
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.encode(value).finish()
      };
    },
    drawDebt: function drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: _tx.MsgDrawDebt.encode(value).finish()
      };
    },
    repayDebt: function repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: _tx.MsgRepayDebt.encode(value).finish()
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    createCDP: function createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: value
      };
    },
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: value
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: value
      };
    },
    drawDebt: function drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: value
      };
    },
    repayDebt: function repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: value
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: value
      };
    }
  },
  toJSON: {
    createCDP: function createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: _tx.MsgCreateCDP.toJSON(value)
      };
    },
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.toJSON(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.toJSON(value)
      };
    },
    drawDebt: function drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: _tx.MsgDrawDebt.toJSON(value)
      };
    },
    repayDebt: function repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: _tx.MsgRepayDebt.toJSON(value)
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.toJSON(value)
      };
    }
  },
  fromJSON: {
    createCDP: function createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: _tx.MsgCreateCDP.fromJSON(value)
      };
    },
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.fromJSON(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.fromJSON(value)
      };
    },
    drawDebt: function drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: _tx.MsgDrawDebt.fromJSON(value)
      };
    },
    repayDebt: function repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: _tx.MsgRepayDebt.fromJSON(value)
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.fromJSON(value)
      };
    }
  },
  fromPartial: {
    createCDP: function createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: _tx.MsgCreateCDP.fromPartial(value)
      };
    },
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.fromPartial(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.fromPartial(value)
      };
    },
    drawDebt: function drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: _tx.MsgDrawDebt.fromPartial(value)
      };
    },
    repayDebt: function repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: _tx.MsgRepayDebt.fromPartial(value)
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;