"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TokenCommittee = exports.TallyOptionSDKType = exports.TallyOption = exports.MemberCommittee = exports.BaseCommittee = void 0;
exports.tallyOptionFromJSON = tallyOptionFromJSON;
exports.tallyOptionToJSON = tallyOptionToJSON;
var _any = require("../../../google/protobuf/any");
var _duration = require("../../../google/protobuf/duration");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
/** TallyOption enumerates the valid types of a tally. */
var TallyOption;
/** TallyOption enumerates the valid types of a tally. */
exports.TallyOption = TallyOption;
(function (TallyOption) {
  TallyOption[TallyOption["TALLY_OPTION_UNSPECIFIED"] = 0] = "TALLY_OPTION_UNSPECIFIED";
  TallyOption[TallyOption["TALLY_OPTION_FIRST_PAST_THE_POST"] = 1] = "TALLY_OPTION_FIRST_PAST_THE_POST";
  TallyOption[TallyOption["TALLY_OPTION_DEADLINE"] = 2] = "TALLY_OPTION_DEADLINE";
  TallyOption[TallyOption["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(TallyOption || (exports.TallyOption = TallyOption = {}));
var TallyOptionSDKType;
exports.TallyOptionSDKType = TallyOptionSDKType;
(function (TallyOptionSDKType) {
  TallyOptionSDKType[TallyOptionSDKType["TALLY_OPTION_UNSPECIFIED"] = 0] = "TALLY_OPTION_UNSPECIFIED";
  TallyOptionSDKType[TallyOptionSDKType["TALLY_OPTION_FIRST_PAST_THE_POST"] = 1] = "TALLY_OPTION_FIRST_PAST_THE_POST";
  TallyOptionSDKType[TallyOptionSDKType["TALLY_OPTION_DEADLINE"] = 2] = "TALLY_OPTION_DEADLINE";
  TallyOptionSDKType[TallyOptionSDKType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(TallyOptionSDKType || (exports.TallyOptionSDKType = TallyOptionSDKType = {}));
function tallyOptionFromJSON(object) {
  switch (object) {
    case 0:
    case "TALLY_OPTION_UNSPECIFIED":
      return TallyOption.TALLY_OPTION_UNSPECIFIED;
    case 1:
    case "TALLY_OPTION_FIRST_PAST_THE_POST":
      return TallyOption.TALLY_OPTION_FIRST_PAST_THE_POST;
    case 2:
    case "TALLY_OPTION_DEADLINE":
      return TallyOption.TALLY_OPTION_DEADLINE;
    case -1:
    case "UNRECOGNIZED":
    default:
      return TallyOption.UNRECOGNIZED;
  }
}
function tallyOptionToJSON(object) {
  switch (object) {
    case TallyOption.TALLY_OPTION_UNSPECIFIED:
      return "TALLY_OPTION_UNSPECIFIED";
    case TallyOption.TALLY_OPTION_FIRST_PAST_THE_POST:
      return "TALLY_OPTION_FIRST_PAST_THE_POST";
    case TallyOption.TALLY_OPTION_DEADLINE:
      return "TALLY_OPTION_DEADLINE";
    case TallyOption.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}
/** BaseCommittee is a common type shared by all Committees */

function createBaseBaseCommittee() {
  return {
    id: _helpers.Long.UZERO,
    description: "",
    members: [],
    permissions: [],
    voteThreshold: "",
    proposalDuration: undefined,
    tallyOption: 0
  };
}
var BaseCommittee = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.id.isZero()) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    var _iterator = _createForOfIteratorHelper(message.members),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        writer.uint32(26).bytes(v);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var _iterator2 = _createForOfIteratorHelper(message.permissions),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        _any.Any.encode(_v, writer.uint32(34).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    if (message.voteThreshold !== "") {
      writer.uint32(42).string(message.voteThreshold);
    }
    if (message.proposalDuration !== undefined) {
      _duration.Duration.encode(message.proposalDuration, writer.uint32(50).fork()).ldelim();
    }
    if (message.tallyOption !== 0) {
      writer.uint32(56).int32(message.tallyOption);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseBaseCommittee();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = reader.uint64();
          break;
        case 2:
          message.description = reader.string();
          break;
        case 3:
          message.members.push(reader.bytes());
          break;
        case 4:
          message.permissions.push(_any.Any.decode(reader, reader.uint32()));
          break;
        case 5:
          message.voteThreshold = reader.string();
          break;
        case 6:
          message.proposalDuration = _duration.Duration.decode(reader, reader.uint32());
          break;
        case 7:
          message.tallyOption = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      id: (0, _helpers.isSet)(object.id) ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO,
      description: (0, _helpers.isSet)(object.description) ? String(object.description) : "",
      members: Array.isArray(object === null || object === void 0 ? void 0 : object.members) ? object.members.map(function (e) {
        return (0, _helpers.bytesFromBase64)(e);
      }) : [],
      permissions: Array.isArray(object === null || object === void 0 ? void 0 : object.permissions) ? object.permissions.map(function (e) {
        return _any.Any.fromJSON(e);
      }) : [],
      voteThreshold: (0, _helpers.isSet)(object.voteThreshold) ? String(object.voteThreshold) : "",
      proposalDuration: (0, _helpers.isSet)(object.proposalDuration) ? _duration.Duration.fromJSON(object.proposalDuration) : undefined,
      tallyOption: (0, _helpers.isSet)(object.tallyOption) ? tallyOptionFromJSON(object.tallyOption) : 0
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.id !== undefined && (obj.id = (message.id || _helpers.Long.UZERO).toString());
    message.description !== undefined && (obj.description = message.description);
    if (message.members) {
      obj.members = message.members.map(function (e) {
        return (0, _helpers.base64FromBytes)(e !== undefined ? e : new Uint8Array());
      });
    } else {
      obj.members = [];
    }
    if (message.permissions) {
      obj.permissions = message.permissions.map(function (e) {
        return e ? _any.Any.toJSON(e) : undefined;
      });
    } else {
      obj.permissions = [];
    }
    message.voteThreshold !== undefined && (obj.voteThreshold = message.voteThreshold);
    message.proposalDuration !== undefined && (obj.proposalDuration = message.proposalDuration ? _duration.Duration.toJSON(message.proposalDuration) : undefined);
    message.tallyOption !== undefined && (obj.tallyOption = tallyOptionToJSON(message.tallyOption));
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$description, _object$members, _object$permissions, _object$voteThreshold, _object$tallyOption;
    var message = createBaseBaseCommittee();
    message.id = object.id !== undefined && object.id !== null ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO;
    message.description = (_object$description = object.description) !== null && _object$description !== void 0 ? _object$description : "";
    message.members = ((_object$members = object.members) === null || _object$members === void 0 ? void 0 : _object$members.map(function (e) {
      return e;
    })) || [];
    message.permissions = ((_object$permissions = object.permissions) === null || _object$permissions === void 0 ? void 0 : _object$permissions.map(function (e) {
      return _any.Any.fromPartial(e);
    })) || [];
    message.voteThreshold = (_object$voteThreshold = object.voteThreshold) !== null && _object$voteThreshold !== void 0 ? _object$voteThreshold : "";
    message.proposalDuration = object.proposalDuration !== undefined && object.proposalDuration !== null ? _duration.Duration.fromPartial(object.proposalDuration) : undefined;
    message.tallyOption = (_object$tallyOption = object.tallyOption) !== null && _object$tallyOption !== void 0 ? _object$tallyOption : 0;
    return message;
  }
};
exports.BaseCommittee = BaseCommittee;
function createBaseMemberCommittee() {
  return {
    baseCommittee: undefined
  };
}
var MemberCommittee = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.baseCommittee !== undefined) {
      BaseCommittee.encode(message.baseCommittee, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMemberCommittee();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseCommittee = BaseCommittee.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      baseCommittee: (0, _helpers.isSet)(object.baseCommittee) ? BaseCommittee.fromJSON(object.baseCommittee) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.baseCommittee !== undefined && (obj.baseCommittee = message.baseCommittee ? BaseCommittee.toJSON(message.baseCommittee) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseMemberCommittee();
    message.baseCommittee = object.baseCommittee !== undefined && object.baseCommittee !== null ? BaseCommittee.fromPartial(object.baseCommittee) : undefined;
    return message;
  }
};
exports.MemberCommittee = MemberCommittee;
function createBaseTokenCommittee() {
  return {
    baseCommittee: undefined,
    quorum: "",
    tallyDenom: ""
  };
}
var TokenCommittee = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.baseCommittee !== undefined) {
      BaseCommittee.encode(message.baseCommittee, writer.uint32(10).fork()).ldelim();
    }
    if (message.quorum !== "") {
      writer.uint32(18).string(message.quorum);
    }
    if (message.tallyDenom !== "") {
      writer.uint32(26).string(message.tallyDenom);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseTokenCommittee();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseCommittee = BaseCommittee.decode(reader, reader.uint32());
          break;
        case 2:
          message.quorum = reader.string();
          break;
        case 3:
          message.tallyDenom = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      baseCommittee: (0, _helpers.isSet)(object.baseCommittee) ? BaseCommittee.fromJSON(object.baseCommittee) : undefined,
      quorum: (0, _helpers.isSet)(object.quorum) ? String(object.quorum) : "",
      tallyDenom: (0, _helpers.isSet)(object.tallyDenom) ? String(object.tallyDenom) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.baseCommittee !== undefined && (obj.baseCommittee = message.baseCommittee ? BaseCommittee.toJSON(message.baseCommittee) : undefined);
    message.quorum !== undefined && (obj.quorum = message.quorum);
    message.tallyDenom !== undefined && (obj.tallyDenom = message.tallyDenom);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$quorum, _object$tallyDenom;
    var message = createBaseTokenCommittee();
    message.baseCommittee = object.baseCommittee !== undefined && object.baseCommittee !== null ? BaseCommittee.fromPartial(object.baseCommittee) : undefined;
    message.quorum = (_object$quorum = object.quorum) !== null && _object$quorum !== void 0 ? _object$quorum : "";
    message.tallyDenom = (_object$tallyDenom = object.tallyDenom) !== null && _object$tallyDenom !== void 0 ? _object$tallyDenom : "";
    return message;
  }
};
exports.TokenCommittee = TokenCommittee;