"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VoteTypeSDKType = exports.VoteType = exports.Vote = exports.Proposal = exports.GenesisState = void 0;
exports.voteTypeFromJSON = voteTypeFromJSON;
exports.voteTypeToJSON = voteTypeToJSON;
var _any = require("../../../google/protobuf/any");
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
/** VoteType enumerates the valid types of a vote. */
var VoteType;
/** VoteType enumerates the valid types of a vote. */
exports.VoteType = VoteType;
(function (VoteType) {
  VoteType[VoteType["VOTE_TYPE_UNSPECIFIED"] = 0] = "VOTE_TYPE_UNSPECIFIED";
  VoteType[VoteType["VOTE_TYPE_YES"] = 1] = "VOTE_TYPE_YES";
  VoteType[VoteType["VOTE_TYPE_NO"] = 2] = "VOTE_TYPE_NO";
  VoteType[VoteType["VOTE_TYPE_ABSTAIN"] = 3] = "VOTE_TYPE_ABSTAIN";
  VoteType[VoteType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(VoteType || (exports.VoteType = VoteType = {}));
var VoteTypeSDKType;
exports.VoteTypeSDKType = VoteTypeSDKType;
(function (VoteTypeSDKType) {
  VoteTypeSDKType[VoteTypeSDKType["VOTE_TYPE_UNSPECIFIED"] = 0] = "VOTE_TYPE_UNSPECIFIED";
  VoteTypeSDKType[VoteTypeSDKType["VOTE_TYPE_YES"] = 1] = "VOTE_TYPE_YES";
  VoteTypeSDKType[VoteTypeSDKType["VOTE_TYPE_NO"] = 2] = "VOTE_TYPE_NO";
  VoteTypeSDKType[VoteTypeSDKType["VOTE_TYPE_ABSTAIN"] = 3] = "VOTE_TYPE_ABSTAIN";
  VoteTypeSDKType[VoteTypeSDKType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(VoteTypeSDKType || (exports.VoteTypeSDKType = VoteTypeSDKType = {}));
function voteTypeFromJSON(object) {
  switch (object) {
    case 0:
    case "VOTE_TYPE_UNSPECIFIED":
      return VoteType.VOTE_TYPE_UNSPECIFIED;
    case 1:
    case "VOTE_TYPE_YES":
      return VoteType.VOTE_TYPE_YES;
    case 2:
    case "VOTE_TYPE_NO":
      return VoteType.VOTE_TYPE_NO;
    case 3:
    case "VOTE_TYPE_ABSTAIN":
      return VoteType.VOTE_TYPE_ABSTAIN;
    case -1:
    case "UNRECOGNIZED":
    default:
      return VoteType.UNRECOGNIZED;
  }
}
function voteTypeToJSON(object) {
  switch (object) {
    case VoteType.VOTE_TYPE_UNSPECIFIED:
      return "VOTE_TYPE_UNSPECIFIED";
    case VoteType.VOTE_TYPE_YES:
      return "VOTE_TYPE_YES";
    case VoteType.VOTE_TYPE_NO:
      return "VOTE_TYPE_NO";
    case VoteType.VOTE_TYPE_ABSTAIN:
      return "VOTE_TYPE_ABSTAIN";
    case VoteType.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}
/** GenesisState defines the committee module's genesis state. */

function createBaseGenesisState() {
  return {
    nextProposalId: _helpers.Long.UZERO,
    committees: [],
    proposals: [],
    votes: []
  };
}
var GenesisState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.nextProposalId.isZero()) {
      writer.uint32(8).uint64(message.nextProposalId);
    }
    var _iterator = _createForOfIteratorHelper(message.committees),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        _any.Any.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var _iterator2 = _createForOfIteratorHelper(message.proposals),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        Proposal.encode(_v, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    var _iterator3 = _createForOfIteratorHelper(message.votes),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var _v2 = _step3.value;
        Vote.encode(_v2, writer.uint32(34).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.nextProposalId = reader.uint64();
          break;
        case 2:
          message.committees.push(_any.Any.decode(reader, reader.uint32()));
          break;
        case 3:
          message.proposals.push(Proposal.decode(reader, reader.uint32()));
          break;
        case 4:
          message.votes.push(Vote.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      nextProposalId: (0, _helpers.isSet)(object.nextProposalId) ? _helpers.Long.fromValue(object.nextProposalId) : _helpers.Long.UZERO,
      committees: Array.isArray(object === null || object === void 0 ? void 0 : object.committees) ? object.committees.map(function (e) {
        return _any.Any.fromJSON(e);
      }) : [],
      proposals: Array.isArray(object === null || object === void 0 ? void 0 : object.proposals) ? object.proposals.map(function (e) {
        return Proposal.fromJSON(e);
      }) : [],
      votes: Array.isArray(object === null || object === void 0 ? void 0 : object.votes) ? object.votes.map(function (e) {
        return Vote.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.nextProposalId !== undefined && (obj.nextProposalId = (message.nextProposalId || _helpers.Long.UZERO).toString());
    if (message.committees) {
      obj.committees = message.committees.map(function (e) {
        return e ? _any.Any.toJSON(e) : undefined;
      });
    } else {
      obj.committees = [];
    }
    if (message.proposals) {
      obj.proposals = message.proposals.map(function (e) {
        return e ? Proposal.toJSON(e) : undefined;
      });
    } else {
      obj.proposals = [];
    }
    if (message.votes) {
      obj.votes = message.votes.map(function (e) {
        return e ? Vote.toJSON(e) : undefined;
      });
    } else {
      obj.votes = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$committees, _object$proposals, _object$votes;
    var message = createBaseGenesisState();
    message.nextProposalId = object.nextProposalId !== undefined && object.nextProposalId !== null ? _helpers.Long.fromValue(object.nextProposalId) : _helpers.Long.UZERO;
    message.committees = ((_object$committees = object.committees) === null || _object$committees === void 0 ? void 0 : _object$committees.map(function (e) {
      return _any.Any.fromPartial(e);
    })) || [];
    message.proposals = ((_object$proposals = object.proposals) === null || _object$proposals === void 0 ? void 0 : _object$proposals.map(function (e) {
      return Proposal.fromPartial(e);
    })) || [];
    message.votes = ((_object$votes = object.votes) === null || _object$votes === void 0 ? void 0 : _object$votes.map(function (e) {
      return Vote.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.GenesisState = GenesisState;
function createBaseProposal() {
  return {
    content: undefined,
    id: _helpers.Long.UZERO,
    committeeId: _helpers.Long.UZERO,
    deadline: undefined
  };
}
var Proposal = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.content !== undefined) {
      _any.Any.encode(message.content, writer.uint32(10).fork()).ldelim();
    }
    if (!message.id.isZero()) {
      writer.uint32(16).uint64(message.id);
    }
    if (!message.committeeId.isZero()) {
      writer.uint32(24).uint64(message.committeeId);
    }
    if (message.deadline !== undefined) {
      _timestamp.Timestamp.encode(message.deadline, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseProposal();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.content = _any.Any.decode(reader, reader.uint32());
          break;
        case 2:
          message.id = reader.uint64();
          break;
        case 3:
          message.committeeId = reader.uint64();
          break;
        case 4:
          message.deadline = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      content: (0, _helpers.isSet)(object.content) ? _any.Any.fromJSON(object.content) : undefined,
      id: (0, _helpers.isSet)(object.id) ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO,
      committeeId: (0, _helpers.isSet)(object.committeeId) ? _helpers.Long.fromValue(object.committeeId) : _helpers.Long.UZERO,
      deadline: (0, _helpers.isSet)(object.deadline) ? (0, _helpers.fromJsonTimestamp)(object.deadline) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.content !== undefined && (obj.content = message.content ? _any.Any.toJSON(message.content) : undefined);
    message.id !== undefined && (obj.id = (message.id || _helpers.Long.UZERO).toString());
    message.committeeId !== undefined && (obj.committeeId = (message.committeeId || _helpers.Long.UZERO).toString());
    message.deadline !== undefined && (obj.deadline = (0, _helpers.fromTimestamp)(message.deadline).toISOString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseProposal();
    message.content = object.content !== undefined && object.content !== null ? _any.Any.fromPartial(object.content) : undefined;
    message.id = object.id !== undefined && object.id !== null ? _helpers.Long.fromValue(object.id) : _helpers.Long.UZERO;
    message.committeeId = object.committeeId !== undefined && object.committeeId !== null ? _helpers.Long.fromValue(object.committeeId) : _helpers.Long.UZERO;
    message.deadline = object.deadline !== undefined && object.deadline !== null ? _timestamp.Timestamp.fromPartial(object.deadline) : undefined;
    return message;
  }
};
exports.Proposal = Proposal;
function createBaseVote() {
  return {
    proposalId: _helpers.Long.UZERO,
    voter: new Uint8Array(),
    voteType: 0
  };
}
var Vote = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (!message.proposalId.isZero()) {
      writer.uint32(8).uint64(message.proposalId);
    }
    if (message.voter.length !== 0) {
      writer.uint32(18).bytes(message.voter);
    }
    if (message.voteType !== 0) {
      writer.uint32(24).int32(message.voteType);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseVote();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.proposalId = reader.uint64();
          break;
        case 2:
          message.voter = reader.bytes();
          break;
        case 3:
          message.voteType = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      proposalId: (0, _helpers.isSet)(object.proposalId) ? _helpers.Long.fromValue(object.proposalId) : _helpers.Long.UZERO,
      voter: (0, _helpers.isSet)(object.voter) ? (0, _helpers.bytesFromBase64)(object.voter) : new Uint8Array(),
      voteType: (0, _helpers.isSet)(object.voteType) ? voteTypeFromJSON(object.voteType) : 0
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.proposalId !== undefined && (obj.proposalId = (message.proposalId || _helpers.Long.UZERO).toString());
    message.voter !== undefined && (obj.voter = (0, _helpers.base64FromBytes)(message.voter !== undefined ? message.voter : new Uint8Array()));
    message.voteType !== undefined && (obj.voteType = voteTypeToJSON(message.voteType));
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$voter, _object$voteType;
    var message = createBaseVote();
    message.proposalId = object.proposalId !== undefined && object.proposalId !== null ? _helpers.Long.fromValue(object.proposalId) : _helpers.Long.UZERO;
    message.voter = (_object$voter = object.voter) !== null && _object$voter !== void 0 ? _object$voter : new Uint8Array();
    message.voteType = (_object$voteType = object.voteType) !== null && _object$voteType !== void 0 ? _object$voteType : 0;
    return message;
  }
};
exports.Vote = Vote;