"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRpcQueryExtension = exports.QueryClientImpl = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _stargate = require("@cosmjs/stargate");
var _query = require("./query");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var QueryClientImpl = /*#__PURE__*/function () {
  function QueryClientImpl(rpc) {
    (0, _classCallCheck2["default"])(this, QueryClientImpl);
    (0, _defineProperty2["default"])(this, "rpc", void 0);
    this.rpc = rpc;
    this.committees = this.committees.bind(this);
    this.committee = this.committee.bind(this);
    this.proposals = this.proposals.bind(this);
    this.proposal = this.proposal.bind(this);
    this.nextProposalID = this.nextProposalID.bind(this);
    this.votes = this.votes.bind(this);
    this.vote = this.vote.bind(this);
    this.tally = this.tally.bind(this);
    this.rawParams = this.rawParams.bind(this);
  }
  (0, _createClass2["default"])(QueryClientImpl, [{
    key: "committees",
    value: function committees() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryCommitteesRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Committees", data);
      return promise.then(function (data) {
        return _query.QueryCommitteesResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "committee",
    value: function committee(request) {
      var data = _query.QueryCommitteeRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Committee", data);
      return promise.then(function (data) {
        return _query.QueryCommitteeResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "proposals",
    value: function proposals(request) {
      var data = _query.QueryProposalsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Proposals", data);
      return promise.then(function (data) {
        return _query.QueryProposalsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "proposal",
    value: function proposal(request) {
      var data = _query.QueryProposalRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Proposal", data);
      return promise.then(function (data) {
        return _query.QueryProposalResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "nextProposalID",
    value: function nextProposalID() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryNextProposalIDRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "NextProposalID", data);
      return promise.then(function (data) {
        return _query.QueryNextProposalIDResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "votes",
    value: function votes(request) {
      var data = _query.QueryVotesRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Votes", data);
      return promise.then(function (data) {
        return _query.QueryVotesResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "vote",
    value: function vote(request) {
      var data = _query.QueryVoteRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Vote", data);
      return promise.then(function (data) {
        return _query.QueryVoteResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "tally",
    value: function tally(request) {
      var data = _query.QueryTallyRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "Tally", data);
      return promise.then(function (data) {
        return _query.QueryTallyResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "rawParams",
    value: function rawParams(request) {
      var data = _query.QueryRawParamsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.committee.v1beta1.Query", "RawParams", data);
      return promise.then(function (data) {
        return _query.QueryRawParamsResponse.decode(new _m0.Reader(data));
      });
    }
  }]);
  return QueryClientImpl;
}();
exports.QueryClientImpl = QueryClientImpl;
var createRpcQueryExtension = function createRpcQueryExtension(base) {
  var rpc = (0, _stargate.createProtobufRpcClient)(base);
  var queryService = new QueryClientImpl(rpc);
  return {
    committees: function committees(request) {
      return queryService.committees(request);
    },
    committee: function committee(request) {
      return queryService.committee(request);
    },
    proposals: function proposals(request) {
      return queryService.proposals(request);
    },
    proposal: function proposal(request) {
      return queryService.proposal(request);
    },
    nextProposalID: function nextProposalID(request) {
      return queryService.nextProposalID(request);
    },
    votes: function votes(request) {
      return queryService.votes(request);
    },
    vote: function vote(request) {
      return queryService.vote(request);
    },
    tally: function tally(request) {
      return queryService.tally(request);
    },
    rawParams: function rawParams(request) {
      return queryService.rawParams(request);
    }
  };
};
exports.createRpcQueryExtension = createRpcQueryExtension;