"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _genesis = require("./genesis");
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.committee.v1beta1.MsgSubmitProposal": {
    aminoType: "/kava.committee.v1beta1.MsgSubmitProposal",
    toAmino: function toAmino(_ref) {
      var pubProposal = _ref.pubProposal,
        proposer = _ref.proposer,
        committeeId = _ref.committeeId;
      return {
        pub_proposal: {
          type_url: pubProposal.typeUrl,
          value: pubProposal.value
        },
        proposer: proposer,
        committee_id: committeeId.toString()
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var pub_proposal = _ref2.pub_proposal,
        proposer = _ref2.proposer,
        committee_id = _ref2.committee_id;
      return {
        pubProposal: {
          typeUrl: pub_proposal.type_url,
          value: pub_proposal.value
        },
        proposer: proposer,
        committeeId: _helpers.Long.fromString(committee_id)
      };
    }
  },
  "/kava.committee.v1beta1.MsgVote": {
    aminoType: "/kava.committee.v1beta1.MsgVote",
    toAmino: function toAmino(_ref3) {
      var proposalId = _ref3.proposalId,
        voter = _ref3.voter,
        voteType = _ref3.voteType;
      return {
        proposal_id: proposalId.toString(),
        voter: voter,
        vote_type: voteType
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var proposal_id = _ref4.proposal_id,
        voter = _ref4.voter,
        vote_type = _ref4.vote_type;
      return {
        proposalId: _helpers.Long.fromString(proposal_id),
        voter: voter,
        voteType: (0, _genesis.voteTypeFromJSON)(vote_type)
      };
    }
  }
};
exports.AminoConverter = AminoConverter;