"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _strategy = require("./strategy");
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.earn.v1beta1.MsgDeposit": {
    aminoType: "/kava.earn.v1beta1.MsgDeposit",
    toAmino: function toAmino(_ref) {
      var depositor = _ref.depositor,
        amount = _ref.amount,
        strategy = _ref.strategy;
      return {
        depositor: depositor,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        },
        strategy: strategy
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var depositor = _ref2.depositor,
        amount = _ref2.amount,
        strategy = _ref2.strategy;
      return {
        depositor: depositor,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        },
        strategy: (0, _strategy.strategyTypeFromJSON)(strategy)
      };
    }
  },
  "/kava.earn.v1beta1.MsgWithdraw": {
    aminoType: "/kava.earn.v1beta1.MsgWithdraw",
    toAmino: function toAmino(_ref3) {
      var from = _ref3.from,
        amount = _ref3.amount,
        strategy = _ref3.strategy;
      return {
        from: from,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        },
        strategy: strategy
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var from = _ref4.from,
        amount = _ref4.amount,
        strategy = _ref4.strategy;
      return {
        from: from,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        },
        strategy: (0, _strategy.strategyTypeFromJSON)(strategy)
      };
    }
  }
};
exports.AminoConverter = AminoConverter;