"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MsgWithdrawResponse = exports.MsgWithdraw = exports.MsgDepositResponse = exports.MsgDeposit = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _strategy = require("./strategy");
var _vault = require("./vault");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function createBaseMsgDeposit() {
  return {
    depositor: "",
    amount: undefined,
    strategy: 0
  };
}
var MsgDeposit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.amount !== undefined) {
      _coin.Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
    }
    if (message.strategy !== 0) {
      writer.uint32(24).int32(message.strategy);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDeposit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.amount = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.strategy = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      depositor: (0, _helpers.isSet)(object.depositor) ? String(object.depositor) : "",
      amount: (0, _helpers.isSet)(object.amount) ? _coin.Coin.fromJSON(object.amount) : undefined,
      strategy: (0, _helpers.isSet)(object.strategy) ? (0, _strategy.strategyTypeFromJSON)(object.strategy) : 0
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.amount !== undefined && (obj.amount = message.amount ? _coin.Coin.toJSON(message.amount) : undefined);
    message.strategy !== undefined && (obj.strategy = (0, _strategy.strategyTypeToJSON)(message.strategy));
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor, _object$strategy;
    var message = createBaseMsgDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.amount = object.amount !== undefined && object.amount !== null ? _coin.Coin.fromPartial(object.amount) : undefined;
    message.strategy = (_object$strategy = object.strategy) !== null && _object$strategy !== void 0 ? _object$strategy : 0;
    return message;
  }
};
exports.MsgDeposit = MsgDeposit;
function createBaseMsgDepositResponse() {
  return {
    shares: undefined
  };
}
var MsgDepositResponse = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.shares !== undefined) {
      _vault.VaultShare.encode(message.shares, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDepositResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.shares = _vault.VaultShare.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      shares: (0, _helpers.isSet)(object.shares) ? _vault.VaultShare.fromJSON(object.shares) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.shares !== undefined && (obj.shares = message.shares ? _vault.VaultShare.toJSON(message.shares) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseMsgDepositResponse();
    message.shares = object.shares !== undefined && object.shares !== null ? _vault.VaultShare.fromPartial(object.shares) : undefined;
    return message;
  }
};
exports.MsgDepositResponse = MsgDepositResponse;
function createBaseMsgWithdraw() {
  return {
    from: "",
    amount: undefined,
    strategy: 0
  };
}
var MsgWithdraw = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.amount !== undefined) {
      _coin.Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
    }
    if (message.strategy !== 0) {
      writer.uint32(24).int32(message.strategy);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgWithdraw();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.amount = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.strategy = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      from: (0, _helpers.isSet)(object.from) ? String(object.from) : "",
      amount: (0, _helpers.isSet)(object.amount) ? _coin.Coin.fromJSON(object.amount) : undefined,
      strategy: (0, _helpers.isSet)(object.strategy) ? (0, _strategy.strategyTypeFromJSON)(object.strategy) : 0
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.amount !== undefined && (obj.amount = message.amount ? _coin.Coin.toJSON(message.amount) : undefined);
    message.strategy !== undefined && (obj.strategy = (0, _strategy.strategyTypeToJSON)(message.strategy));
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$from, _object$strategy2;
    var message = createBaseMsgWithdraw();
    message.from = (_object$from = object.from) !== null && _object$from !== void 0 ? _object$from : "";
    message.amount = object.amount !== undefined && object.amount !== null ? _coin.Coin.fromPartial(object.amount) : undefined;
    message.strategy = (_object$strategy2 = object.strategy) !== null && _object$strategy2 !== void 0 ? _object$strategy2 : 0;
    return message;
  }
};
exports.MsgWithdraw = MsgWithdraw;
function createBaseMsgWithdrawResponse() {
  return {
    shares: undefined
  };
}
var MsgWithdrawResponse = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.shares !== undefined) {
      _vault.VaultShare.encode(message.shares, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgWithdrawResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.shares = _vault.VaultShare.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      shares: (0, _helpers.isSet)(object.shares) ? _vault.VaultShare.fromJSON(object.shares) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.shares !== undefined && (obj.shares = message.shares ? _vault.VaultShare.toJSON(message.shares) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseMsgWithdrawResponse();
    message.shares = object.shares !== undefined && object.shares !== null ? _vault.VaultShare.fromPartial(object.shares) : undefined;
    return message;
  }
};
exports.MsgWithdrawResponse = MsgWithdrawResponse;