"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.evmutil.v1beta1.MsgConvertCoinToERC20": {
    aminoType: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
    toAmino: function toAmino(_ref) {
      var initiator = _ref.initiator,
        receiver = _ref.receiver,
        amount = _ref.amount;
      return {
        initiator: initiator,
        receiver: receiver,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var initiator = _ref2.initiator,
        receiver = _ref2.receiver,
        amount = _ref2.amount;
      return {
        initiator: initiator,
        receiver: receiver,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin": {
    aminoType: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
    toAmino: function toAmino(_ref3) {
      var initiator = _ref3.initiator,
        receiver = _ref3.receiver,
        kavaErc20Address = _ref3.kavaErc20Address,
        amount = _ref3.amount;
      return {
        initiator: initiator,
        receiver: receiver,
        kava_erc20_address: kavaErc20Address,
        amount: amount
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var initiator = _ref4.initiator,
        receiver = _ref4.receiver,
        kava_erc20_address = _ref4.kava_erc20_address,
        amount = _ref4.amount;
      return {
        initiator: initiator,
        receiver: receiver,
        kavaErc20Address: kava_erc20_address,
        amount: amount
      };
    }
  }
};
exports.AminoConverter = AminoConverter;