"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.evmutil.v1beta1.MsgConvertCoinToERC20", _tx.MsgConvertCoinToERC20], ["/kava.evmutil.v1beta1.MsgConvertERC20ToCoin", _tx.MsgConvertERC20ToCoin]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    convertCoinToERC20: function convertCoinToERC20(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
        value: _tx.MsgConvertCoinToERC20.encode(value).finish()
      };
    },
    convertERC20ToCoin: function convertERC20ToCoin(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
        value: _tx.MsgConvertERC20ToCoin.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    convertCoinToERC20: function convertCoinToERC20(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
        value: value
      };
    },
    convertERC20ToCoin: function convertERC20ToCoin(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
        value: value
      };
    }
  },
  toJSON: {
    convertCoinToERC20: function convertCoinToERC20(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
        value: _tx.MsgConvertCoinToERC20.toJSON(value)
      };
    },
    convertERC20ToCoin: function convertERC20ToCoin(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
        value: _tx.MsgConvertERC20ToCoin.toJSON(value)
      };
    }
  },
  fromJSON: {
    convertCoinToERC20: function convertCoinToERC20(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
        value: _tx.MsgConvertCoinToERC20.fromJSON(value)
      };
    },
    convertERC20ToCoin: function convertERC20ToCoin(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
        value: _tx.MsgConvertERC20ToCoin.fromJSON(value)
      };
    }
  },
  fromPartial: {
    convertCoinToERC20: function convertCoinToERC20(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
        value: _tx.MsgConvertCoinToERC20.fromPartial(value)
      };
    },
    convertERC20ToCoin: function convertERC20ToCoin(value) {
      return {
        typeUrl: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
        value: _tx.MsgConvertERC20ToCoin.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;