"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenesisState = exports.GenesisAccumulationTime = void 0;
var _hard = require("./hard");
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseGenesisState() {
  return {
    params: undefined,
    previousAccumulationTimes: [],
    deposits: [],
    borrows: [],
    totalSupplied: [],
    totalBorrowed: [],
    totalReserves: []
  };
}
var GenesisState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.params !== undefined) {
      _hard.Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    var _iterator = _createForOfIteratorHelper(message.previousAccumulationTimes),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        GenesisAccumulationTime.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var _iterator2 = _createForOfIteratorHelper(message.deposits),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        _hard.Deposit.encode(_v, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    var _iterator3 = _createForOfIteratorHelper(message.borrows),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var _v2 = _step3.value;
        _hard.Borrow.encode(_v2, writer.uint32(34).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    var _iterator4 = _createForOfIteratorHelper(message.totalSupplied),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var _v3 = _step4.value;
        _coin.Coin.encode(_v3, writer.uint32(42).fork()).ldelim();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    var _iterator5 = _createForOfIteratorHelper(message.totalBorrowed),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var _v4 = _step5.value;
        _coin.Coin.encode(_v4, writer.uint32(50).fork()).ldelim();
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    var _iterator6 = _createForOfIteratorHelper(message.totalReserves),
      _step6;
    try {
      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
        var _v5 = _step6.value;
        _coin.Coin.encode(_v5, writer.uint32(58).fork()).ldelim();
      }
    } catch (err) {
      _iterator6.e(err);
    } finally {
      _iterator6.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = _hard.Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.previousAccumulationTimes.push(GenesisAccumulationTime.decode(reader, reader.uint32()));
          break;
        case 3:
          message.deposits.push(_hard.Deposit.decode(reader, reader.uint32()));
          break;
        case 4:
          message.borrows.push(_hard.Borrow.decode(reader, reader.uint32()));
          break;
        case 5:
          message.totalSupplied.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        case 6:
          message.totalBorrowed.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        case 7:
          message.totalReserves.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      params: (0, _helpers.isSet)(object.params) ? _hard.Params.fromJSON(object.params) : undefined,
      previousAccumulationTimes: Array.isArray(object === null || object === void 0 ? void 0 : object.previousAccumulationTimes) ? object.previousAccumulationTimes.map(function (e) {
        return GenesisAccumulationTime.fromJSON(e);
      }) : [],
      deposits: Array.isArray(object === null || object === void 0 ? void 0 : object.deposits) ? object.deposits.map(function (e) {
        return _hard.Deposit.fromJSON(e);
      }) : [],
      borrows: Array.isArray(object === null || object === void 0 ? void 0 : object.borrows) ? object.borrows.map(function (e) {
        return _hard.Borrow.fromJSON(e);
      }) : [],
      totalSupplied: Array.isArray(object === null || object === void 0 ? void 0 : object.totalSupplied) ? object.totalSupplied.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : [],
      totalBorrowed: Array.isArray(object === null || object === void 0 ? void 0 : object.totalBorrowed) ? object.totalBorrowed.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : [],
      totalReserves: Array.isArray(object === null || object === void 0 ? void 0 : object.totalReserves) ? object.totalReserves.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.params !== undefined && (obj.params = message.params ? _hard.Params.toJSON(message.params) : undefined);
    if (message.previousAccumulationTimes) {
      obj.previousAccumulationTimes = message.previousAccumulationTimes.map(function (e) {
        return e ? GenesisAccumulationTime.toJSON(e) : undefined;
      });
    } else {
      obj.previousAccumulationTimes = [];
    }
    if (message.deposits) {
      obj.deposits = message.deposits.map(function (e) {
        return e ? _hard.Deposit.toJSON(e) : undefined;
      });
    } else {
      obj.deposits = [];
    }
    if (message.borrows) {
      obj.borrows = message.borrows.map(function (e) {
        return e ? _hard.Borrow.toJSON(e) : undefined;
      });
    } else {
      obj.borrows = [];
    }
    if (message.totalSupplied) {
      obj.totalSupplied = message.totalSupplied.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.totalSupplied = [];
    }
    if (message.totalBorrowed) {
      obj.totalBorrowed = message.totalBorrowed.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.totalBorrowed = [];
    }
    if (message.totalReserves) {
      obj.totalReserves = message.totalReserves.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.totalReserves = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$previousAccum, _object$deposits, _object$borrows, _object$totalSupplied, _object$totalBorrowed, _object$totalReserves;
    var message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? _hard.Params.fromPartial(object.params) : undefined;
    message.previousAccumulationTimes = ((_object$previousAccum = object.previousAccumulationTimes) === null || _object$previousAccum === void 0 ? void 0 : _object$previousAccum.map(function (e) {
      return GenesisAccumulationTime.fromPartial(e);
    })) || [];
    message.deposits = ((_object$deposits = object.deposits) === null || _object$deposits === void 0 ? void 0 : _object$deposits.map(function (e) {
      return _hard.Deposit.fromPartial(e);
    })) || [];
    message.borrows = ((_object$borrows = object.borrows) === null || _object$borrows === void 0 ? void 0 : _object$borrows.map(function (e) {
      return _hard.Borrow.fromPartial(e);
    })) || [];
    message.totalSupplied = ((_object$totalSupplied = object.totalSupplied) === null || _object$totalSupplied === void 0 ? void 0 : _object$totalSupplied.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    message.totalBorrowed = ((_object$totalBorrowed = object.totalBorrowed) === null || _object$totalBorrowed === void 0 ? void 0 : _object$totalBorrowed.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    message.totalReserves = ((_object$totalReserves = object.totalReserves) === null || _object$totalReserves === void 0 ? void 0 : _object$totalReserves.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.GenesisState = GenesisState;
function createBaseGenesisAccumulationTime() {
  return {
    collateralType: "",
    previousAccumulationTime: undefined,
    supplyInterestFactor: "",
    borrowInterestFactor: ""
  };
}
var GenesisAccumulationTime = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.previousAccumulationTime !== undefined) {
      _timestamp.Timestamp.encode(message.previousAccumulationTime, writer.uint32(18).fork()).ldelim();
    }
    if (message.supplyInterestFactor !== "") {
      writer.uint32(26).string(message.supplyInterestFactor);
    }
    if (message.borrowInterestFactor !== "") {
      writer.uint32(34).string(message.borrowInterestFactor);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisAccumulationTime();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.previousAccumulationTime = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 3:
          message.supplyInterestFactor = reader.string();
          break;
        case 4:
          message.borrowInterestFactor = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      previousAccumulationTime: (0, _helpers.isSet)(object.previousAccumulationTime) ? (0, _helpers.fromJsonTimestamp)(object.previousAccumulationTime) : undefined,
      supplyInterestFactor: (0, _helpers.isSet)(object.supplyInterestFactor) ? String(object.supplyInterestFactor) : "",
      borrowInterestFactor: (0, _helpers.isSet)(object.borrowInterestFactor) ? String(object.borrowInterestFactor) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.previousAccumulationTime !== undefined && (obj.previousAccumulationTime = (0, _helpers.fromTimestamp)(message.previousAccumulationTime).toISOString());
    message.supplyInterestFactor !== undefined && (obj.supplyInterestFactor = message.supplyInterestFactor);
    message.borrowInterestFactor !== undefined && (obj.borrowInterestFactor = message.borrowInterestFactor);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralTyp, _object$supplyInteres, _object$borrowInteres;
    var message = createBaseGenesisAccumulationTime();
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.previousAccumulationTime = object.previousAccumulationTime !== undefined && object.previousAccumulationTime !== null ? _timestamp.Timestamp.fromPartial(object.previousAccumulationTime) : undefined;
    message.supplyInterestFactor = (_object$supplyInteres = object.supplyInterestFactor) !== null && _object$supplyInteres !== void 0 ? _object$supplyInteres : "";
    message.borrowInterestFactor = (_object$borrowInteres = object.borrowInterestFactor) !== null && _object$borrowInteres !== void 0 ? _object$borrowInteres : "";
    return message;
  }
};
exports.GenesisAccumulationTime = GenesisAccumulationTime;