"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SupplyInterestFactor = exports.Params = exports.MoneyMarket = exports.InterestRateModel = exports.Deposit = exports.CoinsProto = exports.BorrowLimit = exports.BorrowInterestFactor = exports.Borrow = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseParams() {
  return {
    moneyMarkets: [],
    minimumBorrowUsdValue: ""
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator = _createForOfIteratorHelper(message.moneyMarkets),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        MoneyMarket.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    if (message.minimumBorrowUsdValue !== "") {
      writer.uint32(18).string(message.minimumBorrowUsdValue);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.moneyMarkets.push(MoneyMarket.decode(reader, reader.uint32()));
          break;
        case 2:
          message.minimumBorrowUsdValue = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      moneyMarkets: Array.isArray(object === null || object === void 0 ? void 0 : object.moneyMarkets) ? object.moneyMarkets.map(function (e) {
        return MoneyMarket.fromJSON(e);
      }) : [],
      minimumBorrowUsdValue: (0, _helpers.isSet)(object.minimumBorrowUsdValue) ? String(object.minimumBorrowUsdValue) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.moneyMarkets) {
      obj.moneyMarkets = message.moneyMarkets.map(function (e) {
        return e ? MoneyMarket.toJSON(e) : undefined;
      });
    } else {
      obj.moneyMarkets = [];
    }
    message.minimumBorrowUsdValue !== undefined && (obj.minimumBorrowUsdValue = message.minimumBorrowUsdValue);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$moneyMarkets, _object$minimumBorrow;
    var message = createBaseParams();
    message.moneyMarkets = ((_object$moneyMarkets = object.moneyMarkets) === null || _object$moneyMarkets === void 0 ? void 0 : _object$moneyMarkets.map(function (e) {
      return MoneyMarket.fromPartial(e);
    })) || [];
    message.minimumBorrowUsdValue = (_object$minimumBorrow = object.minimumBorrowUsdValue) !== null && _object$minimumBorrow !== void 0 ? _object$minimumBorrow : "";
    return message;
  }
};
exports.Params = Params;
function createBaseMoneyMarket() {
  return {
    denom: "",
    borrowLimit: undefined,
    spotMarketId: "",
    conversionFactor: "",
    interestRateModel: undefined,
    reserveFactor: "",
    keeperRewardPercentage: ""
  };
}
var MoneyMarket = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.borrowLimit !== undefined) {
      BorrowLimit.encode(message.borrowLimit, writer.uint32(18).fork()).ldelim();
    }
    if (message.spotMarketId !== "") {
      writer.uint32(26).string(message.spotMarketId);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(34).string(message.conversionFactor);
    }
    if (message.interestRateModel !== undefined) {
      InterestRateModel.encode(message.interestRateModel, writer.uint32(42).fork()).ldelim();
    }
    if (message.reserveFactor !== "") {
      writer.uint32(50).string(message.reserveFactor);
    }
    if (message.keeperRewardPercentage !== "") {
      writer.uint32(58).string(message.keeperRewardPercentage);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMoneyMarket();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.borrowLimit = BorrowLimit.decode(reader, reader.uint32());
          break;
        case 3:
          message.spotMarketId = reader.string();
          break;
        case 4:
          message.conversionFactor = reader.string();
          break;
        case 5:
          message.interestRateModel = InterestRateModel.decode(reader, reader.uint32());
          break;
        case 6:
          message.reserveFactor = reader.string();
          break;
        case 7:
          message.keeperRewardPercentage = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      borrowLimit: (0, _helpers.isSet)(object.borrowLimit) ? BorrowLimit.fromJSON(object.borrowLimit) : undefined,
      spotMarketId: (0, _helpers.isSet)(object.spotMarketId) ? String(object.spotMarketId) : "",
      conversionFactor: (0, _helpers.isSet)(object.conversionFactor) ? String(object.conversionFactor) : "",
      interestRateModel: (0, _helpers.isSet)(object.interestRateModel) ? InterestRateModel.fromJSON(object.interestRateModel) : undefined,
      reserveFactor: (0, _helpers.isSet)(object.reserveFactor) ? String(object.reserveFactor) : "",
      keeperRewardPercentage: (0, _helpers.isSet)(object.keeperRewardPercentage) ? String(object.keeperRewardPercentage) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.borrowLimit !== undefined && (obj.borrowLimit = message.borrowLimit ? BorrowLimit.toJSON(message.borrowLimit) : undefined);
    message.spotMarketId !== undefined && (obj.spotMarketId = message.spotMarketId);
    message.conversionFactor !== undefined && (obj.conversionFactor = message.conversionFactor);
    message.interestRateModel !== undefined && (obj.interestRateModel = message.interestRateModel ? InterestRateModel.toJSON(message.interestRateModel) : undefined);
    message.reserveFactor !== undefined && (obj.reserveFactor = message.reserveFactor);
    message.keeperRewardPercentage !== undefined && (obj.keeperRewardPercentage = message.keeperRewardPercentage);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$denom, _object$spotMarketId, _object$conversionFac, _object$reserveFactor, _object$keeperRewardP;
    var message = createBaseMoneyMarket();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.borrowLimit = object.borrowLimit !== undefined && object.borrowLimit !== null ? BorrowLimit.fromPartial(object.borrowLimit) : undefined;
    message.spotMarketId = (_object$spotMarketId = object.spotMarketId) !== null && _object$spotMarketId !== void 0 ? _object$spotMarketId : "";
    message.conversionFactor = (_object$conversionFac = object.conversionFactor) !== null && _object$conversionFac !== void 0 ? _object$conversionFac : "";
    message.interestRateModel = object.interestRateModel !== undefined && object.interestRateModel !== null ? InterestRateModel.fromPartial(object.interestRateModel) : undefined;
    message.reserveFactor = (_object$reserveFactor = object.reserveFactor) !== null && _object$reserveFactor !== void 0 ? _object$reserveFactor : "";
    message.keeperRewardPercentage = (_object$keeperRewardP = object.keeperRewardPercentage) !== null && _object$keeperRewardP !== void 0 ? _object$keeperRewardP : "";
    return message;
  }
};
exports.MoneyMarket = MoneyMarket;
function createBaseBorrowLimit() {
  return {
    hasMaxLimit: false,
    maximumLimit: "",
    loanToValue: ""
  };
}
var BorrowLimit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.hasMaxLimit === true) {
      writer.uint32(8).bool(message.hasMaxLimit);
    }
    if (message.maximumLimit !== "") {
      writer.uint32(18).string(message.maximumLimit);
    }
    if (message.loanToValue !== "") {
      writer.uint32(26).string(message.loanToValue);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseBorrowLimit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.hasMaxLimit = reader.bool();
          break;
        case 2:
          message.maximumLimit = reader.string();
          break;
        case 3:
          message.loanToValue = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      hasMaxLimit: (0, _helpers.isSet)(object.hasMaxLimit) ? Boolean(object.hasMaxLimit) : false,
      maximumLimit: (0, _helpers.isSet)(object.maximumLimit) ? String(object.maximumLimit) : "",
      loanToValue: (0, _helpers.isSet)(object.loanToValue) ? String(object.loanToValue) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.hasMaxLimit !== undefined && (obj.hasMaxLimit = message.hasMaxLimit);
    message.maximumLimit !== undefined && (obj.maximumLimit = message.maximumLimit);
    message.loanToValue !== undefined && (obj.loanToValue = message.loanToValue);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$hasMaxLimit, _object$maximumLimit, _object$loanToValue;
    var message = createBaseBorrowLimit();
    message.hasMaxLimit = (_object$hasMaxLimit = object.hasMaxLimit) !== null && _object$hasMaxLimit !== void 0 ? _object$hasMaxLimit : false;
    message.maximumLimit = (_object$maximumLimit = object.maximumLimit) !== null && _object$maximumLimit !== void 0 ? _object$maximumLimit : "";
    message.loanToValue = (_object$loanToValue = object.loanToValue) !== null && _object$loanToValue !== void 0 ? _object$loanToValue : "";
    return message;
  }
};
exports.BorrowLimit = BorrowLimit;
function createBaseInterestRateModel() {
  return {
    baseRateApy: "",
    baseMultiplier: "",
    kink: "",
    jumpMultiplier: ""
  };
}
var InterestRateModel = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.baseRateApy !== "") {
      writer.uint32(10).string(message.baseRateApy);
    }
    if (message.baseMultiplier !== "") {
      writer.uint32(18).string(message.baseMultiplier);
    }
    if (message.kink !== "") {
      writer.uint32(26).string(message.kink);
    }
    if (message.jumpMultiplier !== "") {
      writer.uint32(34).string(message.jumpMultiplier);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseInterestRateModel();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseRateApy = reader.string();
          break;
        case 2:
          message.baseMultiplier = reader.string();
          break;
        case 3:
          message.kink = reader.string();
          break;
        case 4:
          message.jumpMultiplier = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      baseRateApy: (0, _helpers.isSet)(object.baseRateApy) ? String(object.baseRateApy) : "",
      baseMultiplier: (0, _helpers.isSet)(object.baseMultiplier) ? String(object.baseMultiplier) : "",
      kink: (0, _helpers.isSet)(object.kink) ? String(object.kink) : "",
      jumpMultiplier: (0, _helpers.isSet)(object.jumpMultiplier) ? String(object.jumpMultiplier) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.baseRateApy !== undefined && (obj.baseRateApy = message.baseRateApy);
    message.baseMultiplier !== undefined && (obj.baseMultiplier = message.baseMultiplier);
    message.kink !== undefined && (obj.kink = message.kink);
    message.jumpMultiplier !== undefined && (obj.jumpMultiplier = message.jumpMultiplier);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$baseRateApy, _object$baseMultiplie, _object$kink, _object$jumpMultiplie;
    var message = createBaseInterestRateModel();
    message.baseRateApy = (_object$baseRateApy = object.baseRateApy) !== null && _object$baseRateApy !== void 0 ? _object$baseRateApy : "";
    message.baseMultiplier = (_object$baseMultiplie = object.baseMultiplier) !== null && _object$baseMultiplie !== void 0 ? _object$baseMultiplie : "";
    message.kink = (_object$kink = object.kink) !== null && _object$kink !== void 0 ? _object$kink : "";
    message.jumpMultiplier = (_object$jumpMultiplie = object.jumpMultiplier) !== null && _object$jumpMultiplie !== void 0 ? _object$jumpMultiplie : "";
    return message;
  }
};
exports.InterestRateModel = InterestRateModel;
function createBaseDeposit() {
  return {
    depositor: "",
    amount: [],
    index: []
  };
}
var Deposit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    var _iterator2 = _createForOfIteratorHelper(message.amount),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var v = _step2.value;
        _coin.Coin.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    var _iterator3 = _createForOfIteratorHelper(message.index),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var _v = _step3.value;
        SupplyInterestFactor.encode(_v, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseDeposit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.amount.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        case 3:
          message.index.push(SupplyInterestFactor.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      depositor: (0, _helpers.isSet)(object.depositor) ? String(object.depositor) : "",
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : [],
      index: Array.isArray(object === null || object === void 0 ? void 0 : object.index) ? object.index.map(function (e) {
        return SupplyInterestFactor.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    if (message.amount) {
      obj.amount = message.amount.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.amount = [];
    }
    if (message.index) {
      obj.index = message.index.map(function (e) {
        return e ? SupplyInterestFactor.toJSON(e) : undefined;
      });
    } else {
      obj.index = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor, _object$amount, _object$index;
    var message = createBaseDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    message.index = ((_object$index = object.index) === null || _object$index === void 0 ? void 0 : _object$index.map(function (e) {
      return SupplyInterestFactor.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.Deposit = Deposit;
function createBaseBorrow() {
  return {
    borrower: "",
    amount: [],
    index: []
  };
}
var Borrow = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.borrower !== "") {
      writer.uint32(10).string(message.borrower);
    }
    var _iterator4 = _createForOfIteratorHelper(message.amount),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var v = _step4.value;
        _coin.Coin.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    var _iterator5 = _createForOfIteratorHelper(message.index),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var _v2 = _step5.value;
        BorrowInterestFactor.encode(_v2, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseBorrow();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.borrower = reader.string();
          break;
        case 2:
          message.amount.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        case 3:
          message.index.push(BorrowInterestFactor.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      borrower: (0, _helpers.isSet)(object.borrower) ? String(object.borrower) : "",
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : [],
      index: Array.isArray(object === null || object === void 0 ? void 0 : object.index) ? object.index.map(function (e) {
        return BorrowInterestFactor.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.borrower !== undefined && (obj.borrower = message.borrower);
    if (message.amount) {
      obj.amount = message.amount.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.amount = [];
    }
    if (message.index) {
      obj.index = message.index.map(function (e) {
        return e ? BorrowInterestFactor.toJSON(e) : undefined;
      });
    } else {
      obj.index = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$borrower, _object$amount2, _object$index2;
    var message = createBaseBorrow();
    message.borrower = (_object$borrower = object.borrower) !== null && _object$borrower !== void 0 ? _object$borrower : "";
    message.amount = ((_object$amount2 = object.amount) === null || _object$amount2 === void 0 ? void 0 : _object$amount2.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    message.index = ((_object$index2 = object.index) === null || _object$index2 === void 0 ? void 0 : _object$index2.map(function (e) {
      return BorrowInterestFactor.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.Borrow = Borrow;
function createBaseSupplyInterestFactor() {
  return {
    denom: "",
    value: ""
  };
}
var SupplyInterestFactor = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseSupplyInterestFactor();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.value = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      value: (0, _helpers.isSet)(object.value) ? String(object.value) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$denom2, _object$value;
    var message = createBaseSupplyInterestFactor();
    message.denom = (_object$denom2 = object.denom) !== null && _object$denom2 !== void 0 ? _object$denom2 : "";
    message.value = (_object$value = object.value) !== null && _object$value !== void 0 ? _object$value : "";
    return message;
  }
};
exports.SupplyInterestFactor = SupplyInterestFactor;
function createBaseBorrowInterestFactor() {
  return {
    denom: "",
    value: ""
  };
}
var BorrowInterestFactor = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseBorrowInterestFactor();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.value = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      value: (0, _helpers.isSet)(object.value) ? String(object.value) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$denom3, _object$value2;
    var message = createBaseBorrowInterestFactor();
    message.denom = (_object$denom3 = object.denom) !== null && _object$denom3 !== void 0 ? _object$denom3 : "";
    message.value = (_object$value2 = object.value) !== null && _object$value2 !== void 0 ? _object$value2 : "";
    return message;
  }
};
exports.BorrowInterestFactor = BorrowInterestFactor;
function createBaseCoinsProto() {
  return {
    coins: []
  };
}
var CoinsProto = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator6 = _createForOfIteratorHelper(message.coins),
      _step6;
    try {
      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
        var v = _step6.value;
        _coin.Coin.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator6.e(err);
    } finally {
      _iterator6.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCoinsProto();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.coins.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      coins: Array.isArray(object === null || object === void 0 ? void 0 : object.coins) ? object.coins.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.coins) {
      obj.coins = message.coins.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.coins = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$coins;
    var message = createBaseCoinsProto();
    message.coins = ((_object$coins = object.coins) === null || _object$coins === void 0 ? void 0 : _object$coins.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.CoinsProto = CoinsProto;