"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRpcQueryExtension = exports.QueryClientImpl = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _stargate = require("@cosmjs/stargate");
var _query = require("./query");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var QueryClientImpl = /*#__PURE__*/function () {
  function QueryClientImpl(rpc) {
    (0, _classCallCheck2["default"])(this, QueryClientImpl);
    (0, _defineProperty2["default"])(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.accounts = this.accounts.bind(this);
    this.deposits = this.deposits.bind(this);
    this.unsyncedDeposits = this.unsyncedDeposits.bind(this);
    this.totalDeposited = this.totalDeposited.bind(this);
    this.borrows = this.borrows.bind(this);
    this.unsyncedBorrows = this.unsyncedBorrows.bind(this);
    this.totalBorrowed = this.totalBorrowed.bind(this);
    this.interestRate = this.interestRate.bind(this);
    this.reserves = this.reserves.bind(this);
    this.interestFactors = this.interestFactors.bind(this);
  }
  (0, _createClass2["default"])(QueryClientImpl, [{
    key: "params",
    value: function params() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryParamsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "Params", data);
      return promise.then(function (data) {
        return _query.QueryParamsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "accounts",
    value: function accounts() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryAccountsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "Accounts", data);
      return promise.then(function (data) {
        return _query.QueryAccountsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "deposits",
    value: function deposits(request) {
      var data = _query.QueryDepositsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "Deposits", data);
      return promise.then(function (data) {
        return _query.QueryDepositsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "unsyncedDeposits",
    value: function unsyncedDeposits(request) {
      var data = _query.QueryUnsyncedDepositsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "UnsyncedDeposits", data);
      return promise.then(function (data) {
        return _query.QueryUnsyncedDepositsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "totalDeposited",
    value: function totalDeposited(request) {
      var data = _query.QueryTotalDepositedRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "TotalDeposited", data);
      return promise.then(function (data) {
        return _query.QueryTotalDepositedResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "borrows",
    value: function borrows(request) {
      var data = _query.QueryBorrowsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "Borrows", data);
      return promise.then(function (data) {
        return _query.QueryBorrowsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "unsyncedBorrows",
    value: function unsyncedBorrows(request) {
      var data = _query.QueryUnsyncedBorrowsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "UnsyncedBorrows", data);
      return promise.then(function (data) {
        return _query.QueryUnsyncedBorrowsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "totalBorrowed",
    value: function totalBorrowed(request) {
      var data = _query.QueryTotalBorrowedRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "TotalBorrowed", data);
      return promise.then(function (data) {
        return _query.QueryTotalBorrowedResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "interestRate",
    value: function interestRate(request) {
      var data = _query.QueryInterestRateRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "InterestRate", data);
      return promise.then(function (data) {
        return _query.QueryInterestRateResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "reserves",
    value: function reserves(request) {
      var data = _query.QueryReservesRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "Reserves", data);
      return promise.then(function (data) {
        return _query.QueryReservesResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "interestFactors",
    value: function interestFactors(request) {
      var data = _query.QueryInterestFactorsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.hard.v1beta1.Query", "InterestFactors", data);
      return promise.then(function (data) {
        return _query.QueryInterestFactorsResponse.decode(new _m0.Reader(data));
      });
    }
  }]);
  return QueryClientImpl;
}();
exports.QueryClientImpl = QueryClientImpl;
var createRpcQueryExtension = function createRpcQueryExtension(base) {
  var rpc = (0, _stargate.createProtobufRpcClient)(base);
  var queryService = new QueryClientImpl(rpc);
  return {
    params: function params(request) {
      return queryService.params(request);
    },
    accounts: function accounts(request) {
      return queryService.accounts(request);
    },
    deposits: function deposits(request) {
      return queryService.deposits(request);
    },
    unsyncedDeposits: function unsyncedDeposits(request) {
      return queryService.unsyncedDeposits(request);
    },
    totalDeposited: function totalDeposited(request) {
      return queryService.totalDeposited(request);
    },
    borrows: function borrows(request) {
      return queryService.borrows(request);
    },
    unsyncedBorrows: function unsyncedBorrows(request) {
      return queryService.unsyncedBorrows(request);
    },
    totalBorrowed: function totalBorrowed(request) {
      return queryService.totalBorrowed(request);
    },
    interestRate: function interestRate(request) {
      return queryService.interestRate(request);
    },
    reserves: function reserves(request) {
      return queryService.reserves(request);
    },
    interestFactors: function interestFactors(request) {
      return queryService.interestFactors(request);
    }
  };
};
exports.createRpcQueryExtension = createRpcQueryExtension;