"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
//@ts-nocheck

var AminoConverter = {
  "/kava.hard.v1beta1.MsgDeposit": {
    aminoType: "/kava.hard.v1beta1.MsgDeposit",
    toAmino: function toAmino(_ref) {
      var depositor = _ref.depositor,
        amount = _ref.amount;
      return {
        depositor: depositor,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var depositor = _ref2.depositor,
        amount = _ref2.amount;
      return {
        depositor: depositor,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    }
  },
  "/kava.hard.v1beta1.MsgWithdraw": {
    aminoType: "/kava.hard.v1beta1.MsgWithdraw",
    toAmino: function toAmino(_ref3) {
      var depositor = _ref3.depositor,
        amount = _ref3.amount;
      return {
        depositor: depositor,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var depositor = _ref4.depositor,
        amount = _ref4.amount;
      return {
        depositor: depositor,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    }
  },
  "/kava.hard.v1beta1.MsgBorrow": {
    aminoType: "/kava.hard.v1beta1.MsgBorrow",
    toAmino: function toAmino(_ref5) {
      var borrower = _ref5.borrower,
        amount = _ref5.amount;
      return {
        borrower: borrower,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref6) {
      var borrower = _ref6.borrower,
        amount = _ref6.amount;
      return {
        borrower: borrower,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    }
  },
  "/kava.hard.v1beta1.MsgRepay": {
    aminoType: "/kava.hard.v1beta1.MsgRepay",
    toAmino: function toAmino(_ref7) {
      var sender = _ref7.sender,
        owner = _ref7.owner,
        amount = _ref7.amount;
      return {
        sender: sender,
        owner: owner,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref8) {
      var sender = _ref8.sender,
        owner = _ref8.owner,
        amount = _ref8.amount;
      return {
        sender: sender,
        owner: owner,
        amount: amount.map(function (el0) {
          return {
            denom: el0.denom,
            amount: el0.amount
          };
        })
      };
    }
  },
  "/kava.hard.v1beta1.MsgLiquidate": {
    aminoType: "/kava.hard.v1beta1.MsgLiquidate",
    toAmino: function toAmino(_ref9) {
      var keeper = _ref9.keeper,
        borrower = _ref9.borrower;
      return {
        keeper: keeper,
        borrower: borrower
      };
    },
    fromAmino: function fromAmino(_ref10) {
      var keeper = _ref10.keeper,
        borrower = _ref10.borrower;
      return {
        keeper: keeper,
        borrower: borrower
      };
    }
  }
};
exports.AminoConverter = AminoConverter;