"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.hard.v1beta1.MsgDeposit", _tx.MsgDeposit], ["/kava.hard.v1beta1.MsgWithdraw", _tx.MsgWithdraw], ["/kava.hard.v1beta1.MsgBorrow", _tx.MsgBorrow], ["/kava.hard.v1beta1.MsgRepay", _tx.MsgRepay], ["/kava.hard.v1beta1.MsgLiquidate", _tx.MsgLiquidate]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.encode(value).finish()
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.encode(value).finish()
      };
    },
    borrow: function borrow(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgBorrow",
        value: _tx.MsgBorrow.encode(value).finish()
      };
    },
    repay: function repay(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgRepay",
        value: _tx.MsgRepay.encode(value).finish()
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgDeposit",
        value: value
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgWithdraw",
        value: value
      };
    },
    borrow: function borrow(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgBorrow",
        value: value
      };
    },
    repay: function repay(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgRepay",
        value: value
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgLiquidate",
        value: value
      };
    }
  },
  toJSON: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.toJSON(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.toJSON(value)
      };
    },
    borrow: function borrow(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgBorrow",
        value: _tx.MsgBorrow.toJSON(value)
      };
    },
    repay: function repay(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgRepay",
        value: _tx.MsgRepay.toJSON(value)
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.toJSON(value)
      };
    }
  },
  fromJSON: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.fromJSON(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.fromJSON(value)
      };
    },
    borrow: function borrow(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgBorrow",
        value: _tx.MsgBorrow.fromJSON(value)
      };
    },
    repay: function repay(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgRepay",
        value: _tx.MsgRepay.fromJSON(value)
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.fromJSON(value)
      };
    }
  },
  fromPartial: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.fromPartial(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.fromPartial(value)
      };
    },
    borrow: function borrow(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgBorrow",
        value: _tx.MsgBorrow.fromPartial(value)
      };
    },
    repay: function repay(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgRepay",
        value: _tx.MsgRepay.fromPartial(value)
      };
    },
    liquidate: function liquidate(value) {
      return {
        typeUrl: "/kava.hard.v1beta1.MsgLiquidate",
        value: _tx.MsgLiquidate.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;