"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenesisState = exports.GenesisRewardState = exports.AccumulationTime = void 0;
var _timestamp = require("../../../google/protobuf/timestamp");
var _claims = require("./claims");
var _params = require("./params");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseAccumulationTime() {
  return {
    collateralType: "",
    previousAccumulationTime: undefined
  };
}
var AccumulationTime = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.previousAccumulationTime !== undefined) {
      _timestamp.Timestamp.encode(message.previousAccumulationTime, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseAccumulationTime();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.previousAccumulationTime = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      previousAccumulationTime: (0, _helpers.isSet)(object.previousAccumulationTime) ? (0, _helpers.fromJsonTimestamp)(object.previousAccumulationTime) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.previousAccumulationTime !== undefined && (obj.previousAccumulationTime = (0, _helpers.fromTimestamp)(message.previousAccumulationTime).toISOString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$collateralTyp;
    var message = createBaseAccumulationTime();
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.previousAccumulationTime = object.previousAccumulationTime !== undefined && object.previousAccumulationTime !== null ? _timestamp.Timestamp.fromPartial(object.previousAccumulationTime) : undefined;
    return message;
  }
};
exports.AccumulationTime = AccumulationTime;
function createBaseGenesisRewardState() {
  return {
    accumulationTimes: [],
    multiRewardIndexes: []
  };
}
var GenesisRewardState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator = _createForOfIteratorHelper(message.accumulationTimes),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        AccumulationTime.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var _iterator2 = _createForOfIteratorHelper(message.multiRewardIndexes),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        _claims.MultiRewardIndex.encode(_v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisRewardState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.accumulationTimes.push(AccumulationTime.decode(reader, reader.uint32()));
          break;
        case 2:
          message.multiRewardIndexes.push(_claims.MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      accumulationTimes: Array.isArray(object === null || object === void 0 ? void 0 : object.accumulationTimes) ? object.accumulationTimes.map(function (e) {
        return AccumulationTime.fromJSON(e);
      }) : [],
      multiRewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.multiRewardIndexes) ? object.multiRewardIndexes.map(function (e) {
        return _claims.MultiRewardIndex.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.accumulationTimes) {
      obj.accumulationTimes = message.accumulationTimes.map(function (e) {
        return e ? AccumulationTime.toJSON(e) : undefined;
      });
    } else {
      obj.accumulationTimes = [];
    }
    if (message.multiRewardIndexes) {
      obj.multiRewardIndexes = message.multiRewardIndexes.map(function (e) {
        return e ? _claims.MultiRewardIndex.toJSON(e) : undefined;
      });
    } else {
      obj.multiRewardIndexes = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$accumulationT, _object$multiRewardIn;
    var message = createBaseGenesisRewardState();
    message.accumulationTimes = ((_object$accumulationT = object.accumulationTimes) === null || _object$accumulationT === void 0 ? void 0 : _object$accumulationT.map(function (e) {
      return AccumulationTime.fromPartial(e);
    })) || [];
    message.multiRewardIndexes = ((_object$multiRewardIn = object.multiRewardIndexes) === null || _object$multiRewardIn === void 0 ? void 0 : _object$multiRewardIn.map(function (e) {
      return _claims.MultiRewardIndex.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.GenesisRewardState = GenesisRewardState;
function createBaseGenesisState() {
  return {
    params: undefined,
    usdxRewardState: undefined,
    hardSupplyRewardState: undefined,
    hardBorrowRewardState: undefined,
    delegatorRewardState: undefined,
    swapRewardState: undefined,
    usdxMintingClaims: [],
    hardLiquidityProviderClaims: [],
    delegatorClaims: [],
    swapClaims: [],
    savingsRewardState: undefined,
    savingsClaims: [],
    earnRewardState: undefined,
    earnClaims: []
  };
}
var GenesisState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.params !== undefined) {
      _params.Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    if (message.usdxRewardState !== undefined) {
      GenesisRewardState.encode(message.usdxRewardState, writer.uint32(18).fork()).ldelim();
    }
    if (message.hardSupplyRewardState !== undefined) {
      GenesisRewardState.encode(message.hardSupplyRewardState, writer.uint32(26).fork()).ldelim();
    }
    if (message.hardBorrowRewardState !== undefined) {
      GenesisRewardState.encode(message.hardBorrowRewardState, writer.uint32(34).fork()).ldelim();
    }
    if (message.delegatorRewardState !== undefined) {
      GenesisRewardState.encode(message.delegatorRewardState, writer.uint32(42).fork()).ldelim();
    }
    if (message.swapRewardState !== undefined) {
      GenesisRewardState.encode(message.swapRewardState, writer.uint32(50).fork()).ldelim();
    }
    var _iterator3 = _createForOfIteratorHelper(message.usdxMintingClaims),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var v = _step3.value;
        _claims.USDXMintingClaim.encode(v, writer.uint32(58).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    var _iterator4 = _createForOfIteratorHelper(message.hardLiquidityProviderClaims),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var _v2 = _step4.value;
        _claims.HardLiquidityProviderClaim.encode(_v2, writer.uint32(66).fork()).ldelim();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    var _iterator5 = _createForOfIteratorHelper(message.delegatorClaims),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var _v3 = _step5.value;
        _claims.DelegatorClaim.encode(_v3, writer.uint32(74).fork()).ldelim();
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    var _iterator6 = _createForOfIteratorHelper(message.swapClaims),
      _step6;
    try {
      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
        var _v4 = _step6.value;
        _claims.SwapClaim.encode(_v4, writer.uint32(82).fork()).ldelim();
      }
    } catch (err) {
      _iterator6.e(err);
    } finally {
      _iterator6.f();
    }
    if (message.savingsRewardState !== undefined) {
      GenesisRewardState.encode(message.savingsRewardState, writer.uint32(90).fork()).ldelim();
    }
    var _iterator7 = _createForOfIteratorHelper(message.savingsClaims),
      _step7;
    try {
      for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
        var _v5 = _step7.value;
        _claims.SavingsClaim.encode(_v5, writer.uint32(98).fork()).ldelim();
      }
    } catch (err) {
      _iterator7.e(err);
    } finally {
      _iterator7.f();
    }
    if (message.earnRewardState !== undefined) {
      GenesisRewardState.encode(message.earnRewardState, writer.uint32(106).fork()).ldelim();
    }
    var _iterator8 = _createForOfIteratorHelper(message.earnClaims),
      _step8;
    try {
      for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
        var _v6 = _step8.value;
        _claims.EarnClaim.encode(_v6, writer.uint32(114).fork()).ldelim();
      }
    } catch (err) {
      _iterator8.e(err);
    } finally {
      _iterator8.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = _params.Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.usdxRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 3:
          message.hardSupplyRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 4:
          message.hardBorrowRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 5:
          message.delegatorRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 6:
          message.swapRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 7:
          message.usdxMintingClaims.push(_claims.USDXMintingClaim.decode(reader, reader.uint32()));
          break;
        case 8:
          message.hardLiquidityProviderClaims.push(_claims.HardLiquidityProviderClaim.decode(reader, reader.uint32()));
          break;
        case 9:
          message.delegatorClaims.push(_claims.DelegatorClaim.decode(reader, reader.uint32()));
          break;
        case 10:
          message.swapClaims.push(_claims.SwapClaim.decode(reader, reader.uint32()));
          break;
        case 11:
          message.savingsRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 12:
          message.savingsClaims.push(_claims.SavingsClaim.decode(reader, reader.uint32()));
          break;
        case 13:
          message.earnRewardState = GenesisRewardState.decode(reader, reader.uint32());
          break;
        case 14:
          message.earnClaims.push(_claims.EarnClaim.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      params: (0, _helpers.isSet)(object.params) ? _params.Params.fromJSON(object.params) : undefined,
      usdxRewardState: (0, _helpers.isSet)(object.usdxRewardState) ? GenesisRewardState.fromJSON(object.usdxRewardState) : undefined,
      hardSupplyRewardState: (0, _helpers.isSet)(object.hardSupplyRewardState) ? GenesisRewardState.fromJSON(object.hardSupplyRewardState) : undefined,
      hardBorrowRewardState: (0, _helpers.isSet)(object.hardBorrowRewardState) ? GenesisRewardState.fromJSON(object.hardBorrowRewardState) : undefined,
      delegatorRewardState: (0, _helpers.isSet)(object.delegatorRewardState) ? GenesisRewardState.fromJSON(object.delegatorRewardState) : undefined,
      swapRewardState: (0, _helpers.isSet)(object.swapRewardState) ? GenesisRewardState.fromJSON(object.swapRewardState) : undefined,
      usdxMintingClaims: Array.isArray(object === null || object === void 0 ? void 0 : object.usdxMintingClaims) ? object.usdxMintingClaims.map(function (e) {
        return _claims.USDXMintingClaim.fromJSON(e);
      }) : [],
      hardLiquidityProviderClaims: Array.isArray(object === null || object === void 0 ? void 0 : object.hardLiquidityProviderClaims) ? object.hardLiquidityProviderClaims.map(function (e) {
        return _claims.HardLiquidityProviderClaim.fromJSON(e);
      }) : [],
      delegatorClaims: Array.isArray(object === null || object === void 0 ? void 0 : object.delegatorClaims) ? object.delegatorClaims.map(function (e) {
        return _claims.DelegatorClaim.fromJSON(e);
      }) : [],
      swapClaims: Array.isArray(object === null || object === void 0 ? void 0 : object.swapClaims) ? object.swapClaims.map(function (e) {
        return _claims.SwapClaim.fromJSON(e);
      }) : [],
      savingsRewardState: (0, _helpers.isSet)(object.savingsRewardState) ? GenesisRewardState.fromJSON(object.savingsRewardState) : undefined,
      savingsClaims: Array.isArray(object === null || object === void 0 ? void 0 : object.savingsClaims) ? object.savingsClaims.map(function (e) {
        return _claims.SavingsClaim.fromJSON(e);
      }) : [],
      earnRewardState: (0, _helpers.isSet)(object.earnRewardState) ? GenesisRewardState.fromJSON(object.earnRewardState) : undefined,
      earnClaims: Array.isArray(object === null || object === void 0 ? void 0 : object.earnClaims) ? object.earnClaims.map(function (e) {
        return _claims.EarnClaim.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.params !== undefined && (obj.params = message.params ? _params.Params.toJSON(message.params) : undefined);
    message.usdxRewardState !== undefined && (obj.usdxRewardState = message.usdxRewardState ? GenesisRewardState.toJSON(message.usdxRewardState) : undefined);
    message.hardSupplyRewardState !== undefined && (obj.hardSupplyRewardState = message.hardSupplyRewardState ? GenesisRewardState.toJSON(message.hardSupplyRewardState) : undefined);
    message.hardBorrowRewardState !== undefined && (obj.hardBorrowRewardState = message.hardBorrowRewardState ? GenesisRewardState.toJSON(message.hardBorrowRewardState) : undefined);
    message.delegatorRewardState !== undefined && (obj.delegatorRewardState = message.delegatorRewardState ? GenesisRewardState.toJSON(message.delegatorRewardState) : undefined);
    message.swapRewardState !== undefined && (obj.swapRewardState = message.swapRewardState ? GenesisRewardState.toJSON(message.swapRewardState) : undefined);
    if (message.usdxMintingClaims) {
      obj.usdxMintingClaims = message.usdxMintingClaims.map(function (e) {
        return e ? _claims.USDXMintingClaim.toJSON(e) : undefined;
      });
    } else {
      obj.usdxMintingClaims = [];
    }
    if (message.hardLiquidityProviderClaims) {
      obj.hardLiquidityProviderClaims = message.hardLiquidityProviderClaims.map(function (e) {
        return e ? _claims.HardLiquidityProviderClaim.toJSON(e) : undefined;
      });
    } else {
      obj.hardLiquidityProviderClaims = [];
    }
    if (message.delegatorClaims) {
      obj.delegatorClaims = message.delegatorClaims.map(function (e) {
        return e ? _claims.DelegatorClaim.toJSON(e) : undefined;
      });
    } else {
      obj.delegatorClaims = [];
    }
    if (message.swapClaims) {
      obj.swapClaims = message.swapClaims.map(function (e) {
        return e ? _claims.SwapClaim.toJSON(e) : undefined;
      });
    } else {
      obj.swapClaims = [];
    }
    message.savingsRewardState !== undefined && (obj.savingsRewardState = message.savingsRewardState ? GenesisRewardState.toJSON(message.savingsRewardState) : undefined);
    if (message.savingsClaims) {
      obj.savingsClaims = message.savingsClaims.map(function (e) {
        return e ? _claims.SavingsClaim.toJSON(e) : undefined;
      });
    } else {
      obj.savingsClaims = [];
    }
    message.earnRewardState !== undefined && (obj.earnRewardState = message.earnRewardState ? GenesisRewardState.toJSON(message.earnRewardState) : undefined);
    if (message.earnClaims) {
      obj.earnClaims = message.earnClaims.map(function (e) {
        return e ? _claims.EarnClaim.toJSON(e) : undefined;
      });
    } else {
      obj.earnClaims = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$usdxMintingCl, _object$hardLiquidity, _object$delegatorClai, _object$swapClaims, _object$savingsClaims, _object$earnClaims;
    var message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? _params.Params.fromPartial(object.params) : undefined;
    message.usdxRewardState = object.usdxRewardState !== undefined && object.usdxRewardState !== null ? GenesisRewardState.fromPartial(object.usdxRewardState) : undefined;
    message.hardSupplyRewardState = object.hardSupplyRewardState !== undefined && object.hardSupplyRewardState !== null ? GenesisRewardState.fromPartial(object.hardSupplyRewardState) : undefined;
    message.hardBorrowRewardState = object.hardBorrowRewardState !== undefined && object.hardBorrowRewardState !== null ? GenesisRewardState.fromPartial(object.hardBorrowRewardState) : undefined;
    message.delegatorRewardState = object.delegatorRewardState !== undefined && object.delegatorRewardState !== null ? GenesisRewardState.fromPartial(object.delegatorRewardState) : undefined;
    message.swapRewardState = object.swapRewardState !== undefined && object.swapRewardState !== null ? GenesisRewardState.fromPartial(object.swapRewardState) : undefined;
    message.usdxMintingClaims = ((_object$usdxMintingCl = object.usdxMintingClaims) === null || _object$usdxMintingCl === void 0 ? void 0 : _object$usdxMintingCl.map(function (e) {
      return _claims.USDXMintingClaim.fromPartial(e);
    })) || [];
    message.hardLiquidityProviderClaims = ((_object$hardLiquidity = object.hardLiquidityProviderClaims) === null || _object$hardLiquidity === void 0 ? void 0 : _object$hardLiquidity.map(function (e) {
      return _claims.HardLiquidityProviderClaim.fromPartial(e);
    })) || [];
    message.delegatorClaims = ((_object$delegatorClai = object.delegatorClaims) === null || _object$delegatorClai === void 0 ? void 0 : _object$delegatorClai.map(function (e) {
      return _claims.DelegatorClaim.fromPartial(e);
    })) || [];
    message.swapClaims = ((_object$swapClaims = object.swapClaims) === null || _object$swapClaims === void 0 ? void 0 : _object$swapClaims.map(function (e) {
      return _claims.SwapClaim.fromPartial(e);
    })) || [];
    message.savingsRewardState = object.savingsRewardState !== undefined && object.savingsRewardState !== null ? GenesisRewardState.fromPartial(object.savingsRewardState) : undefined;
    message.savingsClaims = ((_object$savingsClaims = object.savingsClaims) === null || _object$savingsClaims === void 0 ? void 0 : _object$savingsClaims.map(function (e) {
      return _claims.SavingsClaim.fromPartial(e);
    })) || [];
    message.earnRewardState = object.earnRewardState !== undefined && object.earnRewardState !== null ? GenesisRewardState.fromPartial(object.earnRewardState) : undefined;
    message.earnClaims = ((_object$earnClaims = object.earnClaims) === null || _object$earnClaims === void 0 ? void 0 : _object$earnClaims.map(function (e) {
      return _claims.EarnClaim.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.GenesisState = GenesisState;