"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardPeriod = exports.Params = exports.MultipliersPerDenom = exports.Multiplier = exports.MultiRewardPeriod = void 0;
var _timestamp = require("../../../google/protobuf/timestamp");
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseRewardPeriod() {
  return {
    active: false,
    collateralType: "",
    start: undefined,
    end: undefined,
    rewardsPerSecond: undefined
  };
}
var RewardPeriod = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.start !== undefined) {
      _timestamp.Timestamp.encode(message.start, writer.uint32(26).fork()).ldelim();
    }
    if (message.end !== undefined) {
      _timestamp.Timestamp.encode(message.end, writer.uint32(34).fork()).ldelim();
    }
    if (message.rewardsPerSecond !== undefined) {
      _coin.Coin.encode(message.rewardsPerSecond, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseRewardPeriod();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.start = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 4:
          message.end = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 5:
          message.rewardsPerSecond = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      active: (0, _helpers.isSet)(object.active) ? Boolean(object.active) : false,
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      start: (0, _helpers.isSet)(object.start) ? (0, _helpers.fromJsonTimestamp)(object.start) : undefined,
      end: (0, _helpers.isSet)(object.end) ? (0, _helpers.fromJsonTimestamp)(object.end) : undefined,
      rewardsPerSecond: (0, _helpers.isSet)(object.rewardsPerSecond) ? _coin.Coin.fromJSON(object.rewardsPerSecond) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.active !== undefined && (obj.active = message.active);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.start !== undefined && (obj.start = (0, _helpers.fromTimestamp)(message.start).toISOString());
    message.end !== undefined && (obj.end = (0, _helpers.fromTimestamp)(message.end).toISOString());
    message.rewardsPerSecond !== undefined && (obj.rewardsPerSecond = message.rewardsPerSecond ? _coin.Coin.toJSON(message.rewardsPerSecond) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$active, _object$collateralTyp;
    var message = createBaseRewardPeriod();
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.start = object.start !== undefined && object.start !== null ? _timestamp.Timestamp.fromPartial(object.start) : undefined;
    message.end = object.end !== undefined && object.end !== null ? _timestamp.Timestamp.fromPartial(object.end) : undefined;
    message.rewardsPerSecond = object.rewardsPerSecond !== undefined && object.rewardsPerSecond !== null ? _coin.Coin.fromPartial(object.rewardsPerSecond) : undefined;
    return message;
  }
};
exports.RewardPeriod = RewardPeriod;
function createBaseMultiRewardPeriod() {
  return {
    active: false,
    collateralType: "",
    start: undefined,
    end: undefined,
    rewardsPerSecond: []
  };
}
var MultiRewardPeriod = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.start !== undefined) {
      _timestamp.Timestamp.encode(message.start, writer.uint32(26).fork()).ldelim();
    }
    if (message.end !== undefined) {
      _timestamp.Timestamp.encode(message.end, writer.uint32(34).fork()).ldelim();
    }
    var _iterator = _createForOfIteratorHelper(message.rewardsPerSecond),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        _coin.Coin.encode(v, writer.uint32(42).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMultiRewardPeriod();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.start = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 4:
          message.end = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 5:
          message.rewardsPerSecond.push(_coin.Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      active: (0, _helpers.isSet)(object.active) ? Boolean(object.active) : false,
      collateralType: (0, _helpers.isSet)(object.collateralType) ? String(object.collateralType) : "",
      start: (0, _helpers.isSet)(object.start) ? (0, _helpers.fromJsonTimestamp)(object.start) : undefined,
      end: (0, _helpers.isSet)(object.end) ? (0, _helpers.fromJsonTimestamp)(object.end) : undefined,
      rewardsPerSecond: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardsPerSecond) ? object.rewardsPerSecond.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.active !== undefined && (obj.active = message.active);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.start !== undefined && (obj.start = (0, _helpers.fromTimestamp)(message.start).toISOString());
    message.end !== undefined && (obj.end = (0, _helpers.fromTimestamp)(message.end).toISOString());
    if (message.rewardsPerSecond) {
      obj.rewardsPerSecond = message.rewardsPerSecond.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.rewardsPerSecond = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$active2, _object$collateralTyp2, _object$rewardsPerSec;
    var message = createBaseMultiRewardPeriod();
    message.active = (_object$active2 = object.active) !== null && _object$active2 !== void 0 ? _object$active2 : false;
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    message.start = object.start !== undefined && object.start !== null ? _timestamp.Timestamp.fromPartial(object.start) : undefined;
    message.end = object.end !== undefined && object.end !== null ? _timestamp.Timestamp.fromPartial(object.end) : undefined;
    message.rewardsPerSecond = ((_object$rewardsPerSec = object.rewardsPerSecond) === null || _object$rewardsPerSec === void 0 ? void 0 : _object$rewardsPerSec.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.MultiRewardPeriod = MultiRewardPeriod;
function createBaseMultiplier() {
  return {
    name: "",
    monthsLockup: _helpers.Long.ZERO,
    factor: new Uint8Array()
  };
}
var Multiplier = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    if (!message.monthsLockup.isZero()) {
      writer.uint32(16).int64(message.monthsLockup);
    }
    if (message.factor.length !== 0) {
      writer.uint32(26).bytes(message.factor);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMultiplier();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.name = reader.string();
          break;
        case 2:
          message.monthsLockup = reader.int64();
          break;
        case 3:
          message.factor = reader.bytes();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      name: (0, _helpers.isSet)(object.name) ? String(object.name) : "",
      monthsLockup: (0, _helpers.isSet)(object.monthsLockup) ? _helpers.Long.fromValue(object.monthsLockup) : _helpers.Long.ZERO,
      factor: (0, _helpers.isSet)(object.factor) ? (0, _helpers.bytesFromBase64)(object.factor) : new Uint8Array()
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.name !== undefined && (obj.name = message.name);
    message.monthsLockup !== undefined && (obj.monthsLockup = (message.monthsLockup || _helpers.Long.ZERO).toString());
    message.factor !== undefined && (obj.factor = (0, _helpers.base64FromBytes)(message.factor !== undefined ? message.factor : new Uint8Array()));
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$name, _object$factor;
    var message = createBaseMultiplier();
    message.name = (_object$name = object.name) !== null && _object$name !== void 0 ? _object$name : "";
    message.monthsLockup = object.monthsLockup !== undefined && object.monthsLockup !== null ? _helpers.Long.fromValue(object.monthsLockup) : _helpers.Long.ZERO;
    message.factor = (_object$factor = object.factor) !== null && _object$factor !== void 0 ? _object$factor : new Uint8Array();
    return message;
  }
};
exports.Multiplier = Multiplier;
function createBaseMultipliersPerDenom() {
  return {
    denom: "",
    multipliers: []
  };
}
var MultipliersPerDenom = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    var _iterator2 = _createForOfIteratorHelper(message.multipliers),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var v = _step2.value;
        Multiplier.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMultipliersPerDenom();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.multipliers.push(Multiplier.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      multipliers: Array.isArray(object === null || object === void 0 ? void 0 : object.multipliers) ? object.multipliers.map(function (e) {
        return Multiplier.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    if (message.multipliers) {
      obj.multipliers = message.multipliers.map(function (e) {
        return e ? Multiplier.toJSON(e) : undefined;
      });
    } else {
      obj.multipliers = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$denom, _object$multipliers;
    var message = createBaseMultipliersPerDenom();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.multipliers = ((_object$multipliers = object.multipliers) === null || _object$multipliers === void 0 ? void 0 : _object$multipliers.map(function (e) {
      return Multiplier.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.MultipliersPerDenom = MultipliersPerDenom;
function createBaseParams() {
  return {
    usdxMintingRewardPeriods: [],
    hardSupplyRewardPeriods: [],
    hardBorrowRewardPeriods: [],
    delegatorRewardPeriods: [],
    swapRewardPeriods: [],
    claimMultipliers: [],
    claimEnd: undefined,
    savingsRewardPeriods: [],
    earnRewardPeriods: []
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator3 = _createForOfIteratorHelper(message.usdxMintingRewardPeriods),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var v = _step3.value;
        RewardPeriod.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    var _iterator4 = _createForOfIteratorHelper(message.hardSupplyRewardPeriods),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var _v = _step4.value;
        MultiRewardPeriod.encode(_v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    var _iterator5 = _createForOfIteratorHelper(message.hardBorrowRewardPeriods),
      _step5;
    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var _v2 = _step5.value;
        MultiRewardPeriod.encode(_v2, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
    var _iterator6 = _createForOfIteratorHelper(message.delegatorRewardPeriods),
      _step6;
    try {
      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
        var _v3 = _step6.value;
        MultiRewardPeriod.encode(_v3, writer.uint32(34).fork()).ldelim();
      }
    } catch (err) {
      _iterator6.e(err);
    } finally {
      _iterator6.f();
    }
    var _iterator7 = _createForOfIteratorHelper(message.swapRewardPeriods),
      _step7;
    try {
      for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
        var _v4 = _step7.value;
        MultiRewardPeriod.encode(_v4, writer.uint32(42).fork()).ldelim();
      }
    } catch (err) {
      _iterator7.e(err);
    } finally {
      _iterator7.f();
    }
    var _iterator8 = _createForOfIteratorHelper(message.claimMultipliers),
      _step8;
    try {
      for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
        var _v5 = _step8.value;
        MultipliersPerDenom.encode(_v5, writer.uint32(50).fork()).ldelim();
      }
    } catch (err) {
      _iterator8.e(err);
    } finally {
      _iterator8.f();
    }
    if (message.claimEnd !== undefined) {
      _timestamp.Timestamp.encode(message.claimEnd, writer.uint32(58).fork()).ldelim();
    }
    var _iterator9 = _createForOfIteratorHelper(message.savingsRewardPeriods),
      _step9;
    try {
      for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
        var _v6 = _step9.value;
        MultiRewardPeriod.encode(_v6, writer.uint32(66).fork()).ldelim();
      }
    } catch (err) {
      _iterator9.e(err);
    } finally {
      _iterator9.f();
    }
    var _iterator10 = _createForOfIteratorHelper(message.earnRewardPeriods),
      _step10;
    try {
      for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
        var _v7 = _step10.value;
        MultiRewardPeriod.encode(_v7, writer.uint32(74).fork()).ldelim();
      }
    } catch (err) {
      _iterator10.e(err);
    } finally {
      _iterator10.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.usdxMintingRewardPeriods.push(RewardPeriod.decode(reader, reader.uint32()));
          break;
        case 2:
          message.hardSupplyRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 3:
          message.hardBorrowRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 4:
          message.delegatorRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 5:
          message.swapRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 6:
          message.claimMultipliers.push(MultipliersPerDenom.decode(reader, reader.uint32()));
          break;
        case 7:
          message.claimEnd = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 8:
          message.savingsRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 9:
          message.earnRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      usdxMintingRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.usdxMintingRewardPeriods) ? object.usdxMintingRewardPeriods.map(function (e) {
        return RewardPeriod.fromJSON(e);
      }) : [],
      hardSupplyRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.hardSupplyRewardPeriods) ? object.hardSupplyRewardPeriods.map(function (e) {
        return MultiRewardPeriod.fromJSON(e);
      }) : [],
      hardBorrowRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.hardBorrowRewardPeriods) ? object.hardBorrowRewardPeriods.map(function (e) {
        return MultiRewardPeriod.fromJSON(e);
      }) : [],
      delegatorRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.delegatorRewardPeriods) ? object.delegatorRewardPeriods.map(function (e) {
        return MultiRewardPeriod.fromJSON(e);
      }) : [],
      swapRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.swapRewardPeriods) ? object.swapRewardPeriods.map(function (e) {
        return MultiRewardPeriod.fromJSON(e);
      }) : [],
      claimMultipliers: Array.isArray(object === null || object === void 0 ? void 0 : object.claimMultipliers) ? object.claimMultipliers.map(function (e) {
        return MultipliersPerDenom.fromJSON(e);
      }) : [],
      claimEnd: (0, _helpers.isSet)(object.claimEnd) ? (0, _helpers.fromJsonTimestamp)(object.claimEnd) : undefined,
      savingsRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.savingsRewardPeriods) ? object.savingsRewardPeriods.map(function (e) {
        return MultiRewardPeriod.fromJSON(e);
      }) : [],
      earnRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.earnRewardPeriods) ? object.earnRewardPeriods.map(function (e) {
        return MultiRewardPeriod.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.usdxMintingRewardPeriods) {
      obj.usdxMintingRewardPeriods = message.usdxMintingRewardPeriods.map(function (e) {
        return e ? RewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.usdxMintingRewardPeriods = [];
    }
    if (message.hardSupplyRewardPeriods) {
      obj.hardSupplyRewardPeriods = message.hardSupplyRewardPeriods.map(function (e) {
        return e ? MultiRewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.hardSupplyRewardPeriods = [];
    }
    if (message.hardBorrowRewardPeriods) {
      obj.hardBorrowRewardPeriods = message.hardBorrowRewardPeriods.map(function (e) {
        return e ? MultiRewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.hardBorrowRewardPeriods = [];
    }
    if (message.delegatorRewardPeriods) {
      obj.delegatorRewardPeriods = message.delegatorRewardPeriods.map(function (e) {
        return e ? MultiRewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.delegatorRewardPeriods = [];
    }
    if (message.swapRewardPeriods) {
      obj.swapRewardPeriods = message.swapRewardPeriods.map(function (e) {
        return e ? MultiRewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.swapRewardPeriods = [];
    }
    if (message.claimMultipliers) {
      obj.claimMultipliers = message.claimMultipliers.map(function (e) {
        return e ? MultipliersPerDenom.toJSON(e) : undefined;
      });
    } else {
      obj.claimMultipliers = [];
    }
    message.claimEnd !== undefined && (obj.claimEnd = (0, _helpers.fromTimestamp)(message.claimEnd).toISOString());
    if (message.savingsRewardPeriods) {
      obj.savingsRewardPeriods = message.savingsRewardPeriods.map(function (e) {
        return e ? MultiRewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.savingsRewardPeriods = [];
    }
    if (message.earnRewardPeriods) {
      obj.earnRewardPeriods = message.earnRewardPeriods.map(function (e) {
        return e ? MultiRewardPeriod.toJSON(e) : undefined;
      });
    } else {
      obj.earnRewardPeriods = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$usdxMintingRe, _object$hardSupplyRew, _object$hardBorrowRew, _object$delegatorRewa, _object$swapRewardPer, _object$claimMultipli, _object$savingsReward, _object$earnRewardPer;
    var message = createBaseParams();
    message.usdxMintingRewardPeriods = ((_object$usdxMintingRe = object.usdxMintingRewardPeriods) === null || _object$usdxMintingRe === void 0 ? void 0 : _object$usdxMintingRe.map(function (e) {
      return RewardPeriod.fromPartial(e);
    })) || [];
    message.hardSupplyRewardPeriods = ((_object$hardSupplyRew = object.hardSupplyRewardPeriods) === null || _object$hardSupplyRew === void 0 ? void 0 : _object$hardSupplyRew.map(function (e) {
      return MultiRewardPeriod.fromPartial(e);
    })) || [];
    message.hardBorrowRewardPeriods = ((_object$hardBorrowRew = object.hardBorrowRewardPeriods) === null || _object$hardBorrowRew === void 0 ? void 0 : _object$hardBorrowRew.map(function (e) {
      return MultiRewardPeriod.fromPartial(e);
    })) || [];
    message.delegatorRewardPeriods = ((_object$delegatorRewa = object.delegatorRewardPeriods) === null || _object$delegatorRewa === void 0 ? void 0 : _object$delegatorRewa.map(function (e) {
      return MultiRewardPeriod.fromPartial(e);
    })) || [];
    message.swapRewardPeriods = ((_object$swapRewardPer = object.swapRewardPeriods) === null || _object$swapRewardPer === void 0 ? void 0 : _object$swapRewardPer.map(function (e) {
      return MultiRewardPeriod.fromPartial(e);
    })) || [];
    message.claimMultipliers = ((_object$claimMultipli = object.claimMultipliers) === null || _object$claimMultipli === void 0 ? void 0 : _object$claimMultipli.map(function (e) {
      return MultipliersPerDenom.fromPartial(e);
    })) || [];
    message.claimEnd = object.claimEnd !== undefined && object.claimEnd !== null ? _timestamp.Timestamp.fromPartial(object.claimEnd) : undefined;
    message.savingsRewardPeriods = ((_object$savingsReward = object.savingsRewardPeriods) === null || _object$savingsReward === void 0 ? void 0 : _object$savingsReward.map(function (e) {
      return MultiRewardPeriod.fromPartial(e);
    })) || [];
    message.earnRewardPeriods = ((_object$earnRewardPer = object.earnRewardPeriods) === null || _object$earnRewardPer === void 0 ? void 0 : _object$earnRewardPer.map(function (e) {
      return MultiRewardPeriod.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.Params = Params;