"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
//@ts-nocheck

var AminoConverter = {
  "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward": {
    aminoType: "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward",
    toAmino: function toAmino(_ref) {
      var sender = _ref.sender,
        multiplierName = _ref.multiplierName;
      return {
        sender: sender,
        multiplier_name: multiplierName
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var sender = _ref2.sender,
        multiplier_name = _ref2.multiplier_name;
      return {
        sender: sender,
        multiplierName: multiplier_name
      };
    }
  },
  "/kava.incentive.v1beta1.MsgClaimHardReward": {
    aminoType: "/kava.incentive.v1beta1.MsgClaimHardReward",
    toAmino: function toAmino(_ref3) {
      var sender = _ref3.sender,
        denomsToClaim = _ref3.denomsToClaim;
      return {
        sender: sender,
        denoms_to_claim: denomsToClaim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplier_name: el0.multiplierName
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var sender = _ref4.sender,
        denoms_to_claim = _ref4.denoms_to_claim;
      return {
        sender: sender,
        denomsToClaim: denoms_to_claim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplierName: el0.multiplier_name
          };
        })
      };
    }
  },
  "/kava.incentive.v1beta1.MsgClaimDelegatorReward": {
    aminoType: "/kava.incentive.v1beta1.MsgClaimDelegatorReward",
    toAmino: function toAmino(_ref5) {
      var sender = _ref5.sender,
        denomsToClaim = _ref5.denomsToClaim;
      return {
        sender: sender,
        denoms_to_claim: denomsToClaim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplier_name: el0.multiplierName
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref6) {
      var sender = _ref6.sender,
        denoms_to_claim = _ref6.denoms_to_claim;
      return {
        sender: sender,
        denomsToClaim: denoms_to_claim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplierName: el0.multiplier_name
          };
        })
      };
    }
  },
  "/kava.incentive.v1beta1.MsgClaimSwapReward": {
    aminoType: "/kava.incentive.v1beta1.MsgClaimSwapReward",
    toAmino: function toAmino(_ref7) {
      var sender = _ref7.sender,
        denomsToClaim = _ref7.denomsToClaim;
      return {
        sender: sender,
        denoms_to_claim: denomsToClaim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplier_name: el0.multiplierName
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref8) {
      var sender = _ref8.sender,
        denoms_to_claim = _ref8.denoms_to_claim;
      return {
        sender: sender,
        denomsToClaim: denoms_to_claim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplierName: el0.multiplier_name
          };
        })
      };
    }
  },
  "/kava.incentive.v1beta1.MsgClaimSavingsReward": {
    aminoType: "/kava.incentive.v1beta1.MsgClaimSavingsReward",
    toAmino: function toAmino(_ref9) {
      var sender = _ref9.sender,
        denomsToClaim = _ref9.denomsToClaim;
      return {
        sender: sender,
        denoms_to_claim: denomsToClaim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplier_name: el0.multiplierName
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref10) {
      var sender = _ref10.sender,
        denoms_to_claim = _ref10.denoms_to_claim;
      return {
        sender: sender,
        denomsToClaim: denoms_to_claim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplierName: el0.multiplier_name
          };
        })
      };
    }
  },
  "/kava.incentive.v1beta1.MsgClaimEarnReward": {
    aminoType: "/kava.incentive.v1beta1.MsgClaimEarnReward",
    toAmino: function toAmino(_ref11) {
      var sender = _ref11.sender,
        denomsToClaim = _ref11.denomsToClaim;
      return {
        sender: sender,
        denoms_to_claim: denomsToClaim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplier_name: el0.multiplierName
          };
        })
      };
    },
    fromAmino: function fromAmino(_ref12) {
      var sender = _ref12.sender,
        denoms_to_claim = _ref12.denoms_to_claim;
      return {
        sender: sender,
        denomsToClaim: denoms_to_claim.map(function (el0) {
          return {
            denom: el0.denom,
            multiplierName: el0.multiplier_name
          };
        })
      };
    }
  }
};
exports.AminoConverter = AminoConverter;