"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.incentive.v1beta1.MsgClaimUSDXMintingReward", _tx.MsgClaimUSDXMintingReward], ["/kava.incentive.v1beta1.MsgClaimHardReward", _tx.MsgClaimHardReward], ["/kava.incentive.v1beta1.MsgClaimDelegatorReward", _tx.MsgClaimDelegatorReward], ["/kava.incentive.v1beta1.MsgClaimSwapReward", _tx.MsgClaimSwapReward], ["/kava.incentive.v1beta1.MsgClaimSavingsReward", _tx.MsgClaimSavingsReward], ["/kava.incentive.v1beta1.MsgClaimEarnReward", _tx.MsgClaimEarnReward]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    claimUSDXMintingReward: function claimUSDXMintingReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward",
        value: _tx.MsgClaimUSDXMintingReward.encode(value).finish()
      };
    },
    claimHardReward: function claimHardReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimHardReward",
        value: _tx.MsgClaimHardReward.encode(value).finish()
      };
    },
    claimDelegatorReward: function claimDelegatorReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimDelegatorReward",
        value: _tx.MsgClaimDelegatorReward.encode(value).finish()
      };
    },
    claimSwapReward: function claimSwapReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSwapReward",
        value: _tx.MsgClaimSwapReward.encode(value).finish()
      };
    },
    claimSavingsReward: function claimSavingsReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSavingsReward",
        value: _tx.MsgClaimSavingsReward.encode(value).finish()
      };
    },
    claimEarnReward: function claimEarnReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimEarnReward",
        value: _tx.MsgClaimEarnReward.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    claimUSDXMintingReward: function claimUSDXMintingReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward",
        value: value
      };
    },
    claimHardReward: function claimHardReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimHardReward",
        value: value
      };
    },
    claimDelegatorReward: function claimDelegatorReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimDelegatorReward",
        value: value
      };
    },
    claimSwapReward: function claimSwapReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSwapReward",
        value: value
      };
    },
    claimSavingsReward: function claimSavingsReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSavingsReward",
        value: value
      };
    },
    claimEarnReward: function claimEarnReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimEarnReward",
        value: value
      };
    }
  },
  toJSON: {
    claimUSDXMintingReward: function claimUSDXMintingReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward",
        value: _tx.MsgClaimUSDXMintingReward.toJSON(value)
      };
    },
    claimHardReward: function claimHardReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimHardReward",
        value: _tx.MsgClaimHardReward.toJSON(value)
      };
    },
    claimDelegatorReward: function claimDelegatorReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimDelegatorReward",
        value: _tx.MsgClaimDelegatorReward.toJSON(value)
      };
    },
    claimSwapReward: function claimSwapReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSwapReward",
        value: _tx.MsgClaimSwapReward.toJSON(value)
      };
    },
    claimSavingsReward: function claimSavingsReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSavingsReward",
        value: _tx.MsgClaimSavingsReward.toJSON(value)
      };
    },
    claimEarnReward: function claimEarnReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimEarnReward",
        value: _tx.MsgClaimEarnReward.toJSON(value)
      };
    }
  },
  fromJSON: {
    claimUSDXMintingReward: function claimUSDXMintingReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward",
        value: _tx.MsgClaimUSDXMintingReward.fromJSON(value)
      };
    },
    claimHardReward: function claimHardReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimHardReward",
        value: _tx.MsgClaimHardReward.fromJSON(value)
      };
    },
    claimDelegatorReward: function claimDelegatorReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimDelegatorReward",
        value: _tx.MsgClaimDelegatorReward.fromJSON(value)
      };
    },
    claimSwapReward: function claimSwapReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSwapReward",
        value: _tx.MsgClaimSwapReward.fromJSON(value)
      };
    },
    claimSavingsReward: function claimSavingsReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSavingsReward",
        value: _tx.MsgClaimSavingsReward.fromJSON(value)
      };
    },
    claimEarnReward: function claimEarnReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimEarnReward",
        value: _tx.MsgClaimEarnReward.fromJSON(value)
      };
    }
  },
  fromPartial: {
    claimUSDXMintingReward: function claimUSDXMintingReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimUSDXMintingReward",
        value: _tx.MsgClaimUSDXMintingReward.fromPartial(value)
      };
    },
    claimHardReward: function claimHardReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimHardReward",
        value: _tx.MsgClaimHardReward.fromPartial(value)
      };
    },
    claimDelegatorReward: function claimDelegatorReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimDelegatorReward",
        value: _tx.MsgClaimDelegatorReward.fromPartial(value)
      };
    },
    claimSwapReward: function claimSwapReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSwapReward",
        value: _tx.MsgClaimSwapReward.fromPartial(value)
      };
    },
    claimSavingsReward: function claimSavingsReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimSavingsReward",
        value: _tx.MsgClaimSavingsReward.fromPartial(value)
      };
    },
    claimEarnReward: function claimEarnReward(value) {
      return {
        typeUrl: "/kava.incentive.v1beta1.MsgClaimEarnReward",
        value: _tx.MsgClaimEarnReward.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;