"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RateLimit = exports.Params = exports.GenesisState = exports.AssetSupply = exports.Asset = void 0;
var _duration = require("../../../google/protobuf/duration");
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseGenesisState() {
  return {
    params: undefined,
    supplies: []
  };
}
var GenesisState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    var _iterator = _createForOfIteratorHelper(message.supplies),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        AssetSupply.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisState();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.supplies.push(AssetSupply.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      params: (0, _helpers.isSet)(object.params) ? Params.fromJSON(object.params) : undefined,
      supplies: Array.isArray(object === null || object === void 0 ? void 0 : object.supplies) ? object.supplies.map(function (e) {
        return AssetSupply.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    if (message.supplies) {
      obj.supplies = message.supplies.map(function (e) {
        return e ? AssetSupply.toJSON(e) : undefined;
      });
    } else {
      obj.supplies = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$supplies;
    var message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    message.supplies = ((_object$supplies = object.supplies) === null || _object$supplies === void 0 ? void 0 : _object$supplies.map(function (e) {
      return AssetSupply.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.GenesisState = GenesisState;
function createBaseParams() {
  return {
    assets: []
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator2 = _createForOfIteratorHelper(message.assets),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var v = _step2.value;
        Asset.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.assets.push(Asset.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      assets: Array.isArray(object === null || object === void 0 ? void 0 : object.assets) ? object.assets.map(function (e) {
        return Asset.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.assets) {
      obj.assets = message.assets.map(function (e) {
        return e ? Asset.toJSON(e) : undefined;
      });
    } else {
      obj.assets = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$assets;
    var message = createBaseParams();
    message.assets = ((_object$assets = object.assets) === null || _object$assets === void 0 ? void 0 : _object$assets.map(function (e) {
      return Asset.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.Params = Params;
function createBaseAsset() {
  return {
    owner: "",
    denom: "",
    blockedAddresses: [],
    paused: false,
    blockable: false,
    rateLimit: undefined
  };
}
var Asset = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.owner !== "") {
      writer.uint32(10).string(message.owner);
    }
    if (message.denom !== "") {
      writer.uint32(18).string(message.denom);
    }
    var _iterator3 = _createForOfIteratorHelper(message.blockedAddresses),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var v = _step3.value;
        writer.uint32(26).string(v);
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    if (message.paused === true) {
      writer.uint32(32).bool(message.paused);
    }
    if (message.blockable === true) {
      writer.uint32(40).bool(message.blockable);
    }
    if (message.rateLimit !== undefined) {
      RateLimit.encode(message.rateLimit, writer.uint32(50).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseAsset();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.owner = reader.string();
          break;
        case 2:
          message.denom = reader.string();
          break;
        case 3:
          message.blockedAddresses.push(reader.string());
          break;
        case 4:
          message.paused = reader.bool();
          break;
        case 5:
          message.blockable = reader.bool();
          break;
        case 6:
          message.rateLimit = RateLimit.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      owner: (0, _helpers.isSet)(object.owner) ? String(object.owner) : "",
      denom: (0, _helpers.isSet)(object.denom) ? String(object.denom) : "",
      blockedAddresses: Array.isArray(object === null || object === void 0 ? void 0 : object.blockedAddresses) ? object.blockedAddresses.map(function (e) {
        return String(e);
      }) : [],
      paused: (0, _helpers.isSet)(object.paused) ? Boolean(object.paused) : false,
      blockable: (0, _helpers.isSet)(object.blockable) ? Boolean(object.blockable) : false,
      rateLimit: (0, _helpers.isSet)(object.rateLimit) ? RateLimit.fromJSON(object.rateLimit) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.owner !== undefined && (obj.owner = message.owner);
    message.denom !== undefined && (obj.denom = message.denom);
    if (message.blockedAddresses) {
      obj.blockedAddresses = message.blockedAddresses.map(function (e) {
        return e;
      });
    } else {
      obj.blockedAddresses = [];
    }
    message.paused !== undefined && (obj.paused = message.paused);
    message.blockable !== undefined && (obj.blockable = message.blockable);
    message.rateLimit !== undefined && (obj.rateLimit = message.rateLimit ? RateLimit.toJSON(message.rateLimit) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$owner, _object$denom, _object$blockedAddres, _object$paused, _object$blockable;
    var message = createBaseAsset();
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : "";
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.blockedAddresses = ((_object$blockedAddres = object.blockedAddresses) === null || _object$blockedAddres === void 0 ? void 0 : _object$blockedAddres.map(function (e) {
      return e;
    })) || [];
    message.paused = (_object$paused = object.paused) !== null && _object$paused !== void 0 ? _object$paused : false;
    message.blockable = (_object$blockable = object.blockable) !== null && _object$blockable !== void 0 ? _object$blockable : false;
    message.rateLimit = object.rateLimit !== undefined && object.rateLimit !== null ? RateLimit.fromPartial(object.rateLimit) : undefined;
    return message;
  }
};
exports.Asset = Asset;
function createBaseRateLimit() {
  return {
    active: false,
    limit: new Uint8Array(),
    timePeriod: undefined
  };
}
var RateLimit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    if (message.limit.length !== 0) {
      writer.uint32(18).bytes(message.limit);
    }
    if (message.timePeriod !== undefined) {
      _duration.Duration.encode(message.timePeriod, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseRateLimit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 2:
          message.limit = reader.bytes();
          break;
        case 3:
          message.timePeriod = _duration.Duration.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      active: (0, _helpers.isSet)(object.active) ? Boolean(object.active) : false,
      limit: (0, _helpers.isSet)(object.limit) ? (0, _helpers.bytesFromBase64)(object.limit) : new Uint8Array(),
      timePeriod: (0, _helpers.isSet)(object.timePeriod) ? _duration.Duration.fromJSON(object.timePeriod) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.active !== undefined && (obj.active = message.active);
    message.limit !== undefined && (obj.limit = (0, _helpers.base64FromBytes)(message.limit !== undefined ? message.limit : new Uint8Array()));
    message.timePeriod !== undefined && (obj.timePeriod = message.timePeriod ? _duration.Duration.toJSON(message.timePeriod) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$active, _object$limit;
    var message = createBaseRateLimit();
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.limit = (_object$limit = object.limit) !== null && _object$limit !== void 0 ? _object$limit : new Uint8Array();
    message.timePeriod = object.timePeriod !== undefined && object.timePeriod !== null ? _duration.Duration.fromPartial(object.timePeriod) : undefined;
    return message;
  }
};
exports.RateLimit = RateLimit;
function createBaseAssetSupply() {
  return {
    currentSupply: undefined,
    timeElapsed: undefined
  };
}
var AssetSupply = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.currentSupply !== undefined) {
      _coin.Coin.encode(message.currentSupply, writer.uint32(10).fork()).ldelim();
    }
    if (message.timeElapsed !== undefined) {
      _duration.Duration.encode(message.timeElapsed, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseAssetSupply();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.currentSupply = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 2:
          message.timeElapsed = _duration.Duration.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      currentSupply: (0, _helpers.isSet)(object.currentSupply) ? _coin.Coin.fromJSON(object.currentSupply) : undefined,
      timeElapsed: (0, _helpers.isSet)(object.timeElapsed) ? _duration.Duration.fromJSON(object.timeElapsed) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.currentSupply !== undefined && (obj.currentSupply = message.currentSupply ? _coin.Coin.toJSON(message.currentSupply) : undefined);
    message.timeElapsed !== undefined && (obj.timeElapsed = message.timeElapsed ? _duration.Duration.toJSON(message.timeElapsed) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseAssetSupply();
    message.currentSupply = object.currentSupply !== undefined && object.currentSupply !== null ? _coin.Coin.fromPartial(object.currentSupply) : undefined;
    message.timeElapsed = object.timeElapsed !== undefined && object.timeElapsed !== null ? _duration.Duration.fromPartial(object.timeElapsed) : undefined;
    return message;
  }
};
exports.AssetSupply = AssetSupply;