"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.issuance.v1beta1.MsgIssueTokens": {
    aminoType: "/kava.issuance.v1beta1.MsgIssueTokens",
    toAmino: function toAmino(_ref) {
      var sender = _ref.sender,
        tokens = _ref.tokens,
        receiver = _ref.receiver;
      return {
        sender: sender,
        tokens: {
          denom: tokens.denom,
          amount: _helpers.Long.fromValue(tokens.amount).toString()
        },
        receiver: receiver
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var sender = _ref2.sender,
        tokens = _ref2.tokens,
        receiver = _ref2.receiver;
      return {
        sender: sender,
        tokens: {
          denom: tokens.denom,
          amount: tokens.amount
        },
        receiver: receiver
      };
    }
  },
  "/kava.issuance.v1beta1.MsgRedeemTokens": {
    aminoType: "/kava.issuance.v1beta1.MsgRedeemTokens",
    toAmino: function toAmino(_ref3) {
      var sender = _ref3.sender,
        tokens = _ref3.tokens;
      return {
        sender: sender,
        tokens: {
          denom: tokens.denom,
          amount: _helpers.Long.fromValue(tokens.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var sender = _ref4.sender,
        tokens = _ref4.tokens;
      return {
        sender: sender,
        tokens: {
          denom: tokens.denom,
          amount: tokens.amount
        }
      };
    }
  },
  "/kava.issuance.v1beta1.MsgBlockAddress": {
    aminoType: "/kava.issuance.v1beta1.MsgBlockAddress",
    toAmino: function toAmino(_ref5) {
      var sender = _ref5.sender,
        denom = _ref5.denom,
        blockedAddress = _ref5.blockedAddress;
      return {
        sender: sender,
        denom: denom,
        blocked_address: blockedAddress
      };
    },
    fromAmino: function fromAmino(_ref6) {
      var sender = _ref6.sender,
        denom = _ref6.denom,
        blocked_address = _ref6.blocked_address;
      return {
        sender: sender,
        denom: denom,
        blockedAddress: blocked_address
      };
    }
  },
  "/kava.issuance.v1beta1.MsgUnblockAddress": {
    aminoType: "/kava.issuance.v1beta1.MsgUnblockAddress",
    toAmino: function toAmino(_ref7) {
      var sender = _ref7.sender,
        denom = _ref7.denom,
        blockedAddress = _ref7.blockedAddress;
      return {
        sender: sender,
        denom: denom,
        blocked_address: blockedAddress
      };
    },
    fromAmino: function fromAmino(_ref8) {
      var sender = _ref8.sender,
        denom = _ref8.denom,
        blocked_address = _ref8.blocked_address;
      return {
        sender: sender,
        denom: denom,
        blockedAddress: blocked_address
      };
    }
  },
  "/kava.issuance.v1beta1.MsgSetPauseStatus": {
    aminoType: "/kava.issuance.v1beta1.MsgSetPauseStatus",
    toAmino: function toAmino(_ref9) {
      var sender = _ref9.sender,
        denom = _ref9.denom,
        status = _ref9.status;
      return {
        sender: sender,
        denom: denom,
        status: status
      };
    },
    fromAmino: function fromAmino(_ref10) {
      var sender = _ref10.sender,
        denom = _ref10.denom,
        status = _ref10.status;
      return {
        sender: sender,
        denom: denom,
        status: status
      };
    }
  }
};
exports.AminoConverter = AminoConverter;