"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.issuance.v1beta1.MsgIssueTokens", _tx.MsgIssueTokens], ["/kava.issuance.v1beta1.MsgRedeemTokens", _tx.MsgRedeemTokens], ["/kava.issuance.v1beta1.MsgBlockAddress", _tx.MsgBlockAddress], ["/kava.issuance.v1beta1.MsgUnblockAddress", _tx.MsgUnblockAddress], ["/kava.issuance.v1beta1.MsgSetPauseStatus", _tx.MsgSetPauseStatus]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    issueTokens: function issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: _tx.MsgIssueTokens.encode(value).finish()
      };
    },
    redeemTokens: function redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: _tx.MsgRedeemTokens.encode(value).finish()
      };
    },
    blockAddress: function blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: _tx.MsgBlockAddress.encode(value).finish()
      };
    },
    unblockAddress: function unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: _tx.MsgUnblockAddress.encode(value).finish()
      };
    },
    setPauseStatus: function setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: _tx.MsgSetPauseStatus.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    issueTokens: function issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: value
      };
    },
    redeemTokens: function redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: value
      };
    },
    blockAddress: function blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: value
      };
    },
    unblockAddress: function unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: value
      };
    },
    setPauseStatus: function setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: value
      };
    }
  },
  toJSON: {
    issueTokens: function issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: _tx.MsgIssueTokens.toJSON(value)
      };
    },
    redeemTokens: function redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: _tx.MsgRedeemTokens.toJSON(value)
      };
    },
    blockAddress: function blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: _tx.MsgBlockAddress.toJSON(value)
      };
    },
    unblockAddress: function unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: _tx.MsgUnblockAddress.toJSON(value)
      };
    },
    setPauseStatus: function setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: _tx.MsgSetPauseStatus.toJSON(value)
      };
    }
  },
  fromJSON: {
    issueTokens: function issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: _tx.MsgIssueTokens.fromJSON(value)
      };
    },
    redeemTokens: function redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: _tx.MsgRedeemTokens.fromJSON(value)
      };
    },
    blockAddress: function blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: _tx.MsgBlockAddress.fromJSON(value)
      };
    },
    unblockAddress: function unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: _tx.MsgUnblockAddress.fromJSON(value)
      };
    },
    setPauseStatus: function setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: _tx.MsgSetPauseStatus.fromJSON(value)
      };
    }
  },
  fromPartial: {
    issueTokens: function issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: _tx.MsgIssueTokens.fromPartial(value)
      };
    },
    redeemTokens: function redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: _tx.MsgRedeemTokens.fromPartial(value)
      };
    },
    blockAddress: function blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: _tx.MsgBlockAddress.fromPartial(value)
      };
    },
    unblockAddress: function unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: _tx.MsgUnblockAddress.fromPartial(value)
      };
    },
    setPauseStatus: function setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: _tx.MsgSetPauseStatus.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;