"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Period = exports.PartnerReward = exports.Params = exports.InfrastructureParams = exports.CoreReward = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseParams() {
  return {
    active: false,
    periods: [],
    infrastructureParams: undefined
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    var _iterator = _createForOfIteratorHelper(message.periods),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        Period.encode(v, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    if (message.infrastructureParams !== undefined) {
      InfrastructureParams.encode(message.infrastructureParams, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 3:
          message.periods.push(Period.decode(reader, reader.uint32()));
          break;
        case 4:
          message.infrastructureParams = InfrastructureParams.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      active: (0, _helpers.isSet)(object.active) ? Boolean(object.active) : false,
      periods: Array.isArray(object === null || object === void 0 ? void 0 : object.periods) ? object.periods.map(function (e) {
        return Period.fromJSON(e);
      }) : [],
      infrastructureParams: (0, _helpers.isSet)(object.infrastructureParams) ? InfrastructureParams.fromJSON(object.infrastructureParams) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.active !== undefined && (obj.active = message.active);
    if (message.periods) {
      obj.periods = message.periods.map(function (e) {
        return e ? Period.toJSON(e) : undefined;
      });
    } else {
      obj.periods = [];
    }
    message.infrastructureParams !== undefined && (obj.infrastructureParams = message.infrastructureParams ? InfrastructureParams.toJSON(message.infrastructureParams) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$active, _object$periods;
    var message = createBaseParams();
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.periods = ((_object$periods = object.periods) === null || _object$periods === void 0 ? void 0 : _object$periods.map(function (e) {
      return Period.fromPartial(e);
    })) || [];
    message.infrastructureParams = object.infrastructureParams !== undefined && object.infrastructureParams !== null ? InfrastructureParams.fromPartial(object.infrastructureParams) : undefined;
    return message;
  }
};
exports.Params = Params;
function createBaseInfrastructureParams() {
  return {
    infrastructurePeriods: [],
    coreRewards: [],
    partnerRewards: []
  };
}
var InfrastructureParams = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator2 = _createForOfIteratorHelper(message.infrastructurePeriods),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var v = _step2.value;
        Period.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    var _iterator3 = _createForOfIteratorHelper(message.coreRewards),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var _v = _step3.value;
        CoreReward.encode(_v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    var _iterator4 = _createForOfIteratorHelper(message.partnerRewards),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var _v2 = _step4.value;
        PartnerReward.encode(_v2, writer.uint32(26).fork()).ldelim();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseInfrastructureParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.infrastructurePeriods.push(Period.decode(reader, reader.uint32()));
          break;
        case 2:
          message.coreRewards.push(CoreReward.decode(reader, reader.uint32()));
          break;
        case 3:
          message.partnerRewards.push(PartnerReward.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      infrastructurePeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.infrastructurePeriods) ? object.infrastructurePeriods.map(function (e) {
        return Period.fromJSON(e);
      }) : [],
      coreRewards: Array.isArray(object === null || object === void 0 ? void 0 : object.coreRewards) ? object.coreRewards.map(function (e) {
        return CoreReward.fromJSON(e);
      }) : [],
      partnerRewards: Array.isArray(object === null || object === void 0 ? void 0 : object.partnerRewards) ? object.partnerRewards.map(function (e) {
        return PartnerReward.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.infrastructurePeriods) {
      obj.infrastructurePeriods = message.infrastructurePeriods.map(function (e) {
        return e ? Period.toJSON(e) : undefined;
      });
    } else {
      obj.infrastructurePeriods = [];
    }
    if (message.coreRewards) {
      obj.coreRewards = message.coreRewards.map(function (e) {
        return e ? CoreReward.toJSON(e) : undefined;
      });
    } else {
      obj.coreRewards = [];
    }
    if (message.partnerRewards) {
      obj.partnerRewards = message.partnerRewards.map(function (e) {
        return e ? PartnerReward.toJSON(e) : undefined;
      });
    } else {
      obj.partnerRewards = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$infrastructur, _object$coreRewards, _object$partnerReward;
    var message = createBaseInfrastructureParams();
    message.infrastructurePeriods = ((_object$infrastructur = object.infrastructurePeriods) === null || _object$infrastructur === void 0 ? void 0 : _object$infrastructur.map(function (e) {
      return Period.fromPartial(e);
    })) || [];
    message.coreRewards = ((_object$coreRewards = object.coreRewards) === null || _object$coreRewards === void 0 ? void 0 : _object$coreRewards.map(function (e) {
      return CoreReward.fromPartial(e);
    })) || [];
    message.partnerRewards = ((_object$partnerReward = object.partnerRewards) === null || _object$partnerReward === void 0 ? void 0 : _object$partnerReward.map(function (e) {
      return PartnerReward.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.InfrastructureParams = InfrastructureParams;
function createBaseCoreReward() {
  return {
    address: new Uint8Array(),
    weight: ""
  };
}
var CoreReward = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.address.length !== 0) {
      writer.uint32(10).bytes(message.address);
    }
    if (message.weight !== "") {
      writer.uint32(18).string(message.weight);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCoreReward();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.bytes();
          break;
        case 2:
          message.weight = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      address: (0, _helpers.isSet)(object.address) ? (0, _helpers.bytesFromBase64)(object.address) : new Uint8Array(),
      weight: (0, _helpers.isSet)(object.weight) ? String(object.weight) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.address !== undefined && (obj.address = (0, _helpers.base64FromBytes)(message.address !== undefined ? message.address : new Uint8Array()));
    message.weight !== undefined && (obj.weight = message.weight);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$address, _object$weight;
    var message = createBaseCoreReward();
    message.address = (_object$address = object.address) !== null && _object$address !== void 0 ? _object$address : new Uint8Array();
    message.weight = (_object$weight = object.weight) !== null && _object$weight !== void 0 ? _object$weight : "";
    return message;
  }
};
exports.CoreReward = CoreReward;
function createBasePartnerReward() {
  return {
    address: new Uint8Array(),
    rewardsPerSecond: undefined
  };
}
var PartnerReward = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.address.length !== 0) {
      writer.uint32(10).bytes(message.address);
    }
    if (message.rewardsPerSecond !== undefined) {
      _coin.Coin.encode(message.rewardsPerSecond, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBasePartnerReward();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.bytes();
          break;
        case 2:
          message.rewardsPerSecond = _coin.Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      address: (0, _helpers.isSet)(object.address) ? (0, _helpers.bytesFromBase64)(object.address) : new Uint8Array(),
      rewardsPerSecond: (0, _helpers.isSet)(object.rewardsPerSecond) ? _coin.Coin.fromJSON(object.rewardsPerSecond) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.address !== undefined && (obj.address = (0, _helpers.base64FromBytes)(message.address !== undefined ? message.address : new Uint8Array()));
    message.rewardsPerSecond !== undefined && (obj.rewardsPerSecond = message.rewardsPerSecond ? _coin.Coin.toJSON(message.rewardsPerSecond) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$address2;
    var message = createBasePartnerReward();
    message.address = (_object$address2 = object.address) !== null && _object$address2 !== void 0 ? _object$address2 : new Uint8Array();
    message.rewardsPerSecond = object.rewardsPerSecond !== undefined && object.rewardsPerSecond !== null ? _coin.Coin.fromPartial(object.rewardsPerSecond) : undefined;
    return message;
  }
};
exports.PartnerReward = PartnerReward;
function createBasePeriod() {
  return {
    start: undefined,
    end: undefined,
    inflation: new Uint8Array()
  };
}
var Period = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.start !== undefined) {
      _timestamp.Timestamp.encode(message.start, writer.uint32(10).fork()).ldelim();
    }
    if (message.end !== undefined) {
      _timestamp.Timestamp.encode(message.end, writer.uint32(18).fork()).ldelim();
    }
    if (message.inflation.length !== 0) {
      writer.uint32(26).bytes(message.inflation);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBasePeriod();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.start = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 2:
          message.end = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        case 3:
          message.inflation = reader.bytes();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      start: (0, _helpers.isSet)(object.start) ? (0, _helpers.fromJsonTimestamp)(object.start) : undefined,
      end: (0, _helpers.isSet)(object.end) ? (0, _helpers.fromJsonTimestamp)(object.end) : undefined,
      inflation: (0, _helpers.isSet)(object.inflation) ? (0, _helpers.bytesFromBase64)(object.inflation) : new Uint8Array()
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.start !== undefined && (obj.start = (0, _helpers.fromTimestamp)(message.start).toISOString());
    message.end !== undefined && (obj.end = (0, _helpers.fromTimestamp)(message.end).toISOString());
    message.inflation !== undefined && (obj.inflation = (0, _helpers.base64FromBytes)(message.inflation !== undefined ? message.inflation : new Uint8Array()));
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$inflation;
    var message = createBasePeriod();
    message.start = object.start !== undefined && object.start !== null ? _timestamp.Timestamp.fromPartial(object.start) : undefined;
    message.end = object.end !== undefined && object.end !== null ? _timestamp.Timestamp.fromPartial(object.end) : undefined;
    message.inflation = (_object$inflation = object.inflation) !== null && _object$inflation !== void 0 ? _object$inflation : new Uint8Array();
    return message;
  }
};
exports.Period = Period;