"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.liquid.v1beta1.MsgMintDerivative": {
    aminoType: "/kava.liquid.v1beta1.MsgMintDerivative",
    toAmino: function toAmino(_ref) {
      var sender = _ref.sender,
        validator = _ref.validator,
        amount = _ref.amount;
      return {
        sender: sender,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var sender = _ref2.sender,
        validator = _ref2.validator,
        amount = _ref2.amount;
      return {
        sender: sender,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.liquid.v1beta1.MsgBurnDerivative": {
    aminoType: "/kava.liquid.v1beta1.MsgBurnDerivative",
    toAmino: function toAmino(_ref3) {
      var sender = _ref3.sender,
        validator = _ref3.validator,
        amount = _ref3.amount;
      return {
        sender: sender,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var sender = _ref4.sender,
        validator = _ref4.validator,
        amount = _ref4.amount;
      return {
        sender: sender,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  }
};
exports.AminoConverter = AminoConverter;