"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.liquid.v1beta1.MsgMintDerivative", _tx.MsgMintDerivative], ["/kava.liquid.v1beta1.MsgBurnDerivative", _tx.MsgBurnDerivative]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    mintDerivative: function mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: _tx.MsgMintDerivative.encode(value).finish()
      };
    },
    burnDerivative: function burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: _tx.MsgBurnDerivative.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    mintDerivative: function mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: value
      };
    },
    burnDerivative: function burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: value
      };
    }
  },
  toJSON: {
    mintDerivative: function mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: _tx.MsgMintDerivative.toJSON(value)
      };
    },
    burnDerivative: function burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: _tx.MsgBurnDerivative.toJSON(value)
      };
    }
  },
  fromJSON: {
    mintDerivative: function mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: _tx.MsgMintDerivative.fromJSON(value)
      };
    },
    burnDerivative: function burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: _tx.MsgBurnDerivative.fromJSON(value)
      };
    }
  },
  fromPartial: {
    mintDerivative: function mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: _tx.MsgMintDerivative.fromPartial(value)
      };
    },
    burnDerivative: function burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: _tx.MsgBurnDerivative.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;