"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRpcQueryExtension = exports.QueryClientImpl = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _stargate = require("@cosmjs/stargate");
var _query = require("./query");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var QueryClientImpl = /*#__PURE__*/function () {
  function QueryClientImpl(rpc) {
    (0, _classCallCheck2["default"])(this, QueryClientImpl);
    (0, _defineProperty2["default"])(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.price = this.price.bind(this);
    this.prices = this.prices.bind(this);
    this.rawPrices = this.rawPrices.bind(this);
    this.oracles = this.oracles.bind(this);
    this.markets = this.markets.bind(this);
  }
  (0, _createClass2["default"])(QueryClientImpl, [{
    key: "params",
    value: function params() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryParamsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Params", data);
      return promise.then(function (data) {
        return _query.QueryParamsResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "price",
    value: function price(request) {
      var data = _query.QueryPriceRequest.encode(request).finish();
      var promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Price", data);
      return promise.then(function (data) {
        return _query.QueryPriceResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "prices",
    value: function prices() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryPricesRequest.encode(request).finish();
      var promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Prices", data);
      return promise.then(function (data) {
        return _query.QueryPricesResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "rawPrices",
    value: function rawPrices(request) {
      var data = _query.QueryRawPricesRequest.encode(request).finish();
      var promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "RawPrices", data);
      return promise.then(function (data) {
        return _query.QueryRawPricesResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "oracles",
    value: function oracles(request) {
      var data = _query.QueryOraclesRequest.encode(request).finish();
      var promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Oracles", data);
      return promise.then(function (data) {
        return _query.QueryOraclesResponse.decode(new _m0.Reader(data));
      });
    }
  }, {
    key: "markets",
    value: function markets() {
      var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var data = _query.QueryMarketsRequest.encode(request).finish();
      var promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Markets", data);
      return promise.then(function (data) {
        return _query.QueryMarketsResponse.decode(new _m0.Reader(data));
      });
    }
  }]);
  return QueryClientImpl;
}();
exports.QueryClientImpl = QueryClientImpl;
var createRpcQueryExtension = function createRpcQueryExtension(base) {
  var rpc = (0, _stargate.createProtobufRpcClient)(base);
  var queryService = new QueryClientImpl(rpc);
  return {
    params: function params(request) {
      return queryService.params(request);
    },
    price: function price(request) {
      return queryService.price(request);
    },
    prices: function prices(request) {
      return queryService.prices(request);
    },
    rawPrices: function rawPrices(request) {
      return queryService.rawPrices(request);
    },
    oracles: function oracles(request) {
      return queryService.oracles(request);
    },
    markets: function markets(request) {
      return queryService.markets(request);
    }
  };
};
exports.createRpcQueryExtension = createRpcQueryExtension;