"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PostedPrice = exports.Params = exports.Market = exports.CurrentPrice = void 0;
var _timestamp = require("../../../google/protobuf/timestamp");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseParams() {
  return {
    markets: []
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator = _createForOfIteratorHelper(message.markets),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        Market.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.markets.push(Market.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      markets: Array.isArray(object === null || object === void 0 ? void 0 : object.markets) ? object.markets.map(function (e) {
        return Market.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.markets) {
      obj.markets = message.markets.map(function (e) {
        return e ? Market.toJSON(e) : undefined;
      });
    } else {
      obj.markets = [];
    }
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$markets;
    var message = createBaseParams();
    message.markets = ((_object$markets = object.markets) === null || _object$markets === void 0 ? void 0 : _object$markets.map(function (e) {
      return Market.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.Params = Params;
function createBaseMarket() {
  return {
    marketId: "",
    baseAsset: "",
    quoteAsset: "",
    oracles: [],
    active: false
  };
}
var Market = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    if (message.baseAsset !== "") {
      writer.uint32(18).string(message.baseAsset);
    }
    if (message.quoteAsset !== "") {
      writer.uint32(26).string(message.quoteAsset);
    }
    var _iterator2 = _createForOfIteratorHelper(message.oracles),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var v = _step2.value;
        writer.uint32(34).bytes(v);
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    if (message.active === true) {
      writer.uint32(40).bool(message.active);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMarket();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        case 2:
          message.baseAsset = reader.string();
          break;
        case 3:
          message.quoteAsset = reader.string();
          break;
        case 4:
          message.oracles.push(reader.bytes());
          break;
        case 5:
          message.active = reader.bool();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      marketId: (0, _helpers.isSet)(object.marketId) ? String(object.marketId) : "",
      baseAsset: (0, _helpers.isSet)(object.baseAsset) ? String(object.baseAsset) : "",
      quoteAsset: (0, _helpers.isSet)(object.quoteAsset) ? String(object.quoteAsset) : "",
      oracles: Array.isArray(object === null || object === void 0 ? void 0 : object.oracles) ? object.oracles.map(function (e) {
        return (0, _helpers.bytesFromBase64)(e);
      }) : [],
      active: (0, _helpers.isSet)(object.active) ? Boolean(object.active) : false
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    message.baseAsset !== undefined && (obj.baseAsset = message.baseAsset);
    message.quoteAsset !== undefined && (obj.quoteAsset = message.quoteAsset);
    if (message.oracles) {
      obj.oracles = message.oracles.map(function (e) {
        return (0, _helpers.base64FromBytes)(e !== undefined ? e : new Uint8Array());
      });
    } else {
      obj.oracles = [];
    }
    message.active !== undefined && (obj.active = message.active);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$marketId, _object$baseAsset, _object$quoteAsset, _object$oracles, _object$active;
    var message = createBaseMarket();
    message.marketId = (_object$marketId = object.marketId) !== null && _object$marketId !== void 0 ? _object$marketId : "";
    message.baseAsset = (_object$baseAsset = object.baseAsset) !== null && _object$baseAsset !== void 0 ? _object$baseAsset : "";
    message.quoteAsset = (_object$quoteAsset = object.quoteAsset) !== null && _object$quoteAsset !== void 0 ? _object$quoteAsset : "";
    message.oracles = ((_object$oracles = object.oracles) === null || _object$oracles === void 0 ? void 0 : _object$oracles.map(function (e) {
      return e;
    })) || [];
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    return message;
  }
};
exports.Market = Market;
function createBasePostedPrice() {
  return {
    marketId: "",
    oracleAddress: new Uint8Array(),
    price: "",
    expiry: undefined
  };
}
var PostedPrice = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    if (message.oracleAddress.length !== 0) {
      writer.uint32(18).bytes(message.oracleAddress);
    }
    if (message.price !== "") {
      writer.uint32(26).string(message.price);
    }
    if (message.expiry !== undefined) {
      _timestamp.Timestamp.encode(message.expiry, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBasePostedPrice();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        case 2:
          message.oracleAddress = reader.bytes();
          break;
        case 3:
          message.price = reader.string();
          break;
        case 4:
          message.expiry = _timestamp.Timestamp.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      marketId: (0, _helpers.isSet)(object.marketId) ? String(object.marketId) : "",
      oracleAddress: (0, _helpers.isSet)(object.oracleAddress) ? (0, _helpers.bytesFromBase64)(object.oracleAddress) : new Uint8Array(),
      price: (0, _helpers.isSet)(object.price) ? String(object.price) : "",
      expiry: (0, _helpers.isSet)(object.expiry) ? (0, _helpers.fromJsonTimestamp)(object.expiry) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    message.oracleAddress !== undefined && (obj.oracleAddress = (0, _helpers.base64FromBytes)(message.oracleAddress !== undefined ? message.oracleAddress : new Uint8Array()));
    message.price !== undefined && (obj.price = message.price);
    message.expiry !== undefined && (obj.expiry = (0, _helpers.fromTimestamp)(message.expiry).toISOString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$marketId2, _object$oracleAddress, _object$price;
    var message = createBasePostedPrice();
    message.marketId = (_object$marketId2 = object.marketId) !== null && _object$marketId2 !== void 0 ? _object$marketId2 : "";
    message.oracleAddress = (_object$oracleAddress = object.oracleAddress) !== null && _object$oracleAddress !== void 0 ? _object$oracleAddress : new Uint8Array();
    message.price = (_object$price = object.price) !== null && _object$price !== void 0 ? _object$price : "";
    message.expiry = object.expiry !== undefined && object.expiry !== null ? _timestamp.Timestamp.fromPartial(object.expiry) : undefined;
    return message;
  }
};
exports.PostedPrice = PostedPrice;
function createBaseCurrentPrice() {
  return {
    marketId: "",
    price: ""
  };
}
var CurrentPrice = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    if (message.price !== "") {
      writer.uint32(18).string(message.price);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCurrentPrice();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        case 2:
          message.price = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      marketId: (0, _helpers.isSet)(object.marketId) ? String(object.marketId) : "",
      price: (0, _helpers.isSet)(object.price) ? String(object.price) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    message.price !== undefined && (obj.price = message.price);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$marketId3, _object$price2;
    var message = createBaseCurrentPrice();
    message.marketId = (_object$marketId3 = object.marketId) !== null && _object$marketId3 !== void 0 ? _object$marketId3 : "";
    message.price = (_object$price2 = object.price) !== null && _object$price2 !== void 0 ? _object$price2 : "";
    return message;
  }
};
exports.CurrentPrice = CurrentPrice;