"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AminoConverter = void 0;
var _helpers = require("../../../helpers");
//@ts-nocheck

var AminoConverter = {
  "/kava.router.v1beta1.MsgMintDeposit": {
    aminoType: "/kava.router.v1beta1.MsgMintDeposit",
    toAmino: function toAmino(_ref) {
      var depositor = _ref.depositor,
        validator = _ref.validator,
        amount = _ref.amount;
      return {
        depositor: depositor,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref2) {
      var depositor = _ref2.depositor,
        validator = _ref2.validator,
        amount = _ref2.amount;
      return {
        depositor: depositor,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.router.v1beta1.MsgDelegateMintDeposit": {
    aminoType: "/kava.router.v1beta1.MsgDelegateMintDeposit",
    toAmino: function toAmino(_ref3) {
      var depositor = _ref3.depositor,
        validator = _ref3.validator,
        amount = _ref3.amount;
      return {
        depositor: depositor,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref4) {
      var depositor = _ref4.depositor,
        validator = _ref4.validator,
        amount = _ref4.amount;
      return {
        depositor: depositor,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.router.v1beta1.MsgWithdrawBurn": {
    aminoType: "/kava.router.v1beta1.MsgWithdrawBurn",
    toAmino: function toAmino(_ref5) {
      var from = _ref5.from,
        validator = _ref5.validator,
        amount = _ref5.amount;
      return {
        from: from,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref6) {
      var from = _ref6.from,
        validator = _ref6.validator,
        amount = _ref6.amount;
      return {
        from: from,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.router.v1beta1.MsgWithdrawBurnUndelegate": {
    aminoType: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
    toAmino: function toAmino(_ref7) {
      var from = _ref7.from,
        validator = _ref7.validator,
        amount = _ref7.amount;
      return {
        from: from,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: _helpers.Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: function fromAmino(_ref8) {
      var from = _ref8.from,
        validator = _ref8.validator,
        amount = _ref8.amount;
      return {
        from: from,
        validator: validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  }
};
exports.AminoConverter = AminoConverter;