"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.router.v1beta1.MsgMintDeposit", _tx.MsgMintDeposit], ["/kava.router.v1beta1.MsgDelegateMintDeposit", _tx.MsgDelegateMintDeposit], ["/kava.router.v1beta1.MsgWithdrawBurn", _tx.MsgWithdrawBurn], ["/kava.router.v1beta1.MsgWithdrawBurnUndelegate", _tx.MsgWithdrawBurnUndelegate]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    mintDeposit: function mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: _tx.MsgMintDeposit.encode(value).finish()
      };
    },
    delegateMintDeposit: function delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: _tx.MsgDelegateMintDeposit.encode(value).finish()
      };
    },
    withdrawBurn: function withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: _tx.MsgWithdrawBurn.encode(value).finish()
      };
    },
    withdrawBurnUndelegate: function withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: _tx.MsgWithdrawBurnUndelegate.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    mintDeposit: function mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: value
      };
    },
    delegateMintDeposit: function delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: value
      };
    },
    withdrawBurn: function withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: value
      };
    },
    withdrawBurnUndelegate: function withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: value
      };
    }
  },
  toJSON: {
    mintDeposit: function mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: _tx.MsgMintDeposit.toJSON(value)
      };
    },
    delegateMintDeposit: function delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: _tx.MsgDelegateMintDeposit.toJSON(value)
      };
    },
    withdrawBurn: function withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: _tx.MsgWithdrawBurn.toJSON(value)
      };
    },
    withdrawBurnUndelegate: function withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: _tx.MsgWithdrawBurnUndelegate.toJSON(value)
      };
    }
  },
  fromJSON: {
    mintDeposit: function mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: _tx.MsgMintDeposit.fromJSON(value)
      };
    },
    delegateMintDeposit: function delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: _tx.MsgDelegateMintDeposit.fromJSON(value)
      };
    },
    withdrawBurn: function withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: _tx.MsgWithdrawBurn.fromJSON(value)
      };
    },
    withdrawBurnUndelegate: function withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: _tx.MsgWithdrawBurnUndelegate.fromJSON(value)
      };
    }
  },
  fromPartial: {
    mintDeposit: function mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: _tx.MsgMintDeposit.fromPartial(value)
      };
    },
    delegateMintDeposit: function delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: _tx.MsgDelegateMintDeposit.fromPartial(value)
      };
    },
    withdrawBurn: function withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: _tx.MsgWithdrawBurn.fromPartial(value)
      };
    },
    withdrawBurnUndelegate: function withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: _tx.MsgWithdrawBurnUndelegate.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;