"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ShareRecord = exports.PoolRecord = exports.Params = exports.AllowedPool = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function createBaseParams() {
  return {
    allowedPools: [],
    swapFee: ""
  };
}
var Params = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    var _iterator = _createForOfIteratorHelper(message.allowedPools),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        AllowedPool.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    if (message.swapFee !== "") {
      writer.uint32(18).string(message.swapFee);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseParams();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.allowedPools.push(AllowedPool.decode(reader, reader.uint32()));
          break;
        case 2:
          message.swapFee = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      allowedPools: Array.isArray(object === null || object === void 0 ? void 0 : object.allowedPools) ? object.allowedPools.map(function (e) {
        return AllowedPool.fromJSON(e);
      }) : [],
      swapFee: (0, _helpers.isSet)(object.swapFee) ? String(object.swapFee) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    if (message.allowedPools) {
      obj.allowedPools = message.allowedPools.map(function (e) {
        return e ? AllowedPool.toJSON(e) : undefined;
      });
    } else {
      obj.allowedPools = [];
    }
    message.swapFee !== undefined && (obj.swapFee = message.swapFee);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$allowedPools, _object$swapFee;
    var message = createBaseParams();
    message.allowedPools = ((_object$allowedPools = object.allowedPools) === null || _object$allowedPools === void 0 ? void 0 : _object$allowedPools.map(function (e) {
      return AllowedPool.fromPartial(e);
    })) || [];
    message.swapFee = (_object$swapFee = object.swapFee) !== null && _object$swapFee !== void 0 ? _object$swapFee : "";
    return message;
  }
};
exports.Params = Params;
function createBaseAllowedPool() {
  return {
    tokenA: "",
    tokenB: ""
  };
}
var AllowedPool = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.tokenA !== "") {
      writer.uint32(10).string(message.tokenA);
    }
    if (message.tokenB !== "") {
      writer.uint32(18).string(message.tokenB);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseAllowedPool();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.tokenA = reader.string();
          break;
        case 2:
          message.tokenB = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      tokenA: (0, _helpers.isSet)(object.tokenA) ? String(object.tokenA) : "",
      tokenB: (0, _helpers.isSet)(object.tokenB) ? String(object.tokenB) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.tokenA !== undefined && (obj.tokenA = message.tokenA);
    message.tokenB !== undefined && (obj.tokenB = message.tokenB);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$tokenA, _object$tokenB;
    var message = createBaseAllowedPool();
    message.tokenA = (_object$tokenA = object.tokenA) !== null && _object$tokenA !== void 0 ? _object$tokenA : "";
    message.tokenB = (_object$tokenB = object.tokenB) !== null && _object$tokenB !== void 0 ? _object$tokenB : "";
    return message;
  }
};
exports.AllowedPool = AllowedPool;
function createBasePoolRecord() {
  return {
    poolId: "",
    reservesA: undefined,
    reservesB: undefined,
    totalShares: ""
  };
}
var PoolRecord = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.poolId !== "") {
      writer.uint32(10).string(message.poolId);
    }
    if (message.reservesA !== undefined) {
      _coin.Coin.encode(message.reservesA, writer.uint32(18).fork()).ldelim();
    }
    if (message.reservesB !== undefined) {
      _coin.Coin.encode(message.reservesB, writer.uint32(26).fork()).ldelim();
    }
    if (message.totalShares !== "") {
      writer.uint32(34).string(message.totalShares);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBasePoolRecord();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.poolId = reader.string();
          break;
        case 2:
          message.reservesA = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.reservesB = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.totalShares = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      poolId: (0, _helpers.isSet)(object.poolId) ? String(object.poolId) : "",
      reservesA: (0, _helpers.isSet)(object.reservesA) ? _coin.Coin.fromJSON(object.reservesA) : undefined,
      reservesB: (0, _helpers.isSet)(object.reservesB) ? _coin.Coin.fromJSON(object.reservesB) : undefined,
      totalShares: (0, _helpers.isSet)(object.totalShares) ? String(object.totalShares) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.poolId !== undefined && (obj.poolId = message.poolId);
    message.reservesA !== undefined && (obj.reservesA = message.reservesA ? _coin.Coin.toJSON(message.reservesA) : undefined);
    message.reservesB !== undefined && (obj.reservesB = message.reservesB ? _coin.Coin.toJSON(message.reservesB) : undefined);
    message.totalShares !== undefined && (obj.totalShares = message.totalShares);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$poolId, _object$totalShares;
    var message = createBasePoolRecord();
    message.poolId = (_object$poolId = object.poolId) !== null && _object$poolId !== void 0 ? _object$poolId : "";
    message.reservesA = object.reservesA !== undefined && object.reservesA !== null ? _coin.Coin.fromPartial(object.reservesA) : undefined;
    message.reservesB = object.reservesB !== undefined && object.reservesB !== null ? _coin.Coin.fromPartial(object.reservesB) : undefined;
    message.totalShares = (_object$totalShares = object.totalShares) !== null && _object$totalShares !== void 0 ? _object$totalShares : "";
    return message;
  }
};
exports.PoolRecord = PoolRecord;
function createBaseShareRecord() {
  return {
    depositor: new Uint8Array(),
    poolId: "",
    sharesOwned: ""
  };
}
var ShareRecord = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.depositor.length !== 0) {
      writer.uint32(10).bytes(message.depositor);
    }
    if (message.poolId !== "") {
      writer.uint32(18).string(message.poolId);
    }
    if (message.sharesOwned !== "") {
      writer.uint32(26).string(message.sharesOwned);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseShareRecord();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.bytes();
          break;
        case 2:
          message.poolId = reader.string();
          break;
        case 3:
          message.sharesOwned = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      depositor: (0, _helpers.isSet)(object.depositor) ? (0, _helpers.bytesFromBase64)(object.depositor) : new Uint8Array(),
      poolId: (0, _helpers.isSet)(object.poolId) ? String(object.poolId) : "",
      sharesOwned: (0, _helpers.isSet)(object.sharesOwned) ? String(object.sharesOwned) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.depositor !== undefined && (obj.depositor = (0, _helpers.base64FromBytes)(message.depositor !== undefined ? message.depositor : new Uint8Array()));
    message.poolId !== undefined && (obj.poolId = message.poolId);
    message.sharesOwned !== undefined && (obj.sharesOwned = message.sharesOwned);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor, _object$poolId2, _object$sharesOwned;
    var message = createBaseShareRecord();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : new Uint8Array();
    message.poolId = (_object$poolId2 = object.poolId) !== null && _object$poolId2 !== void 0 ? _object$poolId2 : "";
    message.sharesOwned = (_object$sharesOwned = object.sharesOwned) !== null && _object$sharesOwned !== void 0 ? _object$sharesOwned : "";
    return message;
  }
};
exports.ShareRecord = ShareRecord;