"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MsgWithdrawResponse = exports.MsgWithdraw = exports.MsgSwapForExactTokensResponse = exports.MsgSwapForExactTokens = exports.MsgSwapExactForTokensResponse = exports.MsgSwapExactForTokens = exports.MsgDepositResponse = exports.MsgDeposit = void 0;
var _coin = require("../../../cosmos/base/v1beta1/coin");
var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));
var _helpers = require("../../../helpers");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function createBaseMsgDeposit() {
  return {
    depositor: "",
    tokenA: undefined,
    tokenB: undefined,
    slippage: "",
    deadline: _helpers.Long.ZERO
  };
}
var MsgDeposit = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.tokenA !== undefined) {
      _coin.Coin.encode(message.tokenA, writer.uint32(18).fork()).ldelim();
    }
    if (message.tokenB !== undefined) {
      _coin.Coin.encode(message.tokenB, writer.uint32(26).fork()).ldelim();
    }
    if (message.slippage !== "") {
      writer.uint32(34).string(message.slippage);
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDeposit();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.tokenA = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.tokenB = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.slippage = reader.string();
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      depositor: (0, _helpers.isSet)(object.depositor) ? String(object.depositor) : "",
      tokenA: (0, _helpers.isSet)(object.tokenA) ? _coin.Coin.fromJSON(object.tokenA) : undefined,
      tokenB: (0, _helpers.isSet)(object.tokenB) ? _coin.Coin.fromJSON(object.tokenB) : undefined,
      slippage: (0, _helpers.isSet)(object.slippage) ? String(object.slippage) : "",
      deadline: (0, _helpers.isSet)(object.deadline) ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.tokenA !== undefined && (obj.tokenA = message.tokenA ? _coin.Coin.toJSON(message.tokenA) : undefined);
    message.tokenB !== undefined && (obj.tokenB = message.tokenB ? _coin.Coin.toJSON(message.tokenB) : undefined);
    message.slippage !== undefined && (obj.slippage = message.slippage);
    message.deadline !== undefined && (obj.deadline = (message.deadline || _helpers.Long.ZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$depositor, _object$slippage;
    var message = createBaseMsgDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.tokenA = object.tokenA !== undefined && object.tokenA !== null ? _coin.Coin.fromPartial(object.tokenA) : undefined;
    message.tokenB = object.tokenB !== undefined && object.tokenB !== null ? _coin.Coin.fromPartial(object.tokenB) : undefined;
    message.slippage = (_object$slippage = object.slippage) !== null && _object$slippage !== void 0 ? _object$slippage : "";
    message.deadline = object.deadline !== undefined && object.deadline !== null ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO;
    return message;
  }
};
exports.MsgDeposit = MsgDeposit;
function createBaseMsgDepositResponse() {
  return {};
}
var MsgDepositResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgDepositResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgDepositResponse();
    return message;
  }
};
exports.MsgDepositResponse = MsgDepositResponse;
function createBaseMsgWithdraw() {
  return {
    from: "",
    shares: "",
    minTokenA: undefined,
    minTokenB: undefined,
    deadline: _helpers.Long.ZERO
  };
}
var MsgWithdraw = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.shares !== "") {
      writer.uint32(18).string(message.shares);
    }
    if (message.minTokenA !== undefined) {
      _coin.Coin.encode(message.minTokenA, writer.uint32(26).fork()).ldelim();
    }
    if (message.minTokenB !== undefined) {
      _coin.Coin.encode(message.minTokenB, writer.uint32(34).fork()).ldelim();
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgWithdraw();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.shares = reader.string();
          break;
        case 3:
          message.minTokenA = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.minTokenB = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      from: (0, _helpers.isSet)(object.from) ? String(object.from) : "",
      shares: (0, _helpers.isSet)(object.shares) ? String(object.shares) : "",
      minTokenA: (0, _helpers.isSet)(object.minTokenA) ? _coin.Coin.fromJSON(object.minTokenA) : undefined,
      minTokenB: (0, _helpers.isSet)(object.minTokenB) ? _coin.Coin.fromJSON(object.minTokenB) : undefined,
      deadline: (0, _helpers.isSet)(object.deadline) ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.shares !== undefined && (obj.shares = message.shares);
    message.minTokenA !== undefined && (obj.minTokenA = message.minTokenA ? _coin.Coin.toJSON(message.minTokenA) : undefined);
    message.minTokenB !== undefined && (obj.minTokenB = message.minTokenB ? _coin.Coin.toJSON(message.minTokenB) : undefined);
    message.deadline !== undefined && (obj.deadline = (message.deadline || _helpers.Long.ZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$from, _object$shares;
    var message = createBaseMsgWithdraw();
    message.from = (_object$from = object.from) !== null && _object$from !== void 0 ? _object$from : "";
    message.shares = (_object$shares = object.shares) !== null && _object$shares !== void 0 ? _object$shares : "";
    message.minTokenA = object.minTokenA !== undefined && object.minTokenA !== null ? _coin.Coin.fromPartial(object.minTokenA) : undefined;
    message.minTokenB = object.minTokenB !== undefined && object.minTokenB !== null ? _coin.Coin.fromPartial(object.minTokenB) : undefined;
    message.deadline = object.deadline !== undefined && object.deadline !== null ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO;
    return message;
  }
};
exports.MsgWithdraw = MsgWithdraw;
function createBaseMsgWithdrawResponse() {
  return {};
}
var MsgWithdrawResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgWithdrawResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgWithdrawResponse();
    return message;
  }
};
exports.MsgWithdrawResponse = MsgWithdrawResponse;
function createBaseMsgSwapExactForTokens() {
  return {
    requester: "",
    exactTokenA: undefined,
    tokenB: undefined,
    slippage: "",
    deadline: _helpers.Long.ZERO
  };
}
var MsgSwapExactForTokens = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.requester !== "") {
      writer.uint32(10).string(message.requester);
    }
    if (message.exactTokenA !== undefined) {
      _coin.Coin.encode(message.exactTokenA, writer.uint32(18).fork()).ldelim();
    }
    if (message.tokenB !== undefined) {
      _coin.Coin.encode(message.tokenB, writer.uint32(26).fork()).ldelim();
    }
    if (message.slippage !== "") {
      writer.uint32(34).string(message.slippage);
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgSwapExactForTokens();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.requester = reader.string();
          break;
        case 2:
          message.exactTokenA = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.tokenB = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.slippage = reader.string();
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      requester: (0, _helpers.isSet)(object.requester) ? String(object.requester) : "",
      exactTokenA: (0, _helpers.isSet)(object.exactTokenA) ? _coin.Coin.fromJSON(object.exactTokenA) : undefined,
      tokenB: (0, _helpers.isSet)(object.tokenB) ? _coin.Coin.fromJSON(object.tokenB) : undefined,
      slippage: (0, _helpers.isSet)(object.slippage) ? String(object.slippage) : "",
      deadline: (0, _helpers.isSet)(object.deadline) ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.requester !== undefined && (obj.requester = message.requester);
    message.exactTokenA !== undefined && (obj.exactTokenA = message.exactTokenA ? _coin.Coin.toJSON(message.exactTokenA) : undefined);
    message.tokenB !== undefined && (obj.tokenB = message.tokenB ? _coin.Coin.toJSON(message.tokenB) : undefined);
    message.slippage !== undefined && (obj.slippage = message.slippage);
    message.deadline !== undefined && (obj.deadline = (message.deadline || _helpers.Long.ZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$requester, _object$slippage2;
    var message = createBaseMsgSwapExactForTokens();
    message.requester = (_object$requester = object.requester) !== null && _object$requester !== void 0 ? _object$requester : "";
    message.exactTokenA = object.exactTokenA !== undefined && object.exactTokenA !== null ? _coin.Coin.fromPartial(object.exactTokenA) : undefined;
    message.tokenB = object.tokenB !== undefined && object.tokenB !== null ? _coin.Coin.fromPartial(object.tokenB) : undefined;
    message.slippage = (_object$slippage2 = object.slippage) !== null && _object$slippage2 !== void 0 ? _object$slippage2 : "";
    message.deadline = object.deadline !== undefined && object.deadline !== null ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO;
    return message;
  }
};
exports.MsgSwapExactForTokens = MsgSwapExactForTokens;
function createBaseMsgSwapExactForTokensResponse() {
  return {};
}
var MsgSwapExactForTokensResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgSwapExactForTokensResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgSwapExactForTokensResponse();
    return message;
  }
};
exports.MsgSwapExactForTokensResponse = MsgSwapExactForTokensResponse;
function createBaseMsgSwapForExactTokens() {
  return {
    requester: "",
    tokenA: undefined,
    exactTokenB: undefined,
    slippage: "",
    deadline: _helpers.Long.ZERO
  };
}
var MsgSwapForExactTokens = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    if (message.requester !== "") {
      writer.uint32(10).string(message.requester);
    }
    if (message.tokenA !== undefined) {
      _coin.Coin.encode(message.tokenA, writer.uint32(18).fork()).ldelim();
    }
    if (message.exactTokenB !== undefined) {
      _coin.Coin.encode(message.exactTokenB, writer.uint32(26).fork()).ldelim();
    }
    if (message.slippage !== "") {
      writer.uint32(34).string(message.slippage);
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgSwapForExactTokens();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.requester = reader.string();
          break;
        case 2:
          message.tokenA = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.exactTokenB = _coin.Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.slippage = reader.string();
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      requester: (0, _helpers.isSet)(object.requester) ? String(object.requester) : "",
      tokenA: (0, _helpers.isSet)(object.tokenA) ? _coin.Coin.fromJSON(object.tokenA) : undefined,
      exactTokenB: (0, _helpers.isSet)(object.exactTokenB) ? _coin.Coin.fromJSON(object.exactTokenB) : undefined,
      slippage: (0, _helpers.isSet)(object.slippage) ? String(object.slippage) : "",
      deadline: (0, _helpers.isSet)(object.deadline) ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.requester !== undefined && (obj.requester = message.requester);
    message.tokenA !== undefined && (obj.tokenA = message.tokenA ? _coin.Coin.toJSON(message.tokenA) : undefined);
    message.exactTokenB !== undefined && (obj.exactTokenB = message.exactTokenB ? _coin.Coin.toJSON(message.exactTokenB) : undefined);
    message.slippage !== undefined && (obj.slippage = message.slippage);
    message.deadline !== undefined && (obj.deadline = (message.deadline || _helpers.Long.ZERO).toString());
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$requester2, _object$slippage3;
    var message = createBaseMsgSwapForExactTokens();
    message.requester = (_object$requester2 = object.requester) !== null && _object$requester2 !== void 0 ? _object$requester2 : "";
    message.tokenA = object.tokenA !== undefined && object.tokenA !== null ? _coin.Coin.fromPartial(object.tokenA) : undefined;
    message.exactTokenB = object.exactTokenB !== undefined && object.exactTokenB !== null ? _coin.Coin.fromPartial(object.exactTokenB) : undefined;
    message.slippage = (_object$slippage3 = object.slippage) !== null && _object$slippage3 !== void 0 ? _object$slippage3 : "";
    message.deadline = object.deadline !== undefined && object.deadline !== null ? _helpers.Long.fromValue(object.deadline) : _helpers.Long.ZERO;
    return message;
  }
};
exports.MsgSwapForExactTokens = MsgSwapForExactTokens;
function createBaseMsgSwapForExactTokensResponse() {
  return {};
}
var MsgSwapForExactTokensResponse = {
  encode: function encode(_) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseMsgSwapForExactTokensResponse();
    while (reader.pos < end) {
      var tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON: function fromJSON(_) {
    return {};
  },
  toJSON: function toJSON(_) {
    var obj = {};
    return obj;
  },
  fromPartial: function fromPartial(_) {
    var message = createBaseMsgSwapForExactTokensResponse();
    return message;
  }
};
exports.MsgSwapForExactTokensResponse = MsgSwapForExactTokensResponse;