"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registry = exports.load = exports.MessageComposer = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _tx = require("./tx");
var registry = [["/kava.swap.v1beta1.MsgDeposit", _tx.MsgDeposit], ["/kava.swap.v1beta1.MsgWithdraw", _tx.MsgWithdraw], ["/kava.swap.v1beta1.MsgSwapExactForTokens", _tx.MsgSwapExactForTokens], ["/kava.swap.v1beta1.MsgSwapForExactTokens", _tx.MsgSwapForExactTokens]];
exports.registry = registry;
var load = function load(protoRegistry) {
  registry.forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      typeUrl = _ref2[0],
      mod = _ref2[1];
    protoRegistry.register(typeUrl, mod);
  });
};
exports.load = load;
var MessageComposer = {
  encoded: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.encode(value).finish()
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.encode(value).finish()
      };
    },
    swapExactForTokens: function swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: _tx.MsgSwapExactForTokens.encode(value).finish()
      };
    },
    swapForExactTokens: function swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: _tx.MsgSwapForExactTokens.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: value
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: value
      };
    },
    swapExactForTokens: function swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: value
      };
    },
    swapForExactTokens: function swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: value
      };
    }
  },
  toJSON: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.toJSON(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.toJSON(value)
      };
    },
    swapExactForTokens: function swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: _tx.MsgSwapExactForTokens.toJSON(value)
      };
    },
    swapForExactTokens: function swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: _tx.MsgSwapForExactTokens.toJSON(value)
      };
    }
  },
  fromJSON: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.fromJSON(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.fromJSON(value)
      };
    },
    swapExactForTokens: function swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: _tx.MsgSwapExactForTokens.fromJSON(value)
      };
    },
    swapForExactTokens: function swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: _tx.MsgSwapForExactTokens.fromJSON(value)
      };
    }
  },
  fromPartial: {
    deposit: function deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: _tx.MsgDeposit.fromPartial(value)
      };
    },
    withdraw: function withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: _tx.MsgWithdraw.fromPartial(value)
      };
    },
    swapExactForTokens: function swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: _tx.MsgSwapExactForTokens.fromPartial(value)
      };
    },
    swapForExactTokens: function swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: _tx.MsgSwapForExactTokens.fromPartial(value)
      };
    }
  }
};
exports.MessageComposer = MessageComposer;