import { MsgEthereumTx } from "./tx";
export const registry = [["/ethermint.evm.v1.MsgEthereumTx", MsgEthereumTx]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    ethereumTx(value) {
      return {
        typeUrl: "/ethermint.evm.v1.MsgEthereumTx",
        value: MsgEthereumTx.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    ethereumTx(value) {
      return {
        typeUrl: "/ethermint.evm.v1.MsgEthereumTx",
        value
      };
    }
  },
  toJSON: {
    ethereumTx(value) {
      return {
        typeUrl: "/ethermint.evm.v1.MsgEthereumTx",
        value: MsgEthereumTx.toJSON(value)
      };
    }
  },
  fromJSON: {
    ethereumTx(value) {
      return {
        typeUrl: "/ethermint.evm.v1.MsgEthereumTx",
        value: MsgEthereumTx.fromJSON(value)
      };
    }
  },
  fromPartial: {
    ethereumTx(value) {
      return {
        typeUrl: "/ethermint.evm.v1.MsgEthereumTx",
        value: MsgEthereumTx.fromPartial(value)
      };
    }
  }
};