import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryParamsRequest, QueryParamsResponse, QueryAuctionRequest, QueryAuctionResponse, QueryAuctionsRequest, QueryAuctionsResponse, QueryNextAuctionIDRequest, QueryNextAuctionIDResponse } from "./query";
/** Query defines the gRPC querier service for auction module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.auction = this.auction.bind(this);
    this.auctions = this.auctions.bind(this);
    this.nextAuctionID = this.nextAuctionID.bind(this);
  }
  params(request = {}) {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.auction.v1beta1.Query", "Params", data);
    return promise.then(data => QueryParamsResponse.decode(new _m0.Reader(data)));
  }
  auction(request) {
    const data = QueryAuctionRequest.encode(request).finish();
    const promise = this.rpc.request("kava.auction.v1beta1.Query", "Auction", data);
    return promise.then(data => QueryAuctionResponse.decode(new _m0.Reader(data)));
  }
  auctions(request) {
    const data = QueryAuctionsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.auction.v1beta1.Query", "Auctions", data);
    return promise.then(data => QueryAuctionsResponse.decode(new _m0.Reader(data)));
  }
  nextAuctionID(request = {}) {
    const data = QueryNextAuctionIDRequest.encode(request).finish();
    const promise = this.rpc.request("kava.auction.v1beta1.Query", "NextAuctionID", data);
    return promise.then(data => QueryNextAuctionIDResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    params(request) {
      return queryService.params(request);
    },
    auction(request) {
      return queryService.auction(request);
    },
    auctions(request) {
      return queryService.auctions(request);
    },
    nextAuctionID(request) {
      return queryService.nextAuctionID(request);
    }
  };
};