import { MsgPlaceBid } from "./tx";
export const registry = [["/kava.auction.v1beta1.MsgPlaceBid", MsgPlaceBid]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: MsgPlaceBid.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value
      };
    }
  },
  toJSON: {
    placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: MsgPlaceBid.toJSON(value)
      };
    }
  },
  fromJSON: {
    placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: MsgPlaceBid.fromJSON(value)
      };
    }
  },
  fromPartial: {
    placeBid(value) {
      return {
        typeUrl: "/kava.auction.v1beta1.MsgPlaceBid",
        value: MsgPlaceBid.fromPartial(value)
      };
    }
  }
};