import { Duration } from "../../../google/protobuf/duration";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { Long, isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
/** SwapStatus is the status of an AtomicSwap */

export let SwapStatus;
/** SwapStatus is the status of an AtomicSwap */
(function (SwapStatus) {
  SwapStatus[SwapStatus["SWAP_STATUS_UNSPECIFIED"] = 0] = "SWAP_STATUS_UNSPECIFIED";
  SwapStatus[SwapStatus["SWAP_STATUS_OPEN"] = 1] = "SWAP_STATUS_OPEN";
  SwapStatus[SwapStatus["SWAP_STATUS_COMPLETED"] = 2] = "SWAP_STATUS_COMPLETED";
  SwapStatus[SwapStatus["SWAP_STATUS_EXPIRED"] = 3] = "SWAP_STATUS_EXPIRED";
  SwapStatus[SwapStatus["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(SwapStatus || (SwapStatus = {}));
export let SwapStatusSDKType;
(function (SwapStatusSDKType) {
  SwapStatusSDKType[SwapStatusSDKType["SWAP_STATUS_UNSPECIFIED"] = 0] = "SWAP_STATUS_UNSPECIFIED";
  SwapStatusSDKType[SwapStatusSDKType["SWAP_STATUS_OPEN"] = 1] = "SWAP_STATUS_OPEN";
  SwapStatusSDKType[SwapStatusSDKType["SWAP_STATUS_COMPLETED"] = 2] = "SWAP_STATUS_COMPLETED";
  SwapStatusSDKType[SwapStatusSDKType["SWAP_STATUS_EXPIRED"] = 3] = "SWAP_STATUS_EXPIRED";
  SwapStatusSDKType[SwapStatusSDKType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(SwapStatusSDKType || (SwapStatusSDKType = {}));
export function swapStatusFromJSON(object) {
  switch (object) {
    case 0:
    case "SWAP_STATUS_UNSPECIFIED":
      return SwapStatus.SWAP_STATUS_UNSPECIFIED;
    case 1:
    case "SWAP_STATUS_OPEN":
      return SwapStatus.SWAP_STATUS_OPEN;
    case 2:
    case "SWAP_STATUS_COMPLETED":
      return SwapStatus.SWAP_STATUS_COMPLETED;
    case 3:
    case "SWAP_STATUS_EXPIRED":
      return SwapStatus.SWAP_STATUS_EXPIRED;
    case -1:
    case "UNRECOGNIZED":
    default:
      return SwapStatus.UNRECOGNIZED;
  }
}
export function swapStatusToJSON(object) {
  switch (object) {
    case SwapStatus.SWAP_STATUS_UNSPECIFIED:
      return "SWAP_STATUS_UNSPECIFIED";
    case SwapStatus.SWAP_STATUS_OPEN:
      return "SWAP_STATUS_OPEN";
    case SwapStatus.SWAP_STATUS_COMPLETED:
      return "SWAP_STATUS_COMPLETED";
    case SwapStatus.SWAP_STATUS_EXPIRED:
      return "SWAP_STATUS_EXPIRED";
    case SwapStatus.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}
/** SwapDirection is the direction of an AtomicSwap */

export let SwapDirection;
/** SwapDirection is the direction of an AtomicSwap */
(function (SwapDirection) {
  SwapDirection[SwapDirection["SWAP_DIRECTION_UNSPECIFIED"] = 0] = "SWAP_DIRECTION_UNSPECIFIED";
  SwapDirection[SwapDirection["SWAP_DIRECTION_INCOMING"] = 1] = "SWAP_DIRECTION_INCOMING";
  SwapDirection[SwapDirection["SWAP_DIRECTION_OUTGOING"] = 2] = "SWAP_DIRECTION_OUTGOING";
  SwapDirection[SwapDirection["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(SwapDirection || (SwapDirection = {}));
export let SwapDirectionSDKType;
(function (SwapDirectionSDKType) {
  SwapDirectionSDKType[SwapDirectionSDKType["SWAP_DIRECTION_UNSPECIFIED"] = 0] = "SWAP_DIRECTION_UNSPECIFIED";
  SwapDirectionSDKType[SwapDirectionSDKType["SWAP_DIRECTION_INCOMING"] = 1] = "SWAP_DIRECTION_INCOMING";
  SwapDirectionSDKType[SwapDirectionSDKType["SWAP_DIRECTION_OUTGOING"] = 2] = "SWAP_DIRECTION_OUTGOING";
  SwapDirectionSDKType[SwapDirectionSDKType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(SwapDirectionSDKType || (SwapDirectionSDKType = {}));
export function swapDirectionFromJSON(object) {
  switch (object) {
    case 0:
    case "SWAP_DIRECTION_UNSPECIFIED":
      return SwapDirection.SWAP_DIRECTION_UNSPECIFIED;
    case 1:
    case "SWAP_DIRECTION_INCOMING":
      return SwapDirection.SWAP_DIRECTION_INCOMING;
    case 2:
    case "SWAP_DIRECTION_OUTGOING":
      return SwapDirection.SWAP_DIRECTION_OUTGOING;
    case -1:
    case "UNRECOGNIZED":
    default:
      return SwapDirection.UNRECOGNIZED;
  }
}
export function swapDirectionToJSON(object) {
  switch (object) {
    case SwapDirection.SWAP_DIRECTION_UNSPECIFIED:
      return "SWAP_DIRECTION_UNSPECIFIED";
    case SwapDirection.SWAP_DIRECTION_INCOMING:
      return "SWAP_DIRECTION_INCOMING";
    case SwapDirection.SWAP_DIRECTION_OUTGOING:
      return "SWAP_DIRECTION_OUTGOING";
    case SwapDirection.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}
/** Params defines the parameters for the bep3 module. */

function createBaseParams() {
  return {
    assetParams: []
  };
}
export const Params = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.assetParams) {
      AssetParam.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.assetParams.push(AssetParam.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      assetParams: Array.isArray(object === null || object === void 0 ? void 0 : object.assetParams) ? object.assetParams.map(e => AssetParam.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.assetParams) {
      obj.assetParams = message.assetParams.map(e => e ? AssetParam.toJSON(e) : undefined);
    } else {
      obj.assetParams = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$assetParams;
    const message = createBaseParams();
    message.assetParams = ((_object$assetParams = object.assetParams) === null || _object$assetParams === void 0 ? void 0 : _object$assetParams.map(e => AssetParam.fromPartial(e))) || [];
    return message;
  }
};
function createBaseAssetParam() {
  return {
    denom: "",
    coinId: Long.ZERO,
    supplyLimit: undefined,
    active: false,
    deputyAddress: new Uint8Array(),
    fixedFee: "",
    minSwapAmount: "",
    maxSwapAmount: "",
    minBlockLock: Long.UZERO,
    maxBlockLock: Long.UZERO
  };
}
export const AssetParam = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (!message.coinId.isZero()) {
      writer.uint32(16).int64(message.coinId);
    }
    if (message.supplyLimit !== undefined) {
      SupplyLimit.encode(message.supplyLimit, writer.uint32(26).fork()).ldelim();
    }
    if (message.active === true) {
      writer.uint32(32).bool(message.active);
    }
    if (message.deputyAddress.length !== 0) {
      writer.uint32(42).bytes(message.deputyAddress);
    }
    if (message.fixedFee !== "") {
      writer.uint32(50).string(message.fixedFee);
    }
    if (message.minSwapAmount !== "") {
      writer.uint32(58).string(message.minSwapAmount);
    }
    if (message.maxSwapAmount !== "") {
      writer.uint32(66).string(message.maxSwapAmount);
    }
    if (!message.minBlockLock.isZero()) {
      writer.uint32(72).uint64(message.minBlockLock);
    }
    if (!message.maxBlockLock.isZero()) {
      writer.uint32(80).uint64(message.maxBlockLock);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetParam();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.coinId = reader.int64();
          break;
        case 3:
          message.supplyLimit = SupplyLimit.decode(reader, reader.uint32());
          break;
        case 4:
          message.active = reader.bool();
          break;
        case 5:
          message.deputyAddress = reader.bytes();
          break;
        case 6:
          message.fixedFee = reader.string();
          break;
        case 7:
          message.minSwapAmount = reader.string();
          break;
        case 8:
          message.maxSwapAmount = reader.string();
          break;
        case 9:
          message.minBlockLock = reader.uint64();
          break;
        case 10:
          message.maxBlockLock = reader.uint64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      coinId: isSet(object.coinId) ? Long.fromValue(object.coinId) : Long.ZERO,
      supplyLimit: isSet(object.supplyLimit) ? SupplyLimit.fromJSON(object.supplyLimit) : undefined,
      active: isSet(object.active) ? Boolean(object.active) : false,
      deputyAddress: isSet(object.deputyAddress) ? bytesFromBase64(object.deputyAddress) : new Uint8Array(),
      fixedFee: isSet(object.fixedFee) ? String(object.fixedFee) : "",
      minSwapAmount: isSet(object.minSwapAmount) ? String(object.minSwapAmount) : "",
      maxSwapAmount: isSet(object.maxSwapAmount) ? String(object.maxSwapAmount) : "",
      minBlockLock: isSet(object.minBlockLock) ? Long.fromValue(object.minBlockLock) : Long.UZERO,
      maxBlockLock: isSet(object.maxBlockLock) ? Long.fromValue(object.maxBlockLock) : Long.UZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.coinId !== undefined && (obj.coinId = (message.coinId || Long.ZERO).toString());
    message.supplyLimit !== undefined && (obj.supplyLimit = message.supplyLimit ? SupplyLimit.toJSON(message.supplyLimit) : undefined);
    message.active !== undefined && (obj.active = message.active);
    message.deputyAddress !== undefined && (obj.deputyAddress = base64FromBytes(message.deputyAddress !== undefined ? message.deputyAddress : new Uint8Array()));
    message.fixedFee !== undefined && (obj.fixedFee = message.fixedFee);
    message.minSwapAmount !== undefined && (obj.minSwapAmount = message.minSwapAmount);
    message.maxSwapAmount !== undefined && (obj.maxSwapAmount = message.maxSwapAmount);
    message.minBlockLock !== undefined && (obj.minBlockLock = (message.minBlockLock || Long.UZERO).toString());
    message.maxBlockLock !== undefined && (obj.maxBlockLock = (message.maxBlockLock || Long.UZERO).toString());
    return obj;
  },
  fromPartial(object) {
    var _object$denom, _object$active, _object$deputyAddress, _object$fixedFee, _object$minSwapAmount, _object$maxSwapAmount;
    const message = createBaseAssetParam();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.coinId = object.coinId !== undefined && object.coinId !== null ? Long.fromValue(object.coinId) : Long.ZERO;
    message.supplyLimit = object.supplyLimit !== undefined && object.supplyLimit !== null ? SupplyLimit.fromPartial(object.supplyLimit) : undefined;
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.deputyAddress = (_object$deputyAddress = object.deputyAddress) !== null && _object$deputyAddress !== void 0 ? _object$deputyAddress : new Uint8Array();
    message.fixedFee = (_object$fixedFee = object.fixedFee) !== null && _object$fixedFee !== void 0 ? _object$fixedFee : "";
    message.minSwapAmount = (_object$minSwapAmount = object.minSwapAmount) !== null && _object$minSwapAmount !== void 0 ? _object$minSwapAmount : "";
    message.maxSwapAmount = (_object$maxSwapAmount = object.maxSwapAmount) !== null && _object$maxSwapAmount !== void 0 ? _object$maxSwapAmount : "";
    message.minBlockLock = object.minBlockLock !== undefined && object.minBlockLock !== null ? Long.fromValue(object.minBlockLock) : Long.UZERO;
    message.maxBlockLock = object.maxBlockLock !== undefined && object.maxBlockLock !== null ? Long.fromValue(object.maxBlockLock) : Long.UZERO;
    return message;
  }
};
function createBaseSupplyLimit() {
  return {
    limit: "",
    timeLimited: false,
    timePeriod: undefined,
    timeBasedLimit: ""
  };
}
export const SupplyLimit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.limit !== "") {
      writer.uint32(10).string(message.limit);
    }
    if (message.timeLimited === true) {
      writer.uint32(16).bool(message.timeLimited);
    }
    if (message.timePeriod !== undefined) {
      Duration.encode(message.timePeriod, writer.uint32(26).fork()).ldelim();
    }
    if (message.timeBasedLimit !== "") {
      writer.uint32(34).string(message.timeBasedLimit);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSupplyLimit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.limit = reader.string();
          break;
        case 2:
          message.timeLimited = reader.bool();
          break;
        case 3:
          message.timePeriod = Duration.decode(reader, reader.uint32());
          break;
        case 4:
          message.timeBasedLimit = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      limit: isSet(object.limit) ? String(object.limit) : "",
      timeLimited: isSet(object.timeLimited) ? Boolean(object.timeLimited) : false,
      timePeriod: isSet(object.timePeriod) ? Duration.fromJSON(object.timePeriod) : undefined,
      timeBasedLimit: isSet(object.timeBasedLimit) ? String(object.timeBasedLimit) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.limit !== undefined && (obj.limit = message.limit);
    message.timeLimited !== undefined && (obj.timeLimited = message.timeLimited);
    message.timePeriod !== undefined && (obj.timePeriod = message.timePeriod ? Duration.toJSON(message.timePeriod) : undefined);
    message.timeBasedLimit !== undefined && (obj.timeBasedLimit = message.timeBasedLimit);
    return obj;
  },
  fromPartial(object) {
    var _object$limit, _object$timeLimited, _object$timeBasedLimi;
    const message = createBaseSupplyLimit();
    message.limit = (_object$limit = object.limit) !== null && _object$limit !== void 0 ? _object$limit : "";
    message.timeLimited = (_object$timeLimited = object.timeLimited) !== null && _object$timeLimited !== void 0 ? _object$timeLimited : false;
    message.timePeriod = object.timePeriod !== undefined && object.timePeriod !== null ? Duration.fromPartial(object.timePeriod) : undefined;
    message.timeBasedLimit = (_object$timeBasedLimi = object.timeBasedLimit) !== null && _object$timeBasedLimi !== void 0 ? _object$timeBasedLimi : "";
    return message;
  }
};
function createBaseAtomicSwap() {
  return {
    amount: [],
    randomNumberHash: new Uint8Array(),
    expireHeight: Long.UZERO,
    timestamp: Long.ZERO,
    sender: new Uint8Array(),
    recipient: new Uint8Array(),
    senderOtherChain: "",
    recipientOtherChain: "",
    closedBlock: Long.ZERO,
    status: 0,
    crossChain: false,
    direction: 0
  };
}
export const AtomicSwap = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.amount) {
      Coin.encode(v, writer.uint32(10).fork()).ldelim();
    }
    if (message.randomNumberHash.length !== 0) {
      writer.uint32(18).bytes(message.randomNumberHash);
    }
    if (!message.expireHeight.isZero()) {
      writer.uint32(24).uint64(message.expireHeight);
    }
    if (!message.timestamp.isZero()) {
      writer.uint32(32).int64(message.timestamp);
    }
    if (message.sender.length !== 0) {
      writer.uint32(42).bytes(message.sender);
    }
    if (message.recipient.length !== 0) {
      writer.uint32(50).bytes(message.recipient);
    }
    if (message.senderOtherChain !== "") {
      writer.uint32(58).string(message.senderOtherChain);
    }
    if (message.recipientOtherChain !== "") {
      writer.uint32(66).string(message.recipientOtherChain);
    }
    if (!message.closedBlock.isZero()) {
      writer.uint32(72).int64(message.closedBlock);
    }
    if (message.status !== 0) {
      writer.uint32(80).int32(message.status);
    }
    if (message.crossChain === true) {
      writer.uint32(88).bool(message.crossChain);
    }
    if (message.direction !== 0) {
      writer.uint32(96).int32(message.direction);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAtomicSwap();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.amount.push(Coin.decode(reader, reader.uint32()));
          break;
        case 2:
          message.randomNumberHash = reader.bytes();
          break;
        case 3:
          message.expireHeight = reader.uint64();
          break;
        case 4:
          message.timestamp = reader.int64();
          break;
        case 5:
          message.sender = reader.bytes();
          break;
        case 6:
          message.recipient = reader.bytes();
          break;
        case 7:
          message.senderOtherChain = reader.string();
          break;
        case 8:
          message.recipientOtherChain = reader.string();
          break;
        case 9:
          message.closedBlock = reader.int64();
          break;
        case 10:
          message.status = reader.int32();
          break;
        case 11:
          message.crossChain = reader.bool();
          break;
        case 12:
          message.direction = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(e => Coin.fromJSON(e)) : [],
      randomNumberHash: isSet(object.randomNumberHash) ? bytesFromBase64(object.randomNumberHash) : new Uint8Array(),
      expireHeight: isSet(object.expireHeight) ? Long.fromValue(object.expireHeight) : Long.UZERO,
      timestamp: isSet(object.timestamp) ? Long.fromValue(object.timestamp) : Long.ZERO,
      sender: isSet(object.sender) ? bytesFromBase64(object.sender) : new Uint8Array(),
      recipient: isSet(object.recipient) ? bytesFromBase64(object.recipient) : new Uint8Array(),
      senderOtherChain: isSet(object.senderOtherChain) ? String(object.senderOtherChain) : "",
      recipientOtherChain: isSet(object.recipientOtherChain) ? String(object.recipientOtherChain) : "",
      closedBlock: isSet(object.closedBlock) ? Long.fromValue(object.closedBlock) : Long.ZERO,
      status: isSet(object.status) ? swapStatusFromJSON(object.status) : 0,
      crossChain: isSet(object.crossChain) ? Boolean(object.crossChain) : false,
      direction: isSet(object.direction) ? swapDirectionFromJSON(object.direction) : 0
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.amount) {
      obj.amount = message.amount.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.amount = [];
    }
    message.randomNumberHash !== undefined && (obj.randomNumberHash = base64FromBytes(message.randomNumberHash !== undefined ? message.randomNumberHash : new Uint8Array()));
    message.expireHeight !== undefined && (obj.expireHeight = (message.expireHeight || Long.UZERO).toString());
    message.timestamp !== undefined && (obj.timestamp = (message.timestamp || Long.ZERO).toString());
    message.sender !== undefined && (obj.sender = base64FromBytes(message.sender !== undefined ? message.sender : new Uint8Array()));
    message.recipient !== undefined && (obj.recipient = base64FromBytes(message.recipient !== undefined ? message.recipient : new Uint8Array()));
    message.senderOtherChain !== undefined && (obj.senderOtherChain = message.senderOtherChain);
    message.recipientOtherChain !== undefined && (obj.recipientOtherChain = message.recipientOtherChain);
    message.closedBlock !== undefined && (obj.closedBlock = (message.closedBlock || Long.ZERO).toString());
    message.status !== undefined && (obj.status = swapStatusToJSON(message.status));
    message.crossChain !== undefined && (obj.crossChain = message.crossChain);
    message.direction !== undefined && (obj.direction = swapDirectionToJSON(message.direction));
    return obj;
  },
  fromPartial(object) {
    var _object$amount, _object$randomNumberH, _object$sender, _object$recipient, _object$senderOtherCh, _object$recipientOthe, _object$status, _object$crossChain, _object$direction;
    const message = createBaseAtomicSwap();
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(e => Coin.fromPartial(e))) || [];
    message.randomNumberHash = (_object$randomNumberH = object.randomNumberHash) !== null && _object$randomNumberH !== void 0 ? _object$randomNumberH : new Uint8Array();
    message.expireHeight = object.expireHeight !== undefined && object.expireHeight !== null ? Long.fromValue(object.expireHeight) : Long.UZERO;
    message.timestamp = object.timestamp !== undefined && object.timestamp !== null ? Long.fromValue(object.timestamp) : Long.ZERO;
    message.sender = (_object$sender = object.sender) !== null && _object$sender !== void 0 ? _object$sender : new Uint8Array();
    message.recipient = (_object$recipient = object.recipient) !== null && _object$recipient !== void 0 ? _object$recipient : new Uint8Array();
    message.senderOtherChain = (_object$senderOtherCh = object.senderOtherChain) !== null && _object$senderOtherCh !== void 0 ? _object$senderOtherCh : "";
    message.recipientOtherChain = (_object$recipientOthe = object.recipientOtherChain) !== null && _object$recipientOthe !== void 0 ? _object$recipientOthe : "";
    message.closedBlock = object.closedBlock !== undefined && object.closedBlock !== null ? Long.fromValue(object.closedBlock) : Long.ZERO;
    message.status = (_object$status = object.status) !== null && _object$status !== void 0 ? _object$status : 0;
    message.crossChain = (_object$crossChain = object.crossChain) !== null && _object$crossChain !== void 0 ? _object$crossChain : false;
    message.direction = (_object$direction = object.direction) !== null && _object$direction !== void 0 ? _object$direction : 0;
    return message;
  }
};
function createBaseAssetSupply() {
  return {
    incomingSupply: undefined,
    outgoingSupply: undefined,
    currentSupply: undefined,
    timeLimitedCurrentSupply: undefined,
    timeElapsed: undefined
  };
}
export const AssetSupply = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.incomingSupply !== undefined) {
      Coin.encode(message.incomingSupply, writer.uint32(10).fork()).ldelim();
    }
    if (message.outgoingSupply !== undefined) {
      Coin.encode(message.outgoingSupply, writer.uint32(18).fork()).ldelim();
    }
    if (message.currentSupply !== undefined) {
      Coin.encode(message.currentSupply, writer.uint32(26).fork()).ldelim();
    }
    if (message.timeLimitedCurrentSupply !== undefined) {
      Coin.encode(message.timeLimitedCurrentSupply, writer.uint32(34).fork()).ldelim();
    }
    if (message.timeElapsed !== undefined) {
      Duration.encode(message.timeElapsed, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetSupply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.incomingSupply = Coin.decode(reader, reader.uint32());
          break;
        case 2:
          message.outgoingSupply = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.currentSupply = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.timeLimitedCurrentSupply = Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.timeElapsed = Duration.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      incomingSupply: isSet(object.incomingSupply) ? Coin.fromJSON(object.incomingSupply) : undefined,
      outgoingSupply: isSet(object.outgoingSupply) ? Coin.fromJSON(object.outgoingSupply) : undefined,
      currentSupply: isSet(object.currentSupply) ? Coin.fromJSON(object.currentSupply) : undefined,
      timeLimitedCurrentSupply: isSet(object.timeLimitedCurrentSupply) ? Coin.fromJSON(object.timeLimitedCurrentSupply) : undefined,
      timeElapsed: isSet(object.timeElapsed) ? Duration.fromJSON(object.timeElapsed) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.incomingSupply !== undefined && (obj.incomingSupply = message.incomingSupply ? Coin.toJSON(message.incomingSupply) : undefined);
    message.outgoingSupply !== undefined && (obj.outgoingSupply = message.outgoingSupply ? Coin.toJSON(message.outgoingSupply) : undefined);
    message.currentSupply !== undefined && (obj.currentSupply = message.currentSupply ? Coin.toJSON(message.currentSupply) : undefined);
    message.timeLimitedCurrentSupply !== undefined && (obj.timeLimitedCurrentSupply = message.timeLimitedCurrentSupply ? Coin.toJSON(message.timeLimitedCurrentSupply) : undefined);
    message.timeElapsed !== undefined && (obj.timeElapsed = message.timeElapsed ? Duration.toJSON(message.timeElapsed) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseAssetSupply();
    message.incomingSupply = object.incomingSupply !== undefined && object.incomingSupply !== null ? Coin.fromPartial(object.incomingSupply) : undefined;
    message.outgoingSupply = object.outgoingSupply !== undefined && object.outgoingSupply !== null ? Coin.fromPartial(object.outgoingSupply) : undefined;
    message.currentSupply = object.currentSupply !== undefined && object.currentSupply !== null ? Coin.fromPartial(object.currentSupply) : undefined;
    message.timeLimitedCurrentSupply = object.timeLimitedCurrentSupply !== undefined && object.timeLimitedCurrentSupply !== null ? Coin.fromPartial(object.timeLimitedCurrentSupply) : undefined;
    message.timeElapsed = object.timeElapsed !== undefined && object.timeElapsed !== null ? Duration.fromPartial(object.timeElapsed) : undefined;
    return message;
  }
};