import { Params, AtomicSwap, AssetSupply } from "./bep3";
import { Timestamp } from "../../../google/protobuf/timestamp";
import * as _m0 from "protobufjs/minimal";
import { isSet, fromJsonTimestamp, fromTimestamp } from "../../../helpers";
/** GenesisState defines the pricefeed module's genesis state. */

function createBaseGenesisState() {
  return {
    params: undefined,
    atomicSwaps: [],
    supplies: [],
    previousBlockTime: undefined
  };
}
export const GenesisState = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.atomicSwaps) {
      AtomicSwap.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.supplies) {
      AssetSupply.encode(v, writer.uint32(26).fork()).ldelim();
    }
    if (message.previousBlockTime !== undefined) {
      Timestamp.encode(message.previousBlockTime, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.atomicSwaps.push(AtomicSwap.decode(reader, reader.uint32()));
          break;
        case 3:
          message.supplies.push(AssetSupply.decode(reader, reader.uint32()));
          break;
        case 4:
          message.previousBlockTime = Timestamp.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      atomicSwaps: Array.isArray(object === null || object === void 0 ? void 0 : object.atomicSwaps) ? object.atomicSwaps.map(e => AtomicSwap.fromJSON(e)) : [],
      supplies: Array.isArray(object === null || object === void 0 ? void 0 : object.supplies) ? object.supplies.map(e => AssetSupply.fromJSON(e)) : [],
      previousBlockTime: isSet(object.previousBlockTime) ? fromJsonTimestamp(object.previousBlockTime) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    if (message.atomicSwaps) {
      obj.atomicSwaps = message.atomicSwaps.map(e => e ? AtomicSwap.toJSON(e) : undefined);
    } else {
      obj.atomicSwaps = [];
    }
    if (message.supplies) {
      obj.supplies = message.supplies.map(e => e ? AssetSupply.toJSON(e) : undefined);
    } else {
      obj.supplies = [];
    }
    message.previousBlockTime !== undefined && (obj.previousBlockTime = fromTimestamp(message.previousBlockTime).toISOString());
    return obj;
  },
  fromPartial(object) {
    var _object$atomicSwaps, _object$supplies;
    const message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    message.atomicSwaps = ((_object$atomicSwaps = object.atomicSwaps) === null || _object$atomicSwaps === void 0 ? void 0 : _object$atomicSwaps.map(e => AtomicSwap.fromPartial(e))) || [];
    message.supplies = ((_object$supplies = object.supplies) === null || _object$supplies === void 0 ? void 0 : _object$supplies.map(e => AssetSupply.fromPartial(e))) || [];
    message.previousBlockTime = object.previousBlockTime !== undefined && object.previousBlockTime !== null ? Timestamp.fromPartial(object.previousBlockTime) : undefined;
    return message;
  }
};