import { Params, swapStatusFromJSON, swapDirectionFromJSON, swapStatusToJSON, swapDirectionToJSON } from "./bep3";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Duration } from "../../../google/protobuf/duration";
import * as _m0 from "protobufjs/minimal";
import { isSet, Long } from "../../../helpers";
/** QueryParamsRequest defines the request type for querying x/bep3 parameters. */

function createBaseQueryParamsRequest() {
  return {};
}
export const QueryParamsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryParamsRequest();
    return message;
  }
};
function createBaseQueryParamsResponse() {
  return {
    params: undefined
  };
}
export const QueryParamsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryParamsResponse();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    return message;
  }
};
function createBaseQueryAssetSupplyRequest() {
  return {
    denom: ""
  };
}
export const QueryAssetSupplyRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAssetSupplyRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    return obj;
  },
  fromPartial(object) {
    var _object$denom;
    const message = createBaseQueryAssetSupplyRequest();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    return message;
  }
};
function createBaseAssetSupplyResponse() {
  return {
    incomingSupply: undefined,
    outgoingSupply: undefined,
    currentSupply: undefined,
    timeLimitedCurrentSupply: undefined,
    timeElapsed: undefined
  };
}
export const AssetSupplyResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.incomingSupply !== undefined) {
      Coin.encode(message.incomingSupply, writer.uint32(10).fork()).ldelim();
    }
    if (message.outgoingSupply !== undefined) {
      Coin.encode(message.outgoingSupply, writer.uint32(18).fork()).ldelim();
    }
    if (message.currentSupply !== undefined) {
      Coin.encode(message.currentSupply, writer.uint32(26).fork()).ldelim();
    }
    if (message.timeLimitedCurrentSupply !== undefined) {
      Coin.encode(message.timeLimitedCurrentSupply, writer.uint32(34).fork()).ldelim();
    }
    if (message.timeElapsed !== undefined) {
      Duration.encode(message.timeElapsed, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetSupplyResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.incomingSupply = Coin.decode(reader, reader.uint32());
          break;
        case 2:
          message.outgoingSupply = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.currentSupply = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.timeLimitedCurrentSupply = Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.timeElapsed = Duration.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      incomingSupply: isSet(object.incomingSupply) ? Coin.fromJSON(object.incomingSupply) : undefined,
      outgoingSupply: isSet(object.outgoingSupply) ? Coin.fromJSON(object.outgoingSupply) : undefined,
      currentSupply: isSet(object.currentSupply) ? Coin.fromJSON(object.currentSupply) : undefined,
      timeLimitedCurrentSupply: isSet(object.timeLimitedCurrentSupply) ? Coin.fromJSON(object.timeLimitedCurrentSupply) : undefined,
      timeElapsed: isSet(object.timeElapsed) ? Duration.fromJSON(object.timeElapsed) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.incomingSupply !== undefined && (obj.incomingSupply = message.incomingSupply ? Coin.toJSON(message.incomingSupply) : undefined);
    message.outgoingSupply !== undefined && (obj.outgoingSupply = message.outgoingSupply ? Coin.toJSON(message.outgoingSupply) : undefined);
    message.currentSupply !== undefined && (obj.currentSupply = message.currentSupply ? Coin.toJSON(message.currentSupply) : undefined);
    message.timeLimitedCurrentSupply !== undefined && (obj.timeLimitedCurrentSupply = message.timeLimitedCurrentSupply ? Coin.toJSON(message.timeLimitedCurrentSupply) : undefined);
    message.timeElapsed !== undefined && (obj.timeElapsed = message.timeElapsed ? Duration.toJSON(message.timeElapsed) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseAssetSupplyResponse();
    message.incomingSupply = object.incomingSupply !== undefined && object.incomingSupply !== null ? Coin.fromPartial(object.incomingSupply) : undefined;
    message.outgoingSupply = object.outgoingSupply !== undefined && object.outgoingSupply !== null ? Coin.fromPartial(object.outgoingSupply) : undefined;
    message.currentSupply = object.currentSupply !== undefined && object.currentSupply !== null ? Coin.fromPartial(object.currentSupply) : undefined;
    message.timeLimitedCurrentSupply = object.timeLimitedCurrentSupply !== undefined && object.timeLimitedCurrentSupply !== null ? Coin.fromPartial(object.timeLimitedCurrentSupply) : undefined;
    message.timeElapsed = object.timeElapsed !== undefined && object.timeElapsed !== null ? Duration.fromPartial(object.timeElapsed) : undefined;
    return message;
  }
};
function createBaseQueryAssetSupplyResponse() {
  return {
    assetSupply: undefined
  };
}
export const QueryAssetSupplyResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.assetSupply !== undefined) {
      AssetSupplyResponse.encode(message.assetSupply, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAssetSupplyResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.assetSupply = AssetSupplyResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      assetSupply: isSet(object.assetSupply) ? AssetSupplyResponse.fromJSON(object.assetSupply) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.assetSupply !== undefined && (obj.assetSupply = message.assetSupply ? AssetSupplyResponse.toJSON(message.assetSupply) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryAssetSupplyResponse();
    message.assetSupply = object.assetSupply !== undefined && object.assetSupply !== null ? AssetSupplyResponse.fromPartial(object.assetSupply) : undefined;
    return message;
  }
};
function createBaseQueryAssetSuppliesRequest() {
  return {};
}
export const QueryAssetSuppliesRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAssetSuppliesRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryAssetSuppliesRequest();
    return message;
  }
};
function createBaseQueryAssetSuppliesResponse() {
  return {
    assetSupplies: []
  };
}
export const QueryAssetSuppliesResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.assetSupplies) {
      AssetSupplyResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAssetSuppliesResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.assetSupplies.push(AssetSupplyResponse.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      assetSupplies: Array.isArray(object === null || object === void 0 ? void 0 : object.assetSupplies) ? object.assetSupplies.map(e => AssetSupplyResponse.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.assetSupplies) {
      obj.assetSupplies = message.assetSupplies.map(e => e ? AssetSupplyResponse.toJSON(e) : undefined);
    } else {
      obj.assetSupplies = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$assetSupplies;
    const message = createBaseQueryAssetSuppliesResponse();
    message.assetSupplies = ((_object$assetSupplies = object.assetSupplies) === null || _object$assetSupplies === void 0 ? void 0 : _object$assetSupplies.map(e => AssetSupplyResponse.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryAtomicSwapRequest() {
  return {
    swapId: ""
  };
}
export const QueryAtomicSwapRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.swapId !== "") {
      writer.uint32(10).string(message.swapId);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAtomicSwapRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.swapId = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      swapId: isSet(object.swapId) ? String(object.swapId) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.swapId !== undefined && (obj.swapId = message.swapId);
    return obj;
  },
  fromPartial(object) {
    var _object$swapId;
    const message = createBaseQueryAtomicSwapRequest();
    message.swapId = (_object$swapId = object.swapId) !== null && _object$swapId !== void 0 ? _object$swapId : "";
    return message;
  }
};
function createBaseQueryAtomicSwapResponse() {
  return {
    atomicSwap: undefined
  };
}
export const QueryAtomicSwapResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.atomicSwap !== undefined) {
      AtomicSwapResponse.encode(message.atomicSwap, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAtomicSwapResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 2:
          message.atomicSwap = AtomicSwapResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      atomicSwap: isSet(object.atomicSwap) ? AtomicSwapResponse.fromJSON(object.atomicSwap) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.atomicSwap !== undefined && (obj.atomicSwap = message.atomicSwap ? AtomicSwapResponse.toJSON(message.atomicSwap) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryAtomicSwapResponse();
    message.atomicSwap = object.atomicSwap !== undefined && object.atomicSwap !== null ? AtomicSwapResponse.fromPartial(object.atomicSwap) : undefined;
    return message;
  }
};
function createBaseAtomicSwapResponse() {
  return {
    id: "",
    amount: [],
    randomNumberHash: "",
    expireHeight: Long.UZERO,
    timestamp: Long.ZERO,
    sender: "",
    recipient: "",
    senderOtherChain: "",
    recipientOtherChain: "",
    closedBlock: Long.ZERO,
    status: 0,
    crossChain: false,
    direction: 0
  };
}
export const AtomicSwapResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.id !== "") {
      writer.uint32(10).string(message.id);
    }
    for (const v of message.amount) {
      Coin.encode(v, writer.uint32(18).fork()).ldelim();
    }
    if (message.randomNumberHash !== "") {
      writer.uint32(26).string(message.randomNumberHash);
    }
    if (!message.expireHeight.isZero()) {
      writer.uint32(32).uint64(message.expireHeight);
    }
    if (!message.timestamp.isZero()) {
      writer.uint32(40).int64(message.timestamp);
    }
    if (message.sender !== "") {
      writer.uint32(50).string(message.sender);
    }
    if (message.recipient !== "") {
      writer.uint32(58).string(message.recipient);
    }
    if (message.senderOtherChain !== "") {
      writer.uint32(66).string(message.senderOtherChain);
    }
    if (message.recipientOtherChain !== "") {
      writer.uint32(74).string(message.recipientOtherChain);
    }
    if (!message.closedBlock.isZero()) {
      writer.uint32(80).int64(message.closedBlock);
    }
    if (message.status !== 0) {
      writer.uint32(88).int32(message.status);
    }
    if (message.crossChain === true) {
      writer.uint32(96).bool(message.crossChain);
    }
    if (message.direction !== 0) {
      writer.uint32(104).int32(message.direction);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAtomicSwapResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = reader.string();
          break;
        case 2:
          message.amount.push(Coin.decode(reader, reader.uint32()));
          break;
        case 3:
          message.randomNumberHash = reader.string();
          break;
        case 4:
          message.expireHeight = reader.uint64();
          break;
        case 5:
          message.timestamp = reader.int64();
          break;
        case 6:
          message.sender = reader.string();
          break;
        case 7:
          message.recipient = reader.string();
          break;
        case 8:
          message.senderOtherChain = reader.string();
          break;
        case 9:
          message.recipientOtherChain = reader.string();
          break;
        case 10:
          message.closedBlock = reader.int64();
          break;
        case 11:
          message.status = reader.int32();
          break;
        case 12:
          message.crossChain = reader.bool();
          break;
        case 13:
          message.direction = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      id: isSet(object.id) ? String(object.id) : "",
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(e => Coin.fromJSON(e)) : [],
      randomNumberHash: isSet(object.randomNumberHash) ? String(object.randomNumberHash) : "",
      expireHeight: isSet(object.expireHeight) ? Long.fromValue(object.expireHeight) : Long.UZERO,
      timestamp: isSet(object.timestamp) ? Long.fromValue(object.timestamp) : Long.ZERO,
      sender: isSet(object.sender) ? String(object.sender) : "",
      recipient: isSet(object.recipient) ? String(object.recipient) : "",
      senderOtherChain: isSet(object.senderOtherChain) ? String(object.senderOtherChain) : "",
      recipientOtherChain: isSet(object.recipientOtherChain) ? String(object.recipientOtherChain) : "",
      closedBlock: isSet(object.closedBlock) ? Long.fromValue(object.closedBlock) : Long.ZERO,
      status: isSet(object.status) ? swapStatusFromJSON(object.status) : 0,
      crossChain: isSet(object.crossChain) ? Boolean(object.crossChain) : false,
      direction: isSet(object.direction) ? swapDirectionFromJSON(object.direction) : 0
    };
  },
  toJSON(message) {
    const obj = {};
    message.id !== undefined && (obj.id = message.id);
    if (message.amount) {
      obj.amount = message.amount.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.amount = [];
    }
    message.randomNumberHash !== undefined && (obj.randomNumberHash = message.randomNumberHash);
    message.expireHeight !== undefined && (obj.expireHeight = (message.expireHeight || Long.UZERO).toString());
    message.timestamp !== undefined && (obj.timestamp = (message.timestamp || Long.ZERO).toString());
    message.sender !== undefined && (obj.sender = message.sender);
    message.recipient !== undefined && (obj.recipient = message.recipient);
    message.senderOtherChain !== undefined && (obj.senderOtherChain = message.senderOtherChain);
    message.recipientOtherChain !== undefined && (obj.recipientOtherChain = message.recipientOtherChain);
    message.closedBlock !== undefined && (obj.closedBlock = (message.closedBlock || Long.ZERO).toString());
    message.status !== undefined && (obj.status = swapStatusToJSON(message.status));
    message.crossChain !== undefined && (obj.crossChain = message.crossChain);
    message.direction !== undefined && (obj.direction = swapDirectionToJSON(message.direction));
    return obj;
  },
  fromPartial(object) {
    var _object$id, _object$amount, _object$randomNumberH, _object$sender, _object$recipient, _object$senderOtherCh, _object$recipientOthe, _object$status, _object$crossChain, _object$direction;
    const message = createBaseAtomicSwapResponse();
    message.id = (_object$id = object.id) !== null && _object$id !== void 0 ? _object$id : "";
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(e => Coin.fromPartial(e))) || [];
    message.randomNumberHash = (_object$randomNumberH = object.randomNumberHash) !== null && _object$randomNumberH !== void 0 ? _object$randomNumberH : "";
    message.expireHeight = object.expireHeight !== undefined && object.expireHeight !== null ? Long.fromValue(object.expireHeight) : Long.UZERO;
    message.timestamp = object.timestamp !== undefined && object.timestamp !== null ? Long.fromValue(object.timestamp) : Long.ZERO;
    message.sender = (_object$sender = object.sender) !== null && _object$sender !== void 0 ? _object$sender : "";
    message.recipient = (_object$recipient = object.recipient) !== null && _object$recipient !== void 0 ? _object$recipient : "";
    message.senderOtherChain = (_object$senderOtherCh = object.senderOtherChain) !== null && _object$senderOtherCh !== void 0 ? _object$senderOtherCh : "";
    message.recipientOtherChain = (_object$recipientOthe = object.recipientOtherChain) !== null && _object$recipientOthe !== void 0 ? _object$recipientOthe : "";
    message.closedBlock = object.closedBlock !== undefined && object.closedBlock !== null ? Long.fromValue(object.closedBlock) : Long.ZERO;
    message.status = (_object$status = object.status) !== null && _object$status !== void 0 ? _object$status : 0;
    message.crossChain = (_object$crossChain = object.crossChain) !== null && _object$crossChain !== void 0 ? _object$crossChain : false;
    message.direction = (_object$direction = object.direction) !== null && _object$direction !== void 0 ? _object$direction : 0;
    return message;
  }
};
function createBaseQueryAtomicSwapsRequest() {
  return {
    involve: "",
    expiration: Long.UZERO,
    status: 0,
    direction: 0,
    pagination: undefined
  };
}
export const QueryAtomicSwapsRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.involve !== "") {
      writer.uint32(10).string(message.involve);
    }
    if (!message.expiration.isZero()) {
      writer.uint32(16).uint64(message.expiration);
    }
    if (message.status !== 0) {
      writer.uint32(24).int32(message.status);
    }
    if (message.direction !== 0) {
      writer.uint32(32).int32(message.direction);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAtomicSwapsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.involve = reader.string();
          break;
        case 2:
          message.expiration = reader.uint64();
          break;
        case 3:
          message.status = reader.int32();
          break;
        case 4:
          message.direction = reader.int32();
          break;
        case 5:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      involve: isSet(object.involve) ? String(object.involve) : "",
      expiration: isSet(object.expiration) ? Long.fromValue(object.expiration) : Long.UZERO,
      status: isSet(object.status) ? swapStatusFromJSON(object.status) : 0,
      direction: isSet(object.direction) ? swapDirectionFromJSON(object.direction) : 0,
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.involve !== undefined && (obj.involve = message.involve);
    message.expiration !== undefined && (obj.expiration = (message.expiration || Long.UZERO).toString());
    message.status !== undefined && (obj.status = swapStatusToJSON(message.status));
    message.direction !== undefined && (obj.direction = swapDirectionToJSON(message.direction));
    message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$involve, _object$status2, _object$direction2;
    const message = createBaseQueryAtomicSwapsRequest();
    message.involve = (_object$involve = object.involve) !== null && _object$involve !== void 0 ? _object$involve : "";
    message.expiration = object.expiration !== undefined && object.expiration !== null ? Long.fromValue(object.expiration) : Long.UZERO;
    message.status = (_object$status2 = object.status) !== null && _object$status2 !== void 0 ? _object$status2 : 0;
    message.direction = (_object$direction2 = object.direction) !== null && _object$direction2 !== void 0 ? _object$direction2 : 0;
    message.pagination = object.pagination !== undefined && object.pagination !== null ? PageRequest.fromPartial(object.pagination) : undefined;
    return message;
  }
};
function createBaseQueryAtomicSwapsResponse() {
  return {
    atomicSwaps: [],
    pagination: undefined
  };
}
export const QueryAtomicSwapsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.atomicSwaps) {
      AtomicSwapResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAtomicSwapsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.atomicSwaps.push(AtomicSwapResponse.decode(reader, reader.uint32()));
          break;
        case 3:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      atomicSwaps: Array.isArray(object === null || object === void 0 ? void 0 : object.atomicSwaps) ? object.atomicSwaps.map(e => AtomicSwapResponse.fromJSON(e)) : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.atomicSwaps) {
      obj.atomicSwaps = message.atomicSwaps.map(e => e ? AtomicSwapResponse.toJSON(e) : undefined);
    } else {
      obj.atomicSwaps = [];
    }
    message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$atomicSwaps;
    const message = createBaseQueryAtomicSwapsResponse();
    message.atomicSwaps = ((_object$atomicSwaps = object.atomicSwaps) === null || _object$atomicSwaps === void 0 ? void 0 : _object$atomicSwaps.map(e => AtomicSwapResponse.fromPartial(e))) || [];
    message.pagination = object.pagination !== undefined && object.pagination !== null ? PageResponse.fromPartial(object.pagination) : undefined;
    return message;
  }
};