import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryParamsRequest, QueryParamsResponse, QueryAssetSupplyRequest, QueryAssetSupplyResponse, QueryAssetSuppliesRequest, QueryAssetSuppliesResponse, QueryAtomicSwapRequest, QueryAtomicSwapResponse, QueryAtomicSwapsRequest, QueryAtomicSwapsResponse } from "./query";
/** Query defines the gRPC querier service for bep3 module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.assetSupply = this.assetSupply.bind(this);
    this.assetSupplies = this.assetSupplies.bind(this);
    this.atomicSwap = this.atomicSwap.bind(this);
    this.atomicSwaps = this.atomicSwaps.bind(this);
  }
  params(request = {}) {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Query", "Params", data);
    return promise.then(data => QueryParamsResponse.decode(new _m0.Reader(data)));
  }
  assetSupply(request) {
    const data = QueryAssetSupplyRequest.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Query", "AssetSupply", data);
    return promise.then(data => QueryAssetSupplyResponse.decode(new _m0.Reader(data)));
  }
  assetSupplies(request = {}) {
    const data = QueryAssetSuppliesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Query", "AssetSupplies", data);
    return promise.then(data => QueryAssetSuppliesResponse.decode(new _m0.Reader(data)));
  }
  atomicSwap(request) {
    const data = QueryAtomicSwapRequest.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Query", "AtomicSwap", data);
    return promise.then(data => QueryAtomicSwapResponse.decode(new _m0.Reader(data)));
  }
  atomicSwaps(request) {
    const data = QueryAtomicSwapsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Query", "AtomicSwaps", data);
    return promise.then(data => QueryAtomicSwapsResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    params(request) {
      return queryService.params(request);
    },
    assetSupply(request) {
      return queryService.assetSupply(request);
    },
    assetSupplies(request) {
      return queryService.assetSupplies(request);
    },
    atomicSwap(request) {
      return queryService.atomicSwap(request);
    },
    atomicSwaps(request) {
      return queryService.atomicSwaps(request);
    }
  };
};