//@ts-nocheck

import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.bep3.v1beta1.MsgCreateAtomicSwap": {
    aminoType: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
    toAmino: ({
      from,
      to,
      recipientOtherChain,
      senderOtherChain,
      randomNumberHash,
      timestamp,
      amount,
      heightSpan
    }) => {
      return {
        from,
        to,
        recipient_other_chain: recipientOtherChain,
        sender_other_chain: senderOtherChain,
        random_number_hash: randomNumberHash,
        timestamp: timestamp.toString(),
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        })),
        height_span: heightSpan.toString()
      };
    },
    fromAmino: ({
      from,
      to,
      recipient_other_chain,
      sender_other_chain,
      random_number_hash,
      timestamp,
      amount,
      height_span
    }) => {
      return {
        from,
        to,
        recipientOtherChain: recipient_other_chain,
        senderOtherChain: sender_other_chain,
        randomNumberHash: random_number_hash,
        timestamp: Long.fromString(timestamp),
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        })),
        heightSpan: Long.fromString(height_span)
      };
    }
  },
  "/kava.bep3.v1beta1.MsgClaimAtomicSwap": {
    aminoType: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
    toAmino: ({
      from,
      swapId,
      randomNumber
    }) => {
      return {
        from,
        swap_id: swapId,
        random_number: randomNumber
      };
    },
    fromAmino: ({
      from,
      swap_id,
      random_number
    }) => {
      return {
        from,
        swapId: swap_id,
        randomNumber: random_number
      };
    }
  },
  "/kava.bep3.v1beta1.MsgRefundAtomicSwap": {
    aminoType: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
    toAmino: ({
      from,
      swapId
    }) => {
      return {
        from,
        swap_id: swapId
      };
    },
    fromAmino: ({
      from,
      swap_id
    }) => {
      return {
        from,
        swapId: swap_id
      };
    }
  }
};