import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { Long, isSet } from "../../../helpers";
/** MsgCreateAtomicSwap defines the Msg/CreateAtomicSwap request type. */

function createBaseMsgCreateAtomicSwap() {
  return {
    from: "",
    to: "",
    recipientOtherChain: "",
    senderOtherChain: "",
    randomNumberHash: "",
    timestamp: Long.ZERO,
    amount: [],
    heightSpan: Long.UZERO
  };
}
export const MsgCreateAtomicSwap = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.to !== "") {
      writer.uint32(18).string(message.to);
    }
    if (message.recipientOtherChain !== "") {
      writer.uint32(26).string(message.recipientOtherChain);
    }
    if (message.senderOtherChain !== "") {
      writer.uint32(34).string(message.senderOtherChain);
    }
    if (message.randomNumberHash !== "") {
      writer.uint32(42).string(message.randomNumberHash);
    }
    if (!message.timestamp.isZero()) {
      writer.uint32(48).int64(message.timestamp);
    }
    for (const v of message.amount) {
      Coin.encode(v, writer.uint32(58).fork()).ldelim();
    }
    if (!message.heightSpan.isZero()) {
      writer.uint32(64).uint64(message.heightSpan);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgCreateAtomicSwap();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.to = reader.string();
          break;
        case 3:
          message.recipientOtherChain = reader.string();
          break;
        case 4:
          message.senderOtherChain = reader.string();
          break;
        case 5:
          message.randomNumberHash = reader.string();
          break;
        case 6:
          message.timestamp = reader.int64();
          break;
        case 7:
          message.amount.push(Coin.decode(reader, reader.uint32()));
          break;
        case 8:
          message.heightSpan = reader.uint64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      from: isSet(object.from) ? String(object.from) : "",
      to: isSet(object.to) ? String(object.to) : "",
      recipientOtherChain: isSet(object.recipientOtherChain) ? String(object.recipientOtherChain) : "",
      senderOtherChain: isSet(object.senderOtherChain) ? String(object.senderOtherChain) : "",
      randomNumberHash: isSet(object.randomNumberHash) ? String(object.randomNumberHash) : "",
      timestamp: isSet(object.timestamp) ? Long.fromValue(object.timestamp) : Long.ZERO,
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(e => Coin.fromJSON(e)) : [],
      heightSpan: isSet(object.heightSpan) ? Long.fromValue(object.heightSpan) : Long.UZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.to !== undefined && (obj.to = message.to);
    message.recipientOtherChain !== undefined && (obj.recipientOtherChain = message.recipientOtherChain);
    message.senderOtherChain !== undefined && (obj.senderOtherChain = message.senderOtherChain);
    message.randomNumberHash !== undefined && (obj.randomNumberHash = message.randomNumberHash);
    message.timestamp !== undefined && (obj.timestamp = (message.timestamp || Long.ZERO).toString());
    if (message.amount) {
      obj.amount = message.amount.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.amount = [];
    }
    message.heightSpan !== undefined && (obj.heightSpan = (message.heightSpan || Long.UZERO).toString());
    return obj;
  },
  fromPartial(object) {
    var _object$from, _object$to, _object$recipientOthe, _object$senderOtherCh, _object$randomNumberH, _object$amount;
    const message = createBaseMsgCreateAtomicSwap();
    message.from = (_object$from = object.from) !== null && _object$from !== void 0 ? _object$from : "";
    message.to = (_object$to = object.to) !== null && _object$to !== void 0 ? _object$to : "";
    message.recipientOtherChain = (_object$recipientOthe = object.recipientOtherChain) !== null && _object$recipientOthe !== void 0 ? _object$recipientOthe : "";
    message.senderOtherChain = (_object$senderOtherCh = object.senderOtherChain) !== null && _object$senderOtherCh !== void 0 ? _object$senderOtherCh : "";
    message.randomNumberHash = (_object$randomNumberH = object.randomNumberHash) !== null && _object$randomNumberH !== void 0 ? _object$randomNumberH : "";
    message.timestamp = object.timestamp !== undefined && object.timestamp !== null ? Long.fromValue(object.timestamp) : Long.ZERO;
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(e => Coin.fromPartial(e))) || [];
    message.heightSpan = object.heightSpan !== undefined && object.heightSpan !== null ? Long.fromValue(object.heightSpan) : Long.UZERO;
    return message;
  }
};
function createBaseMsgCreateAtomicSwapResponse() {
  return {};
}
export const MsgCreateAtomicSwapResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgCreateAtomicSwapResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgCreateAtomicSwapResponse();
    return message;
  }
};
function createBaseMsgClaimAtomicSwap() {
  return {
    from: "",
    swapId: "",
    randomNumber: ""
  };
}
export const MsgClaimAtomicSwap = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.swapId !== "") {
      writer.uint32(18).string(message.swapId);
    }
    if (message.randomNumber !== "") {
      writer.uint32(26).string(message.randomNumber);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimAtomicSwap();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.swapId = reader.string();
          break;
        case 3:
          message.randomNumber = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      from: isSet(object.from) ? String(object.from) : "",
      swapId: isSet(object.swapId) ? String(object.swapId) : "",
      randomNumber: isSet(object.randomNumber) ? String(object.randomNumber) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.swapId !== undefined && (obj.swapId = message.swapId);
    message.randomNumber !== undefined && (obj.randomNumber = message.randomNumber);
    return obj;
  },
  fromPartial(object) {
    var _object$from2, _object$swapId, _object$randomNumber;
    const message = createBaseMsgClaimAtomicSwap();
    message.from = (_object$from2 = object.from) !== null && _object$from2 !== void 0 ? _object$from2 : "";
    message.swapId = (_object$swapId = object.swapId) !== null && _object$swapId !== void 0 ? _object$swapId : "";
    message.randomNumber = (_object$randomNumber = object.randomNumber) !== null && _object$randomNumber !== void 0 ? _object$randomNumber : "";
    return message;
  }
};
function createBaseMsgClaimAtomicSwapResponse() {
  return {};
}
export const MsgClaimAtomicSwapResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimAtomicSwapResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimAtomicSwapResponse();
    return message;
  }
};
function createBaseMsgRefundAtomicSwap() {
  return {
    from: "",
    swapId: ""
  };
}
export const MsgRefundAtomicSwap = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.swapId !== "") {
      writer.uint32(18).string(message.swapId);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgRefundAtomicSwap();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.swapId = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      from: isSet(object.from) ? String(object.from) : "",
      swapId: isSet(object.swapId) ? String(object.swapId) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.swapId !== undefined && (obj.swapId = message.swapId);
    return obj;
  },
  fromPartial(object) {
    var _object$from3, _object$swapId2;
    const message = createBaseMsgRefundAtomicSwap();
    message.from = (_object$from3 = object.from) !== null && _object$from3 !== void 0 ? _object$from3 : "";
    message.swapId = (_object$swapId2 = object.swapId) !== null && _object$swapId2 !== void 0 ? _object$swapId2 : "";
    return message;
  }
};
function createBaseMsgRefundAtomicSwapResponse() {
  return {};
}
export const MsgRefundAtomicSwapResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgRefundAtomicSwapResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgRefundAtomicSwapResponse();
    return message;
  }
};