import { MsgCreateAtomicSwap, MsgClaimAtomicSwap, MsgRefundAtomicSwap } from "./tx";
export const registry = [["/kava.bep3.v1beta1.MsgCreateAtomicSwap", MsgCreateAtomicSwap], ["/kava.bep3.v1beta1.MsgClaimAtomicSwap", MsgClaimAtomicSwap], ["/kava.bep3.v1beta1.MsgRefundAtomicSwap", MsgRefundAtomicSwap]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: MsgCreateAtomicSwap.encode(value).finish()
      };
    },
    claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: MsgClaimAtomicSwap.encode(value).finish()
      };
    },
    refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: MsgRefundAtomicSwap.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value
      };
    },
    claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value
      };
    },
    refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value
      };
    }
  },
  toJSON: {
    createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: MsgCreateAtomicSwap.toJSON(value)
      };
    },
    claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: MsgClaimAtomicSwap.toJSON(value)
      };
    },
    refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: MsgRefundAtomicSwap.toJSON(value)
      };
    }
  },
  fromJSON: {
    createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: MsgCreateAtomicSwap.fromJSON(value)
      };
    },
    claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: MsgClaimAtomicSwap.fromJSON(value)
      };
    },
    refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: MsgRefundAtomicSwap.fromJSON(value)
      };
    }
  },
  fromPartial: {
    createAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgCreateAtomicSwap",
        value: MsgCreateAtomicSwap.fromPartial(value)
      };
    },
    claimAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgClaimAtomicSwap",
        value: MsgClaimAtomicSwap.fromPartial(value)
      };
    },
    refundAtomicSwap(value) {
      return {
        typeUrl: "/kava.bep3.v1beta1.MsgRefundAtomicSwap",
        value: MsgRefundAtomicSwap.fromPartial(value)
      };
    }
  }
};