import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { MsgCreateAtomicSwap, MsgCreateAtomicSwapResponse, MsgClaimAtomicSwap, MsgClaimAtomicSwapResponse, MsgRefundAtomicSwap, MsgRefundAtomicSwapResponse } from "./tx";
/** Msg defines the bep3 Msg service. */

export class MsgClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.createAtomicSwap = this.createAtomicSwap.bind(this);
    this.claimAtomicSwap = this.claimAtomicSwap.bind(this);
    this.refundAtomicSwap = this.refundAtomicSwap.bind(this);
  }
  createAtomicSwap(request) {
    const data = MsgCreateAtomicSwap.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Msg", "CreateAtomicSwap", data);
    return promise.then(data => MsgCreateAtomicSwapResponse.decode(new _m0.Reader(data)));
  }
  claimAtomicSwap(request) {
    const data = MsgClaimAtomicSwap.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Msg", "ClaimAtomicSwap", data);
    return promise.then(data => MsgClaimAtomicSwapResponse.decode(new _m0.Reader(data)));
  }
  refundAtomicSwap(request) {
    const data = MsgRefundAtomicSwap.encode(request).finish();
    const promise = this.rpc.request("kava.bep3.v1beta1.Msg", "RefundAtomicSwap", data);
    return promise.then(data => MsgRefundAtomicSwapResponse.decode(new _m0.Reader(data)));
  }
}