import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Params } from "./genesis";
import { ModuleAccount } from "../../../cosmos/auth/v1beta1/auth";
import { Deposit, TotalPrincipal, TotalCollateral } from "./cdp";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";
import * as _m0 from "protobufjs/minimal";
import { isSet, Long, fromJsonTimestamp, fromTimestamp } from "../../../helpers";
/** QueryParamsRequest defines the request type for the Query/Params RPC method. */

function createBaseQueryParamsRequest() {
  return {};
}
export const QueryParamsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryParamsRequest();
    return message;
  }
};
function createBaseQueryParamsResponse() {
  return {
    params: undefined
  };
}
export const QueryParamsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryParamsResponse();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    return message;
  }
};
function createBaseQueryAccountsRequest() {
  return {};
}
export const QueryAccountsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAccountsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryAccountsRequest();
    return message;
  }
};
function createBaseQueryAccountsResponse() {
  return {
    accounts: []
  };
}
export const QueryAccountsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.accounts) {
      ModuleAccount.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAccountsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.accounts.push(ModuleAccount.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      accounts: Array.isArray(object === null || object === void 0 ? void 0 : object.accounts) ? object.accounts.map(e => ModuleAccount.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.accounts) {
      obj.accounts = message.accounts.map(e => e ? ModuleAccount.toJSON(e) : undefined);
    } else {
      obj.accounts = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$accounts;
    const message = createBaseQueryAccountsResponse();
    message.accounts = ((_object$accounts = object.accounts) === null || _object$accounts === void 0 ? void 0 : _object$accounts.map(e => ModuleAccount.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryCdpRequest() {
  return {
    collateralType: "",
    owner: ""
  };
}
export const QueryCdpRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryCdpRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      owner: isSet(object.owner) ? String(object.owner) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.owner !== undefined && (obj.owner = message.owner);
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp, _object$owner;
    const message = createBaseQueryCdpRequest();
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : "";
    return message;
  }
};
function createBaseQueryCdpResponse() {
  return {
    cdp: undefined
  };
}
export const QueryCdpResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.cdp !== undefined) {
      CDPResponse.encode(message.cdp, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryCdpResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.cdp = CDPResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      cdp: isSet(object.cdp) ? CDPResponse.fromJSON(object.cdp) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.cdp !== undefined && (obj.cdp = message.cdp ? CDPResponse.toJSON(message.cdp) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryCdpResponse();
    message.cdp = object.cdp !== undefined && object.cdp !== null ? CDPResponse.fromPartial(object.cdp) : undefined;
    return message;
  }
};
function createBaseQueryCdpsRequest() {
  return {
    collateralType: "",
    owner: "",
    id: Long.UZERO,
    ratio: "",
    pagination: undefined
  };
}
export const QueryCdpsRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (!message.id.isZero()) {
      writer.uint32(24).uint64(message.id);
    }
    if (message.ratio !== "") {
      writer.uint32(34).string(message.ratio);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryCdpsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        case 3:
          message.id = reader.uint64();
          break;
        case 4:
          message.ratio = reader.string();
          break;
        case 5:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      owner: isSet(object.owner) ? String(object.owner) : "",
      id: isSet(object.id) ? Long.fromValue(object.id) : Long.UZERO,
      ratio: isSet(object.ratio) ? String(object.ratio) : "",
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.owner !== undefined && (obj.owner = message.owner);
    message.id !== undefined && (obj.id = (message.id || Long.UZERO).toString());
    message.ratio !== undefined && (obj.ratio = message.ratio);
    message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp2, _object$owner2, _object$ratio;
    const message = createBaseQueryCdpsRequest();
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    message.owner = (_object$owner2 = object.owner) !== null && _object$owner2 !== void 0 ? _object$owner2 : "";
    message.id = object.id !== undefined && object.id !== null ? Long.fromValue(object.id) : Long.UZERO;
    message.ratio = (_object$ratio = object.ratio) !== null && _object$ratio !== void 0 ? _object$ratio : "";
    message.pagination = object.pagination !== undefined && object.pagination !== null ? PageRequest.fromPartial(object.pagination) : undefined;
    return message;
  }
};
function createBaseQueryCdpsResponse() {
  return {
    cdps: [],
    pagination: undefined
  };
}
export const QueryCdpsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.cdps) {
      CDPResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryCdpsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.cdps.push(CDPResponse.decode(reader, reader.uint32()));
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      cdps: Array.isArray(object === null || object === void 0 ? void 0 : object.cdps) ? object.cdps.map(e => CDPResponse.fromJSON(e)) : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.cdps) {
      obj.cdps = message.cdps.map(e => e ? CDPResponse.toJSON(e) : undefined);
    } else {
      obj.cdps = [];
    }
    message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$cdps;
    const message = createBaseQueryCdpsResponse();
    message.cdps = ((_object$cdps = object.cdps) === null || _object$cdps === void 0 ? void 0 : _object$cdps.map(e => CDPResponse.fromPartial(e))) || [];
    message.pagination = object.pagination !== undefined && object.pagination !== null ? PageResponse.fromPartial(object.pagination) : undefined;
    return message;
  }
};
function createBaseQueryDepositsRequest() {
  return {
    collateralType: "",
    owner: ""
  };
}
export const QueryDepositsRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDepositsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      owner: isSet(object.owner) ? String(object.owner) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.owner !== undefined && (obj.owner = message.owner);
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp3, _object$owner3;
    const message = createBaseQueryDepositsRequest();
    message.collateralType = (_object$collateralTyp3 = object.collateralType) !== null && _object$collateralTyp3 !== void 0 ? _object$collateralTyp3 : "";
    message.owner = (_object$owner3 = object.owner) !== null && _object$owner3 !== void 0 ? _object$owner3 : "";
    return message;
  }
};
function createBaseQueryDepositsResponse() {
  return {
    deposits: []
  };
}
export const QueryDepositsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.deposits) {
      Deposit.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDepositsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.deposits.push(Deposit.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      deposits: Array.isArray(object === null || object === void 0 ? void 0 : object.deposits) ? object.deposits.map(e => Deposit.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.deposits) {
      obj.deposits = message.deposits.map(e => e ? Deposit.toJSON(e) : undefined);
    } else {
      obj.deposits = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$deposits;
    const message = createBaseQueryDepositsResponse();
    message.deposits = ((_object$deposits = object.deposits) === null || _object$deposits === void 0 ? void 0 : _object$deposits.map(e => Deposit.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryTotalPrincipalRequest() {
  return {
    collateralType: ""
  };
}
export const QueryTotalPrincipalRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalPrincipalRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp4;
    const message = createBaseQueryTotalPrincipalRequest();
    message.collateralType = (_object$collateralTyp4 = object.collateralType) !== null && _object$collateralTyp4 !== void 0 ? _object$collateralTyp4 : "";
    return message;
  }
};
function createBaseQueryTotalPrincipalResponse() {
  return {
    totalPrincipal: []
  };
}
export const QueryTotalPrincipalResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.totalPrincipal) {
      TotalPrincipal.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalPrincipalResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.totalPrincipal.push(TotalPrincipal.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      totalPrincipal: Array.isArray(object === null || object === void 0 ? void 0 : object.totalPrincipal) ? object.totalPrincipal.map(e => TotalPrincipal.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.totalPrincipal) {
      obj.totalPrincipal = message.totalPrincipal.map(e => e ? TotalPrincipal.toJSON(e) : undefined);
    } else {
      obj.totalPrincipal = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$totalPrincipa;
    const message = createBaseQueryTotalPrincipalResponse();
    message.totalPrincipal = ((_object$totalPrincipa = object.totalPrincipal) === null || _object$totalPrincipa === void 0 ? void 0 : _object$totalPrincipa.map(e => TotalPrincipal.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryTotalCollateralRequest() {
  return {
    collateralType: ""
  };
}
export const QueryTotalCollateralRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalCollateralRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp5;
    const message = createBaseQueryTotalCollateralRequest();
    message.collateralType = (_object$collateralTyp5 = object.collateralType) !== null && _object$collateralTyp5 !== void 0 ? _object$collateralTyp5 : "";
    return message;
  }
};
function createBaseQueryTotalCollateralResponse() {
  return {
    totalCollateral: []
  };
}
export const QueryTotalCollateralResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.totalCollateral) {
      TotalCollateral.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalCollateralResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.totalCollateral.push(TotalCollateral.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      totalCollateral: Array.isArray(object === null || object === void 0 ? void 0 : object.totalCollateral) ? object.totalCollateral.map(e => TotalCollateral.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.totalCollateral) {
      obj.totalCollateral = message.totalCollateral.map(e => e ? TotalCollateral.toJSON(e) : undefined);
    } else {
      obj.totalCollateral = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$totalCollater;
    const message = createBaseQueryTotalCollateralResponse();
    message.totalCollateral = ((_object$totalCollater = object.totalCollateral) === null || _object$totalCollater === void 0 ? void 0 : _object$totalCollater.map(e => TotalCollateral.fromPartial(e))) || [];
    return message;
  }
};
function createBaseCDPResponse() {
  return {
    id: Long.UZERO,
    owner: "",
    type: "",
    collateral: undefined,
    principal: undefined,
    accumulatedFees: undefined,
    feesUpdated: undefined,
    interestFactor: "",
    collateralValue: undefined,
    collateralizationRatio: ""
  };
}
export const CDPResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (!message.id.isZero()) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.type !== "") {
      writer.uint32(26).string(message.type);
    }
    if (message.collateral !== undefined) {
      Coin.encode(message.collateral, writer.uint32(34).fork()).ldelim();
    }
    if (message.principal !== undefined) {
      Coin.encode(message.principal, writer.uint32(42).fork()).ldelim();
    }
    if (message.accumulatedFees !== undefined) {
      Coin.encode(message.accumulatedFees, writer.uint32(50).fork()).ldelim();
    }
    if (message.feesUpdated !== undefined) {
      Timestamp.encode(message.feesUpdated, writer.uint32(58).fork()).ldelim();
    }
    if (message.interestFactor !== "") {
      writer.uint32(66).string(message.interestFactor);
    }
    if (message.collateralValue !== undefined) {
      Coin.encode(message.collateralValue, writer.uint32(74).fork()).ldelim();
    }
    if (message.collateralizationRatio !== "") {
      writer.uint32(82).string(message.collateralizationRatio);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCDPResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = reader.uint64();
          break;
        case 2:
          message.owner = reader.string();
          break;
        case 3:
          message.type = reader.string();
          break;
        case 4:
          message.collateral = Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.principal = Coin.decode(reader, reader.uint32());
          break;
        case 6:
          message.accumulatedFees = Coin.decode(reader, reader.uint32());
          break;
        case 7:
          message.feesUpdated = Timestamp.decode(reader, reader.uint32());
          break;
        case 8:
          message.interestFactor = reader.string();
          break;
        case 9:
          message.collateralValue = Coin.decode(reader, reader.uint32());
          break;
        case 10:
          message.collateralizationRatio = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      id: isSet(object.id) ? Long.fromValue(object.id) : Long.UZERO,
      owner: isSet(object.owner) ? String(object.owner) : "",
      type: isSet(object.type) ? String(object.type) : "",
      collateral: isSet(object.collateral) ? Coin.fromJSON(object.collateral) : undefined,
      principal: isSet(object.principal) ? Coin.fromJSON(object.principal) : undefined,
      accumulatedFees: isSet(object.accumulatedFees) ? Coin.fromJSON(object.accumulatedFees) : undefined,
      feesUpdated: isSet(object.feesUpdated) ? fromJsonTimestamp(object.feesUpdated) : undefined,
      interestFactor: isSet(object.interestFactor) ? String(object.interestFactor) : "",
      collateralValue: isSet(object.collateralValue) ? Coin.fromJSON(object.collateralValue) : undefined,
      collateralizationRatio: isSet(object.collateralizationRatio) ? String(object.collateralizationRatio) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.id !== undefined && (obj.id = (message.id || Long.UZERO).toString());
    message.owner !== undefined && (obj.owner = message.owner);
    message.type !== undefined && (obj.type = message.type);
    message.collateral !== undefined && (obj.collateral = message.collateral ? Coin.toJSON(message.collateral) : undefined);
    message.principal !== undefined && (obj.principal = message.principal ? Coin.toJSON(message.principal) : undefined);
    message.accumulatedFees !== undefined && (obj.accumulatedFees = message.accumulatedFees ? Coin.toJSON(message.accumulatedFees) : undefined);
    message.feesUpdated !== undefined && (obj.feesUpdated = fromTimestamp(message.feesUpdated).toISOString());
    message.interestFactor !== undefined && (obj.interestFactor = message.interestFactor);
    message.collateralValue !== undefined && (obj.collateralValue = message.collateralValue ? Coin.toJSON(message.collateralValue) : undefined);
    message.collateralizationRatio !== undefined && (obj.collateralizationRatio = message.collateralizationRatio);
    return obj;
  },
  fromPartial(object) {
    var _object$owner4, _object$type, _object$interestFacto, _object$collateraliza;
    const message = createBaseCDPResponse();
    message.id = object.id !== undefined && object.id !== null ? Long.fromValue(object.id) : Long.UZERO;
    message.owner = (_object$owner4 = object.owner) !== null && _object$owner4 !== void 0 ? _object$owner4 : "";
    message.type = (_object$type = object.type) !== null && _object$type !== void 0 ? _object$type : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? Coin.fromPartial(object.collateral) : undefined;
    message.principal = object.principal !== undefined && object.principal !== null ? Coin.fromPartial(object.principal) : undefined;
    message.accumulatedFees = object.accumulatedFees !== undefined && object.accumulatedFees !== null ? Coin.fromPartial(object.accumulatedFees) : undefined;
    message.feesUpdated = object.feesUpdated !== undefined && object.feesUpdated !== null ? Timestamp.fromPartial(object.feesUpdated) : undefined;
    message.interestFactor = (_object$interestFacto = object.interestFactor) !== null && _object$interestFacto !== void 0 ? _object$interestFacto : "";
    message.collateralValue = object.collateralValue !== undefined && object.collateralValue !== null ? Coin.fromPartial(object.collateralValue) : undefined;
    message.collateralizationRatio = (_object$collateraliza = object.collateralizationRatio) !== null && _object$collateraliza !== void 0 ? _object$collateraliza : "";
    return message;
  }
};