import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryParamsRequest, QueryParamsResponse, QueryAccountsRequest, QueryAccountsResponse, QueryTotalPrincipalRequest, QueryTotalPrincipalResponse, QueryTotalCollateralRequest, QueryTotalCollateralResponse, QueryCdpsRequest, QueryCdpsResponse, QueryCdpRequest, QueryCdpResponse, QueryDepositsRequest, QueryDepositsResponse } from "./query";
/** Query defines the gRPC querier service for cdp module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.accounts = this.accounts.bind(this);
    this.totalPrincipal = this.totalPrincipal.bind(this);
    this.totalCollateral = this.totalCollateral.bind(this);
    this.cdps = this.cdps.bind(this);
    this.cdp = this.cdp.bind(this);
    this.deposits = this.deposits.bind(this);
  }
  params(request = {}) {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "Params", data);
    return promise.then(data => QueryParamsResponse.decode(new _m0.Reader(data)));
  }
  accounts(request = {}) {
    const data = QueryAccountsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "Accounts", data);
    return promise.then(data => QueryAccountsResponse.decode(new _m0.Reader(data)));
  }
  totalPrincipal(request) {
    const data = QueryTotalPrincipalRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "TotalPrincipal", data);
    return promise.then(data => QueryTotalPrincipalResponse.decode(new _m0.Reader(data)));
  }
  totalCollateral(request) {
    const data = QueryTotalCollateralRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "TotalCollateral", data);
    return promise.then(data => QueryTotalCollateralResponse.decode(new _m0.Reader(data)));
  }
  cdps(request) {
    const data = QueryCdpsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "Cdps", data);
    return promise.then(data => QueryCdpsResponse.decode(new _m0.Reader(data)));
  }
  cdp(request) {
    const data = QueryCdpRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "Cdp", data);
    return promise.then(data => QueryCdpResponse.decode(new _m0.Reader(data)));
  }
  deposits(request) {
    const data = QueryDepositsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Query", "Deposits", data);
    return promise.then(data => QueryDepositsResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    params(request) {
      return queryService.params(request);
    },
    accounts(request) {
      return queryService.accounts(request);
    },
    totalPrincipal(request) {
      return queryService.totalPrincipal(request);
    },
    totalCollateral(request) {
      return queryService.totalCollateral(request);
    },
    cdps(request) {
      return queryService.cdps(request);
    },
    cdp(request) {
      return queryService.cdp(request);
    },
    deposits(request) {
      return queryService.deposits(request);
    }
  };
};