//@ts-nocheck

import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.cdp.v1beta1.MsgCreateCDP": {
    aminoType: "/kava.cdp.v1beta1.MsgCreateCDP",
    toAmino: ({
      sender,
      collateral,
      principal,
      collateralType
    }) => {
      return {
        sender,
        collateral: {
          denom: collateral.denom,
          amount: Long.fromValue(collateral.amount).toString()
        },
        principal: {
          denom: principal.denom,
          amount: Long.fromValue(principal.amount).toString()
        },
        collateral_type: collateralType
      };
    },
    fromAmino: ({
      sender,
      collateral,
      principal,
      collateral_type
    }) => {
      return {
        sender,
        collateral: {
          denom: collateral.denom,
          amount: collateral.amount
        },
        principal: {
          denom: principal.denom,
          amount: principal.amount
        },
        collateralType: collateral_type
      };
    }
  },
  "/kava.cdp.v1beta1.MsgDeposit": {
    aminoType: "/kava.cdp.v1beta1.MsgDeposit",
    toAmino: ({
      depositor,
      owner,
      collateral,
      collateralType
    }) => {
      return {
        depositor,
        owner,
        collateral: {
          denom: collateral.denom,
          amount: Long.fromValue(collateral.amount).toString()
        },
        collateral_type: collateralType
      };
    },
    fromAmino: ({
      depositor,
      owner,
      collateral,
      collateral_type
    }) => {
      return {
        depositor,
        owner,
        collateral: {
          denom: collateral.denom,
          amount: collateral.amount
        },
        collateralType: collateral_type
      };
    }
  },
  "/kava.cdp.v1beta1.MsgWithdraw": {
    aminoType: "/kava.cdp.v1beta1.MsgWithdraw",
    toAmino: ({
      depositor,
      owner,
      collateral,
      collateralType
    }) => {
      return {
        depositor,
        owner,
        collateral: {
          denom: collateral.denom,
          amount: Long.fromValue(collateral.amount).toString()
        },
        collateral_type: collateralType
      };
    },
    fromAmino: ({
      depositor,
      owner,
      collateral,
      collateral_type
    }) => {
      return {
        depositor,
        owner,
        collateral: {
          denom: collateral.denom,
          amount: collateral.amount
        },
        collateralType: collateral_type
      };
    }
  },
  "/kava.cdp.v1beta1.MsgDrawDebt": {
    aminoType: "/kava.cdp.v1beta1.MsgDrawDebt",
    toAmino: ({
      sender,
      collateralType,
      principal
    }) => {
      return {
        sender,
        collateral_type: collateralType,
        principal: {
          denom: principal.denom,
          amount: Long.fromValue(principal.amount).toString()
        }
      };
    },
    fromAmino: ({
      sender,
      collateral_type,
      principal
    }) => {
      return {
        sender,
        collateralType: collateral_type,
        principal: {
          denom: principal.denom,
          amount: principal.amount
        }
      };
    }
  },
  "/kava.cdp.v1beta1.MsgRepayDebt": {
    aminoType: "/kava.cdp.v1beta1.MsgRepayDebt",
    toAmino: ({
      sender,
      collateralType,
      payment
    }) => {
      return {
        sender,
        collateral_type: collateralType,
        payment: {
          denom: payment.denom,
          amount: Long.fromValue(payment.amount).toString()
        }
      };
    },
    fromAmino: ({
      sender,
      collateral_type,
      payment
    }) => {
      return {
        sender,
        collateralType: collateral_type,
        payment: {
          denom: payment.denom,
          amount: payment.amount
        }
      };
    }
  },
  "/kava.cdp.v1beta1.MsgLiquidate": {
    aminoType: "/kava.cdp.v1beta1.MsgLiquidate",
    toAmino: ({
      keeper,
      borrower,
      collateralType
    }) => {
      return {
        keeper,
        borrower,
        collateral_type: collateralType
      };
    },
    fromAmino: ({
      keeper,
      borrower,
      collateral_type
    }) => {
      return {
        keeper,
        borrower,
        collateralType: collateral_type
      };
    }
  }
};