import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet, Long } from "../../../helpers";
/** MsgCreateCDP defines a message to create a new CDP. */

function createBaseMsgCreateCDP() {
  return {
    sender: "",
    collateral: undefined,
    principal: undefined,
    collateralType: ""
  };
}
export const MsgCreateCDP = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.collateral !== undefined) {
      Coin.encode(message.collateral, writer.uint32(18).fork()).ldelim();
    }
    if (message.principal !== undefined) {
      Coin.encode(message.principal, writer.uint32(26).fork()).ldelim();
    }
    if (message.collateralType !== "") {
      writer.uint32(34).string(message.collateralType);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgCreateCDP();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.collateral = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.principal = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      collateral: isSet(object.collateral) ? Coin.fromJSON(object.collateral) : undefined,
      principal: isSet(object.principal) ? Coin.fromJSON(object.principal) : undefined,
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.collateral !== undefined && (obj.collateral = message.collateral ? Coin.toJSON(message.collateral) : undefined);
    message.principal !== undefined && (obj.principal = message.principal ? Coin.toJSON(message.principal) : undefined);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial(object) {
    var _object$sender, _object$collateralTyp;
    const message = createBaseMsgCreateCDP();
    message.sender = (_object$sender = object.sender) !== null && _object$sender !== void 0 ? _object$sender : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? Coin.fromPartial(object.collateral) : undefined;
    message.principal = object.principal !== undefined && object.principal !== null ? Coin.fromPartial(object.principal) : undefined;
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    return message;
  }
};
function createBaseMsgCreateCDPResponse() {
  return {
    cdpId: Long.UZERO
  };
}
export const MsgCreateCDPResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (!message.cdpId.isZero()) {
      writer.uint32(8).uint64(message.cdpId);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgCreateCDPResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.cdpId = reader.uint64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      cdpId: isSet(object.cdpId) ? Long.fromValue(object.cdpId) : Long.UZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.cdpId !== undefined && (obj.cdpId = (message.cdpId || Long.UZERO).toString());
    return obj;
  },
  fromPartial(object) {
    const message = createBaseMsgCreateCDPResponse();
    message.cdpId = object.cdpId !== undefined && object.cdpId !== null ? Long.fromValue(object.cdpId) : Long.UZERO;
    return message;
  }
};
function createBaseMsgDeposit() {
  return {
    depositor: "",
    owner: "",
    collateral: undefined,
    collateralType: ""
  };
}
export const MsgDeposit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.collateral !== undefined) {
      Coin.encode(message.collateral, writer.uint32(26).fork()).ldelim();
    }
    if (message.collateralType !== "") {
      writer.uint32(34).string(message.collateralType);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDeposit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        case 3:
          message.collateral = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      owner: isSet(object.owner) ? String(object.owner) : "",
      collateral: isSet(object.collateral) ? Coin.fromJSON(object.collateral) : undefined,
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.owner !== undefined && (obj.owner = message.owner);
    message.collateral !== undefined && (obj.collateral = message.collateral ? Coin.toJSON(message.collateral) : undefined);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial(object) {
    var _object$depositor, _object$owner, _object$collateralTyp2;
    const message = createBaseMsgDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? Coin.fromPartial(object.collateral) : undefined;
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    return message;
  }
};
function createBaseMsgDepositResponse() {
  return {};
}
export const MsgDepositResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDepositResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgDepositResponse();
    return message;
  }
};
function createBaseMsgWithdraw() {
  return {
    depositor: "",
    owner: "",
    collateral: undefined,
    collateralType: ""
  };
}
export const MsgWithdraw = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.collateral !== undefined) {
      Coin.encode(message.collateral, writer.uint32(26).fork()).ldelim();
    }
    if (message.collateralType !== "") {
      writer.uint32(34).string(message.collateralType);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgWithdraw();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.owner = reader.string();
          break;
        case 3:
          message.collateral = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      owner: isSet(object.owner) ? String(object.owner) : "",
      collateral: isSet(object.collateral) ? Coin.fromJSON(object.collateral) : undefined,
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.owner !== undefined && (obj.owner = message.owner);
    message.collateral !== undefined && (obj.collateral = message.collateral ? Coin.toJSON(message.collateral) : undefined);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial(object) {
    var _object$depositor2, _object$owner2, _object$collateralTyp3;
    const message = createBaseMsgWithdraw();
    message.depositor = (_object$depositor2 = object.depositor) !== null && _object$depositor2 !== void 0 ? _object$depositor2 : "";
    message.owner = (_object$owner2 = object.owner) !== null && _object$owner2 !== void 0 ? _object$owner2 : "";
    message.collateral = object.collateral !== undefined && object.collateral !== null ? Coin.fromPartial(object.collateral) : undefined;
    message.collateralType = (_object$collateralTyp3 = object.collateralType) !== null && _object$collateralTyp3 !== void 0 ? _object$collateralTyp3 : "";
    return message;
  }
};
function createBaseMsgWithdrawResponse() {
  return {};
}
export const MsgWithdrawResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgWithdrawResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgWithdrawResponse();
    return message;
  }
};
function createBaseMsgDrawDebt() {
  return {
    sender: "",
    collateralType: "",
    principal: undefined
  };
}
export const MsgDrawDebt = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.principal !== undefined) {
      Coin.encode(message.principal, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDrawDebt();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.principal = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      principal: isSet(object.principal) ? Coin.fromJSON(object.principal) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.principal !== undefined && (obj.principal = message.principal ? Coin.toJSON(message.principal) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$sender2, _object$collateralTyp4;
    const message = createBaseMsgDrawDebt();
    message.sender = (_object$sender2 = object.sender) !== null && _object$sender2 !== void 0 ? _object$sender2 : "";
    message.collateralType = (_object$collateralTyp4 = object.collateralType) !== null && _object$collateralTyp4 !== void 0 ? _object$collateralTyp4 : "";
    message.principal = object.principal !== undefined && object.principal !== null ? Coin.fromPartial(object.principal) : undefined;
    return message;
  }
};
function createBaseMsgDrawDebtResponse() {
  return {};
}
export const MsgDrawDebtResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDrawDebtResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgDrawDebtResponse();
    return message;
  }
};
function createBaseMsgRepayDebt() {
  return {
    sender: "",
    collateralType: "",
    payment: undefined
  };
}
export const MsgRepayDebt = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.payment !== undefined) {
      Coin.encode(message.payment, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgRepayDebt();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.payment = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      payment: isSet(object.payment) ? Coin.fromJSON(object.payment) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.payment !== undefined && (obj.payment = message.payment ? Coin.toJSON(message.payment) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$sender3, _object$collateralTyp5;
    const message = createBaseMsgRepayDebt();
    message.sender = (_object$sender3 = object.sender) !== null && _object$sender3 !== void 0 ? _object$sender3 : "";
    message.collateralType = (_object$collateralTyp5 = object.collateralType) !== null && _object$collateralTyp5 !== void 0 ? _object$collateralTyp5 : "";
    message.payment = object.payment !== undefined && object.payment !== null ? Coin.fromPartial(object.payment) : undefined;
    return message;
  }
};
function createBaseMsgRepayDebtResponse() {
  return {};
}
export const MsgRepayDebtResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgRepayDebtResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgRepayDebtResponse();
    return message;
  }
};
function createBaseMsgLiquidate() {
  return {
    keeper: "",
    borrower: "",
    collateralType: ""
  };
}
export const MsgLiquidate = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.keeper !== "") {
      writer.uint32(10).string(message.keeper);
    }
    if (message.borrower !== "") {
      writer.uint32(18).string(message.borrower);
    }
    if (message.collateralType !== "") {
      writer.uint32(26).string(message.collateralType);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgLiquidate();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.keeper = reader.string();
          break;
        case 2:
          message.borrower = reader.string();
          break;
        case 3:
          message.collateralType = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      keeper: isSet(object.keeper) ? String(object.keeper) : "",
      borrower: isSet(object.borrower) ? String(object.borrower) : "",
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.keeper !== undefined && (obj.keeper = message.keeper);
    message.borrower !== undefined && (obj.borrower = message.borrower);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    return obj;
  },
  fromPartial(object) {
    var _object$keeper, _object$borrower, _object$collateralTyp6;
    const message = createBaseMsgLiquidate();
    message.keeper = (_object$keeper = object.keeper) !== null && _object$keeper !== void 0 ? _object$keeper : "";
    message.borrower = (_object$borrower = object.borrower) !== null && _object$borrower !== void 0 ? _object$borrower : "";
    message.collateralType = (_object$collateralTyp6 = object.collateralType) !== null && _object$collateralTyp6 !== void 0 ? _object$collateralTyp6 : "";
    return message;
  }
};
function createBaseMsgLiquidateResponse() {
  return {};
}
export const MsgLiquidateResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgLiquidateResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgLiquidateResponse();
    return message;
  }
};