import { MsgCreateCDP, MsgDeposit, MsgWithdraw, MsgDrawDebt, MsgRepayDebt, MsgLiquidate } from "./tx";
export const registry = [["/kava.cdp.v1beta1.MsgCreateCDP", MsgCreateCDP], ["/kava.cdp.v1beta1.MsgDeposit", MsgDeposit], ["/kava.cdp.v1beta1.MsgWithdraw", MsgWithdraw], ["/kava.cdp.v1beta1.MsgDrawDebt", MsgDrawDebt], ["/kava.cdp.v1beta1.MsgRepayDebt", MsgRepayDebt], ["/kava.cdp.v1beta1.MsgLiquidate", MsgLiquidate]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: MsgCreateCDP.encode(value).finish()
      };
    },
    deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: MsgDeposit.encode(value).finish()
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: MsgWithdraw.encode(value).finish()
      };
    },
    drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: MsgDrawDebt.encode(value).finish()
      };
    },
    repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: MsgRepayDebt.encode(value).finish()
      };
    },
    liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: MsgLiquidate.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value
      };
    },
    deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value
      };
    },
    drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value
      };
    },
    repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value
      };
    },
    liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value
      };
    }
  },
  toJSON: {
    createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: MsgCreateCDP.toJSON(value)
      };
    },
    deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: MsgDeposit.toJSON(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: MsgWithdraw.toJSON(value)
      };
    },
    drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: MsgDrawDebt.toJSON(value)
      };
    },
    repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: MsgRepayDebt.toJSON(value)
      };
    },
    liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: MsgLiquidate.toJSON(value)
      };
    }
  },
  fromJSON: {
    createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: MsgCreateCDP.fromJSON(value)
      };
    },
    deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: MsgDeposit.fromJSON(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: MsgWithdraw.fromJSON(value)
      };
    },
    drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: MsgDrawDebt.fromJSON(value)
      };
    },
    repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: MsgRepayDebt.fromJSON(value)
      };
    },
    liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: MsgLiquidate.fromJSON(value)
      };
    }
  },
  fromPartial: {
    createCDP(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgCreateCDP",
        value: MsgCreateCDP.fromPartial(value)
      };
    },
    deposit(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDeposit",
        value: MsgDeposit.fromPartial(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgWithdraw",
        value: MsgWithdraw.fromPartial(value)
      };
    },
    drawDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgDrawDebt",
        value: MsgDrawDebt.fromPartial(value)
      };
    },
    repayDebt(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgRepayDebt",
        value: MsgRepayDebt.fromPartial(value)
      };
    },
    liquidate(value) {
      return {
        typeUrl: "/kava.cdp.v1beta1.MsgLiquidate",
        value: MsgLiquidate.fromPartial(value)
      };
    }
  }
};