import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { MsgCreateCDP, MsgCreateCDPResponse, MsgDeposit, MsgDepositResponse, MsgWithdraw, MsgWithdrawResponse, MsgDrawDebt, MsgDrawDebtResponse, MsgRepayDebt, MsgRepayDebtResponse, MsgLiquidate, MsgLiquidateResponse } from "./tx";
/** Msg defines the cdp Msg service. */

export class MsgClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.createCDP = this.createCDP.bind(this);
    this.deposit = this.deposit.bind(this);
    this.withdraw = this.withdraw.bind(this);
    this.drawDebt = this.drawDebt.bind(this);
    this.repayDebt = this.repayDebt.bind(this);
    this.liquidate = this.liquidate.bind(this);
  }
  createCDP(request) {
    const data = MsgCreateCDP.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Msg", "CreateCDP", data);
    return promise.then(data => MsgCreateCDPResponse.decode(new _m0.Reader(data)));
  }
  deposit(request) {
    const data = MsgDeposit.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Msg", "Deposit", data);
    return promise.then(data => MsgDepositResponse.decode(new _m0.Reader(data)));
  }
  withdraw(request) {
    const data = MsgWithdraw.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Msg", "Withdraw", data);
    return promise.then(data => MsgWithdrawResponse.decode(new _m0.Reader(data)));
  }
  drawDebt(request) {
    const data = MsgDrawDebt.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Msg", "DrawDebt", data);
    return promise.then(data => MsgDrawDebtResponse.decode(new _m0.Reader(data)));
  }
  repayDebt(request) {
    const data = MsgRepayDebt.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Msg", "RepayDebt", data);
    return promise.then(data => MsgRepayDebtResponse.decode(new _m0.Reader(data)));
  }
  liquidate(request) {
    const data = MsgLiquidate.encode(request).finish();
    const promise = this.rpc.request("kava.cdp.v1beta1.Msg", "Liquidate", data);
    return promise.then(data => MsgLiquidateResponse.decode(new _m0.Reader(data)));
  }
}