import { Any } from "../../../google/protobuf/any";
import { Duration } from "../../../google/protobuf/duration";
import * as _m0 from "protobufjs/minimal";
import { Long, isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
/** TallyOption enumerates the valid types of a tally. */

export let TallyOption;
/** TallyOption enumerates the valid types of a tally. */
(function (TallyOption) {
  TallyOption[TallyOption["TALLY_OPTION_UNSPECIFIED"] = 0] = "TALLY_OPTION_UNSPECIFIED";
  TallyOption[TallyOption["TALLY_OPTION_FIRST_PAST_THE_POST"] = 1] = "TALLY_OPTION_FIRST_PAST_THE_POST";
  TallyOption[TallyOption["TALLY_OPTION_DEADLINE"] = 2] = "TALLY_OPTION_DEADLINE";
  TallyOption[TallyOption["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(TallyOption || (TallyOption = {}));
export let TallyOptionSDKType;
(function (TallyOptionSDKType) {
  TallyOptionSDKType[TallyOptionSDKType["TALLY_OPTION_UNSPECIFIED"] = 0] = "TALLY_OPTION_UNSPECIFIED";
  TallyOptionSDKType[TallyOptionSDKType["TALLY_OPTION_FIRST_PAST_THE_POST"] = 1] = "TALLY_OPTION_FIRST_PAST_THE_POST";
  TallyOptionSDKType[TallyOptionSDKType["TALLY_OPTION_DEADLINE"] = 2] = "TALLY_OPTION_DEADLINE";
  TallyOptionSDKType[TallyOptionSDKType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(TallyOptionSDKType || (TallyOptionSDKType = {}));
export function tallyOptionFromJSON(object) {
  switch (object) {
    case 0:
    case "TALLY_OPTION_UNSPECIFIED":
      return TallyOption.TALLY_OPTION_UNSPECIFIED;
    case 1:
    case "TALLY_OPTION_FIRST_PAST_THE_POST":
      return TallyOption.TALLY_OPTION_FIRST_PAST_THE_POST;
    case 2:
    case "TALLY_OPTION_DEADLINE":
      return TallyOption.TALLY_OPTION_DEADLINE;
    case -1:
    case "UNRECOGNIZED":
    default:
      return TallyOption.UNRECOGNIZED;
  }
}
export function tallyOptionToJSON(object) {
  switch (object) {
    case TallyOption.TALLY_OPTION_UNSPECIFIED:
      return "TALLY_OPTION_UNSPECIFIED";
    case TallyOption.TALLY_OPTION_FIRST_PAST_THE_POST:
      return "TALLY_OPTION_FIRST_PAST_THE_POST";
    case TallyOption.TALLY_OPTION_DEADLINE:
      return "TALLY_OPTION_DEADLINE";
    case TallyOption.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}
/** BaseCommittee is a common type shared by all Committees */

function createBaseBaseCommittee() {
  return {
    id: Long.UZERO,
    description: "",
    members: [],
    permissions: [],
    voteThreshold: "",
    proposalDuration: undefined,
    tallyOption: 0
  };
}
export const BaseCommittee = {
  encode(message, writer = _m0.Writer.create()) {
    if (!message.id.isZero()) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    for (const v of message.members) {
      writer.uint32(26).bytes(v);
    }
    for (const v of message.permissions) {
      Any.encode(v, writer.uint32(34).fork()).ldelim();
    }
    if (message.voteThreshold !== "") {
      writer.uint32(42).string(message.voteThreshold);
    }
    if (message.proposalDuration !== undefined) {
      Duration.encode(message.proposalDuration, writer.uint32(50).fork()).ldelim();
    }
    if (message.tallyOption !== 0) {
      writer.uint32(56).int32(message.tallyOption);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseCommittee();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = reader.uint64();
          break;
        case 2:
          message.description = reader.string();
          break;
        case 3:
          message.members.push(reader.bytes());
          break;
        case 4:
          message.permissions.push(Any.decode(reader, reader.uint32()));
          break;
        case 5:
          message.voteThreshold = reader.string();
          break;
        case 6:
          message.proposalDuration = Duration.decode(reader, reader.uint32());
          break;
        case 7:
          message.tallyOption = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      id: isSet(object.id) ? Long.fromValue(object.id) : Long.UZERO,
      description: isSet(object.description) ? String(object.description) : "",
      members: Array.isArray(object === null || object === void 0 ? void 0 : object.members) ? object.members.map(e => bytesFromBase64(e)) : [],
      permissions: Array.isArray(object === null || object === void 0 ? void 0 : object.permissions) ? object.permissions.map(e => Any.fromJSON(e)) : [],
      voteThreshold: isSet(object.voteThreshold) ? String(object.voteThreshold) : "",
      proposalDuration: isSet(object.proposalDuration) ? Duration.fromJSON(object.proposalDuration) : undefined,
      tallyOption: isSet(object.tallyOption) ? tallyOptionFromJSON(object.tallyOption) : 0
    };
  },
  toJSON(message) {
    const obj = {};
    message.id !== undefined && (obj.id = (message.id || Long.UZERO).toString());
    message.description !== undefined && (obj.description = message.description);
    if (message.members) {
      obj.members = message.members.map(e => base64FromBytes(e !== undefined ? e : new Uint8Array()));
    } else {
      obj.members = [];
    }
    if (message.permissions) {
      obj.permissions = message.permissions.map(e => e ? Any.toJSON(e) : undefined);
    } else {
      obj.permissions = [];
    }
    message.voteThreshold !== undefined && (obj.voteThreshold = message.voteThreshold);
    message.proposalDuration !== undefined && (obj.proposalDuration = message.proposalDuration ? Duration.toJSON(message.proposalDuration) : undefined);
    message.tallyOption !== undefined && (obj.tallyOption = tallyOptionToJSON(message.tallyOption));
    return obj;
  },
  fromPartial(object) {
    var _object$description, _object$members, _object$permissions, _object$voteThreshold, _object$tallyOption;
    const message = createBaseBaseCommittee();
    message.id = object.id !== undefined && object.id !== null ? Long.fromValue(object.id) : Long.UZERO;
    message.description = (_object$description = object.description) !== null && _object$description !== void 0 ? _object$description : "";
    message.members = ((_object$members = object.members) === null || _object$members === void 0 ? void 0 : _object$members.map(e => e)) || [];
    message.permissions = ((_object$permissions = object.permissions) === null || _object$permissions === void 0 ? void 0 : _object$permissions.map(e => Any.fromPartial(e))) || [];
    message.voteThreshold = (_object$voteThreshold = object.voteThreshold) !== null && _object$voteThreshold !== void 0 ? _object$voteThreshold : "";
    message.proposalDuration = object.proposalDuration !== undefined && object.proposalDuration !== null ? Duration.fromPartial(object.proposalDuration) : undefined;
    message.tallyOption = (_object$tallyOption = object.tallyOption) !== null && _object$tallyOption !== void 0 ? _object$tallyOption : 0;
    return message;
  }
};
function createBaseMemberCommittee() {
  return {
    baseCommittee: undefined
  };
}
export const MemberCommittee = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseCommittee !== undefined) {
      BaseCommittee.encode(message.baseCommittee, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMemberCommittee();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseCommittee = BaseCommittee.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseCommittee: isSet(object.baseCommittee) ? BaseCommittee.fromJSON(object.baseCommittee) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseCommittee !== undefined && (obj.baseCommittee = message.baseCommittee ? BaseCommittee.toJSON(message.baseCommittee) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseMemberCommittee();
    message.baseCommittee = object.baseCommittee !== undefined && object.baseCommittee !== null ? BaseCommittee.fromPartial(object.baseCommittee) : undefined;
    return message;
  }
};
function createBaseTokenCommittee() {
  return {
    baseCommittee: undefined,
    quorum: "",
    tallyDenom: ""
  };
}
export const TokenCommittee = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseCommittee !== undefined) {
      BaseCommittee.encode(message.baseCommittee, writer.uint32(10).fork()).ldelim();
    }
    if (message.quorum !== "") {
      writer.uint32(18).string(message.quorum);
    }
    if (message.tallyDenom !== "") {
      writer.uint32(26).string(message.tallyDenom);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseTokenCommittee();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseCommittee = BaseCommittee.decode(reader, reader.uint32());
          break;
        case 2:
          message.quorum = reader.string();
          break;
        case 3:
          message.tallyDenom = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseCommittee: isSet(object.baseCommittee) ? BaseCommittee.fromJSON(object.baseCommittee) : undefined,
      quorum: isSet(object.quorum) ? String(object.quorum) : "",
      tallyDenom: isSet(object.tallyDenom) ? String(object.tallyDenom) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseCommittee !== undefined && (obj.baseCommittee = message.baseCommittee ? BaseCommittee.toJSON(message.baseCommittee) : undefined);
    message.quorum !== undefined && (obj.quorum = message.quorum);
    message.tallyDenom !== undefined && (obj.tallyDenom = message.tallyDenom);
    return obj;
  },
  fromPartial(object) {
    var _object$quorum, _object$tallyDenom;
    const message = createBaseTokenCommittee();
    message.baseCommittee = object.baseCommittee !== undefined && object.baseCommittee !== null ? BaseCommittee.fromPartial(object.baseCommittee) : undefined;
    message.quorum = (_object$quorum = object.quorum) !== null && _object$quorum !== void 0 ? _object$quorum : "";
    message.tallyDenom = (_object$tallyDenom = object.tallyDenom) !== null && _object$tallyDenom !== void 0 ? _object$tallyDenom : "";
    return message;
  }
};