import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** GodPermission allows any governance proposal. It is used mainly for testing. */

function createBaseGodPermission() {
  return {};
}
export const GodPermission = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGodPermission();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseGodPermission();
    return message;
  }
};
function createBaseSoftwareUpgradePermission() {
  return {};
}
export const SoftwareUpgradePermission = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSoftwareUpgradePermission();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseSoftwareUpgradePermission();
    return message;
  }
};
function createBaseTextPermission() {
  return {};
}
export const TextPermission = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseTextPermission();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseTextPermission();
    return message;
  }
};
function createBaseParamsChangePermission() {
  return {
    allowedParamsChanges: []
  };
}
export const ParamsChangePermission = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.allowedParamsChanges) {
      AllowedParamsChange.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParamsChangePermission();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.allowedParamsChanges.push(AllowedParamsChange.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      allowedParamsChanges: Array.isArray(object === null || object === void 0 ? void 0 : object.allowedParamsChanges) ? object.allowedParamsChanges.map(e => AllowedParamsChange.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.allowedParamsChanges) {
      obj.allowedParamsChanges = message.allowedParamsChanges.map(e => e ? AllowedParamsChange.toJSON(e) : undefined);
    } else {
      obj.allowedParamsChanges = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$allowedParams;
    const message = createBaseParamsChangePermission();
    message.allowedParamsChanges = ((_object$allowedParams = object.allowedParamsChanges) === null || _object$allowedParams === void 0 ? void 0 : _object$allowedParams.map(e => AllowedParamsChange.fromPartial(e))) || [];
    return message;
  }
};
function createBaseAllowedParamsChange() {
  return {
    subspace: "",
    key: "",
    singleSubparamAllowedAttrs: [],
    multiSubparamsRequirements: []
  };
}
export const AllowedParamsChange = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.subspace !== "") {
      writer.uint32(10).string(message.subspace);
    }
    if (message.key !== "") {
      writer.uint32(18).string(message.key);
    }
    for (const v of message.singleSubparamAllowedAttrs) {
      writer.uint32(26).string(v);
    }
    for (const v of message.multiSubparamsRequirements) {
      SubparamRequirement.encode(v, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAllowedParamsChange();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.subspace = reader.string();
          break;
        case 2:
          message.key = reader.string();
          break;
        case 3:
          message.singleSubparamAllowedAttrs.push(reader.string());
          break;
        case 4:
          message.multiSubparamsRequirements.push(SubparamRequirement.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      subspace: isSet(object.subspace) ? String(object.subspace) : "",
      key: isSet(object.key) ? String(object.key) : "",
      singleSubparamAllowedAttrs: Array.isArray(object === null || object === void 0 ? void 0 : object.singleSubparamAllowedAttrs) ? object.singleSubparamAllowedAttrs.map(e => String(e)) : [],
      multiSubparamsRequirements: Array.isArray(object === null || object === void 0 ? void 0 : object.multiSubparamsRequirements) ? object.multiSubparamsRequirements.map(e => SubparamRequirement.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.subspace !== undefined && (obj.subspace = message.subspace);
    message.key !== undefined && (obj.key = message.key);
    if (message.singleSubparamAllowedAttrs) {
      obj.singleSubparamAllowedAttrs = message.singleSubparamAllowedAttrs.map(e => e);
    } else {
      obj.singleSubparamAllowedAttrs = [];
    }
    if (message.multiSubparamsRequirements) {
      obj.multiSubparamsRequirements = message.multiSubparamsRequirements.map(e => e ? SubparamRequirement.toJSON(e) : undefined);
    } else {
      obj.multiSubparamsRequirements = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$subspace, _object$key, _object$singleSubpara, _object$multiSubparam;
    const message = createBaseAllowedParamsChange();
    message.subspace = (_object$subspace = object.subspace) !== null && _object$subspace !== void 0 ? _object$subspace : "";
    message.key = (_object$key = object.key) !== null && _object$key !== void 0 ? _object$key : "";
    message.singleSubparamAllowedAttrs = ((_object$singleSubpara = object.singleSubparamAllowedAttrs) === null || _object$singleSubpara === void 0 ? void 0 : _object$singleSubpara.map(e => e)) || [];
    message.multiSubparamsRequirements = ((_object$multiSubparam = object.multiSubparamsRequirements) === null || _object$multiSubparam === void 0 ? void 0 : _object$multiSubparam.map(e => SubparamRequirement.fromPartial(e))) || [];
    return message;
  }
};
function createBaseSubparamRequirement() {
  return {
    key: "",
    val: "",
    allowedSubparamAttrChanges: []
  };
}
export const SubparamRequirement = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.key !== "") {
      writer.uint32(10).string(message.key);
    }
    if (message.val !== "") {
      writer.uint32(18).string(message.val);
    }
    for (const v of message.allowedSubparamAttrChanges) {
      writer.uint32(26).string(v);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSubparamRequirement();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.key = reader.string();
          break;
        case 2:
          message.val = reader.string();
          break;
        case 3:
          message.allowedSubparamAttrChanges.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      key: isSet(object.key) ? String(object.key) : "",
      val: isSet(object.val) ? String(object.val) : "",
      allowedSubparamAttrChanges: Array.isArray(object === null || object === void 0 ? void 0 : object.allowedSubparamAttrChanges) ? object.allowedSubparamAttrChanges.map(e => String(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.key !== undefined && (obj.key = message.key);
    message.val !== undefined && (obj.val = message.val);
    if (message.allowedSubparamAttrChanges) {
      obj.allowedSubparamAttrChanges = message.allowedSubparamAttrChanges.map(e => e);
    } else {
      obj.allowedSubparamAttrChanges = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$key2, _object$val, _object$allowedSubpar;
    const message = createBaseSubparamRequirement();
    message.key = (_object$key2 = object.key) !== null && _object$key2 !== void 0 ? _object$key2 : "";
    message.val = (_object$val = object.val) !== null && _object$val !== void 0 ? _object$val : "";
    message.allowedSubparamAttrChanges = ((_object$allowedSubpar = object.allowedSubparamAttrChanges) === null || _object$allowedSubpar === void 0 ? void 0 : _object$allowedSubpar.map(e => e)) || [];
    return message;
  }
};