import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryCommitteesRequest, QueryCommitteesResponse, QueryCommitteeRequest, QueryCommitteeResponse, QueryProposalsRequest, QueryProposalsResponse, QueryProposalRequest, QueryProposalResponse, QueryNextProposalIDRequest, QueryNextProposalIDResponse, QueryVotesRequest, QueryVotesResponse, QueryVoteRequest, QueryVoteResponse, QueryTallyRequest, QueryTallyResponse, QueryRawParamsRequest, QueryRawParamsResponse } from "./query";
/** Query defines the gRPC querier service for committee module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.committees = this.committees.bind(this);
    this.committee = this.committee.bind(this);
    this.proposals = this.proposals.bind(this);
    this.proposal = this.proposal.bind(this);
    this.nextProposalID = this.nextProposalID.bind(this);
    this.votes = this.votes.bind(this);
    this.vote = this.vote.bind(this);
    this.tally = this.tally.bind(this);
    this.rawParams = this.rawParams.bind(this);
  }
  committees(request = {}) {
    const data = QueryCommitteesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Committees", data);
    return promise.then(data => QueryCommitteesResponse.decode(new _m0.Reader(data)));
  }
  committee(request) {
    const data = QueryCommitteeRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Committee", data);
    return promise.then(data => QueryCommitteeResponse.decode(new _m0.Reader(data)));
  }
  proposals(request) {
    const data = QueryProposalsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Proposals", data);
    return promise.then(data => QueryProposalsResponse.decode(new _m0.Reader(data)));
  }
  proposal(request) {
    const data = QueryProposalRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Proposal", data);
    return promise.then(data => QueryProposalResponse.decode(new _m0.Reader(data)));
  }
  nextProposalID(request = {}) {
    const data = QueryNextProposalIDRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "NextProposalID", data);
    return promise.then(data => QueryNextProposalIDResponse.decode(new _m0.Reader(data)));
  }
  votes(request) {
    const data = QueryVotesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Votes", data);
    return promise.then(data => QueryVotesResponse.decode(new _m0.Reader(data)));
  }
  vote(request) {
    const data = QueryVoteRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Vote", data);
    return promise.then(data => QueryVoteResponse.decode(new _m0.Reader(data)));
  }
  tally(request) {
    const data = QueryTallyRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "Tally", data);
    return promise.then(data => QueryTallyResponse.decode(new _m0.Reader(data)));
  }
  rawParams(request) {
    const data = QueryRawParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.committee.v1beta1.Query", "RawParams", data);
    return promise.then(data => QueryRawParamsResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    committees(request) {
      return queryService.committees(request);
    },
    committee(request) {
      return queryService.committee(request);
    },
    proposals(request) {
      return queryService.proposals(request);
    },
    proposal(request) {
      return queryService.proposal(request);
    },
    nextProposalID(request) {
      return queryService.nextProposalID(request);
    },
    votes(request) {
      return queryService.votes(request);
    },
    vote(request) {
      return queryService.vote(request);
    },
    tally(request) {
      return queryService.tally(request);
    },
    rawParams(request) {
      return queryService.rawParams(request);
    }
  };
};