//@ts-nocheck
import { voteTypeFromJSON } from "./genesis";
import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.committee.v1beta1.MsgSubmitProposal": {
    aminoType: "/kava.committee.v1beta1.MsgSubmitProposal",
    toAmino: ({
      pubProposal,
      proposer,
      committeeId
    }) => {
      return {
        pub_proposal: {
          type_url: pubProposal.typeUrl,
          value: pubProposal.value
        },
        proposer,
        committee_id: committeeId.toString()
      };
    },
    fromAmino: ({
      pub_proposal,
      proposer,
      committee_id
    }) => {
      return {
        pubProposal: {
          typeUrl: pub_proposal.type_url,
          value: pub_proposal.value
        },
        proposer,
        committeeId: Long.fromString(committee_id)
      };
    }
  },
  "/kava.committee.v1beta1.MsgVote": {
    aminoType: "/kava.committee.v1beta1.MsgVote",
    toAmino: ({
      proposalId,
      voter,
      voteType
    }) => {
      return {
        proposal_id: proposalId.toString(),
        voter,
        vote_type: voteType
      };
    },
    fromAmino: ({
      proposal_id,
      voter,
      vote_type
    }) => {
      return {
        proposalId: Long.fromString(proposal_id),
        voter,
        voteType: voteTypeFromJSON(vote_type)
      };
    }
  }
};