import { MsgSubmitProposal, MsgVote } from "./tx";
export const registry = [["/kava.committee.v1beta1.MsgSubmitProposal", MsgSubmitProposal], ["/kava.committee.v1beta1.MsgVote", MsgVote]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    submitProposal(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgSubmitProposal",
        value: MsgSubmitProposal.encode(value).finish()
      };
    },
    vote(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgVote",
        value: MsgVote.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    submitProposal(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgSubmitProposal",
        value
      };
    },
    vote(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgVote",
        value
      };
    }
  },
  toJSON: {
    submitProposal(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgSubmitProposal",
        value: MsgSubmitProposal.toJSON(value)
      };
    },
    vote(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgVote",
        value: MsgVote.toJSON(value)
      };
    }
  },
  fromJSON: {
    submitProposal(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgSubmitProposal",
        value: MsgSubmitProposal.fromJSON(value)
      };
    },
    vote(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgVote",
        value: MsgVote.fromJSON(value)
      };
    }
  },
  fromPartial: {
    submitProposal(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgSubmitProposal",
        value: MsgSubmitProposal.fromPartial(value)
      };
    },
    vote(value) {
      return {
        typeUrl: "/kava.committee.v1beta1.MsgVote",
        value: MsgVote.fromPartial(value)
      };
    }
  }
};