import { Params } from "./params";
import { VaultRecord, VaultShareRecord } from "./vault";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** GenesisState defines the earn module's genesis state. */

function createBaseGenesisState() {
  return {
    params: undefined,
    vaultRecords: [],
    vaultShareRecords: []
  };
}
export const GenesisState = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.vaultRecords) {
      VaultRecord.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.vaultShareRecords) {
      VaultShareRecord.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.vaultRecords.push(VaultRecord.decode(reader, reader.uint32()));
          break;
        case 3:
          message.vaultShareRecords.push(VaultShareRecord.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      vaultRecords: Array.isArray(object === null || object === void 0 ? void 0 : object.vaultRecords) ? object.vaultRecords.map(e => VaultRecord.fromJSON(e)) : [],
      vaultShareRecords: Array.isArray(object === null || object === void 0 ? void 0 : object.vaultShareRecords) ? object.vaultShareRecords.map(e => VaultShareRecord.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    if (message.vaultRecords) {
      obj.vaultRecords = message.vaultRecords.map(e => e ? VaultRecord.toJSON(e) : undefined);
    } else {
      obj.vaultRecords = [];
    }
    if (message.vaultShareRecords) {
      obj.vaultShareRecords = message.vaultShareRecords.map(e => e ? VaultShareRecord.toJSON(e) : undefined);
    } else {
      obj.vaultShareRecords = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$vaultRecords, _object$vaultShareRec;
    const message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    message.vaultRecords = ((_object$vaultRecords = object.vaultRecords) === null || _object$vaultRecords === void 0 ? void 0 : _object$vaultRecords.map(e => VaultRecord.fromPartial(e))) || [];
    message.vaultShareRecords = ((_object$vaultShareRec = object.vaultShareRecords) === null || _object$vaultShareRec === void 0 ? void 0 : _object$vaultShareRec.map(e => VaultShareRecord.fromPartial(e))) || [];
    return message;
  }
};