import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Params } from "./params";
import { strategyTypeFromJSON, strategyTypeToJSON } from "./strategy";
import { VaultShare } from "./vault";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** QueryParamsRequest defines the request type for querying x/earn parameters. */

function createBaseQueryParamsRequest() {
  return {};
}
export const QueryParamsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryParamsRequest();
    return message;
  }
};
function createBaseQueryParamsResponse() {
  return {
    params: undefined
  };
}
export const QueryParamsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryParamsResponse();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    return message;
  }
};
function createBaseQueryVaultsRequest() {
  return {};
}
export const QueryVaultsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryVaultsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryVaultsRequest();
    return message;
  }
};
function createBaseQueryVaultsResponse() {
  return {
    vaults: []
  };
}
export const QueryVaultsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.vaults) {
      VaultResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryVaultsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.vaults.push(VaultResponse.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      vaults: Array.isArray(object === null || object === void 0 ? void 0 : object.vaults) ? object.vaults.map(e => VaultResponse.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.vaults) {
      obj.vaults = message.vaults.map(e => e ? VaultResponse.toJSON(e) : undefined);
    } else {
      obj.vaults = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$vaults;
    const message = createBaseQueryVaultsResponse();
    message.vaults = ((_object$vaults = object.vaults) === null || _object$vaults === void 0 ? void 0 : _object$vaults.map(e => VaultResponse.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryVaultRequest() {
  return {
    denom: ""
  };
}
export const QueryVaultRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryVaultRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    return obj;
  },
  fromPartial(object) {
    var _object$denom;
    const message = createBaseQueryVaultRequest();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    return message;
  }
};
function createBaseQueryVaultResponse() {
  return {
    vault: undefined
  };
}
export const QueryVaultResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.vault !== undefined) {
      VaultResponse.encode(message.vault, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryVaultResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.vault = VaultResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      vault: isSet(object.vault) ? VaultResponse.fromJSON(object.vault) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.vault !== undefined && (obj.vault = message.vault ? VaultResponse.toJSON(message.vault) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryVaultResponse();
    message.vault = object.vault !== undefined && object.vault !== null ? VaultResponse.fromPartial(object.vault) : undefined;
    return message;
  }
};
function createBaseVaultResponse() {
  return {
    denom: "",
    strategies: [],
    isPrivateVault: false,
    allowedDepositors: [],
    totalShares: "",
    totalValue: ""
  };
}
export const VaultResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    writer.uint32(18).fork();
    for (const v of message.strategies) {
      writer.int32(v);
    }
    writer.ldelim();
    if (message.isPrivateVault === true) {
      writer.uint32(24).bool(message.isPrivateVault);
    }
    for (const v of message.allowedDepositors) {
      writer.uint32(34).string(v);
    }
    if (message.totalShares !== "") {
      writer.uint32(42).string(message.totalShares);
    }
    if (message.totalValue !== "") {
      writer.uint32(50).string(message.totalValue);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVaultResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          if ((tag & 7) === 2) {
            const end2 = reader.uint32() + reader.pos;
            while (reader.pos < end2) {
              message.strategies.push(reader.int32());
            }
          } else {
            message.strategies.push(reader.int32());
          }
          break;
        case 3:
          message.isPrivateVault = reader.bool();
          break;
        case 4:
          message.allowedDepositors.push(reader.string());
          break;
        case 5:
          message.totalShares = reader.string();
          break;
        case 6:
          message.totalValue = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      strategies: Array.isArray(object === null || object === void 0 ? void 0 : object.strategies) ? object.strategies.map(e => strategyTypeFromJSON(e)) : [],
      isPrivateVault: isSet(object.isPrivateVault) ? Boolean(object.isPrivateVault) : false,
      allowedDepositors: Array.isArray(object === null || object === void 0 ? void 0 : object.allowedDepositors) ? object.allowedDepositors.map(e => String(e)) : [],
      totalShares: isSet(object.totalShares) ? String(object.totalShares) : "",
      totalValue: isSet(object.totalValue) ? String(object.totalValue) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    if (message.strategies) {
      obj.strategies = message.strategies.map(e => strategyTypeToJSON(e));
    } else {
      obj.strategies = [];
    }
    message.isPrivateVault !== undefined && (obj.isPrivateVault = message.isPrivateVault);
    if (message.allowedDepositors) {
      obj.allowedDepositors = message.allowedDepositors.map(e => e);
    } else {
      obj.allowedDepositors = [];
    }
    message.totalShares !== undefined && (obj.totalShares = message.totalShares);
    message.totalValue !== undefined && (obj.totalValue = message.totalValue);
    return obj;
  },
  fromPartial(object) {
    var _object$denom2, _object$strategies, _object$isPrivateVaul, _object$allowedDeposi, _object$totalShares, _object$totalValue;
    const message = createBaseVaultResponse();
    message.denom = (_object$denom2 = object.denom) !== null && _object$denom2 !== void 0 ? _object$denom2 : "";
    message.strategies = ((_object$strategies = object.strategies) === null || _object$strategies === void 0 ? void 0 : _object$strategies.map(e => e)) || [];
    message.isPrivateVault = (_object$isPrivateVaul = object.isPrivateVault) !== null && _object$isPrivateVaul !== void 0 ? _object$isPrivateVaul : false;
    message.allowedDepositors = ((_object$allowedDeposi = object.allowedDepositors) === null || _object$allowedDeposi === void 0 ? void 0 : _object$allowedDeposi.map(e => e)) || [];
    message.totalShares = (_object$totalShares = object.totalShares) !== null && _object$totalShares !== void 0 ? _object$totalShares : "";
    message.totalValue = (_object$totalValue = object.totalValue) !== null && _object$totalValue !== void 0 ? _object$totalValue : "";
    return message;
  }
};
function createBaseQueryDepositsRequest() {
  return {
    depositor: "",
    denom: "",
    valueInStakedTokens: false,
    pagination: undefined
  };
}
export const QueryDepositsRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.denom !== "") {
      writer.uint32(18).string(message.denom);
    }
    if (message.valueInStakedTokens === true) {
      writer.uint32(24).bool(message.valueInStakedTokens);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDepositsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.denom = reader.string();
          break;
        case 3:
          message.valueInStakedTokens = reader.bool();
          break;
        case 4:
          message.pagination = PageRequest.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      denom: isSet(object.denom) ? String(object.denom) : "",
      valueInStakedTokens: isSet(object.valueInStakedTokens) ? Boolean(object.valueInStakedTokens) : false,
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.denom !== undefined && (obj.denom = message.denom);
    message.valueInStakedTokens !== undefined && (obj.valueInStakedTokens = message.valueInStakedTokens);
    message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$depositor, _object$denom3, _object$valueInStaked;
    const message = createBaseQueryDepositsRequest();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.denom = (_object$denom3 = object.denom) !== null && _object$denom3 !== void 0 ? _object$denom3 : "";
    message.valueInStakedTokens = (_object$valueInStaked = object.valueInStakedTokens) !== null && _object$valueInStaked !== void 0 ? _object$valueInStaked : false;
    message.pagination = object.pagination !== undefined && object.pagination !== null ? PageRequest.fromPartial(object.pagination) : undefined;
    return message;
  }
};
function createBaseQueryDepositsResponse() {
  return {
    deposits: [],
    pagination: undefined
  };
}
export const QueryDepositsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.deposits) {
      DepositResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDepositsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.deposits.push(DepositResponse.decode(reader, reader.uint32()));
          break;
        case 2:
          message.pagination = PageResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      deposits: Array.isArray(object === null || object === void 0 ? void 0 : object.deposits) ? object.deposits.map(e => DepositResponse.fromJSON(e)) : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.deposits) {
      obj.deposits = message.deposits.map(e => e ? DepositResponse.toJSON(e) : undefined);
    } else {
      obj.deposits = [];
    }
    message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$deposits;
    const message = createBaseQueryDepositsResponse();
    message.deposits = ((_object$deposits = object.deposits) === null || _object$deposits === void 0 ? void 0 : _object$deposits.map(e => DepositResponse.fromPartial(e))) || [];
    message.pagination = object.pagination !== undefined && object.pagination !== null ? PageResponse.fromPartial(object.pagination) : undefined;
    return message;
  }
};
function createBaseDepositResponse() {
  return {
    depositor: "",
    shares: [],
    value: []
  };
}
export const DepositResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    for (const v of message.shares) {
      VaultShare.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.value) {
      Coin.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDepositResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.shares.push(VaultShare.decode(reader, reader.uint32()));
          break;
        case 3:
          message.value.push(Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      shares: Array.isArray(object === null || object === void 0 ? void 0 : object.shares) ? object.shares.map(e => VaultShare.fromJSON(e)) : [],
      value: Array.isArray(object === null || object === void 0 ? void 0 : object.value) ? object.value.map(e => Coin.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    if (message.shares) {
      obj.shares = message.shares.map(e => e ? VaultShare.toJSON(e) : undefined);
    } else {
      obj.shares = [];
    }
    if (message.value) {
      obj.value = message.value.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.value = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$depositor2, _object$shares, _object$value;
    const message = createBaseDepositResponse();
    message.depositor = (_object$depositor2 = object.depositor) !== null && _object$depositor2 !== void 0 ? _object$depositor2 : "";
    message.shares = ((_object$shares = object.shares) === null || _object$shares === void 0 ? void 0 : _object$shares.map(e => VaultShare.fromPartial(e))) || [];
    message.value = ((_object$value = object.value) === null || _object$value === void 0 ? void 0 : _object$value.map(e => Coin.fromPartial(e))) || [];
    return message;
  }
};