import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryParamsRequest, QueryParamsResponse, QueryVaultsRequest, QueryVaultsResponse, QueryVaultRequest, QueryVaultResponse, QueryDepositsRequest, QueryDepositsResponse } from "./query";
/** Query defines the gRPC querier service for earn module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.vaults = this.vaults.bind(this);
    this.vault = this.vault.bind(this);
    this.deposits = this.deposits.bind(this);
  }
  params(request = {}) {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.earn.v1beta1.Query", "Params", data);
    return promise.then(data => QueryParamsResponse.decode(new _m0.Reader(data)));
  }
  vaults(request = {}) {
    const data = QueryVaultsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.earn.v1beta1.Query", "Vaults", data);
    return promise.then(data => QueryVaultsResponse.decode(new _m0.Reader(data)));
  }
  vault(request) {
    const data = QueryVaultRequest.encode(request).finish();
    const promise = this.rpc.request("kava.earn.v1beta1.Query", "Vault", data);
    return promise.then(data => QueryVaultResponse.decode(new _m0.Reader(data)));
  }
  deposits(request) {
    const data = QueryDepositsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.earn.v1beta1.Query", "Deposits", data);
    return promise.then(data => QueryDepositsResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    params(request) {
      return queryService.params(request);
    },
    vaults(request) {
      return queryService.vaults(request);
    },
    vault(request) {
      return queryService.vault(request);
    },
    deposits(request) {
      return queryService.deposits(request);
    }
  };
};