//@ts-nocheck
import { strategyTypeFromJSON } from "./strategy";
import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.earn.v1beta1.MsgDeposit": {
    aminoType: "/kava.earn.v1beta1.MsgDeposit",
    toAmino: ({
      depositor,
      amount,
      strategy
    }) => {
      return {
        depositor,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        },
        strategy
      };
    },
    fromAmino: ({
      depositor,
      amount,
      strategy
    }) => {
      return {
        depositor,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        },
        strategy: strategyTypeFromJSON(strategy)
      };
    }
  },
  "/kava.earn.v1beta1.MsgWithdraw": {
    aminoType: "/kava.earn.v1beta1.MsgWithdraw",
    toAmino: ({
      from,
      amount,
      strategy
    }) => {
      return {
        from,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        },
        strategy
      };
    },
    fromAmino: ({
      from,
      amount,
      strategy
    }) => {
      return {
        from,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        },
        strategy: strategyTypeFromJSON(strategy)
      };
    }
  }
};