import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { strategyTypeFromJSON, strategyTypeToJSON } from "./strategy";
import { VaultShare } from "./vault";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** MsgDeposit represents a message for depositing assedts into a vault */

function createBaseMsgDeposit() {
  return {
    depositor: "",
    amount: undefined,
    strategy: 0
  };
}
export const MsgDeposit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.amount !== undefined) {
      Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
    }
    if (message.strategy !== 0) {
      writer.uint32(24).int32(message.strategy);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDeposit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.amount = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.strategy = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      amount: isSet(object.amount) ? Coin.fromJSON(object.amount) : undefined,
      strategy: isSet(object.strategy) ? strategyTypeFromJSON(object.strategy) : 0
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.amount !== undefined && (obj.amount = message.amount ? Coin.toJSON(message.amount) : undefined);
    message.strategy !== undefined && (obj.strategy = strategyTypeToJSON(message.strategy));
    return obj;
  },
  fromPartial(object) {
    var _object$depositor, _object$strategy;
    const message = createBaseMsgDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.amount = object.amount !== undefined && object.amount !== null ? Coin.fromPartial(object.amount) : undefined;
    message.strategy = (_object$strategy = object.strategy) !== null && _object$strategy !== void 0 ? _object$strategy : 0;
    return message;
  }
};
function createBaseMsgDepositResponse() {
  return {
    shares: undefined
  };
}
export const MsgDepositResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.shares !== undefined) {
      VaultShare.encode(message.shares, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDepositResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.shares = VaultShare.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      shares: isSet(object.shares) ? VaultShare.fromJSON(object.shares) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.shares !== undefined && (obj.shares = message.shares ? VaultShare.toJSON(message.shares) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseMsgDepositResponse();
    message.shares = object.shares !== undefined && object.shares !== null ? VaultShare.fromPartial(object.shares) : undefined;
    return message;
  }
};
function createBaseMsgWithdraw() {
  return {
    from: "",
    amount: undefined,
    strategy: 0
  };
}
export const MsgWithdraw = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.amount !== undefined) {
      Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
    }
    if (message.strategy !== 0) {
      writer.uint32(24).int32(message.strategy);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgWithdraw();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.amount = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.strategy = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      from: isSet(object.from) ? String(object.from) : "",
      amount: isSet(object.amount) ? Coin.fromJSON(object.amount) : undefined,
      strategy: isSet(object.strategy) ? strategyTypeFromJSON(object.strategy) : 0
    };
  },
  toJSON(message) {
    const obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.amount !== undefined && (obj.amount = message.amount ? Coin.toJSON(message.amount) : undefined);
    message.strategy !== undefined && (obj.strategy = strategyTypeToJSON(message.strategy));
    return obj;
  },
  fromPartial(object) {
    var _object$from, _object$strategy2;
    const message = createBaseMsgWithdraw();
    message.from = (_object$from = object.from) !== null && _object$from !== void 0 ? _object$from : "";
    message.amount = object.amount !== undefined && object.amount !== null ? Coin.fromPartial(object.amount) : undefined;
    message.strategy = (_object$strategy2 = object.strategy) !== null && _object$strategy2 !== void 0 ? _object$strategy2 : 0;
    return message;
  }
};
function createBaseMsgWithdrawResponse() {
  return {
    shares: undefined
  };
}
export const MsgWithdrawResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.shares !== undefined) {
      VaultShare.encode(message.shares, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgWithdrawResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.shares = VaultShare.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      shares: isSet(object.shares) ? VaultShare.fromJSON(object.shares) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.shares !== undefined && (obj.shares = message.shares ? VaultShare.toJSON(message.shares) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseMsgWithdrawResponse();
    message.shares = object.shares !== undefined && object.shares !== null ? VaultShare.fromPartial(object.shares) : undefined;
    return message;
  }
};