import { MsgDeposit, MsgWithdraw } from "./tx";
export const registry = [["/kava.earn.v1beta1.MsgDeposit", MsgDeposit], ["/kava.earn.v1beta1.MsgWithdraw", MsgWithdraw]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    deposit(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgDeposit",
        value: MsgDeposit.encode(value).finish()
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgWithdraw",
        value: MsgWithdraw.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    deposit(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgDeposit",
        value
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgWithdraw",
        value
      };
    }
  },
  toJSON: {
    deposit(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgDeposit",
        value: MsgDeposit.toJSON(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgWithdraw",
        value: MsgWithdraw.toJSON(value)
      };
    }
  },
  fromJSON: {
    deposit(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgDeposit",
        value: MsgDeposit.fromJSON(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgWithdraw",
        value: MsgWithdraw.fromJSON(value)
      };
    }
  },
  fromPartial: {
    deposit(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgDeposit",
        value: MsgDeposit.fromPartial(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.earn.v1beta1.MsgWithdraw",
        value: MsgWithdraw.fromPartial(value)
      };
    }
  }
};