import * as _m0 from "protobufjs/minimal";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
/**
 * ConversionPair defines a Kava ERC20 address and corresponding denom that is
 * allowed to be converted between ERC20 and sdk.Coin
 */

function createBaseConversionPair() {
  return {
    kavaErc20Address: new Uint8Array(),
    denom: ""
  };
}
export const ConversionPair = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.kavaErc20Address.length !== 0) {
      writer.uint32(10).bytes(message.kavaErc20Address);
    }
    if (message.denom !== "") {
      writer.uint32(18).string(message.denom);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseConversionPair();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.kavaErc20Address = reader.bytes();
          break;
        case 2:
          message.denom = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      kavaErc20Address: isSet(object.kavaErc20Address) ? bytesFromBase64(object.kavaErc20Address) : new Uint8Array(),
      denom: isSet(object.denom) ? String(object.denom) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.kavaErc20Address !== undefined && (obj.kavaErc20Address = base64FromBytes(message.kavaErc20Address !== undefined ? message.kavaErc20Address : new Uint8Array()));
    message.denom !== undefined && (obj.denom = message.denom);
    return obj;
  },
  fromPartial(object) {
    var _object$kavaErc20Addr, _object$denom;
    const message = createBaseConversionPair();
    message.kavaErc20Address = (_object$kavaErc20Addr = object.kavaErc20Address) !== null && _object$kavaErc20Addr !== void 0 ? _object$kavaErc20Addr : new Uint8Array();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    return message;
  }
};