//@ts-nocheck

import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.evmutil.v1beta1.MsgConvertCoinToERC20": {
    aminoType: "/kava.evmutil.v1beta1.MsgConvertCoinToERC20",
    toAmino: ({
      initiator,
      receiver,
      amount
    }) => {
      return {
        initiator,
        receiver,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: ({
      initiator,
      receiver,
      amount
    }) => {
      return {
        initiator,
        receiver,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin": {
    aminoType: "/kava.evmutil.v1beta1.MsgConvertERC20ToCoin",
    toAmino: ({
      initiator,
      receiver,
      kavaErc20Address,
      amount
    }) => {
      return {
        initiator,
        receiver,
        kava_erc20_address: kavaErc20Address,
        amount
      };
    },
    fromAmino: ({
      initiator,
      receiver,
      kava_erc20_address,
      amount
    }) => {
      return {
        initiator,
        receiver,
        kavaErc20Address: kava_erc20_address,
        amount
      };
    }
  }
};