import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** MsgConvertCoinToERC20 defines a conversion from sdk.Coin to Kava ERC20. */

function createBaseMsgConvertCoinToERC20() {
  return {
    initiator: "",
    receiver: "",
    amount: undefined
  };
}
export const MsgConvertCoinToERC20 = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.initiator !== "") {
      writer.uint32(10).string(message.initiator);
    }
    if (message.receiver !== "") {
      writer.uint32(18).string(message.receiver);
    }
    if (message.amount !== undefined) {
      Coin.encode(message.amount, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCoinToERC20();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.initiator = reader.string();
          break;
        case 2:
          message.receiver = reader.string();
          break;
        case 3:
          message.amount = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      initiator: isSet(object.initiator) ? String(object.initiator) : "",
      receiver: isSet(object.receiver) ? String(object.receiver) : "",
      amount: isSet(object.amount) ? Coin.fromJSON(object.amount) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.initiator !== undefined && (obj.initiator = message.initiator);
    message.receiver !== undefined && (obj.receiver = message.receiver);
    message.amount !== undefined && (obj.amount = message.amount ? Coin.toJSON(message.amount) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$initiator, _object$receiver;
    const message = createBaseMsgConvertCoinToERC20();
    message.initiator = (_object$initiator = object.initiator) !== null && _object$initiator !== void 0 ? _object$initiator : "";
    message.receiver = (_object$receiver = object.receiver) !== null && _object$receiver !== void 0 ? _object$receiver : "";
    message.amount = object.amount !== undefined && object.amount !== null ? Coin.fromPartial(object.amount) : undefined;
    return message;
  }
};
function createBaseMsgConvertCoinToERC20Response() {
  return {};
}
export const MsgConvertCoinToERC20Response = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCoinToERC20Response();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgConvertCoinToERC20Response();
    return message;
  }
};
function createBaseMsgConvertERC20ToCoin() {
  return {
    initiator: "",
    receiver: "",
    kavaErc20Address: "",
    amount: ""
  };
}
export const MsgConvertERC20ToCoin = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.initiator !== "") {
      writer.uint32(10).string(message.initiator);
    }
    if (message.receiver !== "") {
      writer.uint32(18).string(message.receiver);
    }
    if (message.kavaErc20Address !== "") {
      writer.uint32(26).string(message.kavaErc20Address);
    }
    if (message.amount !== "") {
      writer.uint32(34).string(message.amount);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertERC20ToCoin();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.initiator = reader.string();
          break;
        case 2:
          message.receiver = reader.string();
          break;
        case 3:
          message.kavaErc20Address = reader.string();
          break;
        case 4:
          message.amount = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      initiator: isSet(object.initiator) ? String(object.initiator) : "",
      receiver: isSet(object.receiver) ? String(object.receiver) : "",
      kavaErc20Address: isSet(object.kavaErc20Address) ? String(object.kavaErc20Address) : "",
      amount: isSet(object.amount) ? String(object.amount) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.initiator !== undefined && (obj.initiator = message.initiator);
    message.receiver !== undefined && (obj.receiver = message.receiver);
    message.kavaErc20Address !== undefined && (obj.kavaErc20Address = message.kavaErc20Address);
    message.amount !== undefined && (obj.amount = message.amount);
    return obj;
  },
  fromPartial(object) {
    var _object$initiator2, _object$receiver2, _object$kavaErc20Addr, _object$amount;
    const message = createBaseMsgConvertERC20ToCoin();
    message.initiator = (_object$initiator2 = object.initiator) !== null && _object$initiator2 !== void 0 ? _object$initiator2 : "";
    message.receiver = (_object$receiver2 = object.receiver) !== null && _object$receiver2 !== void 0 ? _object$receiver2 : "";
    message.kavaErc20Address = (_object$kavaErc20Addr = object.kavaErc20Address) !== null && _object$kavaErc20Addr !== void 0 ? _object$kavaErc20Addr : "";
    message.amount = (_object$amount = object.amount) !== null && _object$amount !== void 0 ? _object$amount : "";
    return message;
  }
};
function createBaseMsgConvertERC20ToCoinResponse() {
  return {};
}
export const MsgConvertERC20ToCoinResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertERC20ToCoinResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgConvertERC20ToCoinResponse();
    return message;
  }
};