import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** Params defines the parameters for the hard module. */

function createBaseParams() {
  return {
    moneyMarkets: [],
    minimumBorrowUsdValue: ""
  };
}
export const Params = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.moneyMarkets) {
      MoneyMarket.encode(v, writer.uint32(10).fork()).ldelim();
    }
    if (message.minimumBorrowUsdValue !== "") {
      writer.uint32(18).string(message.minimumBorrowUsdValue);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.moneyMarkets.push(MoneyMarket.decode(reader, reader.uint32()));
          break;
        case 2:
          message.minimumBorrowUsdValue = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      moneyMarkets: Array.isArray(object === null || object === void 0 ? void 0 : object.moneyMarkets) ? object.moneyMarkets.map(e => MoneyMarket.fromJSON(e)) : [],
      minimumBorrowUsdValue: isSet(object.minimumBorrowUsdValue) ? String(object.minimumBorrowUsdValue) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.moneyMarkets) {
      obj.moneyMarkets = message.moneyMarkets.map(e => e ? MoneyMarket.toJSON(e) : undefined);
    } else {
      obj.moneyMarkets = [];
    }
    message.minimumBorrowUsdValue !== undefined && (obj.minimumBorrowUsdValue = message.minimumBorrowUsdValue);
    return obj;
  },
  fromPartial(object) {
    var _object$moneyMarkets, _object$minimumBorrow;
    const message = createBaseParams();
    message.moneyMarkets = ((_object$moneyMarkets = object.moneyMarkets) === null || _object$moneyMarkets === void 0 ? void 0 : _object$moneyMarkets.map(e => MoneyMarket.fromPartial(e))) || [];
    message.minimumBorrowUsdValue = (_object$minimumBorrow = object.minimumBorrowUsdValue) !== null && _object$minimumBorrow !== void 0 ? _object$minimumBorrow : "";
    return message;
  }
};
function createBaseMoneyMarket() {
  return {
    denom: "",
    borrowLimit: undefined,
    spotMarketId: "",
    conversionFactor: "",
    interestRateModel: undefined,
    reserveFactor: "",
    keeperRewardPercentage: ""
  };
}
export const MoneyMarket = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.borrowLimit !== undefined) {
      BorrowLimit.encode(message.borrowLimit, writer.uint32(18).fork()).ldelim();
    }
    if (message.spotMarketId !== "") {
      writer.uint32(26).string(message.spotMarketId);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(34).string(message.conversionFactor);
    }
    if (message.interestRateModel !== undefined) {
      InterestRateModel.encode(message.interestRateModel, writer.uint32(42).fork()).ldelim();
    }
    if (message.reserveFactor !== "") {
      writer.uint32(50).string(message.reserveFactor);
    }
    if (message.keeperRewardPercentage !== "") {
      writer.uint32(58).string(message.keeperRewardPercentage);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMoneyMarket();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.borrowLimit = BorrowLimit.decode(reader, reader.uint32());
          break;
        case 3:
          message.spotMarketId = reader.string();
          break;
        case 4:
          message.conversionFactor = reader.string();
          break;
        case 5:
          message.interestRateModel = InterestRateModel.decode(reader, reader.uint32());
          break;
        case 6:
          message.reserveFactor = reader.string();
          break;
        case 7:
          message.keeperRewardPercentage = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      borrowLimit: isSet(object.borrowLimit) ? BorrowLimit.fromJSON(object.borrowLimit) : undefined,
      spotMarketId: isSet(object.spotMarketId) ? String(object.spotMarketId) : "",
      conversionFactor: isSet(object.conversionFactor) ? String(object.conversionFactor) : "",
      interestRateModel: isSet(object.interestRateModel) ? InterestRateModel.fromJSON(object.interestRateModel) : undefined,
      reserveFactor: isSet(object.reserveFactor) ? String(object.reserveFactor) : "",
      keeperRewardPercentage: isSet(object.keeperRewardPercentage) ? String(object.keeperRewardPercentage) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.borrowLimit !== undefined && (obj.borrowLimit = message.borrowLimit ? BorrowLimit.toJSON(message.borrowLimit) : undefined);
    message.spotMarketId !== undefined && (obj.spotMarketId = message.spotMarketId);
    message.conversionFactor !== undefined && (obj.conversionFactor = message.conversionFactor);
    message.interestRateModel !== undefined && (obj.interestRateModel = message.interestRateModel ? InterestRateModel.toJSON(message.interestRateModel) : undefined);
    message.reserveFactor !== undefined && (obj.reserveFactor = message.reserveFactor);
    message.keeperRewardPercentage !== undefined && (obj.keeperRewardPercentage = message.keeperRewardPercentage);
    return obj;
  },
  fromPartial(object) {
    var _object$denom, _object$spotMarketId, _object$conversionFac, _object$reserveFactor, _object$keeperRewardP;
    const message = createBaseMoneyMarket();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.borrowLimit = object.borrowLimit !== undefined && object.borrowLimit !== null ? BorrowLimit.fromPartial(object.borrowLimit) : undefined;
    message.spotMarketId = (_object$spotMarketId = object.spotMarketId) !== null && _object$spotMarketId !== void 0 ? _object$spotMarketId : "";
    message.conversionFactor = (_object$conversionFac = object.conversionFactor) !== null && _object$conversionFac !== void 0 ? _object$conversionFac : "";
    message.interestRateModel = object.interestRateModel !== undefined && object.interestRateModel !== null ? InterestRateModel.fromPartial(object.interestRateModel) : undefined;
    message.reserveFactor = (_object$reserveFactor = object.reserveFactor) !== null && _object$reserveFactor !== void 0 ? _object$reserveFactor : "";
    message.keeperRewardPercentage = (_object$keeperRewardP = object.keeperRewardPercentage) !== null && _object$keeperRewardP !== void 0 ? _object$keeperRewardP : "";
    return message;
  }
};
function createBaseBorrowLimit() {
  return {
    hasMaxLimit: false,
    maximumLimit: "",
    loanToValue: ""
  };
}
export const BorrowLimit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.hasMaxLimit === true) {
      writer.uint32(8).bool(message.hasMaxLimit);
    }
    if (message.maximumLimit !== "") {
      writer.uint32(18).string(message.maximumLimit);
    }
    if (message.loanToValue !== "") {
      writer.uint32(26).string(message.loanToValue);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrowLimit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.hasMaxLimit = reader.bool();
          break;
        case 2:
          message.maximumLimit = reader.string();
          break;
        case 3:
          message.loanToValue = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      hasMaxLimit: isSet(object.hasMaxLimit) ? Boolean(object.hasMaxLimit) : false,
      maximumLimit: isSet(object.maximumLimit) ? String(object.maximumLimit) : "",
      loanToValue: isSet(object.loanToValue) ? String(object.loanToValue) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.hasMaxLimit !== undefined && (obj.hasMaxLimit = message.hasMaxLimit);
    message.maximumLimit !== undefined && (obj.maximumLimit = message.maximumLimit);
    message.loanToValue !== undefined && (obj.loanToValue = message.loanToValue);
    return obj;
  },
  fromPartial(object) {
    var _object$hasMaxLimit, _object$maximumLimit, _object$loanToValue;
    const message = createBaseBorrowLimit();
    message.hasMaxLimit = (_object$hasMaxLimit = object.hasMaxLimit) !== null && _object$hasMaxLimit !== void 0 ? _object$hasMaxLimit : false;
    message.maximumLimit = (_object$maximumLimit = object.maximumLimit) !== null && _object$maximumLimit !== void 0 ? _object$maximumLimit : "";
    message.loanToValue = (_object$loanToValue = object.loanToValue) !== null && _object$loanToValue !== void 0 ? _object$loanToValue : "";
    return message;
  }
};
function createBaseInterestRateModel() {
  return {
    baseRateApy: "",
    baseMultiplier: "",
    kink: "",
    jumpMultiplier: ""
  };
}
export const InterestRateModel = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseRateApy !== "") {
      writer.uint32(10).string(message.baseRateApy);
    }
    if (message.baseMultiplier !== "") {
      writer.uint32(18).string(message.baseMultiplier);
    }
    if (message.kink !== "") {
      writer.uint32(26).string(message.kink);
    }
    if (message.jumpMultiplier !== "") {
      writer.uint32(34).string(message.jumpMultiplier);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseInterestRateModel();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseRateApy = reader.string();
          break;
        case 2:
          message.baseMultiplier = reader.string();
          break;
        case 3:
          message.kink = reader.string();
          break;
        case 4:
          message.jumpMultiplier = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseRateApy: isSet(object.baseRateApy) ? String(object.baseRateApy) : "",
      baseMultiplier: isSet(object.baseMultiplier) ? String(object.baseMultiplier) : "",
      kink: isSet(object.kink) ? String(object.kink) : "",
      jumpMultiplier: isSet(object.jumpMultiplier) ? String(object.jumpMultiplier) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseRateApy !== undefined && (obj.baseRateApy = message.baseRateApy);
    message.baseMultiplier !== undefined && (obj.baseMultiplier = message.baseMultiplier);
    message.kink !== undefined && (obj.kink = message.kink);
    message.jumpMultiplier !== undefined && (obj.jumpMultiplier = message.jumpMultiplier);
    return obj;
  },
  fromPartial(object) {
    var _object$baseRateApy, _object$baseMultiplie, _object$kink, _object$jumpMultiplie;
    const message = createBaseInterestRateModel();
    message.baseRateApy = (_object$baseRateApy = object.baseRateApy) !== null && _object$baseRateApy !== void 0 ? _object$baseRateApy : "";
    message.baseMultiplier = (_object$baseMultiplie = object.baseMultiplier) !== null && _object$baseMultiplie !== void 0 ? _object$baseMultiplie : "";
    message.kink = (_object$kink = object.kink) !== null && _object$kink !== void 0 ? _object$kink : "";
    message.jumpMultiplier = (_object$jumpMultiplie = object.jumpMultiplier) !== null && _object$jumpMultiplie !== void 0 ? _object$jumpMultiplie : "";
    return message;
  }
};
function createBaseDeposit() {
  return {
    depositor: "",
    amount: [],
    index: []
  };
}
export const Deposit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    for (const v of message.amount) {
      Coin.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.index) {
      SupplyInterestFactor.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDeposit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.amount.push(Coin.decode(reader, reader.uint32()));
          break;
        case 3:
          message.index.push(SupplyInterestFactor.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(e => Coin.fromJSON(e)) : [],
      index: Array.isArray(object === null || object === void 0 ? void 0 : object.index) ? object.index.map(e => SupplyInterestFactor.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    if (message.amount) {
      obj.amount = message.amount.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.amount = [];
    }
    if (message.index) {
      obj.index = message.index.map(e => e ? SupplyInterestFactor.toJSON(e) : undefined);
    } else {
      obj.index = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$depositor, _object$amount, _object$index;
    const message = createBaseDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(e => Coin.fromPartial(e))) || [];
    message.index = ((_object$index = object.index) === null || _object$index === void 0 ? void 0 : _object$index.map(e => SupplyInterestFactor.fromPartial(e))) || [];
    return message;
  }
};
function createBaseBorrow() {
  return {
    borrower: "",
    amount: [],
    index: []
  };
}
export const Borrow = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.borrower !== "") {
      writer.uint32(10).string(message.borrower);
    }
    for (const v of message.amount) {
      Coin.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.index) {
      BorrowInterestFactor.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrow();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.borrower = reader.string();
          break;
        case 2:
          message.amount.push(Coin.decode(reader, reader.uint32()));
          break;
        case 3:
          message.index.push(BorrowInterestFactor.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      borrower: isSet(object.borrower) ? String(object.borrower) : "",
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(e => Coin.fromJSON(e)) : [],
      index: Array.isArray(object === null || object === void 0 ? void 0 : object.index) ? object.index.map(e => BorrowInterestFactor.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.borrower !== undefined && (obj.borrower = message.borrower);
    if (message.amount) {
      obj.amount = message.amount.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.amount = [];
    }
    if (message.index) {
      obj.index = message.index.map(e => e ? BorrowInterestFactor.toJSON(e) : undefined);
    } else {
      obj.index = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$borrower, _object$amount2, _object$index2;
    const message = createBaseBorrow();
    message.borrower = (_object$borrower = object.borrower) !== null && _object$borrower !== void 0 ? _object$borrower : "";
    message.amount = ((_object$amount2 = object.amount) === null || _object$amount2 === void 0 ? void 0 : _object$amount2.map(e => Coin.fromPartial(e))) || [];
    message.index = ((_object$index2 = object.index) === null || _object$index2 === void 0 ? void 0 : _object$index2.map(e => BorrowInterestFactor.fromPartial(e))) || [];
    return message;
  }
};
function createBaseSupplyInterestFactor() {
  return {
    denom: "",
    value: ""
  };
}
export const SupplyInterestFactor = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSupplyInterestFactor();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.value = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      value: isSet(object.value) ? String(object.value) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },
  fromPartial(object) {
    var _object$denom2, _object$value;
    const message = createBaseSupplyInterestFactor();
    message.denom = (_object$denom2 = object.denom) !== null && _object$denom2 !== void 0 ? _object$denom2 : "";
    message.value = (_object$value = object.value) !== null && _object$value !== void 0 ? _object$value : "";
    return message;
  }
};
function createBaseBorrowInterestFactor() {
  return {
    denom: "",
    value: ""
  };
}
export const BorrowInterestFactor = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrowInterestFactor();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.value = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      value: isSet(object.value) ? String(object.value) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },
  fromPartial(object) {
    var _object$denom3, _object$value2;
    const message = createBaseBorrowInterestFactor();
    message.denom = (_object$denom3 = object.denom) !== null && _object$denom3 !== void 0 ? _object$denom3 : "";
    message.value = (_object$value2 = object.value) !== null && _object$value2 !== void 0 ? _object$value2 : "";
    return message;
  }
};
function createBaseCoinsProto() {
  return {
    coins: []
  };
}
export const CoinsProto = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.coins) {
      Coin.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCoinsProto();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.coins.push(Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      coins: Array.isArray(object === null || object === void 0 ? void 0 : object.coins) ? object.coins.map(e => Coin.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.coins) {
      obj.coins = message.coins.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.coins = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$coins;
    const message = createBaseCoinsProto();
    message.coins = ((_object$coins = object.coins) === null || _object$coins === void 0 ? void 0 : _object$coins.map(e => Coin.fromPartial(e))) || [];
    return message;
  }
};