import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryParamsRequest, QueryParamsResponse, QueryAccountsRequest, QueryAccountsResponse, QueryDepositsRequest, QueryDepositsResponse, QueryUnsyncedDepositsRequest, QueryUnsyncedDepositsResponse, QueryTotalDepositedRequest, QueryTotalDepositedResponse, QueryBorrowsRequest, QueryBorrowsResponse, QueryUnsyncedBorrowsRequest, QueryUnsyncedBorrowsResponse, QueryTotalBorrowedRequest, QueryTotalBorrowedResponse, QueryInterestRateRequest, QueryInterestRateResponse, QueryReservesRequest, QueryReservesResponse, QueryInterestFactorsRequest, QueryInterestFactorsResponse } from "./query";
/** Query defines the gRPC querier service for bep3 module. */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.accounts = this.accounts.bind(this);
    this.deposits = this.deposits.bind(this);
    this.unsyncedDeposits = this.unsyncedDeposits.bind(this);
    this.totalDeposited = this.totalDeposited.bind(this);
    this.borrows = this.borrows.bind(this);
    this.unsyncedBorrows = this.unsyncedBorrows.bind(this);
    this.totalBorrowed = this.totalBorrowed.bind(this);
    this.interestRate = this.interestRate.bind(this);
    this.reserves = this.reserves.bind(this);
    this.interestFactors = this.interestFactors.bind(this);
  }
  params(request = {}) {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "Params", data);
    return promise.then(data => QueryParamsResponse.decode(new _m0.Reader(data)));
  }
  accounts(request = {}) {
    const data = QueryAccountsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "Accounts", data);
    return promise.then(data => QueryAccountsResponse.decode(new _m0.Reader(data)));
  }
  deposits(request) {
    const data = QueryDepositsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "Deposits", data);
    return promise.then(data => QueryDepositsResponse.decode(new _m0.Reader(data)));
  }
  unsyncedDeposits(request) {
    const data = QueryUnsyncedDepositsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "UnsyncedDeposits", data);
    return promise.then(data => QueryUnsyncedDepositsResponse.decode(new _m0.Reader(data)));
  }
  totalDeposited(request) {
    const data = QueryTotalDepositedRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "TotalDeposited", data);
    return promise.then(data => QueryTotalDepositedResponse.decode(new _m0.Reader(data)));
  }
  borrows(request) {
    const data = QueryBorrowsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "Borrows", data);
    return promise.then(data => QueryBorrowsResponse.decode(new _m0.Reader(data)));
  }
  unsyncedBorrows(request) {
    const data = QueryUnsyncedBorrowsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "UnsyncedBorrows", data);
    return promise.then(data => QueryUnsyncedBorrowsResponse.decode(new _m0.Reader(data)));
  }
  totalBorrowed(request) {
    const data = QueryTotalBorrowedRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "TotalBorrowed", data);
    return promise.then(data => QueryTotalBorrowedResponse.decode(new _m0.Reader(data)));
  }
  interestRate(request) {
    const data = QueryInterestRateRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "InterestRate", data);
    return promise.then(data => QueryInterestRateResponse.decode(new _m0.Reader(data)));
  }
  reserves(request) {
    const data = QueryReservesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "Reserves", data);
    return promise.then(data => QueryReservesResponse.decode(new _m0.Reader(data)));
  }
  interestFactors(request) {
    const data = QueryInterestFactorsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Query", "InterestFactors", data);
    return promise.then(data => QueryInterestFactorsResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    params(request) {
      return queryService.params(request);
    },
    accounts(request) {
      return queryService.accounts(request);
    },
    deposits(request) {
      return queryService.deposits(request);
    },
    unsyncedDeposits(request) {
      return queryService.unsyncedDeposits(request);
    },
    totalDeposited(request) {
      return queryService.totalDeposited(request);
    },
    borrows(request) {
      return queryService.borrows(request);
    },
    unsyncedBorrows(request) {
      return queryService.unsyncedBorrows(request);
    },
    totalBorrowed(request) {
      return queryService.totalBorrowed(request);
    },
    interestRate(request) {
      return queryService.interestRate(request);
    },
    reserves(request) {
      return queryService.reserves(request);
    },
    interestFactors(request) {
      return queryService.interestFactors(request);
    }
  };
};