//@ts-nocheck

export const AminoConverter = {
  "/kava.hard.v1beta1.MsgDeposit": {
    aminoType: "/kava.hard.v1beta1.MsgDeposit",
    toAmino: ({
      depositor,
      amount
    }) => {
      return {
        depositor,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    },
    fromAmino: ({
      depositor,
      amount
    }) => {
      return {
        depositor,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    }
  },
  "/kava.hard.v1beta1.MsgWithdraw": {
    aminoType: "/kava.hard.v1beta1.MsgWithdraw",
    toAmino: ({
      depositor,
      amount
    }) => {
      return {
        depositor,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    },
    fromAmino: ({
      depositor,
      amount
    }) => {
      return {
        depositor,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    }
  },
  "/kava.hard.v1beta1.MsgBorrow": {
    aminoType: "/kava.hard.v1beta1.MsgBorrow",
    toAmino: ({
      borrower,
      amount
    }) => {
      return {
        borrower,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    },
    fromAmino: ({
      borrower,
      amount
    }) => {
      return {
        borrower,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    }
  },
  "/kava.hard.v1beta1.MsgRepay": {
    aminoType: "/kava.hard.v1beta1.MsgRepay",
    toAmino: ({
      sender,
      owner,
      amount
    }) => {
      return {
        sender,
        owner,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    },
    fromAmino: ({
      sender,
      owner,
      amount
    }) => {
      return {
        sender,
        owner,
        amount: amount.map(el0 => ({
          denom: el0.denom,
          amount: el0.amount
        }))
      };
    }
  },
  "/kava.hard.v1beta1.MsgLiquidate": {
    aminoType: "/kava.hard.v1beta1.MsgLiquidate",
    toAmino: ({
      keeper,
      borrower
    }) => {
      return {
        keeper,
        borrower
      };
    },
    fromAmino: ({
      keeper,
      borrower
    }) => {
      return {
        keeper,
        borrower
      };
    }
  }
};