import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { MsgDeposit, MsgDepositResponse, MsgWithdraw, MsgWithdrawResponse, MsgBorrow, MsgBorrowResponse, MsgRepay, MsgRepayResponse, MsgLiquidate, MsgLiquidateResponse } from "./tx";
/** Msg defines the hard Msg service. */

export class MsgClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.deposit = this.deposit.bind(this);
    this.withdraw = this.withdraw.bind(this);
    this.borrow = this.borrow.bind(this);
    this.repay = this.repay.bind(this);
    this.liquidate = this.liquidate.bind(this);
  }
  deposit(request) {
    const data = MsgDeposit.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Msg", "Deposit", data);
    return promise.then(data => MsgDepositResponse.decode(new _m0.Reader(data)));
  }
  withdraw(request) {
    const data = MsgWithdraw.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Msg", "Withdraw", data);
    return promise.then(data => MsgWithdrawResponse.decode(new _m0.Reader(data)));
  }
  borrow(request) {
    const data = MsgBorrow.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Msg", "Borrow", data);
    return promise.then(data => MsgBorrowResponse.decode(new _m0.Reader(data)));
  }
  repay(request) {
    const data = MsgRepay.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Msg", "Repay", data);
    return promise.then(data => MsgRepayResponse.decode(new _m0.Reader(data)));
  }
  liquidate(request) {
    const data = MsgLiquidate.encode(request).finish();
    const promise = this.rpc.request("kava.hard.v1beta1.Msg", "Liquidate", data);
    return promise.then(data => MsgLiquidateResponse.decode(new _m0.Reader(data)));
  }
}