import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
/** ClaimType is the type of claim */

export let ClaimType;
/** ClaimType is the type of claim */
(function (ClaimType) {
  ClaimType[ClaimType["CLAIM_TYPE_UNSPECIFIED"] = 0] = "CLAIM_TYPE_UNSPECIFIED";
  ClaimType[ClaimType["CLAIM_TYPE_HARD_BORROW"] = 1] = "CLAIM_TYPE_HARD_BORROW";
  ClaimType[ClaimType["CLAIM_TYPE_HARD_SUPPLY"] = 2] = "CLAIM_TYPE_HARD_SUPPLY";
  ClaimType[ClaimType["CLAIM_TYPE_DELEGATOR"] = 3] = "CLAIM_TYPE_DELEGATOR";
  ClaimType[ClaimType["CLAIM_TYPE_EARN"] = 4] = "CLAIM_TYPE_EARN";
  ClaimType[ClaimType["CLAIM_TYPE_SAVINGS"] = 5] = "CLAIM_TYPE_SAVINGS";
  ClaimType[ClaimType["CLAIM_TYPE_SWAP"] = 6] = "CLAIM_TYPE_SWAP";
  ClaimType[ClaimType["CLAIM_TYPE_USDX_MINTING"] = 7] = "CLAIM_TYPE_USDX_MINTING";
  ClaimType[ClaimType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(ClaimType || (ClaimType = {}));
export let ClaimTypeSDKType;
(function (ClaimTypeSDKType) {
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_UNSPECIFIED"] = 0] = "CLAIM_TYPE_UNSPECIFIED";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_HARD_BORROW"] = 1] = "CLAIM_TYPE_HARD_BORROW";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_HARD_SUPPLY"] = 2] = "CLAIM_TYPE_HARD_SUPPLY";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_DELEGATOR"] = 3] = "CLAIM_TYPE_DELEGATOR";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_EARN"] = 4] = "CLAIM_TYPE_EARN";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_SAVINGS"] = 5] = "CLAIM_TYPE_SAVINGS";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_SWAP"] = 6] = "CLAIM_TYPE_SWAP";
  ClaimTypeSDKType[ClaimTypeSDKType["CLAIM_TYPE_USDX_MINTING"] = 7] = "CLAIM_TYPE_USDX_MINTING";
  ClaimTypeSDKType[ClaimTypeSDKType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(ClaimTypeSDKType || (ClaimTypeSDKType = {}));
export function claimTypeFromJSON(object) {
  switch (object) {
    case 0:
    case "CLAIM_TYPE_UNSPECIFIED":
      return ClaimType.CLAIM_TYPE_UNSPECIFIED;
    case 1:
    case "CLAIM_TYPE_HARD_BORROW":
      return ClaimType.CLAIM_TYPE_HARD_BORROW;
    case 2:
    case "CLAIM_TYPE_HARD_SUPPLY":
      return ClaimType.CLAIM_TYPE_HARD_SUPPLY;
    case 3:
    case "CLAIM_TYPE_DELEGATOR":
      return ClaimType.CLAIM_TYPE_DELEGATOR;
    case 4:
    case "CLAIM_TYPE_EARN":
      return ClaimType.CLAIM_TYPE_EARN;
    case 5:
    case "CLAIM_TYPE_SAVINGS":
      return ClaimType.CLAIM_TYPE_SAVINGS;
    case 6:
    case "CLAIM_TYPE_SWAP":
      return ClaimType.CLAIM_TYPE_SWAP;
    case 7:
    case "CLAIM_TYPE_USDX_MINTING":
      return ClaimType.CLAIM_TYPE_USDX_MINTING;
    case -1:
    case "UNRECOGNIZED":
    default:
      return ClaimType.UNRECOGNIZED;
  }
}
export function claimTypeToJSON(object) {
  switch (object) {
    case ClaimType.CLAIM_TYPE_UNSPECIFIED:
      return "CLAIM_TYPE_UNSPECIFIED";
    case ClaimType.CLAIM_TYPE_HARD_BORROW:
      return "CLAIM_TYPE_HARD_BORROW";
    case ClaimType.CLAIM_TYPE_HARD_SUPPLY:
      return "CLAIM_TYPE_HARD_SUPPLY";
    case ClaimType.CLAIM_TYPE_DELEGATOR:
      return "CLAIM_TYPE_DELEGATOR";
    case ClaimType.CLAIM_TYPE_EARN:
      return "CLAIM_TYPE_EARN";
    case ClaimType.CLAIM_TYPE_SAVINGS:
      return "CLAIM_TYPE_SAVINGS";
    case ClaimType.CLAIM_TYPE_SWAP:
      return "CLAIM_TYPE_SWAP";
    case ClaimType.CLAIM_TYPE_USDX_MINTING:
      return "CLAIM_TYPE_USDX_MINTING";
    case ClaimType.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}
/** BaseClaim is a claim with a single reward coin types */

function createBaseBaseClaim() {
  return {
    owner: new Uint8Array(),
    reward: undefined
  };
}
export const BaseClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.owner.length !== 0) {
      writer.uint32(10).bytes(message.owner);
    }
    if (message.reward !== undefined) {
      Coin.encode(message.reward, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.owner = reader.bytes();
          break;
        case 2:
          message.reward = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      owner: isSet(object.owner) ? bytesFromBase64(object.owner) : new Uint8Array(),
      reward: isSet(object.reward) ? Coin.fromJSON(object.reward) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.owner !== undefined && (obj.owner = base64FromBytes(message.owner !== undefined ? message.owner : new Uint8Array()));
    message.reward !== undefined && (obj.reward = message.reward ? Coin.toJSON(message.reward) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$owner;
    const message = createBaseBaseClaim();
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : new Uint8Array();
    message.reward = object.reward !== undefined && object.reward !== null ? Coin.fromPartial(object.reward) : undefined;
    return message;
  }
};
function createBaseBaseMultiClaim() {
  return {
    owner: new Uint8Array(),
    reward: []
  };
}
export const BaseMultiClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.owner.length !== 0) {
      writer.uint32(10).bytes(message.owner);
    }
    for (const v of message.reward) {
      Coin.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseMultiClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.owner = reader.bytes();
          break;
        case 2:
          message.reward.push(Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      owner: isSet(object.owner) ? bytesFromBase64(object.owner) : new Uint8Array(),
      reward: Array.isArray(object === null || object === void 0 ? void 0 : object.reward) ? object.reward.map(e => Coin.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.owner !== undefined && (obj.owner = base64FromBytes(message.owner !== undefined ? message.owner : new Uint8Array()));
    if (message.reward) {
      obj.reward = message.reward.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.reward = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$owner2, _object$reward;
    const message = createBaseBaseMultiClaim();
    message.owner = (_object$owner2 = object.owner) !== null && _object$owner2 !== void 0 ? _object$owner2 : new Uint8Array();
    message.reward = ((_object$reward = object.reward) === null || _object$reward === void 0 ? void 0 : _object$reward.map(e => Coin.fromPartial(e))) || [];
    return message;
  }
};
function createBaseRewardIndex() {
  return {
    collateralType: "",
    rewardFactor: new Uint8Array()
  };
}
export const RewardIndex = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.rewardFactor.length !== 0) {
      writer.uint32(18).bytes(message.rewardFactor);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRewardIndex();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.rewardFactor = reader.bytes();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      rewardFactor: isSet(object.rewardFactor) ? bytesFromBase64(object.rewardFactor) : new Uint8Array()
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.rewardFactor !== undefined && (obj.rewardFactor = base64FromBytes(message.rewardFactor !== undefined ? message.rewardFactor : new Uint8Array()));
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp, _object$rewardFactor;
    const message = createBaseRewardIndex();
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.rewardFactor = (_object$rewardFactor = object.rewardFactor) !== null && _object$rewardFactor !== void 0 ? _object$rewardFactor : new Uint8Array();
    return message;
  }
};
function createBaseRewardIndexesProto() {
  return {
    rewardIndexes: []
  };
}
export const RewardIndexesProto = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.rewardIndexes) {
      RewardIndex.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRewardIndexesProto();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.rewardIndexes.push(RewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => RewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? RewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rewardIndexes;
    const message = createBaseRewardIndexesProto();
    message.rewardIndexes = ((_object$rewardIndexes = object.rewardIndexes) === null || _object$rewardIndexes === void 0 ? void 0 : _object$rewardIndexes.map(e => RewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMultiRewardIndex() {
  return {
    collateralType: "",
    rewardIndexes: []
  };
}
export const MultiRewardIndex = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    for (const v of message.rewardIndexes) {
      RewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiRewardIndex();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.collateralType = reader.string();
          break;
        case 2:
          message.rewardIndexes.push(RewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => RewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? RewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$collateralTyp2, _object$rewardIndexes2;
    const message = createBaseMultiRewardIndex();
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    message.rewardIndexes = ((_object$rewardIndexes2 = object.rewardIndexes) === null || _object$rewardIndexes2 === void 0 ? void 0 : _object$rewardIndexes2.map(e => RewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMultiRewardIndexesProto() {
  return {
    multiRewardIndexes: []
  };
}
export const MultiRewardIndexesProto = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.multiRewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiRewardIndexesProto();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.multiRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      multiRewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.multiRewardIndexes) ? object.multiRewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.multiRewardIndexes) {
      obj.multiRewardIndexes = message.multiRewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.multiRewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$multiRewardIn;
    const message = createBaseMultiRewardIndexesProto();
    message.multiRewardIndexes = ((_object$multiRewardIn = object.multiRewardIndexes) === null || _object$multiRewardIn === void 0 ? void 0 : _object$multiRewardIn.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseUSDXMintingClaim() {
  return {
    baseClaim: undefined,
    rewardIndexes: []
  };
}
export const USDXMintingClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseClaim !== undefined) {
      BaseClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      RewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseUSDXMintingClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseClaim = BaseClaim.decode(reader, reader.uint32());
          break;
        case 2:
          message.rewardIndexes.push(RewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => RewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseClaim !== undefined && (obj.baseClaim = message.baseClaim ? BaseClaim.toJSON(message.baseClaim) : undefined);
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? RewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rewardIndexes3;
    const message = createBaseUSDXMintingClaim();
    message.baseClaim = object.baseClaim !== undefined && object.baseClaim !== null ? BaseClaim.fromPartial(object.baseClaim) : undefined;
    message.rewardIndexes = ((_object$rewardIndexes3 = object.rewardIndexes) === null || _object$rewardIndexes3 === void 0 ? void 0 : _object$rewardIndexes3.map(e => RewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseHardLiquidityProviderClaim() {
  return {
    baseClaim: undefined,
    supplyRewardIndexes: [],
    borrowRewardIndexes: []
  };
}
export const HardLiquidityProviderClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.supplyRewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.borrowRewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseHardLiquidityProviderClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          break;
        case 2:
          message.supplyRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        case 3:
          message.borrowRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      supplyRewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.supplyRewardIndexes) ? object.supplyRewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : [],
      borrowRewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.borrowRewardIndexes) ? object.borrowRewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseClaim !== undefined && (obj.baseClaim = message.baseClaim ? BaseMultiClaim.toJSON(message.baseClaim) : undefined);
    if (message.supplyRewardIndexes) {
      obj.supplyRewardIndexes = message.supplyRewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.supplyRewardIndexes = [];
    }
    if (message.borrowRewardIndexes) {
      obj.borrowRewardIndexes = message.borrowRewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.borrowRewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$supplyRewardI, _object$borrowRewardI;
    const message = createBaseHardLiquidityProviderClaim();
    message.baseClaim = object.baseClaim !== undefined && object.baseClaim !== null ? BaseMultiClaim.fromPartial(object.baseClaim) : undefined;
    message.supplyRewardIndexes = ((_object$supplyRewardI = object.supplyRewardIndexes) === null || _object$supplyRewardI === void 0 ? void 0 : _object$supplyRewardI.map(e => MultiRewardIndex.fromPartial(e))) || [];
    message.borrowRewardIndexes = ((_object$borrowRewardI = object.borrowRewardIndexes) === null || _object$borrowRewardI === void 0 ? void 0 : _object$borrowRewardI.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseDelegatorClaim() {
  return {
    baseClaim: undefined,
    rewardIndexes: []
  };
}
export const DelegatorClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDelegatorClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          break;
        case 2:
          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseClaim !== undefined && (obj.baseClaim = message.baseClaim ? BaseMultiClaim.toJSON(message.baseClaim) : undefined);
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rewardIndexes4;
    const message = createBaseDelegatorClaim();
    message.baseClaim = object.baseClaim !== undefined && object.baseClaim !== null ? BaseMultiClaim.fromPartial(object.baseClaim) : undefined;
    message.rewardIndexes = ((_object$rewardIndexes4 = object.rewardIndexes) === null || _object$rewardIndexes4 === void 0 ? void 0 : _object$rewardIndexes4.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseSwapClaim() {
  return {
    baseClaim: undefined,
    rewardIndexes: []
  };
}
export const SwapClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSwapClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          break;
        case 2:
          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseClaim !== undefined && (obj.baseClaim = message.baseClaim ? BaseMultiClaim.toJSON(message.baseClaim) : undefined);
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rewardIndexes5;
    const message = createBaseSwapClaim();
    message.baseClaim = object.baseClaim !== undefined && object.baseClaim !== null ? BaseMultiClaim.fromPartial(object.baseClaim) : undefined;
    message.rewardIndexes = ((_object$rewardIndexes5 = object.rewardIndexes) === null || _object$rewardIndexes5 === void 0 ? void 0 : _object$rewardIndexes5.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseSavingsClaim() {
  return {
    baseClaim: undefined,
    rewardIndexes: []
  };
}
export const SavingsClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSavingsClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          break;
        case 2:
          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseClaim !== undefined && (obj.baseClaim = message.baseClaim ? BaseMultiClaim.toJSON(message.baseClaim) : undefined);
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rewardIndexes6;
    const message = createBaseSavingsClaim();
    message.baseClaim = object.baseClaim !== undefined && object.baseClaim !== null ? BaseMultiClaim.fromPartial(object.baseClaim) : undefined;
    message.rewardIndexes = ((_object$rewardIndexes6 = object.rewardIndexes) === null || _object$rewardIndexes6 === void 0 ? void 0 : _object$rewardIndexes6.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseEarnClaim() {
  return {
    baseClaim: undefined,
    rewardIndexes: []
  };
}
export const EarnClaim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEarnClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          break;
        case 2:
          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.baseClaim !== undefined && (obj.baseClaim = message.baseClaim ? BaseMultiClaim.toJSON(message.baseClaim) : undefined);
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rewardIndexes7;
    const message = createBaseEarnClaim();
    message.baseClaim = object.baseClaim !== undefined && object.baseClaim !== null ? BaseMultiClaim.fromPartial(object.baseClaim) : undefined;
    message.rewardIndexes = ((_object$rewardIndexes7 = object.rewardIndexes) === null || _object$rewardIndexes7 === void 0 ? void 0 : _object$rewardIndexes7.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};
function createBaseClaim() {
  return {
    type: 0,
    owner: new Uint8Array(),
    reward: [],
    rewardIndexes: []
  };
}
export const Claim = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.type !== 0) {
      writer.uint32(8).int32(message.type);
    }
    if (message.owner.length !== 0) {
      writer.uint32(18).bytes(message.owner);
    }
    for (const v of message.reward) {
      Coin.encode(v, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.type = reader.int32();
          break;
        case 2:
          message.owner = reader.bytes();
          break;
        case 3:
          message.reward.push(Coin.decode(reader, reader.uint32()));
          break;
        case 4:
          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      type: isSet(object.type) ? claimTypeFromJSON(object.type) : 0,
      owner: isSet(object.owner) ? bytesFromBase64(object.owner) : new Uint8Array(),
      reward: Array.isArray(object === null || object === void 0 ? void 0 : object.reward) ? object.reward.map(e => Coin.fromJSON(e)) : [],
      rewardIndexes: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardIndexes) ? object.rewardIndexes.map(e => MultiRewardIndex.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.type !== undefined && (obj.type = claimTypeToJSON(message.type));
    message.owner !== undefined && (obj.owner = base64FromBytes(message.owner !== undefined ? message.owner : new Uint8Array()));
    if (message.reward) {
      obj.reward = message.reward.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.reward = [];
    }
    if (message.rewardIndexes) {
      obj.rewardIndexes = message.rewardIndexes.map(e => e ? MultiRewardIndex.toJSON(e) : undefined);
    } else {
      obj.rewardIndexes = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$type, _object$owner3, _object$reward2, _object$rewardIndexes8;
    const message = createBaseClaim();
    message.type = (_object$type = object.type) !== null && _object$type !== void 0 ? _object$type : 0;
    message.owner = (_object$owner3 = object.owner) !== null && _object$owner3 !== void 0 ? _object$owner3 : new Uint8Array();
    message.reward = ((_object$reward2 = object.reward) === null || _object$reward2 === void 0 ? void 0 : _object$reward2.map(e => Coin.fromPartial(e))) || [];
    message.rewardIndexes = ((_object$rewardIndexes8 = object.rewardIndexes) === null || _object$rewardIndexes8 === void 0 ? void 0 : _object$rewardIndexes8.map(e => MultiRewardIndex.fromPartial(e))) || [];
    return message;
  }
};