import { Timestamp } from "../../../google/protobuf/timestamp";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet, fromJsonTimestamp, fromTimestamp, Long, bytesFromBase64, base64FromBytes } from "../../../helpers";
/** RewardPeriod stores the state of an ongoing reward */

function createBaseRewardPeriod() {
  return {
    active: false,
    collateralType: "",
    start: undefined,
    end: undefined,
    rewardsPerSecond: undefined
  };
}
export const RewardPeriod = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.start !== undefined) {
      Timestamp.encode(message.start, writer.uint32(26).fork()).ldelim();
    }
    if (message.end !== undefined) {
      Timestamp.encode(message.end, writer.uint32(34).fork()).ldelim();
    }
    if (message.rewardsPerSecond !== undefined) {
      Coin.encode(message.rewardsPerSecond, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRewardPeriod();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.start = Timestamp.decode(reader, reader.uint32());
          break;
        case 4:
          message.end = Timestamp.decode(reader, reader.uint32());
          break;
        case 5:
          message.rewardsPerSecond = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      active: isSet(object.active) ? Boolean(object.active) : false,
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      start: isSet(object.start) ? fromJsonTimestamp(object.start) : undefined,
      end: isSet(object.end) ? fromJsonTimestamp(object.end) : undefined,
      rewardsPerSecond: isSet(object.rewardsPerSecond) ? Coin.fromJSON(object.rewardsPerSecond) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.active !== undefined && (obj.active = message.active);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.start !== undefined && (obj.start = fromTimestamp(message.start).toISOString());
    message.end !== undefined && (obj.end = fromTimestamp(message.end).toISOString());
    message.rewardsPerSecond !== undefined && (obj.rewardsPerSecond = message.rewardsPerSecond ? Coin.toJSON(message.rewardsPerSecond) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$active, _object$collateralTyp;
    const message = createBaseRewardPeriod();
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.collateralType = (_object$collateralTyp = object.collateralType) !== null && _object$collateralTyp !== void 0 ? _object$collateralTyp : "";
    message.start = object.start !== undefined && object.start !== null ? Timestamp.fromPartial(object.start) : undefined;
    message.end = object.end !== undefined && object.end !== null ? Timestamp.fromPartial(object.end) : undefined;
    message.rewardsPerSecond = object.rewardsPerSecond !== undefined && object.rewardsPerSecond !== null ? Coin.fromPartial(object.rewardsPerSecond) : undefined;
    return message;
  }
};
function createBaseMultiRewardPeriod() {
  return {
    active: false,
    collateralType: "",
    start: undefined,
    end: undefined,
    rewardsPerSecond: []
  };
}
export const MultiRewardPeriod = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.start !== undefined) {
      Timestamp.encode(message.start, writer.uint32(26).fork()).ldelim();
    }
    if (message.end !== undefined) {
      Timestamp.encode(message.end, writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.rewardsPerSecond) {
      Coin.encode(v, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiRewardPeriod();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 2:
          message.collateralType = reader.string();
          break;
        case 3:
          message.start = Timestamp.decode(reader, reader.uint32());
          break;
        case 4:
          message.end = Timestamp.decode(reader, reader.uint32());
          break;
        case 5:
          message.rewardsPerSecond.push(Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      active: isSet(object.active) ? Boolean(object.active) : false,
      collateralType: isSet(object.collateralType) ? String(object.collateralType) : "",
      start: isSet(object.start) ? fromJsonTimestamp(object.start) : undefined,
      end: isSet(object.end) ? fromJsonTimestamp(object.end) : undefined,
      rewardsPerSecond: Array.isArray(object === null || object === void 0 ? void 0 : object.rewardsPerSecond) ? object.rewardsPerSecond.map(e => Coin.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.active !== undefined && (obj.active = message.active);
    message.collateralType !== undefined && (obj.collateralType = message.collateralType);
    message.start !== undefined && (obj.start = fromTimestamp(message.start).toISOString());
    message.end !== undefined && (obj.end = fromTimestamp(message.end).toISOString());
    if (message.rewardsPerSecond) {
      obj.rewardsPerSecond = message.rewardsPerSecond.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.rewardsPerSecond = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$active2, _object$collateralTyp2, _object$rewardsPerSec;
    const message = createBaseMultiRewardPeriod();
    message.active = (_object$active2 = object.active) !== null && _object$active2 !== void 0 ? _object$active2 : false;
    message.collateralType = (_object$collateralTyp2 = object.collateralType) !== null && _object$collateralTyp2 !== void 0 ? _object$collateralTyp2 : "";
    message.start = object.start !== undefined && object.start !== null ? Timestamp.fromPartial(object.start) : undefined;
    message.end = object.end !== undefined && object.end !== null ? Timestamp.fromPartial(object.end) : undefined;
    message.rewardsPerSecond = ((_object$rewardsPerSec = object.rewardsPerSecond) === null || _object$rewardsPerSec === void 0 ? void 0 : _object$rewardsPerSec.map(e => Coin.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMultiplier() {
  return {
    name: "",
    monthsLockup: Long.ZERO,
    factor: new Uint8Array()
  };
}
export const Multiplier = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    if (!message.monthsLockup.isZero()) {
      writer.uint32(16).int64(message.monthsLockup);
    }
    if (message.factor.length !== 0) {
      writer.uint32(26).bytes(message.factor);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiplier();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.name = reader.string();
          break;
        case 2:
          message.monthsLockup = reader.int64();
          break;
        case 3:
          message.factor = reader.bytes();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      name: isSet(object.name) ? String(object.name) : "",
      monthsLockup: isSet(object.monthsLockup) ? Long.fromValue(object.monthsLockup) : Long.ZERO,
      factor: isSet(object.factor) ? bytesFromBase64(object.factor) : new Uint8Array()
    };
  },
  toJSON(message) {
    const obj = {};
    message.name !== undefined && (obj.name = message.name);
    message.monthsLockup !== undefined && (obj.monthsLockup = (message.monthsLockup || Long.ZERO).toString());
    message.factor !== undefined && (obj.factor = base64FromBytes(message.factor !== undefined ? message.factor : new Uint8Array()));
    return obj;
  },
  fromPartial(object) {
    var _object$name, _object$factor;
    const message = createBaseMultiplier();
    message.name = (_object$name = object.name) !== null && _object$name !== void 0 ? _object$name : "";
    message.monthsLockup = object.monthsLockup !== undefined && object.monthsLockup !== null ? Long.fromValue(object.monthsLockup) : Long.ZERO;
    message.factor = (_object$factor = object.factor) !== null && _object$factor !== void 0 ? _object$factor : new Uint8Array();
    return message;
  }
};
function createBaseMultipliersPerDenom() {
  return {
    denom: "",
    multipliers: []
  };
}
export const MultipliersPerDenom = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    for (const v of message.multipliers) {
      Multiplier.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultipliersPerDenom();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.multipliers.push(Multiplier.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      multipliers: Array.isArray(object === null || object === void 0 ? void 0 : object.multipliers) ? object.multipliers.map(e => Multiplier.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    if (message.multipliers) {
      obj.multipliers = message.multipliers.map(e => e ? Multiplier.toJSON(e) : undefined);
    } else {
      obj.multipliers = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$denom, _object$multipliers;
    const message = createBaseMultipliersPerDenom();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.multipliers = ((_object$multipliers = object.multipliers) === null || _object$multipliers === void 0 ? void 0 : _object$multipliers.map(e => Multiplier.fromPartial(e))) || [];
    return message;
  }
};
function createBaseParams() {
  return {
    usdxMintingRewardPeriods: [],
    hardSupplyRewardPeriods: [],
    hardBorrowRewardPeriods: [],
    delegatorRewardPeriods: [],
    swapRewardPeriods: [],
    claimMultipliers: [],
    claimEnd: undefined,
    savingsRewardPeriods: [],
    earnRewardPeriods: []
  };
}
export const Params = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.usdxMintingRewardPeriods) {
      RewardPeriod.encode(v, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.hardSupplyRewardPeriods) {
      MultiRewardPeriod.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.hardBorrowRewardPeriods) {
      MultiRewardPeriod.encode(v, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.delegatorRewardPeriods) {
      MultiRewardPeriod.encode(v, writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.swapRewardPeriods) {
      MultiRewardPeriod.encode(v, writer.uint32(42).fork()).ldelim();
    }
    for (const v of message.claimMultipliers) {
      MultipliersPerDenom.encode(v, writer.uint32(50).fork()).ldelim();
    }
    if (message.claimEnd !== undefined) {
      Timestamp.encode(message.claimEnd, writer.uint32(58).fork()).ldelim();
    }
    for (const v of message.savingsRewardPeriods) {
      MultiRewardPeriod.encode(v, writer.uint32(66).fork()).ldelim();
    }
    for (const v of message.earnRewardPeriods) {
      MultiRewardPeriod.encode(v, writer.uint32(74).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.usdxMintingRewardPeriods.push(RewardPeriod.decode(reader, reader.uint32()));
          break;
        case 2:
          message.hardSupplyRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 3:
          message.hardBorrowRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 4:
          message.delegatorRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 5:
          message.swapRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 6:
          message.claimMultipliers.push(MultipliersPerDenom.decode(reader, reader.uint32()));
          break;
        case 7:
          message.claimEnd = Timestamp.decode(reader, reader.uint32());
          break;
        case 8:
          message.savingsRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        case 9:
          message.earnRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      usdxMintingRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.usdxMintingRewardPeriods) ? object.usdxMintingRewardPeriods.map(e => RewardPeriod.fromJSON(e)) : [],
      hardSupplyRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.hardSupplyRewardPeriods) ? object.hardSupplyRewardPeriods.map(e => MultiRewardPeriod.fromJSON(e)) : [],
      hardBorrowRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.hardBorrowRewardPeriods) ? object.hardBorrowRewardPeriods.map(e => MultiRewardPeriod.fromJSON(e)) : [],
      delegatorRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.delegatorRewardPeriods) ? object.delegatorRewardPeriods.map(e => MultiRewardPeriod.fromJSON(e)) : [],
      swapRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.swapRewardPeriods) ? object.swapRewardPeriods.map(e => MultiRewardPeriod.fromJSON(e)) : [],
      claimMultipliers: Array.isArray(object === null || object === void 0 ? void 0 : object.claimMultipliers) ? object.claimMultipliers.map(e => MultipliersPerDenom.fromJSON(e)) : [],
      claimEnd: isSet(object.claimEnd) ? fromJsonTimestamp(object.claimEnd) : undefined,
      savingsRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.savingsRewardPeriods) ? object.savingsRewardPeriods.map(e => MultiRewardPeriod.fromJSON(e)) : [],
      earnRewardPeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.earnRewardPeriods) ? object.earnRewardPeriods.map(e => MultiRewardPeriod.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.usdxMintingRewardPeriods) {
      obj.usdxMintingRewardPeriods = message.usdxMintingRewardPeriods.map(e => e ? RewardPeriod.toJSON(e) : undefined);
    } else {
      obj.usdxMintingRewardPeriods = [];
    }
    if (message.hardSupplyRewardPeriods) {
      obj.hardSupplyRewardPeriods = message.hardSupplyRewardPeriods.map(e => e ? MultiRewardPeriod.toJSON(e) : undefined);
    } else {
      obj.hardSupplyRewardPeriods = [];
    }
    if (message.hardBorrowRewardPeriods) {
      obj.hardBorrowRewardPeriods = message.hardBorrowRewardPeriods.map(e => e ? MultiRewardPeriod.toJSON(e) : undefined);
    } else {
      obj.hardBorrowRewardPeriods = [];
    }
    if (message.delegatorRewardPeriods) {
      obj.delegatorRewardPeriods = message.delegatorRewardPeriods.map(e => e ? MultiRewardPeriod.toJSON(e) : undefined);
    } else {
      obj.delegatorRewardPeriods = [];
    }
    if (message.swapRewardPeriods) {
      obj.swapRewardPeriods = message.swapRewardPeriods.map(e => e ? MultiRewardPeriod.toJSON(e) : undefined);
    } else {
      obj.swapRewardPeriods = [];
    }
    if (message.claimMultipliers) {
      obj.claimMultipliers = message.claimMultipliers.map(e => e ? MultipliersPerDenom.toJSON(e) : undefined);
    } else {
      obj.claimMultipliers = [];
    }
    message.claimEnd !== undefined && (obj.claimEnd = fromTimestamp(message.claimEnd).toISOString());
    if (message.savingsRewardPeriods) {
      obj.savingsRewardPeriods = message.savingsRewardPeriods.map(e => e ? MultiRewardPeriod.toJSON(e) : undefined);
    } else {
      obj.savingsRewardPeriods = [];
    }
    if (message.earnRewardPeriods) {
      obj.earnRewardPeriods = message.earnRewardPeriods.map(e => e ? MultiRewardPeriod.toJSON(e) : undefined);
    } else {
      obj.earnRewardPeriods = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$usdxMintingRe, _object$hardSupplyRew, _object$hardBorrowRew, _object$delegatorRewa, _object$swapRewardPer, _object$claimMultipli, _object$savingsReward, _object$earnRewardPer;
    const message = createBaseParams();
    message.usdxMintingRewardPeriods = ((_object$usdxMintingRe = object.usdxMintingRewardPeriods) === null || _object$usdxMintingRe === void 0 ? void 0 : _object$usdxMintingRe.map(e => RewardPeriod.fromPartial(e))) || [];
    message.hardSupplyRewardPeriods = ((_object$hardSupplyRew = object.hardSupplyRewardPeriods) === null || _object$hardSupplyRew === void 0 ? void 0 : _object$hardSupplyRew.map(e => MultiRewardPeriod.fromPartial(e))) || [];
    message.hardBorrowRewardPeriods = ((_object$hardBorrowRew = object.hardBorrowRewardPeriods) === null || _object$hardBorrowRew === void 0 ? void 0 : _object$hardBorrowRew.map(e => MultiRewardPeriod.fromPartial(e))) || [];
    message.delegatorRewardPeriods = ((_object$delegatorRewa = object.delegatorRewardPeriods) === null || _object$delegatorRewa === void 0 ? void 0 : _object$delegatorRewa.map(e => MultiRewardPeriod.fromPartial(e))) || [];
    message.swapRewardPeriods = ((_object$swapRewardPer = object.swapRewardPeriods) === null || _object$swapRewardPer === void 0 ? void 0 : _object$swapRewardPer.map(e => MultiRewardPeriod.fromPartial(e))) || [];
    message.claimMultipliers = ((_object$claimMultipli = object.claimMultipliers) === null || _object$claimMultipli === void 0 ? void 0 : _object$claimMultipli.map(e => MultipliersPerDenom.fromPartial(e))) || [];
    message.claimEnd = object.claimEnd !== undefined && object.claimEnd !== null ? Timestamp.fromPartial(object.claimEnd) : undefined;
    message.savingsRewardPeriods = ((_object$savingsReward = object.savingsRewardPeriods) === null || _object$savingsReward === void 0 ? void 0 : _object$savingsReward.map(e => MultiRewardPeriod.fromPartial(e))) || [];
    message.earnRewardPeriods = ((_object$earnRewardPer = object.earnRewardPeriods) === null || _object$earnRewardPer === void 0 ? void 0 : _object$earnRewardPer.map(e => MultiRewardPeriod.fromPartial(e))) || [];
    return message;
  }
};