import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/**
 * Selection is a pair of denom and multiplier name. It holds the choice of multiplier a user makes when they claim a
 * denom.
 */

function createBaseSelection() {
  return {
    denom: "",
    multiplierName: ""
  };
}
export const Selection = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.multiplierName !== "") {
      writer.uint32(18).string(message.multiplierName);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSelection();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.denom = reader.string();
          break;
        case 2:
          message.multiplierName = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      denom: isSet(object.denom) ? String(object.denom) : "",
      multiplierName: isSet(object.multiplierName) ? String(object.multiplierName) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.denom !== undefined && (obj.denom = message.denom);
    message.multiplierName !== undefined && (obj.multiplierName = message.multiplierName);
    return obj;
  },
  fromPartial(object) {
    var _object$denom, _object$multiplierNam;
    const message = createBaseSelection();
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.multiplierName = (_object$multiplierNam = object.multiplierName) !== null && _object$multiplierNam !== void 0 ? _object$multiplierNam : "";
    return message;
  }
};
function createBaseMsgClaimUSDXMintingReward() {
  return {
    sender: "",
    multiplierName: ""
  };
}
export const MsgClaimUSDXMintingReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    if (message.multiplierName !== "") {
      writer.uint32(18).string(message.multiplierName);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimUSDXMintingReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.multiplierName = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      multiplierName: isSet(object.multiplierName) ? String(object.multiplierName) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    message.multiplierName !== undefined && (obj.multiplierName = message.multiplierName);
    return obj;
  },
  fromPartial(object) {
    var _object$sender, _object$multiplierNam2;
    const message = createBaseMsgClaimUSDXMintingReward();
    message.sender = (_object$sender = object.sender) !== null && _object$sender !== void 0 ? _object$sender : "";
    message.multiplierName = (_object$multiplierNam2 = object.multiplierName) !== null && _object$multiplierNam2 !== void 0 ? _object$multiplierNam2 : "";
    return message;
  }
};
function createBaseMsgClaimUSDXMintingRewardResponse() {
  return {};
}
export const MsgClaimUSDXMintingRewardResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimUSDXMintingRewardResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimUSDXMintingRewardResponse();
    return message;
  }
};
function createBaseMsgClaimHardReward() {
  return {
    sender: "",
    denomsToClaim: []
  };
}
export const MsgClaimHardReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    for (const v of message.denomsToClaim) {
      Selection.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimHardReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.denomsToClaim.push(Selection.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      denomsToClaim: Array.isArray(object === null || object === void 0 ? void 0 : object.denomsToClaim) ? object.denomsToClaim.map(e => Selection.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    if (message.denomsToClaim) {
      obj.denomsToClaim = message.denomsToClaim.map(e => e ? Selection.toJSON(e) : undefined);
    } else {
      obj.denomsToClaim = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$sender2, _object$denomsToClaim;
    const message = createBaseMsgClaimHardReward();
    message.sender = (_object$sender2 = object.sender) !== null && _object$sender2 !== void 0 ? _object$sender2 : "";
    message.denomsToClaim = ((_object$denomsToClaim = object.denomsToClaim) === null || _object$denomsToClaim === void 0 ? void 0 : _object$denomsToClaim.map(e => Selection.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMsgClaimHardRewardResponse() {
  return {};
}
export const MsgClaimHardRewardResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimHardRewardResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimHardRewardResponse();
    return message;
  }
};
function createBaseMsgClaimDelegatorReward() {
  return {
    sender: "",
    denomsToClaim: []
  };
}
export const MsgClaimDelegatorReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    for (const v of message.denomsToClaim) {
      Selection.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimDelegatorReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.denomsToClaim.push(Selection.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      denomsToClaim: Array.isArray(object === null || object === void 0 ? void 0 : object.denomsToClaim) ? object.denomsToClaim.map(e => Selection.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    if (message.denomsToClaim) {
      obj.denomsToClaim = message.denomsToClaim.map(e => e ? Selection.toJSON(e) : undefined);
    } else {
      obj.denomsToClaim = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$sender3, _object$denomsToClaim2;
    const message = createBaseMsgClaimDelegatorReward();
    message.sender = (_object$sender3 = object.sender) !== null && _object$sender3 !== void 0 ? _object$sender3 : "";
    message.denomsToClaim = ((_object$denomsToClaim2 = object.denomsToClaim) === null || _object$denomsToClaim2 === void 0 ? void 0 : _object$denomsToClaim2.map(e => Selection.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMsgClaimDelegatorRewardResponse() {
  return {};
}
export const MsgClaimDelegatorRewardResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimDelegatorRewardResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimDelegatorRewardResponse();
    return message;
  }
};
function createBaseMsgClaimSwapReward() {
  return {
    sender: "",
    denomsToClaim: []
  };
}
export const MsgClaimSwapReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    for (const v of message.denomsToClaim) {
      Selection.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimSwapReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.denomsToClaim.push(Selection.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      denomsToClaim: Array.isArray(object === null || object === void 0 ? void 0 : object.denomsToClaim) ? object.denomsToClaim.map(e => Selection.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    if (message.denomsToClaim) {
      obj.denomsToClaim = message.denomsToClaim.map(e => e ? Selection.toJSON(e) : undefined);
    } else {
      obj.denomsToClaim = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$sender4, _object$denomsToClaim3;
    const message = createBaseMsgClaimSwapReward();
    message.sender = (_object$sender4 = object.sender) !== null && _object$sender4 !== void 0 ? _object$sender4 : "";
    message.denomsToClaim = ((_object$denomsToClaim3 = object.denomsToClaim) === null || _object$denomsToClaim3 === void 0 ? void 0 : _object$denomsToClaim3.map(e => Selection.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMsgClaimSwapRewardResponse() {
  return {};
}
export const MsgClaimSwapRewardResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimSwapRewardResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimSwapRewardResponse();
    return message;
  }
};
function createBaseMsgClaimSavingsReward() {
  return {
    sender: "",
    denomsToClaim: []
  };
}
export const MsgClaimSavingsReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    for (const v of message.denomsToClaim) {
      Selection.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimSavingsReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.denomsToClaim.push(Selection.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      denomsToClaim: Array.isArray(object === null || object === void 0 ? void 0 : object.denomsToClaim) ? object.denomsToClaim.map(e => Selection.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    if (message.denomsToClaim) {
      obj.denomsToClaim = message.denomsToClaim.map(e => e ? Selection.toJSON(e) : undefined);
    } else {
      obj.denomsToClaim = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$sender5, _object$denomsToClaim4;
    const message = createBaseMsgClaimSavingsReward();
    message.sender = (_object$sender5 = object.sender) !== null && _object$sender5 !== void 0 ? _object$sender5 : "";
    message.denomsToClaim = ((_object$denomsToClaim4 = object.denomsToClaim) === null || _object$denomsToClaim4 === void 0 ? void 0 : _object$denomsToClaim4.map(e => Selection.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMsgClaimSavingsRewardResponse() {
  return {};
}
export const MsgClaimSavingsRewardResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimSavingsRewardResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimSavingsRewardResponse();
    return message;
  }
};
function createBaseMsgClaimEarnReward() {
  return {
    sender: "",
    denomsToClaim: []
  };
}
export const MsgClaimEarnReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.sender !== "") {
      writer.uint32(10).string(message.sender);
    }
    for (const v of message.denomsToClaim) {
      Selection.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimEarnReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.sender = reader.string();
          break;
        case 2:
          message.denomsToClaim.push(Selection.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      sender: isSet(object.sender) ? String(object.sender) : "",
      denomsToClaim: Array.isArray(object === null || object === void 0 ? void 0 : object.denomsToClaim) ? object.denomsToClaim.map(e => Selection.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.sender !== undefined && (obj.sender = message.sender);
    if (message.denomsToClaim) {
      obj.denomsToClaim = message.denomsToClaim.map(e => e ? Selection.toJSON(e) : undefined);
    } else {
      obj.denomsToClaim = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$sender6, _object$denomsToClaim5;
    const message = createBaseMsgClaimEarnReward();
    message.sender = (_object$sender6 = object.sender) !== null && _object$sender6 !== void 0 ? _object$sender6 : "";
    message.denomsToClaim = ((_object$denomsToClaim5 = object.denomsToClaim) === null || _object$denomsToClaim5 === void 0 ? void 0 : _object$denomsToClaim5.map(e => Selection.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMsgClaimEarnRewardResponse() {
  return {};
}
export const MsgClaimEarnRewardResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgClaimEarnRewardResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgClaimEarnRewardResponse();
    return message;
  }
};