import { Duration } from "../../../google/protobuf/duration";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
/** GenesisState defines the issuance module's genesis state. */

function createBaseGenesisState() {
  return {
    params: undefined,
    supplies: []
  };
}
export const GenesisState = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.supplies) {
      AssetSupply.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.supplies.push(AssetSupply.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      supplies: Array.isArray(object === null || object === void 0 ? void 0 : object.supplies) ? object.supplies.map(e => AssetSupply.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    if (message.supplies) {
      obj.supplies = message.supplies.map(e => e ? AssetSupply.toJSON(e) : undefined);
    } else {
      obj.supplies = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$supplies;
    const message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    message.supplies = ((_object$supplies = object.supplies) === null || _object$supplies === void 0 ? void 0 : _object$supplies.map(e => AssetSupply.fromPartial(e))) || [];
    return message;
  }
};
function createBaseParams() {
  return {
    assets: []
  };
}
export const Params = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.assets) {
      Asset.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.assets.push(Asset.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      assets: Array.isArray(object === null || object === void 0 ? void 0 : object.assets) ? object.assets.map(e => Asset.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.assets) {
      obj.assets = message.assets.map(e => e ? Asset.toJSON(e) : undefined);
    } else {
      obj.assets = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$assets;
    const message = createBaseParams();
    message.assets = ((_object$assets = object.assets) === null || _object$assets === void 0 ? void 0 : _object$assets.map(e => Asset.fromPartial(e))) || [];
    return message;
  }
};
function createBaseAsset() {
  return {
    owner: "",
    denom: "",
    blockedAddresses: [],
    paused: false,
    blockable: false,
    rateLimit: undefined
  };
}
export const Asset = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.owner !== "") {
      writer.uint32(10).string(message.owner);
    }
    if (message.denom !== "") {
      writer.uint32(18).string(message.denom);
    }
    for (const v of message.blockedAddresses) {
      writer.uint32(26).string(v);
    }
    if (message.paused === true) {
      writer.uint32(32).bool(message.paused);
    }
    if (message.blockable === true) {
      writer.uint32(40).bool(message.blockable);
    }
    if (message.rateLimit !== undefined) {
      RateLimit.encode(message.rateLimit, writer.uint32(50).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAsset();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.owner = reader.string();
          break;
        case 2:
          message.denom = reader.string();
          break;
        case 3:
          message.blockedAddresses.push(reader.string());
          break;
        case 4:
          message.paused = reader.bool();
          break;
        case 5:
          message.blockable = reader.bool();
          break;
        case 6:
          message.rateLimit = RateLimit.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      owner: isSet(object.owner) ? String(object.owner) : "",
      denom: isSet(object.denom) ? String(object.denom) : "",
      blockedAddresses: Array.isArray(object === null || object === void 0 ? void 0 : object.blockedAddresses) ? object.blockedAddresses.map(e => String(e)) : [],
      paused: isSet(object.paused) ? Boolean(object.paused) : false,
      blockable: isSet(object.blockable) ? Boolean(object.blockable) : false,
      rateLimit: isSet(object.rateLimit) ? RateLimit.fromJSON(object.rateLimit) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.owner !== undefined && (obj.owner = message.owner);
    message.denom !== undefined && (obj.denom = message.denom);
    if (message.blockedAddresses) {
      obj.blockedAddresses = message.blockedAddresses.map(e => e);
    } else {
      obj.blockedAddresses = [];
    }
    message.paused !== undefined && (obj.paused = message.paused);
    message.blockable !== undefined && (obj.blockable = message.blockable);
    message.rateLimit !== undefined && (obj.rateLimit = message.rateLimit ? RateLimit.toJSON(message.rateLimit) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$owner, _object$denom, _object$blockedAddres, _object$paused, _object$blockable;
    const message = createBaseAsset();
    message.owner = (_object$owner = object.owner) !== null && _object$owner !== void 0 ? _object$owner : "";
    message.denom = (_object$denom = object.denom) !== null && _object$denom !== void 0 ? _object$denom : "";
    message.blockedAddresses = ((_object$blockedAddres = object.blockedAddresses) === null || _object$blockedAddres === void 0 ? void 0 : _object$blockedAddres.map(e => e)) || [];
    message.paused = (_object$paused = object.paused) !== null && _object$paused !== void 0 ? _object$paused : false;
    message.blockable = (_object$blockable = object.blockable) !== null && _object$blockable !== void 0 ? _object$blockable : false;
    message.rateLimit = object.rateLimit !== undefined && object.rateLimit !== null ? RateLimit.fromPartial(object.rateLimit) : undefined;
    return message;
  }
};
function createBaseRateLimit() {
  return {
    active: false,
    limit: new Uint8Array(),
    timePeriod: undefined
  };
}
export const RateLimit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    if (message.limit.length !== 0) {
      writer.uint32(18).bytes(message.limit);
    }
    if (message.timePeriod !== undefined) {
      Duration.encode(message.timePeriod, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRateLimit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 2:
          message.limit = reader.bytes();
          break;
        case 3:
          message.timePeriod = Duration.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      active: isSet(object.active) ? Boolean(object.active) : false,
      limit: isSet(object.limit) ? bytesFromBase64(object.limit) : new Uint8Array(),
      timePeriod: isSet(object.timePeriod) ? Duration.fromJSON(object.timePeriod) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.active !== undefined && (obj.active = message.active);
    message.limit !== undefined && (obj.limit = base64FromBytes(message.limit !== undefined ? message.limit : new Uint8Array()));
    message.timePeriod !== undefined && (obj.timePeriod = message.timePeriod ? Duration.toJSON(message.timePeriod) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$active, _object$limit;
    const message = createBaseRateLimit();
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.limit = (_object$limit = object.limit) !== null && _object$limit !== void 0 ? _object$limit : new Uint8Array();
    message.timePeriod = object.timePeriod !== undefined && object.timePeriod !== null ? Duration.fromPartial(object.timePeriod) : undefined;
    return message;
  }
};
function createBaseAssetSupply() {
  return {
    currentSupply: undefined,
    timeElapsed: undefined
  };
}
export const AssetSupply = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.currentSupply !== undefined) {
      Coin.encode(message.currentSupply, writer.uint32(10).fork()).ldelim();
    }
    if (message.timeElapsed !== undefined) {
      Duration.encode(message.timeElapsed, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetSupply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.currentSupply = Coin.decode(reader, reader.uint32());
          break;
        case 2:
          message.timeElapsed = Duration.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      currentSupply: isSet(object.currentSupply) ? Coin.fromJSON(object.currentSupply) : undefined,
      timeElapsed: isSet(object.timeElapsed) ? Duration.fromJSON(object.timeElapsed) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.currentSupply !== undefined && (obj.currentSupply = message.currentSupply ? Coin.toJSON(message.currentSupply) : undefined);
    message.timeElapsed !== undefined && (obj.timeElapsed = message.timeElapsed ? Duration.toJSON(message.timeElapsed) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseAssetSupply();
    message.currentSupply = object.currentSupply !== undefined && object.currentSupply !== null ? Coin.fromPartial(object.currentSupply) : undefined;
    message.timeElapsed = object.timeElapsed !== undefined && object.timeElapsed !== null ? Duration.fromPartial(object.timeElapsed) : undefined;
    return message;
  }
};