//@ts-nocheck

import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.issuance.v1beta1.MsgIssueTokens": {
    aminoType: "/kava.issuance.v1beta1.MsgIssueTokens",
    toAmino: ({
      sender,
      tokens,
      receiver
    }) => {
      return {
        sender,
        tokens: {
          denom: tokens.denom,
          amount: Long.fromValue(tokens.amount).toString()
        },
        receiver
      };
    },
    fromAmino: ({
      sender,
      tokens,
      receiver
    }) => {
      return {
        sender,
        tokens: {
          denom: tokens.denom,
          amount: tokens.amount
        },
        receiver
      };
    }
  },
  "/kava.issuance.v1beta1.MsgRedeemTokens": {
    aminoType: "/kava.issuance.v1beta1.MsgRedeemTokens",
    toAmino: ({
      sender,
      tokens
    }) => {
      return {
        sender,
        tokens: {
          denom: tokens.denom,
          amount: Long.fromValue(tokens.amount).toString()
        }
      };
    },
    fromAmino: ({
      sender,
      tokens
    }) => {
      return {
        sender,
        tokens: {
          denom: tokens.denom,
          amount: tokens.amount
        }
      };
    }
  },
  "/kava.issuance.v1beta1.MsgBlockAddress": {
    aminoType: "/kava.issuance.v1beta1.MsgBlockAddress",
    toAmino: ({
      sender,
      denom,
      blockedAddress
    }) => {
      return {
        sender,
        denom,
        blocked_address: blockedAddress
      };
    },
    fromAmino: ({
      sender,
      denom,
      blocked_address
    }) => {
      return {
        sender,
        denom,
        blockedAddress: blocked_address
      };
    }
  },
  "/kava.issuance.v1beta1.MsgUnblockAddress": {
    aminoType: "/kava.issuance.v1beta1.MsgUnblockAddress",
    toAmino: ({
      sender,
      denom,
      blockedAddress
    }) => {
      return {
        sender,
        denom,
        blocked_address: blockedAddress
      };
    },
    fromAmino: ({
      sender,
      denom,
      blocked_address
    }) => {
      return {
        sender,
        denom,
        blockedAddress: blocked_address
      };
    }
  },
  "/kava.issuance.v1beta1.MsgSetPauseStatus": {
    aminoType: "/kava.issuance.v1beta1.MsgSetPauseStatus",
    toAmino: ({
      sender,
      denom,
      status
    }) => {
      return {
        sender,
        denom,
        status
      };
    },
    fromAmino: ({
      sender,
      denom,
      status
    }) => {
      return {
        sender,
        denom,
        status
      };
    }
  }
};