import { MsgIssueTokens, MsgRedeemTokens, MsgBlockAddress, MsgUnblockAddress, MsgSetPauseStatus } from "./tx";
export const registry = [["/kava.issuance.v1beta1.MsgIssueTokens", MsgIssueTokens], ["/kava.issuance.v1beta1.MsgRedeemTokens", MsgRedeemTokens], ["/kava.issuance.v1beta1.MsgBlockAddress", MsgBlockAddress], ["/kava.issuance.v1beta1.MsgUnblockAddress", MsgUnblockAddress], ["/kava.issuance.v1beta1.MsgSetPauseStatus", MsgSetPauseStatus]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: MsgIssueTokens.encode(value).finish()
      };
    },
    redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: MsgRedeemTokens.encode(value).finish()
      };
    },
    blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: MsgBlockAddress.encode(value).finish()
      };
    },
    unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: MsgUnblockAddress.encode(value).finish()
      };
    },
    setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: MsgSetPauseStatus.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value
      };
    },
    redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value
      };
    },
    blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value
      };
    },
    unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value
      };
    },
    setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value
      };
    }
  },
  toJSON: {
    issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: MsgIssueTokens.toJSON(value)
      };
    },
    redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: MsgRedeemTokens.toJSON(value)
      };
    },
    blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: MsgBlockAddress.toJSON(value)
      };
    },
    unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: MsgUnblockAddress.toJSON(value)
      };
    },
    setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: MsgSetPauseStatus.toJSON(value)
      };
    }
  },
  fromJSON: {
    issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: MsgIssueTokens.fromJSON(value)
      };
    },
    redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: MsgRedeemTokens.fromJSON(value)
      };
    },
    blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: MsgBlockAddress.fromJSON(value)
      };
    },
    unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: MsgUnblockAddress.fromJSON(value)
      };
    },
    setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: MsgSetPauseStatus.fromJSON(value)
      };
    }
  },
  fromPartial: {
    issueTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgIssueTokens",
        value: MsgIssueTokens.fromPartial(value)
      };
    },
    redeemTokens(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgRedeemTokens",
        value: MsgRedeemTokens.fromPartial(value)
      };
    },
    blockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgBlockAddress",
        value: MsgBlockAddress.fromPartial(value)
      };
    },
    unblockAddress(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgUnblockAddress",
        value: MsgUnblockAddress.fromPartial(value)
      };
    },
    setPauseStatus(value) {
      return {
        typeUrl: "/kava.issuance.v1beta1.MsgSetPauseStatus",
        value: MsgSetPauseStatus.fromPartial(value)
      };
    }
  }
};