import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { MsgIssueTokens, MsgIssueTokensResponse, MsgRedeemTokens, MsgRedeemTokensResponse, MsgBlockAddress, MsgBlockAddressResponse, MsgUnblockAddress, MsgUnblockAddressResponse, MsgSetPauseStatus, MsgSetPauseStatusResponse } from "./tx";
/** Msg defines the issuance Msg service. */

export class MsgClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.issueTokens = this.issueTokens.bind(this);
    this.redeemTokens = this.redeemTokens.bind(this);
    this.blockAddress = this.blockAddress.bind(this);
    this.unblockAddress = this.unblockAddress.bind(this);
    this.setPauseStatus = this.setPauseStatus.bind(this);
  }
  issueTokens(request) {
    const data = MsgIssueTokens.encode(request).finish();
    const promise = this.rpc.request("kava.issuance.v1beta1.Msg", "IssueTokens", data);
    return promise.then(data => MsgIssueTokensResponse.decode(new _m0.Reader(data)));
  }
  redeemTokens(request) {
    const data = MsgRedeemTokens.encode(request).finish();
    const promise = this.rpc.request("kava.issuance.v1beta1.Msg", "RedeemTokens", data);
    return promise.then(data => MsgRedeemTokensResponse.decode(new _m0.Reader(data)));
  }
  blockAddress(request) {
    const data = MsgBlockAddress.encode(request).finish();
    const promise = this.rpc.request("kava.issuance.v1beta1.Msg", "BlockAddress", data);
    return promise.then(data => MsgBlockAddressResponse.decode(new _m0.Reader(data)));
  }
  unblockAddress(request) {
    const data = MsgUnblockAddress.encode(request).finish();
    const promise = this.rpc.request("kava.issuance.v1beta1.Msg", "UnblockAddress", data);
    return promise.then(data => MsgUnblockAddressResponse.decode(new _m0.Reader(data)));
  }
  setPauseStatus(request) {
    const data = MsgSetPauseStatus.encode(request).finish();
    const promise = this.rpc.request("kava.issuance.v1beta1.Msg", "SetPauseStatus", data);
    return promise.then(data => MsgSetPauseStatusResponse.decode(new _m0.Reader(data)));
  }
}