import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";
import * as _m0 from "protobufjs/minimal";
import { isSet, bytesFromBase64, base64FromBytes, fromJsonTimestamp, fromTimestamp } from "../../../helpers";
/** Params governance parameters for kavadist module */

function createBaseParams() {
  return {
    active: false,
    periods: [],
    infrastructureParams: undefined
  };
}
export const Params = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.active === true) {
      writer.uint32(8).bool(message.active);
    }
    for (const v of message.periods) {
      Period.encode(v, writer.uint32(26).fork()).ldelim();
    }
    if (message.infrastructureParams !== undefined) {
      InfrastructureParams.encode(message.infrastructureParams, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.active = reader.bool();
          break;
        case 3:
          message.periods.push(Period.decode(reader, reader.uint32()));
          break;
        case 4:
          message.infrastructureParams = InfrastructureParams.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      active: isSet(object.active) ? Boolean(object.active) : false,
      periods: Array.isArray(object === null || object === void 0 ? void 0 : object.periods) ? object.periods.map(e => Period.fromJSON(e)) : [],
      infrastructureParams: isSet(object.infrastructureParams) ? InfrastructureParams.fromJSON(object.infrastructureParams) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.active !== undefined && (obj.active = message.active);
    if (message.periods) {
      obj.periods = message.periods.map(e => e ? Period.toJSON(e) : undefined);
    } else {
      obj.periods = [];
    }
    message.infrastructureParams !== undefined && (obj.infrastructureParams = message.infrastructureParams ? InfrastructureParams.toJSON(message.infrastructureParams) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$active, _object$periods;
    const message = createBaseParams();
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    message.periods = ((_object$periods = object.periods) === null || _object$periods === void 0 ? void 0 : _object$periods.map(e => Period.fromPartial(e))) || [];
    message.infrastructureParams = object.infrastructureParams !== undefined && object.infrastructureParams !== null ? InfrastructureParams.fromPartial(object.infrastructureParams) : undefined;
    return message;
  }
};
function createBaseInfrastructureParams() {
  return {
    infrastructurePeriods: [],
    coreRewards: [],
    partnerRewards: []
  };
}
export const InfrastructureParams = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.infrastructurePeriods) {
      Period.encode(v, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.coreRewards) {
      CoreReward.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.partnerRewards) {
      PartnerReward.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseInfrastructureParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.infrastructurePeriods.push(Period.decode(reader, reader.uint32()));
          break;
        case 2:
          message.coreRewards.push(CoreReward.decode(reader, reader.uint32()));
          break;
        case 3:
          message.partnerRewards.push(PartnerReward.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      infrastructurePeriods: Array.isArray(object === null || object === void 0 ? void 0 : object.infrastructurePeriods) ? object.infrastructurePeriods.map(e => Period.fromJSON(e)) : [],
      coreRewards: Array.isArray(object === null || object === void 0 ? void 0 : object.coreRewards) ? object.coreRewards.map(e => CoreReward.fromJSON(e)) : [],
      partnerRewards: Array.isArray(object === null || object === void 0 ? void 0 : object.partnerRewards) ? object.partnerRewards.map(e => PartnerReward.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.infrastructurePeriods) {
      obj.infrastructurePeriods = message.infrastructurePeriods.map(e => e ? Period.toJSON(e) : undefined);
    } else {
      obj.infrastructurePeriods = [];
    }
    if (message.coreRewards) {
      obj.coreRewards = message.coreRewards.map(e => e ? CoreReward.toJSON(e) : undefined);
    } else {
      obj.coreRewards = [];
    }
    if (message.partnerRewards) {
      obj.partnerRewards = message.partnerRewards.map(e => e ? PartnerReward.toJSON(e) : undefined);
    } else {
      obj.partnerRewards = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$infrastructur, _object$coreRewards, _object$partnerReward;
    const message = createBaseInfrastructureParams();
    message.infrastructurePeriods = ((_object$infrastructur = object.infrastructurePeriods) === null || _object$infrastructur === void 0 ? void 0 : _object$infrastructur.map(e => Period.fromPartial(e))) || [];
    message.coreRewards = ((_object$coreRewards = object.coreRewards) === null || _object$coreRewards === void 0 ? void 0 : _object$coreRewards.map(e => CoreReward.fromPartial(e))) || [];
    message.partnerRewards = ((_object$partnerReward = object.partnerRewards) === null || _object$partnerReward === void 0 ? void 0 : _object$partnerReward.map(e => PartnerReward.fromPartial(e))) || [];
    return message;
  }
};
function createBaseCoreReward() {
  return {
    address: new Uint8Array(),
    weight: ""
  };
}
export const CoreReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.address.length !== 0) {
      writer.uint32(10).bytes(message.address);
    }
    if (message.weight !== "") {
      writer.uint32(18).string(message.weight);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCoreReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.bytes();
          break;
        case 2:
          message.weight = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      address: isSet(object.address) ? bytesFromBase64(object.address) : new Uint8Array(),
      weight: isSet(object.weight) ? String(object.weight) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.address !== undefined && (obj.address = base64FromBytes(message.address !== undefined ? message.address : new Uint8Array()));
    message.weight !== undefined && (obj.weight = message.weight);
    return obj;
  },
  fromPartial(object) {
    var _object$address, _object$weight;
    const message = createBaseCoreReward();
    message.address = (_object$address = object.address) !== null && _object$address !== void 0 ? _object$address : new Uint8Array();
    message.weight = (_object$weight = object.weight) !== null && _object$weight !== void 0 ? _object$weight : "";
    return message;
  }
};
function createBasePartnerReward() {
  return {
    address: new Uint8Array(),
    rewardsPerSecond: undefined
  };
}
export const PartnerReward = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.address.length !== 0) {
      writer.uint32(10).bytes(message.address);
    }
    if (message.rewardsPerSecond !== undefined) {
      Coin.encode(message.rewardsPerSecond, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePartnerReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.bytes();
          break;
        case 2:
          message.rewardsPerSecond = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      address: isSet(object.address) ? bytesFromBase64(object.address) : new Uint8Array(),
      rewardsPerSecond: isSet(object.rewardsPerSecond) ? Coin.fromJSON(object.rewardsPerSecond) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.address !== undefined && (obj.address = base64FromBytes(message.address !== undefined ? message.address : new Uint8Array()));
    message.rewardsPerSecond !== undefined && (obj.rewardsPerSecond = message.rewardsPerSecond ? Coin.toJSON(message.rewardsPerSecond) : undefined);
    return obj;
  },
  fromPartial(object) {
    var _object$address2;
    const message = createBasePartnerReward();
    message.address = (_object$address2 = object.address) !== null && _object$address2 !== void 0 ? _object$address2 : new Uint8Array();
    message.rewardsPerSecond = object.rewardsPerSecond !== undefined && object.rewardsPerSecond !== null ? Coin.fromPartial(object.rewardsPerSecond) : undefined;
    return message;
  }
};
function createBasePeriod() {
  return {
    start: undefined,
    end: undefined,
    inflation: new Uint8Array()
  };
}
export const Period = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.start !== undefined) {
      Timestamp.encode(message.start, writer.uint32(10).fork()).ldelim();
    }
    if (message.end !== undefined) {
      Timestamp.encode(message.end, writer.uint32(18).fork()).ldelim();
    }
    if (message.inflation.length !== 0) {
      writer.uint32(26).bytes(message.inflation);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePeriod();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.start = Timestamp.decode(reader, reader.uint32());
          break;
        case 2:
          message.end = Timestamp.decode(reader, reader.uint32());
          break;
        case 3:
          message.inflation = reader.bytes();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      start: isSet(object.start) ? fromJsonTimestamp(object.start) : undefined,
      end: isSet(object.end) ? fromJsonTimestamp(object.end) : undefined,
      inflation: isSet(object.inflation) ? bytesFromBase64(object.inflation) : new Uint8Array()
    };
  },
  toJSON(message) {
    const obj = {};
    message.start !== undefined && (obj.start = fromTimestamp(message.start).toISOString());
    message.end !== undefined && (obj.end = fromTimestamp(message.end).toISOString());
    message.inflation !== undefined && (obj.inflation = base64FromBytes(message.inflation !== undefined ? message.inflation : new Uint8Array()));
    return obj;
  },
  fromPartial(object) {
    var _object$inflation;
    const message = createBasePeriod();
    message.start = object.start !== undefined && object.start !== null ? Timestamp.fromPartial(object.start) : undefined;
    message.end = object.end !== undefined && object.end !== null ? Timestamp.fromPartial(object.end) : undefined;
    message.inflation = (_object$inflation = object.inflation) !== null && _object$inflation !== void 0 ? _object$inflation : new Uint8Array();
    return message;
  }
};