import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/**
 * CommunityPoolMultiSpendProposal spends from the community pool by sending to one or more
 * addresses
 */

function createBaseCommunityPoolMultiSpendProposal() {
  return {
    title: "",
    description: "",
    recipientList: []
  };
}
export const CommunityPoolMultiSpendProposal = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.title !== "") {
      writer.uint32(10).string(message.title);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    for (const v of message.recipientList) {
      MultiSpendRecipient.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommunityPoolMultiSpendProposal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.title = reader.string();
          break;
        case 2:
          message.description = reader.string();
          break;
        case 3:
          message.recipientList.push(MultiSpendRecipient.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      title: isSet(object.title) ? String(object.title) : "",
      description: isSet(object.description) ? String(object.description) : "",
      recipientList: Array.isArray(object === null || object === void 0 ? void 0 : object.recipientList) ? object.recipientList.map(e => MultiSpendRecipient.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.title !== undefined && (obj.title = message.title);
    message.description !== undefined && (obj.description = message.description);
    if (message.recipientList) {
      obj.recipientList = message.recipientList.map(e => e ? MultiSpendRecipient.toJSON(e) : undefined);
    } else {
      obj.recipientList = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$title, _object$description, _object$recipientList;
    const message = createBaseCommunityPoolMultiSpendProposal();
    message.title = (_object$title = object.title) !== null && _object$title !== void 0 ? _object$title : "";
    message.description = (_object$description = object.description) !== null && _object$description !== void 0 ? _object$description : "";
    message.recipientList = ((_object$recipientList = object.recipientList) === null || _object$recipientList === void 0 ? void 0 : _object$recipientList.map(e => MultiSpendRecipient.fromPartial(e))) || [];
    return message;
  }
};
function createBaseCommunityPoolMultiSpendProposalJSON() {
  return {
    title: "",
    description: "",
    recipientList: [],
    deposit: []
  };
}
export const CommunityPoolMultiSpendProposalJSON = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.title !== "") {
      writer.uint32(10).string(message.title);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    for (const v of message.recipientList) {
      MultiSpendRecipient.encode(v, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.deposit) {
      Coin.encode(v, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommunityPoolMultiSpendProposalJSON();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.title = reader.string();
          break;
        case 2:
          message.description = reader.string();
          break;
        case 3:
          message.recipientList.push(MultiSpendRecipient.decode(reader, reader.uint32()));
          break;
        case 4:
          message.deposit.push(Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      title: isSet(object.title) ? String(object.title) : "",
      description: isSet(object.description) ? String(object.description) : "",
      recipientList: Array.isArray(object === null || object === void 0 ? void 0 : object.recipientList) ? object.recipientList.map(e => MultiSpendRecipient.fromJSON(e)) : [],
      deposit: Array.isArray(object === null || object === void 0 ? void 0 : object.deposit) ? object.deposit.map(e => Coin.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.title !== undefined && (obj.title = message.title);
    message.description !== undefined && (obj.description = message.description);
    if (message.recipientList) {
      obj.recipientList = message.recipientList.map(e => e ? MultiSpendRecipient.toJSON(e) : undefined);
    } else {
      obj.recipientList = [];
    }
    if (message.deposit) {
      obj.deposit = message.deposit.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.deposit = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$title2, _object$description2, _object$recipientList2, _object$deposit;
    const message = createBaseCommunityPoolMultiSpendProposalJSON();
    message.title = (_object$title2 = object.title) !== null && _object$title2 !== void 0 ? _object$title2 : "";
    message.description = (_object$description2 = object.description) !== null && _object$description2 !== void 0 ? _object$description2 : "";
    message.recipientList = ((_object$recipientList2 = object.recipientList) === null || _object$recipientList2 === void 0 ? void 0 : _object$recipientList2.map(e => MultiSpendRecipient.fromPartial(e))) || [];
    message.deposit = ((_object$deposit = object.deposit) === null || _object$deposit === void 0 ? void 0 : _object$deposit.map(e => Coin.fromPartial(e))) || [];
    return message;
  }
};
function createBaseMultiSpendRecipient() {
  return {
    address: "",
    amount: []
  };
}
export const MultiSpendRecipient = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.address !== "") {
      writer.uint32(10).string(message.address);
    }
    for (const v of message.amount) {
      Coin.encode(v, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiSpendRecipient();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.address = reader.string();
          break;
        case 2:
          message.amount.push(Coin.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      address: isSet(object.address) ? String(object.address) : "",
      amount: Array.isArray(object === null || object === void 0 ? void 0 : object.amount) ? object.amount.map(e => Coin.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.address !== undefined && (obj.address = message.address);
    if (message.amount) {
      obj.amount = message.amount.map(e => e ? Coin.toJSON(e) : undefined);
    } else {
      obj.amount = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$address, _object$amount;
    const message = createBaseMultiSpendRecipient();
    message.address = (_object$address = object.address) !== null && _object$address !== void 0 ? _object$address : "";
    message.amount = ((_object$amount = object.amount) === null || _object$amount === void 0 ? void 0 : _object$amount.map(e => Coin.fromPartial(e))) || [];
    return message;
  }
};