import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** QueryDelegatedBalanceRequest defines the request type for Query/DelegatedBalance method. */

function createBaseQueryDelegatedBalanceRequest() {
  return {
    delegator: ""
  };
}
export const QueryDelegatedBalanceRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.delegator !== "") {
      writer.uint32(10).string(message.delegator);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDelegatedBalanceRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.delegator = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      delegator: isSet(object.delegator) ? String(object.delegator) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.delegator !== undefined && (obj.delegator = message.delegator);
    return obj;
  },
  fromPartial(object) {
    var _object$delegator;
    const message = createBaseQueryDelegatedBalanceRequest();
    message.delegator = (_object$delegator = object.delegator) !== null && _object$delegator !== void 0 ? _object$delegator : "";
    return message;
  }
};
function createBaseQueryDelegatedBalanceResponse() {
  return {
    vested: undefined,
    vesting: undefined
  };
}
export const QueryDelegatedBalanceResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.vested !== undefined) {
      Coin.encode(message.vested, writer.uint32(10).fork()).ldelim();
    }
    if (message.vesting !== undefined) {
      Coin.encode(message.vesting, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDelegatedBalanceResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.vested = Coin.decode(reader, reader.uint32());
          break;
        case 2:
          message.vesting = Coin.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      vested: isSet(object.vested) ? Coin.fromJSON(object.vested) : undefined,
      vesting: isSet(object.vesting) ? Coin.fromJSON(object.vesting) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.vested !== undefined && (obj.vested = message.vested ? Coin.toJSON(message.vested) : undefined);
    message.vesting !== undefined && (obj.vesting = message.vesting ? Coin.toJSON(message.vesting) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryDelegatedBalanceResponse();
    message.vested = object.vested !== undefined && object.vested !== null ? Coin.fromPartial(object.vested) : undefined;
    message.vesting = object.vesting !== undefined && object.vesting !== null ? Coin.fromPartial(object.vesting) : undefined;
    return message;
  }
};