import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryDelegatedBalanceRequest, QueryDelegatedBalanceResponse } from "./query";
/** Query defines the gRPC querier service for liquid module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.delegatedBalance = this.delegatedBalance.bind(this);
  }
  delegatedBalance(request) {
    const data = QueryDelegatedBalanceRequest.encode(request).finish();
    const promise = this.rpc.request("kava.liquid.v1beta1.Query", "DelegatedBalance", data);
    return promise.then(data => QueryDelegatedBalanceResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    delegatedBalance(request) {
      return queryService.delegatedBalance(request);
    }
  };
};