import { MsgMintDerivative, MsgBurnDerivative } from "./tx";
export const registry = [["/kava.liquid.v1beta1.MsgMintDerivative", MsgMintDerivative], ["/kava.liquid.v1beta1.MsgBurnDerivative", MsgBurnDerivative]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: MsgMintDerivative.encode(value).finish()
      };
    },
    burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: MsgBurnDerivative.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value
      };
    },
    burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value
      };
    }
  },
  toJSON: {
    mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: MsgMintDerivative.toJSON(value)
      };
    },
    burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: MsgBurnDerivative.toJSON(value)
      };
    }
  },
  fromJSON: {
    mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: MsgMintDerivative.fromJSON(value)
      };
    },
    burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: MsgBurnDerivative.fromJSON(value)
      };
    }
  },
  fromPartial: {
    mintDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgMintDerivative",
        value: MsgMintDerivative.fromPartial(value)
      };
    },
    burnDerivative(value) {
      return {
        typeUrl: "/kava.liquid.v1beta1.MsgBurnDerivative",
        value: MsgBurnDerivative.fromPartial(value)
      };
    }
  }
};