import { Params } from "./store";
import { Timestamp } from "../../../google/protobuf/timestamp";
import * as _m0 from "protobufjs/minimal";
import { isSet, fromJsonTimestamp, fromTimestamp } from "../../../helpers";
/**
 * QueryParamsRequest defines the request type for querying x/pricefeed
 * parameters.
 */

function createBaseQueryParamsRequest() {
  return {};
}
export const QueryParamsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryParamsRequest();
    return message;
  }
};
function createBaseQueryParamsResponse() {
  return {
    params: undefined
  };
}
export const QueryParamsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryParamsResponse();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    return message;
  }
};
function createBaseQueryPriceRequest() {
  return {
    marketId: ""
  };
}
export const QueryPriceRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryPriceRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      marketId: isSet(object.marketId) ? String(object.marketId) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    return obj;
  },
  fromPartial(object) {
    var _object$marketId;
    const message = createBaseQueryPriceRequest();
    message.marketId = (_object$marketId = object.marketId) !== null && _object$marketId !== void 0 ? _object$marketId : "";
    return message;
  }
};
function createBaseQueryPriceResponse() {
  return {
    price: undefined
  };
}
export const QueryPriceResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.price !== undefined) {
      CurrentPriceResponse.encode(message.price, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryPriceResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.price = CurrentPriceResponse.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      price: isSet(object.price) ? CurrentPriceResponse.fromJSON(object.price) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.price !== undefined && (obj.price = message.price ? CurrentPriceResponse.toJSON(message.price) : undefined);
    return obj;
  },
  fromPartial(object) {
    const message = createBaseQueryPriceResponse();
    message.price = object.price !== undefined && object.price !== null ? CurrentPriceResponse.fromPartial(object.price) : undefined;
    return message;
  }
};
function createBaseQueryPricesRequest() {
  return {};
}
export const QueryPricesRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryPricesRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryPricesRequest();
    return message;
  }
};
function createBaseQueryPricesResponse() {
  return {
    prices: []
  };
}
export const QueryPricesResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.prices) {
      CurrentPriceResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryPricesResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.prices.push(CurrentPriceResponse.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      prices: Array.isArray(object === null || object === void 0 ? void 0 : object.prices) ? object.prices.map(e => CurrentPriceResponse.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.prices) {
      obj.prices = message.prices.map(e => e ? CurrentPriceResponse.toJSON(e) : undefined);
    } else {
      obj.prices = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$prices;
    const message = createBaseQueryPricesResponse();
    message.prices = ((_object$prices = object.prices) === null || _object$prices === void 0 ? void 0 : _object$prices.map(e => CurrentPriceResponse.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryRawPricesRequest() {
  return {
    marketId: ""
  };
}
export const QueryRawPricesRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryRawPricesRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      marketId: isSet(object.marketId) ? String(object.marketId) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    return obj;
  },
  fromPartial(object) {
    var _object$marketId2;
    const message = createBaseQueryRawPricesRequest();
    message.marketId = (_object$marketId2 = object.marketId) !== null && _object$marketId2 !== void 0 ? _object$marketId2 : "";
    return message;
  }
};
function createBaseQueryRawPricesResponse() {
  return {
    rawPrices: []
  };
}
export const QueryRawPricesResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.rawPrices) {
      PostedPriceResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryRawPricesResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.rawPrices.push(PostedPriceResponse.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      rawPrices: Array.isArray(object === null || object === void 0 ? void 0 : object.rawPrices) ? object.rawPrices.map(e => PostedPriceResponse.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.rawPrices) {
      obj.rawPrices = message.rawPrices.map(e => e ? PostedPriceResponse.toJSON(e) : undefined);
    } else {
      obj.rawPrices = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$rawPrices;
    const message = createBaseQueryRawPricesResponse();
    message.rawPrices = ((_object$rawPrices = object.rawPrices) === null || _object$rawPrices === void 0 ? void 0 : _object$rawPrices.map(e => PostedPriceResponse.fromPartial(e))) || [];
    return message;
  }
};
function createBaseQueryOraclesRequest() {
  return {
    marketId: ""
  };
}
export const QueryOraclesRequest = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryOraclesRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      marketId: isSet(object.marketId) ? String(object.marketId) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    return obj;
  },
  fromPartial(object) {
    var _object$marketId3;
    const message = createBaseQueryOraclesRequest();
    message.marketId = (_object$marketId3 = object.marketId) !== null && _object$marketId3 !== void 0 ? _object$marketId3 : "";
    return message;
  }
};
function createBaseQueryOraclesResponse() {
  return {
    oracles: []
  };
}
export const QueryOraclesResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.oracles) {
      writer.uint32(10).string(v);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryOraclesResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.oracles.push(reader.string());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      oracles: Array.isArray(object === null || object === void 0 ? void 0 : object.oracles) ? object.oracles.map(e => String(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.oracles) {
      obj.oracles = message.oracles.map(e => e);
    } else {
      obj.oracles = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$oracles;
    const message = createBaseQueryOraclesResponse();
    message.oracles = ((_object$oracles = object.oracles) === null || _object$oracles === void 0 ? void 0 : _object$oracles.map(e => e)) || [];
    return message;
  }
};
function createBaseQueryMarketsRequest() {
  return {};
}
export const QueryMarketsRequest = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryMarketsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseQueryMarketsRequest();
    return message;
  }
};
function createBaseQueryMarketsResponse() {
  return {
    markets: []
  };
}
export const QueryMarketsResponse = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.markets) {
      MarketResponse.encode(v, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryMarketsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.markets.push(MarketResponse.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      markets: Array.isArray(object === null || object === void 0 ? void 0 : object.markets) ? object.markets.map(e => MarketResponse.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.markets) {
      obj.markets = message.markets.map(e => e ? MarketResponse.toJSON(e) : undefined);
    } else {
      obj.markets = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$markets;
    const message = createBaseQueryMarketsResponse();
    message.markets = ((_object$markets = object.markets) === null || _object$markets === void 0 ? void 0 : _object$markets.map(e => MarketResponse.fromPartial(e))) || [];
    return message;
  }
};
function createBasePostedPriceResponse() {
  return {
    marketId: "",
    oracleAddress: "",
    price: "",
    expiry: undefined
  };
}
export const PostedPriceResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    if (message.oracleAddress !== "") {
      writer.uint32(18).string(message.oracleAddress);
    }
    if (message.price !== "") {
      writer.uint32(26).string(message.price);
    }
    if (message.expiry !== undefined) {
      Timestamp.encode(message.expiry, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePostedPriceResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        case 2:
          message.oracleAddress = reader.string();
          break;
        case 3:
          message.price = reader.string();
          break;
        case 4:
          message.expiry = Timestamp.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      marketId: isSet(object.marketId) ? String(object.marketId) : "",
      oracleAddress: isSet(object.oracleAddress) ? String(object.oracleAddress) : "",
      price: isSet(object.price) ? String(object.price) : "",
      expiry: isSet(object.expiry) ? fromJsonTimestamp(object.expiry) : undefined
    };
  },
  toJSON(message) {
    const obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    message.oracleAddress !== undefined && (obj.oracleAddress = message.oracleAddress);
    message.price !== undefined && (obj.price = message.price);
    message.expiry !== undefined && (obj.expiry = fromTimestamp(message.expiry).toISOString());
    return obj;
  },
  fromPartial(object) {
    var _object$marketId4, _object$oracleAddress, _object$price;
    const message = createBasePostedPriceResponse();
    message.marketId = (_object$marketId4 = object.marketId) !== null && _object$marketId4 !== void 0 ? _object$marketId4 : "";
    message.oracleAddress = (_object$oracleAddress = object.oracleAddress) !== null && _object$oracleAddress !== void 0 ? _object$oracleAddress : "";
    message.price = (_object$price = object.price) !== null && _object$price !== void 0 ? _object$price : "";
    message.expiry = object.expiry !== undefined && object.expiry !== null ? Timestamp.fromPartial(object.expiry) : undefined;
    return message;
  }
};
function createBaseCurrentPriceResponse() {
  return {
    marketId: "",
    price: ""
  };
}
export const CurrentPriceResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    if (message.price !== "") {
      writer.uint32(18).string(message.price);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCurrentPriceResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        case 2:
          message.price = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      marketId: isSet(object.marketId) ? String(object.marketId) : "",
      price: isSet(object.price) ? String(object.price) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    message.price !== undefined && (obj.price = message.price);
    return obj;
  },
  fromPartial(object) {
    var _object$marketId5, _object$price2;
    const message = createBaseCurrentPriceResponse();
    message.marketId = (_object$marketId5 = object.marketId) !== null && _object$marketId5 !== void 0 ? _object$marketId5 : "";
    message.price = (_object$price2 = object.price) !== null && _object$price2 !== void 0 ? _object$price2 : "";
    return message;
  }
};
function createBaseMarketResponse() {
  return {
    marketId: "",
    baseAsset: "",
    quoteAsset: "",
    oracles: [],
    active: false
  };
}
export const MarketResponse = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.marketId !== "") {
      writer.uint32(10).string(message.marketId);
    }
    if (message.baseAsset !== "") {
      writer.uint32(18).string(message.baseAsset);
    }
    if (message.quoteAsset !== "") {
      writer.uint32(26).string(message.quoteAsset);
    }
    for (const v of message.oracles) {
      writer.uint32(34).string(v);
    }
    if (message.active === true) {
      writer.uint32(40).bool(message.active);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMarketResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.marketId = reader.string();
          break;
        case 2:
          message.baseAsset = reader.string();
          break;
        case 3:
          message.quoteAsset = reader.string();
          break;
        case 4:
          message.oracles.push(reader.string());
          break;
        case 5:
          message.active = reader.bool();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      marketId: isSet(object.marketId) ? String(object.marketId) : "",
      baseAsset: isSet(object.baseAsset) ? String(object.baseAsset) : "",
      quoteAsset: isSet(object.quoteAsset) ? String(object.quoteAsset) : "",
      oracles: Array.isArray(object === null || object === void 0 ? void 0 : object.oracles) ? object.oracles.map(e => String(e)) : [],
      active: isSet(object.active) ? Boolean(object.active) : false
    };
  },
  toJSON(message) {
    const obj = {};
    message.marketId !== undefined && (obj.marketId = message.marketId);
    message.baseAsset !== undefined && (obj.baseAsset = message.baseAsset);
    message.quoteAsset !== undefined && (obj.quoteAsset = message.quoteAsset);
    if (message.oracles) {
      obj.oracles = message.oracles.map(e => e);
    } else {
      obj.oracles = [];
    }
    message.active !== undefined && (obj.active = message.active);
    return obj;
  },
  fromPartial(object) {
    var _object$marketId6, _object$baseAsset, _object$quoteAsset, _object$oracles2, _object$active;
    const message = createBaseMarketResponse();
    message.marketId = (_object$marketId6 = object.marketId) !== null && _object$marketId6 !== void 0 ? _object$marketId6 : "";
    message.baseAsset = (_object$baseAsset = object.baseAsset) !== null && _object$baseAsset !== void 0 ? _object$baseAsset : "";
    message.quoteAsset = (_object$quoteAsset = object.quoteAsset) !== null && _object$quoteAsset !== void 0 ? _object$quoteAsset : "";
    message.oracles = ((_object$oracles2 = object.oracles) === null || _object$oracles2 === void 0 ? void 0 : _object$oracles2.map(e => e)) || [];
    message.active = (_object$active = object.active) !== null && _object$active !== void 0 ? _object$active : false;
    return message;
  }
};