import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { createProtobufRpcClient } from "@cosmjs/stargate";
import { QueryParamsRequest, QueryParamsResponse, QueryPriceRequest, QueryPriceResponse, QueryPricesRequest, QueryPricesResponse, QueryRawPricesRequest, QueryRawPricesResponse, QueryOraclesRequest, QueryOraclesResponse, QueryMarketsRequest, QueryMarketsResponse } from "./query";
/** Query defines the gRPC querier service for pricefeed module */

export class QueryClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.params = this.params.bind(this);
    this.price = this.price.bind(this);
    this.prices = this.prices.bind(this);
    this.rawPrices = this.rawPrices.bind(this);
    this.oracles = this.oracles.bind(this);
    this.markets = this.markets.bind(this);
  }
  params(request = {}) {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Params", data);
    return promise.then(data => QueryParamsResponse.decode(new _m0.Reader(data)));
  }
  price(request) {
    const data = QueryPriceRequest.encode(request).finish();
    const promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Price", data);
    return promise.then(data => QueryPriceResponse.decode(new _m0.Reader(data)));
  }
  prices(request = {}) {
    const data = QueryPricesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Prices", data);
    return promise.then(data => QueryPricesResponse.decode(new _m0.Reader(data)));
  }
  rawPrices(request) {
    const data = QueryRawPricesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "RawPrices", data);
    return promise.then(data => QueryRawPricesResponse.decode(new _m0.Reader(data)));
  }
  oracles(request) {
    const data = QueryOraclesRequest.encode(request).finish();
    const promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Oracles", data);
    return promise.then(data => QueryOraclesResponse.decode(new _m0.Reader(data)));
  }
  markets(request = {}) {
    const data = QueryMarketsRequest.encode(request).finish();
    const promise = this.rpc.request("kava.pricefeed.v1beta1.Query", "Markets", data);
    return promise.then(data => QueryMarketsResponse.decode(new _m0.Reader(data)));
  }
}
export const createRpcQueryExtension = base => {
  const rpc = createProtobufRpcClient(base);
  const queryService = new QueryClientImpl(rpc);
  return {
    params(request) {
      return queryService.params(request);
    },
    price(request) {
      return queryService.price(request);
    },
    prices(request) {
      return queryService.prices(request);
    },
    rawPrices(request) {
      return queryService.rawPrices(request);
    },
    oracles(request) {
      return queryService.oracles(request);
    },
    markets(request) {
      return queryService.markets(request);
    }
  };
};