import { MsgPostPrice } from "./tx";
export const registry = [["/kava.pricefeed.v1beta1.MsgPostPrice", MsgPostPrice]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    postPrice(value) {
      return {
        typeUrl: "/kava.pricefeed.v1beta1.MsgPostPrice",
        value: MsgPostPrice.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    postPrice(value) {
      return {
        typeUrl: "/kava.pricefeed.v1beta1.MsgPostPrice",
        value
      };
    }
  },
  toJSON: {
    postPrice(value) {
      return {
        typeUrl: "/kava.pricefeed.v1beta1.MsgPostPrice",
        value: MsgPostPrice.toJSON(value)
      };
    }
  },
  fromJSON: {
    postPrice(value) {
      return {
        typeUrl: "/kava.pricefeed.v1beta1.MsgPostPrice",
        value: MsgPostPrice.fromJSON(value)
      };
    }
  },
  fromPartial: {
    postPrice(value) {
      return {
        typeUrl: "/kava.pricefeed.v1beta1.MsgPostPrice",
        value: MsgPostPrice.fromPartial(value)
      };
    }
  }
};