//@ts-nocheck

import { Long } from "../../../helpers";
export const AminoConverter = {
  "/kava.router.v1beta1.MsgMintDeposit": {
    aminoType: "/kava.router.v1beta1.MsgMintDeposit",
    toAmino: ({
      depositor,
      validator,
      amount
    }) => {
      return {
        depositor,
        validator,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: ({
      depositor,
      validator,
      amount
    }) => {
      return {
        depositor,
        validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.router.v1beta1.MsgDelegateMintDeposit": {
    aminoType: "/kava.router.v1beta1.MsgDelegateMintDeposit",
    toAmino: ({
      depositor,
      validator,
      amount
    }) => {
      return {
        depositor,
        validator,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: ({
      depositor,
      validator,
      amount
    }) => {
      return {
        depositor,
        validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.router.v1beta1.MsgWithdrawBurn": {
    aminoType: "/kava.router.v1beta1.MsgWithdrawBurn",
    toAmino: ({
      from,
      validator,
      amount
    }) => {
      return {
        from,
        validator,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: ({
      from,
      validator,
      amount
    }) => {
      return {
        from,
        validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  },
  "/kava.router.v1beta1.MsgWithdrawBurnUndelegate": {
    aminoType: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
    toAmino: ({
      from,
      validator,
      amount
    }) => {
      return {
        from,
        validator,
        amount: {
          denom: amount.denom,
          amount: Long.fromValue(amount.amount).toString()
        }
      };
    },
    fromAmino: ({
      from,
      validator,
      amount
    }) => {
      return {
        from,
        validator,
        amount: {
          denom: amount.denom,
          amount: amount.amount
        }
      };
    }
  }
};