import { MsgMintDeposit, MsgDelegateMintDeposit, MsgWithdrawBurn, MsgWithdrawBurnUndelegate } from "./tx";
export const registry = [["/kava.router.v1beta1.MsgMintDeposit", MsgMintDeposit], ["/kava.router.v1beta1.MsgDelegateMintDeposit", MsgDelegateMintDeposit], ["/kava.router.v1beta1.MsgWithdrawBurn", MsgWithdrawBurn], ["/kava.router.v1beta1.MsgWithdrawBurnUndelegate", MsgWithdrawBurnUndelegate]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: MsgMintDeposit.encode(value).finish()
      };
    },
    delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: MsgDelegateMintDeposit.encode(value).finish()
      };
    },
    withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: MsgWithdrawBurn.encode(value).finish()
      };
    },
    withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: MsgWithdrawBurnUndelegate.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value
      };
    },
    delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value
      };
    },
    withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value
      };
    },
    withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value
      };
    }
  },
  toJSON: {
    mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: MsgMintDeposit.toJSON(value)
      };
    },
    delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: MsgDelegateMintDeposit.toJSON(value)
      };
    },
    withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: MsgWithdrawBurn.toJSON(value)
      };
    },
    withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: MsgWithdrawBurnUndelegate.toJSON(value)
      };
    }
  },
  fromJSON: {
    mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: MsgMintDeposit.fromJSON(value)
      };
    },
    delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: MsgDelegateMintDeposit.fromJSON(value)
      };
    },
    withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: MsgWithdrawBurn.fromJSON(value)
      };
    },
    withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: MsgWithdrawBurnUndelegate.fromJSON(value)
      };
    }
  },
  fromPartial: {
    mintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgMintDeposit",
        value: MsgMintDeposit.fromPartial(value)
      };
    },
    delegateMintDeposit(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgDelegateMintDeposit",
        value: MsgDelegateMintDeposit.fromPartial(value)
      };
    },
    withdrawBurn(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurn",
        value: MsgWithdrawBurn.fromPartial(value)
      };
    },
    withdrawBurnUndelegate(value) {
      return {
        typeUrl: "/kava.router.v1beta1.MsgWithdrawBurnUndelegate",
        value: MsgWithdrawBurnUndelegate.fromPartial(value)
      };
    }
  }
};