import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { MsgMintDeposit, MsgMintDepositResponse, MsgDelegateMintDeposit, MsgDelegateMintDepositResponse, MsgWithdrawBurn, MsgWithdrawBurnResponse, MsgWithdrawBurnUndelegate, MsgWithdrawBurnUndelegateResponse } from "./tx";
/** Msg defines the router Msg service. */

export class MsgClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.mintDeposit = this.mintDeposit.bind(this);
    this.delegateMintDeposit = this.delegateMintDeposit.bind(this);
    this.withdrawBurn = this.withdrawBurn.bind(this);
    this.withdrawBurnUndelegate = this.withdrawBurnUndelegate.bind(this);
  }
  mintDeposit(request) {
    const data = MsgMintDeposit.encode(request).finish();
    const promise = this.rpc.request("kava.router.v1beta1.Msg", "MintDeposit", data);
    return promise.then(data => MsgMintDepositResponse.decode(new _m0.Reader(data)));
  }
  delegateMintDeposit(request) {
    const data = MsgDelegateMintDeposit.encode(request).finish();
    const promise = this.rpc.request("kava.router.v1beta1.Msg", "DelegateMintDeposit", data);
    return promise.then(data => MsgDelegateMintDepositResponse.decode(new _m0.Reader(data)));
  }
  withdrawBurn(request) {
    const data = MsgWithdrawBurn.encode(request).finish();
    const promise = this.rpc.request("kava.router.v1beta1.Msg", "WithdrawBurn", data);
    return promise.then(data => MsgWithdrawBurnResponse.decode(new _m0.Reader(data)));
  }
  withdrawBurnUndelegate(request) {
    const data = MsgWithdrawBurnUndelegate.encode(request).finish();
    const promise = this.rpc.request("kava.router.v1beta1.Msg", "WithdrawBurnUndelegate", data);
    return promise.then(data => MsgWithdrawBurnUndelegateResponse.decode(new _m0.Reader(data)));
  }
}