import { Params, PoolRecord, ShareRecord } from "./swap";
import * as _m0 from "protobufjs/minimal";
import { isSet } from "../../../helpers";
/** GenesisState defines the swap module's genesis state. */

function createBaseGenesisState() {
  return {
    params: undefined,
    poolRecords: [],
    shareRecords: []
  };
}
export const GenesisState = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.poolRecords) {
      PoolRecord.encode(v, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.shareRecords) {
      ShareRecord.encode(v, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.params = Params.decode(reader, reader.uint32());
          break;
        case 2:
          message.poolRecords.push(PoolRecord.decode(reader, reader.uint32()));
          break;
        case 3:
          message.shareRecords.push(ShareRecord.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      poolRecords: Array.isArray(object === null || object === void 0 ? void 0 : object.poolRecords) ? object.poolRecords.map(e => PoolRecord.fromJSON(e)) : [],
      shareRecords: Array.isArray(object === null || object === void 0 ? void 0 : object.shareRecords) ? object.shareRecords.map(e => ShareRecord.fromJSON(e)) : []
    };
  },
  toJSON(message) {
    const obj = {};
    message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
    if (message.poolRecords) {
      obj.poolRecords = message.poolRecords.map(e => e ? PoolRecord.toJSON(e) : undefined);
    } else {
      obj.poolRecords = [];
    }
    if (message.shareRecords) {
      obj.shareRecords = message.shareRecords.map(e => e ? ShareRecord.toJSON(e) : undefined);
    } else {
      obj.shareRecords = [];
    }
    return obj;
  },
  fromPartial(object) {
    var _object$poolRecords, _object$shareRecords;
    const message = createBaseGenesisState();
    message.params = object.params !== undefined && object.params !== null ? Params.fromPartial(object.params) : undefined;
    message.poolRecords = ((_object$poolRecords = object.poolRecords) === null || _object$poolRecords === void 0 ? void 0 : _object$poolRecords.map(e => PoolRecord.fromPartial(e))) || [];
    message.shareRecords = ((_object$shareRecords = object.shareRecords) === null || _object$shareRecords === void 0 ? void 0 : _object$shareRecords.map(e => ShareRecord.fromPartial(e))) || [];
    return message;
  }
};