import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
/** Params defines the parameters for the swap module. */

function createBaseParams() {
  return {
    allowedPools: [],
    swapFee: ""
  };
}
export const Params = {
  encode(message, writer = _m0.Writer.create()) {
    for (const v of message.allowedPools) {
      AllowedPool.encode(v, writer.uint32(10).fork()).ldelim();
    }
    if (message.swapFee !== "") {
      writer.uint32(18).string(message.swapFee);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.allowedPools.push(AllowedPool.decode(reader, reader.uint32()));
          break;
        case 2:
          message.swapFee = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      allowedPools: Array.isArray(object === null || object === void 0 ? void 0 : object.allowedPools) ? object.allowedPools.map(e => AllowedPool.fromJSON(e)) : [],
      swapFee: isSet(object.swapFee) ? String(object.swapFee) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    if (message.allowedPools) {
      obj.allowedPools = message.allowedPools.map(e => e ? AllowedPool.toJSON(e) : undefined);
    } else {
      obj.allowedPools = [];
    }
    message.swapFee !== undefined && (obj.swapFee = message.swapFee);
    return obj;
  },
  fromPartial(object) {
    var _object$allowedPools, _object$swapFee;
    const message = createBaseParams();
    message.allowedPools = ((_object$allowedPools = object.allowedPools) === null || _object$allowedPools === void 0 ? void 0 : _object$allowedPools.map(e => AllowedPool.fromPartial(e))) || [];
    message.swapFee = (_object$swapFee = object.swapFee) !== null && _object$swapFee !== void 0 ? _object$swapFee : "";
    return message;
  }
};
function createBaseAllowedPool() {
  return {
    tokenA: "",
    tokenB: ""
  };
}
export const AllowedPool = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.tokenA !== "") {
      writer.uint32(10).string(message.tokenA);
    }
    if (message.tokenB !== "") {
      writer.uint32(18).string(message.tokenB);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAllowedPool();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.tokenA = reader.string();
          break;
        case 2:
          message.tokenB = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      tokenA: isSet(object.tokenA) ? String(object.tokenA) : "",
      tokenB: isSet(object.tokenB) ? String(object.tokenB) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.tokenA !== undefined && (obj.tokenA = message.tokenA);
    message.tokenB !== undefined && (obj.tokenB = message.tokenB);
    return obj;
  },
  fromPartial(object) {
    var _object$tokenA, _object$tokenB;
    const message = createBaseAllowedPool();
    message.tokenA = (_object$tokenA = object.tokenA) !== null && _object$tokenA !== void 0 ? _object$tokenA : "";
    message.tokenB = (_object$tokenB = object.tokenB) !== null && _object$tokenB !== void 0 ? _object$tokenB : "";
    return message;
  }
};
function createBasePoolRecord() {
  return {
    poolId: "",
    reservesA: undefined,
    reservesB: undefined,
    totalShares: ""
  };
}
export const PoolRecord = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.poolId !== "") {
      writer.uint32(10).string(message.poolId);
    }
    if (message.reservesA !== undefined) {
      Coin.encode(message.reservesA, writer.uint32(18).fork()).ldelim();
    }
    if (message.reservesB !== undefined) {
      Coin.encode(message.reservesB, writer.uint32(26).fork()).ldelim();
    }
    if (message.totalShares !== "") {
      writer.uint32(34).string(message.totalShares);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePoolRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.poolId = reader.string();
          break;
        case 2:
          message.reservesA = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.reservesB = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.totalShares = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      poolId: isSet(object.poolId) ? String(object.poolId) : "",
      reservesA: isSet(object.reservesA) ? Coin.fromJSON(object.reservesA) : undefined,
      reservesB: isSet(object.reservesB) ? Coin.fromJSON(object.reservesB) : undefined,
      totalShares: isSet(object.totalShares) ? String(object.totalShares) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.poolId !== undefined && (obj.poolId = message.poolId);
    message.reservesA !== undefined && (obj.reservesA = message.reservesA ? Coin.toJSON(message.reservesA) : undefined);
    message.reservesB !== undefined && (obj.reservesB = message.reservesB ? Coin.toJSON(message.reservesB) : undefined);
    message.totalShares !== undefined && (obj.totalShares = message.totalShares);
    return obj;
  },
  fromPartial(object) {
    var _object$poolId, _object$totalShares;
    const message = createBasePoolRecord();
    message.poolId = (_object$poolId = object.poolId) !== null && _object$poolId !== void 0 ? _object$poolId : "";
    message.reservesA = object.reservesA !== undefined && object.reservesA !== null ? Coin.fromPartial(object.reservesA) : undefined;
    message.reservesB = object.reservesB !== undefined && object.reservesB !== null ? Coin.fromPartial(object.reservesB) : undefined;
    message.totalShares = (_object$totalShares = object.totalShares) !== null && _object$totalShares !== void 0 ? _object$totalShares : "";
    return message;
  }
};
function createBaseShareRecord() {
  return {
    depositor: new Uint8Array(),
    poolId: "",
    sharesOwned: ""
  };
}
export const ShareRecord = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor.length !== 0) {
      writer.uint32(10).bytes(message.depositor);
    }
    if (message.poolId !== "") {
      writer.uint32(18).string(message.poolId);
    }
    if (message.sharesOwned !== "") {
      writer.uint32(26).string(message.sharesOwned);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseShareRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.bytes();
          break;
        case 2:
          message.poolId = reader.string();
          break;
        case 3:
          message.sharesOwned = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? bytesFromBase64(object.depositor) : new Uint8Array(),
      poolId: isSet(object.poolId) ? String(object.poolId) : "",
      sharesOwned: isSet(object.sharesOwned) ? String(object.sharesOwned) : ""
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = base64FromBytes(message.depositor !== undefined ? message.depositor : new Uint8Array()));
    message.poolId !== undefined && (obj.poolId = message.poolId);
    message.sharesOwned !== undefined && (obj.sharesOwned = message.sharesOwned);
    return obj;
  },
  fromPartial(object) {
    var _object$depositor, _object$poolId2, _object$sharesOwned;
    const message = createBaseShareRecord();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : new Uint8Array();
    message.poolId = (_object$poolId2 = object.poolId) !== null && _object$poolId2 !== void 0 ? _object$poolId2 : "";
    message.sharesOwned = (_object$sharesOwned = object.sharesOwned) !== null && _object$sharesOwned !== void 0 ? _object$sharesOwned : "";
    return message;
  }
};