import { Coin } from "../../../cosmos/base/v1beta1/coin";
import * as _m0 from "protobufjs/minimal";
import { Long, isSet } from "../../../helpers";
/** MsgDeposit represents a message for depositing liquidity into a pool */

function createBaseMsgDeposit() {
  return {
    depositor: "",
    tokenA: undefined,
    tokenB: undefined,
    slippage: "",
    deadline: Long.ZERO
  };
}
export const MsgDeposit = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    if (message.tokenA !== undefined) {
      Coin.encode(message.tokenA, writer.uint32(18).fork()).ldelim();
    }
    if (message.tokenB !== undefined) {
      Coin.encode(message.tokenB, writer.uint32(26).fork()).ldelim();
    }
    if (message.slippage !== "") {
      writer.uint32(34).string(message.slippage);
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDeposit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.depositor = reader.string();
          break;
        case 2:
          message.tokenA = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.tokenB = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.slippage = reader.string();
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      depositor: isSet(object.depositor) ? String(object.depositor) : "",
      tokenA: isSet(object.tokenA) ? Coin.fromJSON(object.tokenA) : undefined,
      tokenB: isSet(object.tokenB) ? Coin.fromJSON(object.tokenB) : undefined,
      slippage: isSet(object.slippage) ? String(object.slippage) : "",
      deadline: isSet(object.deadline) ? Long.fromValue(object.deadline) : Long.ZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.depositor !== undefined && (obj.depositor = message.depositor);
    message.tokenA !== undefined && (obj.tokenA = message.tokenA ? Coin.toJSON(message.tokenA) : undefined);
    message.tokenB !== undefined && (obj.tokenB = message.tokenB ? Coin.toJSON(message.tokenB) : undefined);
    message.slippage !== undefined && (obj.slippage = message.slippage);
    message.deadline !== undefined && (obj.deadline = (message.deadline || Long.ZERO).toString());
    return obj;
  },
  fromPartial(object) {
    var _object$depositor, _object$slippage;
    const message = createBaseMsgDeposit();
    message.depositor = (_object$depositor = object.depositor) !== null && _object$depositor !== void 0 ? _object$depositor : "";
    message.tokenA = object.tokenA !== undefined && object.tokenA !== null ? Coin.fromPartial(object.tokenA) : undefined;
    message.tokenB = object.tokenB !== undefined && object.tokenB !== null ? Coin.fromPartial(object.tokenB) : undefined;
    message.slippage = (_object$slippage = object.slippage) !== null && _object$slippage !== void 0 ? _object$slippage : "";
    message.deadline = object.deadline !== undefined && object.deadline !== null ? Long.fromValue(object.deadline) : Long.ZERO;
    return message;
  }
};
function createBaseMsgDepositResponse() {
  return {};
}
export const MsgDepositResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgDepositResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgDepositResponse();
    return message;
  }
};
function createBaseMsgWithdraw() {
  return {
    from: "",
    shares: "",
    minTokenA: undefined,
    minTokenB: undefined,
    deadline: Long.ZERO
  };
}
export const MsgWithdraw = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.from !== "") {
      writer.uint32(10).string(message.from);
    }
    if (message.shares !== "") {
      writer.uint32(18).string(message.shares);
    }
    if (message.minTokenA !== undefined) {
      Coin.encode(message.minTokenA, writer.uint32(26).fork()).ldelim();
    }
    if (message.minTokenB !== undefined) {
      Coin.encode(message.minTokenB, writer.uint32(34).fork()).ldelim();
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgWithdraw();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = reader.string();
          break;
        case 2:
          message.shares = reader.string();
          break;
        case 3:
          message.minTokenA = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.minTokenB = Coin.decode(reader, reader.uint32());
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      from: isSet(object.from) ? String(object.from) : "",
      shares: isSet(object.shares) ? String(object.shares) : "",
      minTokenA: isSet(object.minTokenA) ? Coin.fromJSON(object.minTokenA) : undefined,
      minTokenB: isSet(object.minTokenB) ? Coin.fromJSON(object.minTokenB) : undefined,
      deadline: isSet(object.deadline) ? Long.fromValue(object.deadline) : Long.ZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.from !== undefined && (obj.from = message.from);
    message.shares !== undefined && (obj.shares = message.shares);
    message.minTokenA !== undefined && (obj.minTokenA = message.minTokenA ? Coin.toJSON(message.minTokenA) : undefined);
    message.minTokenB !== undefined && (obj.minTokenB = message.minTokenB ? Coin.toJSON(message.minTokenB) : undefined);
    message.deadline !== undefined && (obj.deadline = (message.deadline || Long.ZERO).toString());
    return obj;
  },
  fromPartial(object) {
    var _object$from, _object$shares;
    const message = createBaseMsgWithdraw();
    message.from = (_object$from = object.from) !== null && _object$from !== void 0 ? _object$from : "";
    message.shares = (_object$shares = object.shares) !== null && _object$shares !== void 0 ? _object$shares : "";
    message.minTokenA = object.minTokenA !== undefined && object.minTokenA !== null ? Coin.fromPartial(object.minTokenA) : undefined;
    message.minTokenB = object.minTokenB !== undefined && object.minTokenB !== null ? Coin.fromPartial(object.minTokenB) : undefined;
    message.deadline = object.deadline !== undefined && object.deadline !== null ? Long.fromValue(object.deadline) : Long.ZERO;
    return message;
  }
};
function createBaseMsgWithdrawResponse() {
  return {};
}
export const MsgWithdrawResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgWithdrawResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgWithdrawResponse();
    return message;
  }
};
function createBaseMsgSwapExactForTokens() {
  return {
    requester: "",
    exactTokenA: undefined,
    tokenB: undefined,
    slippage: "",
    deadline: Long.ZERO
  };
}
export const MsgSwapExactForTokens = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.requester !== "") {
      writer.uint32(10).string(message.requester);
    }
    if (message.exactTokenA !== undefined) {
      Coin.encode(message.exactTokenA, writer.uint32(18).fork()).ldelim();
    }
    if (message.tokenB !== undefined) {
      Coin.encode(message.tokenB, writer.uint32(26).fork()).ldelim();
    }
    if (message.slippage !== "") {
      writer.uint32(34).string(message.slippage);
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgSwapExactForTokens();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.requester = reader.string();
          break;
        case 2:
          message.exactTokenA = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.tokenB = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.slippage = reader.string();
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      requester: isSet(object.requester) ? String(object.requester) : "",
      exactTokenA: isSet(object.exactTokenA) ? Coin.fromJSON(object.exactTokenA) : undefined,
      tokenB: isSet(object.tokenB) ? Coin.fromJSON(object.tokenB) : undefined,
      slippage: isSet(object.slippage) ? String(object.slippage) : "",
      deadline: isSet(object.deadline) ? Long.fromValue(object.deadline) : Long.ZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.requester !== undefined && (obj.requester = message.requester);
    message.exactTokenA !== undefined && (obj.exactTokenA = message.exactTokenA ? Coin.toJSON(message.exactTokenA) : undefined);
    message.tokenB !== undefined && (obj.tokenB = message.tokenB ? Coin.toJSON(message.tokenB) : undefined);
    message.slippage !== undefined && (obj.slippage = message.slippage);
    message.deadline !== undefined && (obj.deadline = (message.deadline || Long.ZERO).toString());
    return obj;
  },
  fromPartial(object) {
    var _object$requester, _object$slippage2;
    const message = createBaseMsgSwapExactForTokens();
    message.requester = (_object$requester = object.requester) !== null && _object$requester !== void 0 ? _object$requester : "";
    message.exactTokenA = object.exactTokenA !== undefined && object.exactTokenA !== null ? Coin.fromPartial(object.exactTokenA) : undefined;
    message.tokenB = object.tokenB !== undefined && object.tokenB !== null ? Coin.fromPartial(object.tokenB) : undefined;
    message.slippage = (_object$slippage2 = object.slippage) !== null && _object$slippage2 !== void 0 ? _object$slippage2 : "";
    message.deadline = object.deadline !== undefined && object.deadline !== null ? Long.fromValue(object.deadline) : Long.ZERO;
    return message;
  }
};
function createBaseMsgSwapExactForTokensResponse() {
  return {};
}
export const MsgSwapExactForTokensResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgSwapExactForTokensResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgSwapExactForTokensResponse();
    return message;
  }
};
function createBaseMsgSwapForExactTokens() {
  return {
    requester: "",
    tokenA: undefined,
    exactTokenB: undefined,
    slippage: "",
    deadline: Long.ZERO
  };
}
export const MsgSwapForExactTokens = {
  encode(message, writer = _m0.Writer.create()) {
    if (message.requester !== "") {
      writer.uint32(10).string(message.requester);
    }
    if (message.tokenA !== undefined) {
      Coin.encode(message.tokenA, writer.uint32(18).fork()).ldelim();
    }
    if (message.exactTokenB !== undefined) {
      Coin.encode(message.exactTokenB, writer.uint32(26).fork()).ldelim();
    }
    if (message.slippage !== "") {
      writer.uint32(34).string(message.slippage);
    }
    if (!message.deadline.isZero()) {
      writer.uint32(40).int64(message.deadline);
    }
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgSwapForExactTokens();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.requester = reader.string();
          break;
        case 2:
          message.tokenA = Coin.decode(reader, reader.uint32());
          break;
        case 3:
          message.exactTokenB = Coin.decode(reader, reader.uint32());
          break;
        case 4:
          message.slippage = reader.string();
          break;
        case 5:
          message.deadline = reader.int64();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(object) {
    return {
      requester: isSet(object.requester) ? String(object.requester) : "",
      tokenA: isSet(object.tokenA) ? Coin.fromJSON(object.tokenA) : undefined,
      exactTokenB: isSet(object.exactTokenB) ? Coin.fromJSON(object.exactTokenB) : undefined,
      slippage: isSet(object.slippage) ? String(object.slippage) : "",
      deadline: isSet(object.deadline) ? Long.fromValue(object.deadline) : Long.ZERO
    };
  },
  toJSON(message) {
    const obj = {};
    message.requester !== undefined && (obj.requester = message.requester);
    message.tokenA !== undefined && (obj.tokenA = message.tokenA ? Coin.toJSON(message.tokenA) : undefined);
    message.exactTokenB !== undefined && (obj.exactTokenB = message.exactTokenB ? Coin.toJSON(message.exactTokenB) : undefined);
    message.slippage !== undefined && (obj.slippage = message.slippage);
    message.deadline !== undefined && (obj.deadline = (message.deadline || Long.ZERO).toString());
    return obj;
  },
  fromPartial(object) {
    var _object$requester2, _object$slippage3;
    const message = createBaseMsgSwapForExactTokens();
    message.requester = (_object$requester2 = object.requester) !== null && _object$requester2 !== void 0 ? _object$requester2 : "";
    message.tokenA = object.tokenA !== undefined && object.tokenA !== null ? Coin.fromPartial(object.tokenA) : undefined;
    message.exactTokenB = object.exactTokenB !== undefined && object.exactTokenB !== null ? Coin.fromPartial(object.exactTokenB) : undefined;
    message.slippage = (_object$slippage3 = object.slippage) !== null && _object$slippage3 !== void 0 ? _object$slippage3 : "";
    message.deadline = object.deadline !== undefined && object.deadline !== null ? Long.fromValue(object.deadline) : Long.ZERO;
    return message;
  }
};
function createBaseMsgSwapForExactTokensResponse() {
  return {};
}
export const MsgSwapForExactTokensResponse = {
  encode(_, writer = _m0.Writer.create()) {
    return writer;
  },
  decode(input, length) {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgSwapForExactTokensResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },
  fromJSON(_) {
    return {};
  },
  toJSON(_) {
    const obj = {};
    return obj;
  },
  fromPartial(_) {
    const message = createBaseMsgSwapForExactTokensResponse();
    return message;
  }
};