import { MsgDeposit, MsgWithdraw, MsgSwapExactForTokens, MsgSwapForExactTokens } from "./tx";
export const registry = [["/kava.swap.v1beta1.MsgDeposit", MsgDeposit], ["/kava.swap.v1beta1.MsgWithdraw", MsgWithdraw], ["/kava.swap.v1beta1.MsgSwapExactForTokens", MsgSwapExactForTokens], ["/kava.swap.v1beta1.MsgSwapForExactTokens", MsgSwapForExactTokens]];
export const load = protoRegistry => {
  registry.forEach(([typeUrl, mod]) => {
    protoRegistry.register(typeUrl, mod);
  });
};
export const MessageComposer = {
  encoded: {
    deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: MsgDeposit.encode(value).finish()
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: MsgWithdraw.encode(value).finish()
      };
    },
    swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: MsgSwapExactForTokens.encode(value).finish()
      };
    },
    swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: MsgSwapForExactTokens.encode(value).finish()
      };
    }
  },
  withTypeUrl: {
    deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value
      };
    },
    swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value
      };
    },
    swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value
      };
    }
  },
  toJSON: {
    deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: MsgDeposit.toJSON(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: MsgWithdraw.toJSON(value)
      };
    },
    swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: MsgSwapExactForTokens.toJSON(value)
      };
    },
    swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: MsgSwapForExactTokens.toJSON(value)
      };
    }
  },
  fromJSON: {
    deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: MsgDeposit.fromJSON(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: MsgWithdraw.fromJSON(value)
      };
    },
    swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: MsgSwapExactForTokens.fromJSON(value)
      };
    },
    swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: MsgSwapForExactTokens.fromJSON(value)
      };
    }
  },
  fromPartial: {
    deposit(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgDeposit",
        value: MsgDeposit.fromPartial(value)
      };
    },
    withdraw(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgWithdraw",
        value: MsgWithdraw.fromPartial(value)
      };
    },
    swapExactForTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapExactForTokens",
        value: MsgSwapExactForTokens.fromPartial(value)
      };
    },
    swapForExactTokens(value) {
      return {
        typeUrl: "/kava.swap.v1beta1.MsgSwapForExactTokens",
        value: MsgSwapForExactTokens.fromPartial(value)
      };
    }
  }
};