import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as _m0 from "protobufjs/minimal";
import { MsgDeposit, MsgDepositResponse, MsgWithdraw, MsgWithdrawResponse, MsgSwapExactForTokens, MsgSwapExactForTokensResponse, MsgSwapForExactTokens, MsgSwapForExactTokensResponse } from "./tx";
/** Msg defines the swap Msg service. */

export class MsgClientImpl {
  constructor(rpc) {
    _defineProperty(this, "rpc", void 0);
    this.rpc = rpc;
    this.deposit = this.deposit.bind(this);
    this.withdraw = this.withdraw.bind(this);
    this.swapExactForTokens = this.swapExactForTokens.bind(this);
    this.swapForExactTokens = this.swapForExactTokens.bind(this);
  }
  deposit(request) {
    const data = MsgDeposit.encode(request).finish();
    const promise = this.rpc.request("kava.swap.v1beta1.Msg", "Deposit", data);
    return promise.then(data => MsgDepositResponse.decode(new _m0.Reader(data)));
  }
  withdraw(request) {
    const data = MsgWithdraw.encode(request).finish();
    const promise = this.rpc.request("kava.swap.v1beta1.Msg", "Withdraw", data);
    return promise.then(data => MsgWithdrawResponse.decode(new _m0.Reader(data)));
  }
  swapExactForTokens(request) {
    const data = MsgSwapExactForTokens.encode(request).finish();
    const promise = this.rpc.request("kava.swap.v1beta1.Msg", "SwapExactForTokens", data);
    return promise.then(data => MsgSwapExactForTokensResponse.decode(new _m0.Reader(data)));
  }
  swapForExactTokens(request) {
    const data = MsgSwapForExactTokens.encode(request).finish();
    const promise = this.rpc.request("kava.swap.v1beta1.Msg", "SwapForExactTokens", data);
    return promise.then(data => MsgSwapForExactTokensResponse.decode(new _m0.Reader(data)));
  }
}