export declare const createRPCQueryClient: ({ rpcEndpoint }: {
    rpcEndpoint: string;
}) => Promise<{
    cosmos: {
        auth: {
            v1beta1: {
                accounts(request?: import("../cosmos/auth/v1beta1/query").QueryAccountsRequest): Promise<import("../cosmos/auth/v1beta1/query").QueryAccountsResponse>;
                account(request: import("../cosmos/auth/v1beta1/query").QueryAccountRequest): Promise<import("../cosmos/auth/v1beta1/query").QueryAccountResponse>;
                params(request?: import("../cosmos/auth/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/auth/v1beta1/query").QueryParamsResponse>;
            };
        };
        authz: {
            v1beta1: {
                grants(request: import("../cosmos/authz/v1beta1/query").QueryGrantsRequest): Promise<import("../cosmos/authz/v1beta1/query").QueryGrantsResponse>;
                granterGrants(request: import("../cosmos/authz/v1beta1/query").QueryGranterGrantsRequest): Promise<import("../cosmos/authz/v1beta1/query").QueryGranterGrantsResponse>;
                granteeGrants(request: import("../cosmos/authz/v1beta1/query").QueryGranteeGrantsRequest): Promise<import("../cosmos/authz/v1beta1/query").QueryGranteeGrantsResponse>;
            };
        };
        bank: {
            v1beta1: {
                balance(request: import("../cosmos/bank/v1beta1/query").QueryBalanceRequest): Promise<import("../cosmos/bank/v1beta1/query").QueryBalanceResponse>;
                allBalances(request: import("../cosmos/bank/v1beta1/query").QueryAllBalancesRequest): Promise<import("../cosmos/bank/v1beta1/query").QueryAllBalancesResponse>;
                spendableBalances(request: import("../cosmos/bank/v1beta1/query").QuerySpendableBalancesRequest): Promise<import("../cosmos/bank/v1beta1/query").QuerySpendableBalancesResponse>;
                totalSupply(request?: import("../cosmos/bank/v1beta1/query").QueryTotalSupplyRequest): Promise<import("../cosmos/bank/v1beta1/query").QueryTotalSupplyResponse>;
                supplyOf(request: import("../cosmos/bank/v1beta1/query").QuerySupplyOfRequest): Promise<import("../cosmos/bank/v1beta1/query").QuerySupplyOfResponse>;
                params(request?: import("../cosmos/bank/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/bank/v1beta1/query").QueryParamsResponse>;
                denomMetadata(request: import("../cosmos/bank/v1beta1/query").QueryDenomMetadataRequest): Promise<import("../cosmos/bank/v1beta1/query").QueryDenomMetadataResponse>;
                denomsMetadata(request?: import("../cosmos/bank/v1beta1/query").QueryDenomsMetadataRequest): Promise<import("../cosmos/bank/v1beta1/query").QueryDenomsMetadataResponse>;
            };
        };
        base: {
            tendermint: {
                v1beta1: {
                    getNodeInfo(request?: import("../cosmos/base/tendermint/v1beta1/query").GetNodeInfoRequest): Promise<import("../cosmos/base/tendermint/v1beta1/query").GetNodeInfoResponse>;
                    getSyncing(request?: import("../cosmos/base/tendermint/v1beta1/query").GetSyncingRequest): Promise<import("../cosmos/base/tendermint/v1beta1/query").GetSyncingResponse>;
                    getLatestBlock(request?: import("../cosmos/base/tendermint/v1beta1/query").GetLatestBlockRequest): Promise<import("../cosmos/base/tendermint/v1beta1/query").GetLatestBlockResponse>;
                    getBlockByHeight(request: import("../cosmos/base/tendermint/v1beta1/query").GetBlockByHeightRequest): Promise<import("../cosmos/base/tendermint/v1beta1/query").GetBlockByHeightResponse>;
                    getLatestValidatorSet(request?: import("../cosmos/base/tendermint/v1beta1/query").GetLatestValidatorSetRequest): Promise<import("../cosmos/base/tendermint/v1beta1/query").GetLatestValidatorSetResponse>;
                    getValidatorSetByHeight(request: import("../cosmos/base/tendermint/v1beta1/query").GetValidatorSetByHeightRequest): Promise<import("../cosmos/base/tendermint/v1beta1/query").GetValidatorSetByHeightResponse>;
                };
            };
        };
        distribution: {
            v1beta1: {
                params(request?: import("../cosmos/distribution/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryParamsResponse>;
                validatorOutstandingRewards(request: import("../cosmos/distribution/v1beta1/query").QueryValidatorOutstandingRewardsRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryValidatorOutstandingRewardsResponse>;
                validatorCommission(request: import("../cosmos/distribution/v1beta1/query").QueryValidatorCommissionRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryValidatorCommissionResponse>;
                validatorSlashes(request: import("../cosmos/distribution/v1beta1/query").QueryValidatorSlashesRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryValidatorSlashesResponse>;
                delegationRewards(request: import("../cosmos/distribution/v1beta1/query").QueryDelegationRewardsRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryDelegationRewardsResponse>;
                delegationTotalRewards(request: import("../cosmos/distribution/v1beta1/query").QueryDelegationTotalRewardsRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryDelegationTotalRewardsResponse>;
                delegatorValidators(request: import("../cosmos/distribution/v1beta1/query").QueryDelegatorValidatorsRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryDelegatorValidatorsResponse>;
                delegatorWithdrawAddress(request: import("../cosmos/distribution/v1beta1/query").QueryDelegatorWithdrawAddressRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryDelegatorWithdrawAddressResponse>;
                communityPool(request?: import("../cosmos/distribution/v1beta1/query").QueryCommunityPoolRequest): Promise<import("../cosmos/distribution/v1beta1/query").QueryCommunityPoolResponse>;
            };
        };
        evidence: {
            v1beta1: {
                evidence(request: import("../cosmos/evidence/v1beta1/query").QueryEvidenceRequest): Promise<import("../cosmos/evidence/v1beta1/query").QueryEvidenceResponse>;
                allEvidence(request?: import("../cosmos/evidence/v1beta1/query").QueryAllEvidenceRequest): Promise<import("../cosmos/evidence/v1beta1/query").QueryAllEvidenceResponse>;
            };
        };
        feegrant: {
            v1beta1: {
                allowance(request: import("../cosmos/feegrant/v1beta1/query").QueryAllowanceRequest): Promise<import("../cosmos/feegrant/v1beta1/query").QueryAllowanceResponse>;
                allowances(request: import("../cosmos/feegrant/v1beta1/query").QueryAllowancesRequest): Promise<import("../cosmos/feegrant/v1beta1/query").QueryAllowancesResponse>;
                allowancesByGranter(request: import("../cosmos/feegrant/v1beta1/query").QueryAllowancesByGranterRequest): Promise<import("../cosmos/feegrant/v1beta1/query").QueryAllowancesByGranterResponse>;
            };
        };
        gov: {
            v1beta1: {
                proposal(request: import("../cosmos/gov/v1beta1/query").QueryProposalRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryProposalResponse>;
                proposals(request: import("../cosmos/gov/v1beta1/query").QueryProposalsRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryProposalsResponse>;
                vote(request: import("../cosmos/gov/v1beta1/query").QueryVoteRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryVoteResponse>;
                votes(request: import("../cosmos/gov/v1beta1/query").QueryVotesRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryVotesResponse>;
                params(request: import("../cosmos/gov/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryParamsResponse>;
                deposit(request: import("../cosmos/gov/v1beta1/query").QueryDepositRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryDepositResponse>;
                deposits(request: import("../cosmos/gov/v1beta1/query").QueryDepositsRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryDepositsResponse>;
                tallyResult(request: import("../cosmos/gov/v1beta1/query").QueryTallyResultRequest): Promise<import("../cosmos/gov/v1beta1/query").QueryTallyResultResponse>;
            };
        };
        mint: {
            v1beta1: {
                params(request?: import("../cosmos/mint/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/mint/v1beta1/query").QueryParamsResponse>;
                inflation(request?: import("../cosmos/mint/v1beta1/query").QueryInflationRequest): Promise<import("../cosmos/mint/v1beta1/query").QueryInflationResponse>;
                annualProvisions(request?: import("../cosmos/mint/v1beta1/query").QueryAnnualProvisionsRequest): Promise<import("../cosmos/mint/v1beta1/query").QueryAnnualProvisionsResponse>;
            };
        };
        params: {
            v1beta1: {
                params(request: import("../cosmos/params/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/params/v1beta1/query").QueryParamsResponse>;
            };
        };
        slashing: {
            v1beta1: {
                params(request?: import("../cosmos/slashing/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/slashing/v1beta1/query").QueryParamsResponse>;
                signingInfo(request: import("../cosmos/slashing/v1beta1/query").QuerySigningInfoRequest): Promise<import("../cosmos/slashing/v1beta1/query").QuerySigningInfoResponse>;
                signingInfos(request?: import("../cosmos/slashing/v1beta1/query").QuerySigningInfosRequest): Promise<import("../cosmos/slashing/v1beta1/query").QuerySigningInfosResponse>;
            };
        };
        staking: {
            v1beta1: {
                validators(request: import("../cosmos/staking/v1beta1/query").QueryValidatorsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryValidatorsResponse>;
                validator(request: import("../cosmos/staking/v1beta1/query").QueryValidatorRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryValidatorResponse>;
                validatorDelegations(request: import("../cosmos/staking/v1beta1/query").QueryValidatorDelegationsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryValidatorDelegationsResponse>;
                validatorUnbondingDelegations(request: import("../cosmos/staking/v1beta1/query").QueryValidatorUnbondingDelegationsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryValidatorUnbondingDelegationsResponse>;
                delegation(request: import("../cosmos/staking/v1beta1/query").QueryDelegationRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryDelegationResponse>;
                unbondingDelegation(request: import("../cosmos/staking/v1beta1/query").QueryUnbondingDelegationRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryUnbondingDelegationResponse>;
                delegatorDelegations(request: import("../cosmos/staking/v1beta1/query").QueryDelegatorDelegationsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryDelegatorDelegationsResponse>;
                delegatorUnbondingDelegations(request: import("../cosmos/staking/v1beta1/query").QueryDelegatorUnbondingDelegationsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryDelegatorUnbondingDelegationsResponse>;
                redelegations(request: import("../cosmos/staking/v1beta1/query").QueryRedelegationsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryRedelegationsResponse>;
                delegatorValidators(request: import("../cosmos/staking/v1beta1/query").QueryDelegatorValidatorsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryDelegatorValidatorsResponse>;
                delegatorValidator(request: import("../cosmos/staking/v1beta1/query").QueryDelegatorValidatorRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryDelegatorValidatorResponse>;
                historicalInfo(request: import("../cosmos/staking/v1beta1/query").QueryHistoricalInfoRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryHistoricalInfoResponse>;
                pool(request?: import("../cosmos/staking/v1beta1/query").QueryPoolRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryPoolResponse>;
                params(request?: import("../cosmos/staking/v1beta1/query").QueryParamsRequest): Promise<import("../cosmos/staking/v1beta1/query").QueryParamsResponse>;
            };
        };
        tx: {
            v1beta1: {
                simulate(request: import("../cosmos/tx/v1beta1/service").SimulateRequest): Promise<import("../cosmos/tx/v1beta1/service").SimulateResponse>;
                getTx(request: import("../cosmos/tx/v1beta1/service").GetTxRequest): Promise<import("../cosmos/tx/v1beta1/service").GetTxResponse>;
                broadcastTx(request: import("../cosmos/tx/v1beta1/service").BroadcastTxRequest): Promise<import("../cosmos/tx/v1beta1/service").BroadcastTxResponse>;
                getTxsEvent(request: import("../cosmos/tx/v1beta1/service").GetTxsEventRequest): Promise<import("../cosmos/tx/v1beta1/service").GetTxsEventResponse>;
                getBlockWithTxs(request: import("../cosmos/tx/v1beta1/service").GetBlockWithTxsRequest): Promise<import("../cosmos/tx/v1beta1/service").GetBlockWithTxsResponse>;
            };
        };
        upgrade: {
            v1beta1: {
                currentPlan(request?: import("../cosmos/upgrade/v1beta1/query").QueryCurrentPlanRequest): Promise<import("../cosmos/upgrade/v1beta1/query").QueryCurrentPlanResponse>;
                appliedPlan(request: import("../cosmos/upgrade/v1beta1/query").QueryAppliedPlanRequest): Promise<import("../cosmos/upgrade/v1beta1/query").QueryAppliedPlanResponse>;
                upgradedConsensusState(request: import("../cosmos/upgrade/v1beta1/query").QueryUpgradedConsensusStateRequest): Promise<import("../cosmos/upgrade/v1beta1/query").QueryUpgradedConsensusStateResponse>;
                moduleVersions(request: import("../cosmos/upgrade/v1beta1/query").QueryModuleVersionsRequest): Promise<import("../cosmos/upgrade/v1beta1/query").QueryModuleVersionsResponse>;
            };
        };
    };
    kava: {
        auction: {
            v1beta1: {
                params(request?: import("./auction/v1beta1/query").QueryParamsRequest): Promise<import("./auction/v1beta1/query").QueryParamsResponse>;
                auction(request: import("./auction/v1beta1/query").QueryAuctionRequest): Promise<import("./auction/v1beta1/query").QueryAuctionResponse>;
                auctions(request: import("./auction/v1beta1/query").QueryAuctionsRequest): Promise<import("./auction/v1beta1/query").QueryAuctionsResponse>;
                nextAuctionID(request?: import("./auction/v1beta1/query").QueryNextAuctionIDRequest): Promise<import("./auction/v1beta1/query").QueryNextAuctionIDResponse>;
            };
        };
        bep3: {
            v1beta1: {
                params(request?: import("./bep3/v1beta1/query").QueryParamsRequest): Promise<import("./bep3/v1beta1/query").QueryParamsResponse>;
                assetSupply(request: import("./bep3/v1beta1/query").QueryAssetSupplyRequest): Promise<import("./bep3/v1beta1/query").QueryAssetSupplyResponse>;
                assetSupplies(request?: import("./bep3/v1beta1/query").QueryAssetSuppliesRequest): Promise<import("./bep3/v1beta1/query").QueryAssetSuppliesResponse>;
                atomicSwap(request: import("./bep3/v1beta1/query").QueryAtomicSwapRequest): Promise<import("./bep3/v1beta1/query").QueryAtomicSwapResponse>;
                atomicSwaps(request: import("./bep3/v1beta1/query").QueryAtomicSwapsRequest): Promise<import("./bep3/v1beta1/query").QueryAtomicSwapsResponse>;
            };
        };
        cdp: {
            v1beta1: {
                params(request?: import("./cdp/v1beta1/query").QueryParamsRequest): Promise<import("./cdp/v1beta1/query").QueryParamsResponse>;
                accounts(request?: import("./cdp/v1beta1/query").QueryAccountsRequest): Promise<import("./cdp/v1beta1/query").QueryAccountsResponse>;
                totalPrincipal(request: import("./cdp/v1beta1/query").QueryTotalPrincipalRequest): Promise<import("./cdp/v1beta1/query").QueryTotalPrincipalResponse>;
                totalCollateral(request: import("./cdp/v1beta1/query").QueryTotalCollateralRequest): Promise<import("./cdp/v1beta1/query").QueryTotalCollateralResponse>;
                cdps(request: import("./cdp/v1beta1/query").QueryCdpsRequest): Promise<import("./cdp/v1beta1/query").QueryCdpsResponse>;
                cdp(request: import("./cdp/v1beta1/query").QueryCdpRequest): Promise<import("./cdp/v1beta1/query").QueryCdpResponse>;
                deposits(request: import("./cdp/v1beta1/query").QueryDepositsRequest): Promise<import("./cdp/v1beta1/query").QueryDepositsResponse>;
            };
        };
        committee: {
            v1beta1: {
                committees(request?: import("./committee/v1beta1/query").QueryCommitteesRequest): Promise<import("./committee/v1beta1/query").QueryCommitteesResponse>;
                committee(request: import("./committee/v1beta1/query").QueryCommitteeRequest): Promise<import("./committee/v1beta1/query").QueryCommitteeResponse>;
                proposals(request: import("./committee/v1beta1/query").QueryProposalsRequest): Promise<import("./committee/v1beta1/query").QueryProposalsResponse>;
                proposal(request: import("./committee/v1beta1/query").QueryProposalRequest): Promise<import("./committee/v1beta1/query").QueryProposalResponse>;
                nextProposalID(request?: import("./committee/v1beta1/query").QueryNextProposalIDRequest): Promise<import("./committee/v1beta1/query").QueryNextProposalIDResponse>;
                votes(request: import("./committee/v1beta1/query").QueryVotesRequest): Promise<import("./committee/v1beta1/query").QueryVotesResponse>;
                vote(request: import("./committee/v1beta1/query").QueryVoteRequest): Promise<import("./committee/v1beta1/query").QueryVoteResponse>;
                tally(request: import("./committee/v1beta1/query").QueryTallyRequest): Promise<import("./committee/v1beta1/query").QueryTallyResponse>;
                rawParams(request: import("./committee/v1beta1/query").QueryRawParamsRequest): Promise<import("./committee/v1beta1/query").QueryRawParamsResponse>;
            };
        };
        earn: {
            v1beta1: {
                params(request?: import("./earn/v1beta1/query").QueryParamsRequest): Promise<import("./earn/v1beta1/query").QueryParamsResponse>;
                vaults(request?: import("./earn/v1beta1/query").QueryVaultsRequest): Promise<import("./earn/v1beta1/query").QueryVaultsResponse>;
                vault(request: import("./earn/v1beta1/query").QueryVaultRequest): Promise<import("./earn/v1beta1/query").QueryVaultResponse>;
                deposits(request: import("./earn/v1beta1/query").QueryDepositsRequest): Promise<import("./earn/v1beta1/query").QueryDepositsResponse>;
            };
        };
        evmutil: {
            v1beta1: {
                params(request?: import("./evmutil/v1beta1/query").QueryParamsRequest): Promise<import("./evmutil/v1beta1/query").QueryParamsResponse>;
            };
        };
        hard: {
            v1beta1: {
                params(request?: import("./hard/v1beta1/query").QueryParamsRequest): Promise<import("./hard/v1beta1/query").QueryParamsResponse>;
                accounts(request?: import("./hard/v1beta1/query").QueryAccountsRequest): Promise<import("./hard/v1beta1/query").QueryAccountsResponse>;
                deposits(request: import("./hard/v1beta1/query").QueryDepositsRequest): Promise<import("./hard/v1beta1/query").QueryDepositsResponse>;
                unsyncedDeposits(request: import("./hard/v1beta1/query").QueryUnsyncedDepositsRequest): Promise<import("./hard/v1beta1/query").QueryUnsyncedDepositsResponse>;
                totalDeposited(request: import("./hard/v1beta1/query").QueryTotalDepositedRequest): Promise<import("./hard/v1beta1/query").QueryTotalDepositedResponse>;
                borrows(request: import("./hard/v1beta1/query").QueryBorrowsRequest): Promise<import("./hard/v1beta1/query").QueryBorrowsResponse>;
                unsyncedBorrows(request: import("./hard/v1beta1/query").QueryUnsyncedBorrowsRequest): Promise<import("./hard/v1beta1/query").QueryUnsyncedBorrowsResponse>;
                totalBorrowed(request: import("./hard/v1beta1/query").QueryTotalBorrowedRequest): Promise<import("./hard/v1beta1/query").QueryTotalBorrowedResponse>;
                interestRate(request: import("./hard/v1beta1/query").QueryInterestRateRequest): Promise<import("./hard/v1beta1/query").QueryInterestRateResponse>;
                reserves(request: import("./hard/v1beta1/query").QueryReservesRequest): Promise<import("./hard/v1beta1/query").QueryReservesResponse>;
                interestFactors(request: import("./hard/v1beta1/query").QueryInterestFactorsRequest): Promise<import("./hard/v1beta1/query").QueryInterestFactorsResponse>;
            };
        };
        issuance: {
            v1beta1: {
                params(request?: import("./issuance/v1beta1/query").QueryParamsRequest): Promise<import("./issuance/v1beta1/query").QueryParamsResponse>;
            };
        };
        kavadist: {
            v1beta1: {
                params(request?: import("./kavadist/v1beta1/query").QueryParamsRequest): Promise<import("./kavadist/v1beta1/query").QueryParamsResponse>;
                balance(request?: import("./kavadist/v1beta1/query").QueryBalanceRequest): Promise<import("./kavadist/v1beta1/query").QueryBalanceResponse>;
            };
        };
        liquid: {
            v1beta1: {
                delegatedBalance(request: import("./liquid/v1beta1/query").QueryDelegatedBalanceRequest): Promise<import("./liquid/v1beta1/query").QueryDelegatedBalanceResponse>;
            };
        };
        pricefeed: {
            v1beta1: {
                params(request?: import("./pricefeed/v1beta1/query").QueryParamsRequest): Promise<import("./pricefeed/v1beta1/query").QueryParamsResponse>;
                price(request: import("./pricefeed/v1beta1/query").QueryPriceRequest): Promise<import("./pricefeed/v1beta1/query").QueryPriceResponse>;
                prices(request?: import("./pricefeed/v1beta1/query").QueryPricesRequest): Promise<import("./pricefeed/v1beta1/query").QueryPricesResponse>;
                rawPrices(request: import("./pricefeed/v1beta1/query").QueryRawPricesRequest): Promise<import("./pricefeed/v1beta1/query").QueryRawPricesResponse>;
                oracles(request: import("./pricefeed/v1beta1/query").QueryOraclesRequest): Promise<import("./pricefeed/v1beta1/query").QueryOraclesResponse>;
                markets(request?: import("./pricefeed/v1beta1/query").QueryMarketsRequest): Promise<import("./pricefeed/v1beta1/query").QueryMarketsResponse>;
            };
        };
        savings: {
            v1beta1: {
                params(request?: import("./savings/v1beta1/query").QueryParamsRequest): Promise<import("./savings/v1beta1/query").QueryParamsResponse>;
                deposits(request: import("./savings/v1beta1/query").QueryDepositsRequest): Promise<import("./savings/v1beta1/query").QueryDepositsResponse>;
            };
        };
        swap: {
            v1beta1: {
                params(request?: import("./swap/v1beta1/query").QueryParamsRequest): Promise<import("./swap/v1beta1/query").QueryParamsResponse>;
                pools(request: import("./swap/v1beta1/query").QueryPoolsRequest): Promise<import("./swap/v1beta1/query").QueryPoolsResponse>;
                deposits(request: import("./swap/v1beta1/query").QueryDepositsRequest): Promise<import("./swap/v1beta1/query").QueryDepositsResponse>;
            };
        };
    };
}>;
